<?php
/**
 * $Id: RegAppApplyTake.php,v 1.6 2004/02/27 10:04:15 yoshi_s Exp $
 *  TAKE ѥ١饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegAppApplyOp.php");			// ѥ饹

/**
 * ̾  RegAppApplyTake
 *   
 */
class RegAppApplyTake extends RegAppApplyOp
{
	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppApplyTake
	 *   RegAppApplyTake饹󥹥ȥ饯
	 * @param  $db				DBAPI_IMPLE(connectѤǤ뤳)
	 * @param  $take_link_file	TAKE̤Υץȥեʼե̾
	 * @param  $dpn_link_file	DPN LISTѤΥץȥե
	 * @param  $dpn_link_str	DPN LISTѤʸ
	 * @param  $ret_link_file	륹ץȥե
	 * @param  $ret_link_str	󥯤Σȣԣͣɽʸ
	 */
	function RegAppApplyTake($db,
							 $take_link_file, $dpn_link_file, $dpn_link_str, $ret_link_file, $ret_link_str)
	{
		parent::RegAppApplyOp(APPOP_FORM_TAKE,
							  $db,
							  $take_link_file,
							  $dpn_link_file, $dpn_link_str,
							  $ret_link_file, $ret_link_str);
	}

	//-----------------------------------------------------------------------
	// public methods(POSTǡڤʬ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾create_apptake_info
	 *   TAKE̾롣
	 * @param  clerk_id		string		̳ôID
	 * @return λ1
	 *         ԡʶ̡
	 *				ERR_APPOP_FATAL			fatal errorʥ顼ɡܥʤ
	 *         ԡDISP_TYPE_OP_TAKE_REVIEW
	 *				ERR_APPOP_FATAL			fatal errorʥ顼ɡܥʤ
	 *				ERR_APPOP_DB_ACCESS		DB 顼
	 *				ERR_APPOP_MEM_STATUS	ȿơ顼
	 *				ERR_APPOP_STATUS		񥹥ơ顼
	 *				ERR_APPOP_CHANGE		ѹ
	 * @desc   顼ˤ $this->m_err_code_array ˥顼ɤϿ롣
	 *         RegAppDpnListHtml.php include ɬ¹Ԥ뤳ȡ
	 */
	function create_apptake_info($clerk_id)
	{
		if ($clerk_id == "")
		{
			return ERR_APPOP_FATAL;		// ɽԲ
		}

		//--------------------------------------------------------------------
		// POST
		//--------------------------------------------------------------------
		switch ($_POST["fn_page_name"])
		{
		//--------------------------------------------------------------------
		// DPNγǧɽ׵
		// 顼̤ɽ׵
		//--------------------------------------------------------------------
		case "fv_form_take":
		case "fv_err_return":
			$this->m_page_type = DISP_TYPE_OP_TAKE_REVIEW;
			$this->init_apptake_page_info();
			return $this->create_take_review_info();

		//--------------------------------------------------------------------
		// ԣˣƳǧ̤Υܥ
		//--------------------------------------------------------------------
		case "fv_app_action":
			$this->m_page_type = DISP_TYPE_OP_TAKE_REVIEW;
			$this->init_apptake_page_info();
			return $this->create_take_app_action_info($clerk_id);

		//----- ¾Ϥꤨʤ -----//
		default:
			return ERR_APPOP_FATAL;		// ɽԲ
		}
	}

	//-----------------------------------------------------------------------
	// public methods(桼ƥƥ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_page_info
	 *   եѹƲ̤ɽѡĤ
	 * @param  page_type	integer				ڡ				(i)
	 *                      DISP_TYPE_OP_TAKE_REVIEW,DISP_TYPE_OP_TAKE_FIX
	 * @param  fm_conf		RegAppDispConf[]	ɽ(REVIEW)		(i/o)
	 *                      RegAppCreateAppAcc	ѹ(FIX)			(i/o)
	 * @param  file_if		string				̥ץȾ			(i/o)
	 *                      array(ץ̾, conf_obj̾)
	 * @param  title		string				̥ȥ				(i/o)
	 * @param  op_btn		string				ܥ󥿥				(i/o)
	 * @desc   ̾ξ˱ͤ롣
	 */
	function get_page_info($page_type, &$fm_conf, &$file_if, &$title, &$op_btn)
	{
		switch ($page_type)
		{
		case DISP_TYPE_OP_TAKE_REVIEW:
			$file_if	= $this->m_review_file_if;
			$fm_conf	= $this->m_applyfm_conf;
			break;
		case DISP_TYPE_OP_TAKE_FIX:
			$file_if	= $this->m_fix_file_if;
			$fm_conf	= $this->m_acc_info;
			break;
		default:
			$file_if	= array();
			break;
		}

		$title		= $this->m_apply_title;
		$op_btn		= parent::get_op_btn();
	}

	//------------------------------------------------------------------------
	// private methods(ɽ)
	//------------------------------------------------------------------------
	/**
	 * ؿ̾init_apptake_page_info
	 *   TAKE̾
	 */
	function init_apptake_page_info()
	{
		$this->m_appkind_disp_able	= array("opr0102", "ops0101");
		$this->m_memstt_disp_able	= array("normal", "stop");
		$this->m_appstt_disp_able	= array("received");

		//--- POSTGET ---//
		$this->m_appls_conf = array(			// 
					"fn_item_num"		=>	new RegAppDispConf(),
					"fn_cur_page"		=>	new RegAppDispConf(),
					"fn_appno"			=>	new RegAppDispConf(),
					"fn_fy"				=>	new RegAppDispConf(),
					"fn_fm"				=>	new RegAppDispConf(),
					"fn_fd"				=>	new RegAppDispConf(),
					"fn_ty"				=>	new RegAppDispConf(),
					"fn_tm"				=>	new RegAppDispConf(),
					"fn_td"				=>	new RegAppDispConf(),
					"fn_mem"			=>	new RegAppDispConf(),
					"fn_clerk"			=>	new RegAppDispConf(),
					"fn_type"			=>	new RegAppDispConf(),
					"fn_stt"			=>	new RegAppDispConf(),
					"fn_sort"			=>	new RegAppDispConf(),
					);

		$this->m_applyif_conf = array(			// DPN LISTPOSTǡ
					"fn_app_acceptid"	=>	new RegAppDispConf(),
					"fn_app_kindid"		=>	new RegAppDispConf(),
					"fn_app_last_date"	=>	new RegAppDispConf(),
					"fn_app_memnum"		=>	new RegAppDispConf(),
					);
	}

	//------------------------------------------------------------------------
	// private methods(ɽǡ)
	//------------------------------------------------------------------------
	/**
	 * ؿ̾create_take_review_info
	 *   TAKEǧѤξԤ
	 * @return 1λ
	 *         ERR_APPOP_FATAL		fatal errorʥ顼ɡܥʤ
	 *         ERR_APPOP_DB_ACCESS	DB 顼
	 *         ERR_APPOP_STATUS		񥹥ơհʳ
	 *         ERR_APPOP_MEM_STATUS	ȿơnormal,stopʳ
	 * @desc   顼ˤ $this->m_err_code_array ˥顼ɤϿ롣
	 */
	function create_take_review_info()
	{
		//--------------------------------------------------------------------
		// POSTǡ
		//--------------------------------------------------------------------
		if (parent::init_base_post_info(FALSE, FALSE) == FALSE)
		{
			return ERR_APPOP_FATAL;
		}

		//--------------------------------------------------------------------
		// ID,̤鿽(SDB_APPLY_INFO,SDB_FORM_XXXXXXXX)
		//--------------------------------------------------------------------
		// оݤοѥ桼ƥƥ饹 require
		$util_cls	= $this->APPOP_INFO->m_app_form_util[$this->m_applyif_conf["fn_app_kindid"]->m_disp_var];
		require_once($util_cls . ".php");

		$form_obj	= "";
		$get_result	= $this->m_dpnls_cls->get_app_form_info(
											$util_cls,						// 񥯥饹̾
											$form_obj,						// 񥯥饹֥
											$this->m_applyif_conf,			// 
											$this->m_applyfm_conf,			// ե
											$extra_conf,					// ­(ߡ)
											$this->m_appstt_disp_able,		// Ĥ뿽񥹥ơ
											$this->m_memstt_disp_able,		// Ĥȿơ
											"",								// ȿֹ
											$this->reg_db,					// DBAPI_IMPLE
											FALSE);							// åե饰
		switch ($get_result)
		{
		//-----  -----//
		case 1:
			break;

		//----- DB顼 -----//
		case ERR_APPOP_DB_ACCESS:
			$this->m_op_btn = parent::create_dpn_errret_btn();		// 顼ܥ
			array_push($this->m_err_code_array, "D300");			// Ǥʤ顼
			$this->m_err_tail = $this->m_dpn_link_str . ERRTAIL_APP_DPNRET;
			return ERR_APPOP_DB_ACCESS;

		//----- 񥹥ơ顼 -----//
		case ERR_APPOP_STATUS:
			$this->m_op_btn = parent::create_dpn_errret_btn();		// 顼ܥ
			array_push($this->m_err_code_array, "D416");			// 񥹥ơ顼
			$this->m_err_tail = ERRTAIL_APP_STATUS;
			return ERR_APPOP_STATUS;

		//----- ȿơ顼 -----//
		case ERR_APPOP_MEM_STATUS:
			$this->m_op_btn = parent::create_dpn_errret_btn();		// 顼ܥ
			array_push($this->m_err_code_array, "C111");			// normal,stopΤ
			$this->m_err_tail = ERRTAIL_APP_MEM_STATUS;
			return ERR_APPOP_MEM_STATUS;

		//----- 񤬸Ĥʤ顼 -----//
		case ERR_APPOP_SEARCH:
		default:
			return ERR_APPOP_FATAL;
		}

		//--------------------------------------------------------------------
		// REVIEWɽ
		//--------------------------------------------------------------------
		// 꿶ꡢƿĤȿάΤ򥻥åȤREVIEWɽ
		if (strcmp($this->m_applyif_conf["fn_app_kindid"]->m_disp_var, "ops0101") == 0)
		{
			$mem_result = parent::set_mem_short(FALSE, FALSE);
			if ($mem_result !== 1)
			{
				return $mem_result;					// ȿάΥåȼ
			}
		}

		$this->create_take_review_parts($form_obj);	// REVIEW ̥ѡ
		return 1;
	}

	/**
	 * ؿ̾create_take_app_action_info
	 *   ѹƳǧ̤POSTǡå̾
	 * @param  clerk_id		string		̳ôID
	 * @return 1åOK
	 *         ERR_APPOP_FATAL			fatal顼
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_STATUS			񥹥ơ顼
	 *         ERR_APPOP_CHANGE			ѹ
	 *         ERR_APPOP_MEM_STATUS		ȿơ顼
	 * @desc   顼ˤ $this->m_err_code_array ˥顼ɤϿ롣
	 */
	function create_take_app_action_info($clerk_id)
	{
		//--------------------------------------------------------------------
		// POSTǡ
		//--------------------------------------------------------------------
		if (parent::init_base_post_info(TRUE, TRUE) == FALSE)
		{
			return ERR_APPOP_FATAL;
		}

		//--------------------------------------------------------------------
		// ԣˣż¹
		//--------------------------------------------------------------------
		return $this->take_app_form($clerk_id);
	}

	/**
	 * ؿ̾take_app_form
	 *   TAKE̤˱̾
	 * @param  clerk_id		string		̳ôID
	 * @return 1
	 *         ERR_APPOP_FATAL			fatal顼
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_STATUS			񥹥ơ顼
	 *         ERR_APPOP_CHANGE			ѹ
	 *         ERR_APPOP_MEM_STATUS		ȿơ顼
	 * @desc   顼ˤ $this->m_err_code_array ˥顼ɤϿ롣
	 *         ˤ $this->m_acc_info DPNϿ򥻥åȤ롣
	 */
	function take_app_form($clerk_id)
	{
		//--------------------------------------------------------------------
		// ԣˣѥ饹
		//--------------------------------------------------------------------
		// 饹 require_once
		$util_cls	= $this->APPOP_INFO->m_app_form_util[$this->m_applyif_conf["fn_app_kindid"]->m_disp_var];
		require_once($util_cls . ".php");
		// ؿ̾
		$take_app_form_method = "take_app_" . $this->m_applyif_conf["fn_app_kindid"]->m_disp_var;

		//--------------------------------------------------------------------
		// ԣˣŽƤӽФ
		//--------------------------------------------------------------------
		switch ($this->m_applyif_conf["fn_app_kindid"]->m_disp_var)
		{
		case "opr0102":			// Ƽ»ȿϿ
			$form_obj = new $util_cls();
			if (method_exists($form_obj, $take_app_form_method) == FALSE)
			{
				return ERR_APPOP_FATAL;		// ؿ¸ߥå
			}
			$acc_info = $form_obj->$take_app_form_method(
								$this->reg_db,					// DBAPI_IMPLE
								$this->m_applyif_conf,			// 
								$this->m_appstt_disp_able,		// ѹǽơ()
								$clerk_id,						// ̳ôID
								$this->m_err_code_array);		// 顼
			break;

		case "ops0101":			// 꿶꿳
			$form_obj = new $util_cls($this->reg_db);
			if (method_exists($form_obj, $take_app_form_method) == FALSE)
			{
				return ERR_APPOP_FATAL;		// ؿ¸ߥå
			}
			$acc_info = $form_obj->$take_app_form_method(
								$this->m_applyif_conf,			// 
								$this->m_appstt_disp_able,		// ѹǽơ()
								$this->m_memstt_disp_able,		// ѹǽơ(ȿ)
								$clerk_id,						// ̳ôID
								$this->m_err_code_array);		// 顼
			break;

		default:
			return ERR_APPOP_FATAL;
		}

		//--------------------------------------------------------------------
		// ̳ǧ
		//--------------------------------------------------------------------
		if (strcmp(strtoupper(get_class($acc_info)), strtoupper("RegAppCreateAppAcc")) != 0)
		{
			switch ($acc_info)
			{
			case ERR_APPOP_DB_ACCESS:			// DB顼
				$this->m_op_btn		= parent::create_review_errret_btn();
				$this->m_err_tail	= ERRTAIL_APP_REVIEWRET;
				break;

			case ERR_APPOP_STATUS:				// 񥹥ơ顼
				$this->m_op_btn		= parent::create_dpn_errret_btn();
				$this->m_err_tail	= ERRTAIL_APP_STATUS;
				break;

			case ERR_APPOP_MEM_STATUS:			// ȿơ顼
				// ̳¦Υξ硢ѹǤʤΤDPN LIST
				$this->m_op_btn		= parent::create_dpn_errret_btn();
				$this->m_err_tail	= ERRTAIL_APP_MEM_STATUS;
				break;

			case ERR_APPOP_CHANGE:				// ǽ顼
				$this->m_op_btn		= parent::create_review_errret_btn();
				$this->m_err_tail	= ERRTAIL_APP_REVIEWRET;
				break;

			case ERR_APPOP_SEARCH:				// ʤ
			case ERR_APPOP_FATAL:				// fatal顼
			default:
				return ERR_APPOP_FATAL;
			}

			return $acc_info;
		}

		//--------------------------------------------------------------------
		// ѹѥѡĺ
		//--------------------------------------------------------------------
		$this->m_page_type = DISP_TYPE_OP_TAKE_FIX;
		parent::create_fix_parts($form_obj);
		$this->m_acc_info = $acc_info;
		return 1;
	}

	//------------------------------------------------------------------------
	// private methods(̥ѡĺ)
	//------------------------------------------------------------------------
	/**
	 * ؿ̾create_take_review_parts
	 *   ԣˣƳǧѤHTMLѥǡԤ
	 * @param  form_obj		RegAppFormXXXXX		桼ƥƥ饹	(i)
	 * @desc   ܥ󡢥ץȾ󡢥ȥ򥻥åȤ
	 */
	function create_take_review_parts($form_obj)
	{
		$this->m_op_btn = parent::create_review_op_btn();
		parent::create_review_parts($form_obj);
	}
}
?>
