<?php
/**
 * $Id: RegAppDnsList.php,v 1.9 2004/03/05 08:09:19 wtetsuya Exp $
 * DNSѥ١饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegAppPagingUtil.php");
require_once("REGClass.php");				// DBѹ¤Υ饹
require_once("DBAPIWrapper.php");			// DB API
require("config/RegCnfCommon.php");			// ̥ƥե

//------------------------------------------------------------------------
// defines
//------------------------------------------------------------------------
define("DNSLS_TYPE_MEMBER", 1);				// ȿ¦հDNSɽ(ops0505)
define("DNSLS_TYPE_CLERK", 2);				// ̳¦հDNSɽ(ins0109)
define("IF_LINK_GET_NAME", "fn_if");		// ܺپ̤ؤGETѥ᡼̾
define("GET_TYPE_SORT", 0);					// GET󥯺סʥѡ
define("GET_TYPE_INFO", 1);					// GET󥯺סʾѡ
?>

<?php
/**
 * ̾  RegAppDnsList
 *   հDNS̥ӥͥå饹
 */
class RegAppDnsList
{
	//------------------------------------------------------------------------
	// ѿ
	//------------------------------------------------------------------------
	//--- DNSꥹȾ ---//
	var $reg_db;						// DBAPI_IMPLE
	var $m_dns_list_tbl;				// DNSꥹ
	var $m_list_type;					// ꥹȥ(DNSLS_TYPE_MEMBER,DNSLS_TYPE_CLERK)

	//--- HTML ---//
	var $m_pg_link_file;				// ڡ󥰥󥯤ॸ
	var $m_if_link_file;				// ܺپ󥯤ॸ
	var $m_ret_link_file;				// 
	var $m_ret_link_str;				// ʸ
	var $m_err_code_array;				// 顼
	var $m_table_style;					// ơ֥륹

	//--- ڡѾ ---//
	var $m_all_item;					// ƥ
	var $m_cur_page;					// ߥڡ
	var $m_item_num;					// ڡΥƥ
	var $m_disp_item;					// ɽѤHTML٥̾Ϣ
	var $m_disp_able;					// ɽܼ
	var $m_sort_able;					// ȼ̡ʵĤ륽Ⱦ
	var $m_sort_info;					// ȴ_a or _d դǼ
	var $m_sort_def;					// ȥǥեȥƥ
	var $m_sort_col;					// ȹܤ GET value  DB̾Ϣ
	var $m_paging_link;					// ڡѣȣԣͣ
	var $m_sort_link;					// ѣȣԣͣ
	var	$m_ls_colwidth;					// ꥹȣ
	var	$m_page_util;					// ڡ󥰥桼ƥƥ

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppDnsList
	 *   RegAppDnsList饹󥹥ȥ饯
	 * @param  $db				DBAPI_IMPLE(connectѤǤ뤳)
	 * @param  $pg_link_file	ڡ󥰲Υ
	 * @param  $if_link_file	ܺپؤΥ
	 * @param  $ret_link_file	
	 * @param  $ret_link_str	󥯤Σȣԣͣɽʸ
	 * @param  $list_type		ꥹȥ(DNSLS_TYPE_MEMBER, DNSLS_TYPE_CLERK)
	 */
	function RegAppDnsList($db,
						   $pg_link_file, $if_link_file, $ret_link_file, $ret_link_str,
						   $list_type)
	{
		$this->reg_db = $db;

		$this->m_pg_link_file	= $pg_link_file;
		$this->m_if_link_file	= $if_link_file;
		$this->m_ret_link_file	= $ret_link_file;
		$this->m_ret_link_str	= $ret_link_str;
		include("RegAppTableStyle.php");
		$this->m_table_style	= $table_style;

		$this->m_dns_list_tbl	= array();

		$this->m_list_type		= $list_type;
		$this->init_dnsls_info();

		$this->m_err_code_array	= array();
	}

	//------------------------------------------------------------------------
	// ɽ
	//------------------------------------------------------------------------
	/**
	 * ؿ̾init_dnsls_info
	 *   ڡ󥰡Ⱦɽ
	 */
	function init_dnsls_info()
	{
		global $cnf_dns_server_list;

		//-------------------------------------------------------------------
		// ڡ󥰾
		//-------------------------------------------------------------------
		$this->m_all_item		= 0;
		$this->m_cur_page		= 1;
		$this->m_item_num		= $cnf_dns_server_list;
		$this->m_paging_link	= "";
		$this->m_page_util		= null;

		//-------------------------------------------------------------------
		// Ⱦ
		//-------------------------------------------------------------------
		switch ($this->m_list_type)
		{
		//--- ȿ¦հDNSɽ(ops0505) ---//
		case DNSLS_TYPE_MEMBER:
			// ɽ̽
			$this->m_disp_able = array(
						"fv_srt_mem",			// ȿά
						"fv_srt_ip",			// ͥåȥɥ쥹
						"fv_srt_ns",			// ͡ॵ̾
						);

			// ɽܤHTML٥̾Ϣ
			$this->m_disp_item = array(
						"fv_srt_mem"		=>	"ȿά",
						"fv_srt_ip"			=>	"ͥåȥɥ쥹",
						"fv_srt_ns"			=>	"͡ॵ̾",
						);

			// ȼ̡ʵĤ륽Ⱦ˽
			$this->m_sort_able = array(
						"fv_srt_ip",			// ͥåȥɥ쥹
						"fv_srt_ns",			// ͡ॵ̾
						);

			// ȹܤ POST,GET value  DB̾Ϣ
			$this->m_sort_col = array(
						"fv_srt_ip"			=>	"dns.start_sequence_number",
						"fv_srt_ns"			=>	"ns.name_server",
						);

			// ȾΥǥե͡ʥͥåȥɥ쥹
			$this->m_sort_def		= "fv_srt_ip";
			$this->m_sort_info		= $this->m_sort_def . "_a";
			// ȥ
			$this->m_sort_link		= array();

			// ꥹȣ
			$this->m_ls_colwidth	= array(
											"30",			// ȿά
											"30",			// ͥåȥɥ쥹
											"40",			// ͡ॵ̾
											);
			break;

		//--- ̳¦հDNSɽ(ins0109) ---//
		case DNSLS_TYPE_CLERK:
			// ɽ̽
			$this->m_disp_able = array(
						"fv_srt_mem",			// ȿά
						"fv_srt_ip",			// ͥåȥɥ쥹
						"fv_srt_ns",			// ͡ॵ̾
						);

			// ɽܤHTML٥̾Ϣ
			$this->m_disp_item = array(
						"fv_srt_mem"		=>	"ȿά",
						"fv_srt_ip"			=>	"ͥåȥɥ쥹",
						"fv_srt_ns"			=>	"͡ॵ̾",
						);

			// ȼ̡ʵĤ륽Ⱦ˽
			$this->m_sort_able = array(
						"fv_srt_mem",			// ȿά
						"fv_srt_ip",			// ͥåȥɥ쥹
						"fv_srt_ns",			// ͡ॵ̾
						);

			// ȹܤ POST,GET value  DB̾Ϣ
			$this->m_sort_col = array(
						"fv_srt_mem"		=>	"mem.member_short_name",
						"fv_srt_ip"			=>	"dns.start_sequence_number",
						"fv_srt_ns"			=>	"ns.name_server",
						);

			// ȾΥǥե͡ȿάΡ
			$this->m_sort_def		= "fv_srt_mem";
			$this->m_sort_info		= $this->m_sort_def . "_a";

			// ȥ
			$this->m_sort_link		= array();

			// ꥹȣ
			$this->m_ls_colwidth	= array(
											"30",			// ȿά
											"30",			// ͥåȥɥ쥹
											"40",			// ͡ॵ̾
											);
			break;

		//---  ---//
		default:
			$this->m_disp_able	 = array();
			$this->m_disp_item	 = array();
			$this->m_sort_able	 = array();
			$this->m_sort_col	 = array();
			$this->m_sort_def	 = "";
			$this->m_sort_info	 = "";
			$this->m_sort_link	 = array();
			$this->m_ls_colwidth = array();
			break;
		}
	}

	/**
	 * ؿ̾create_dnsls_info()
	 *   ڡ󥰾DNS롣
	 *         RegAppDnsListHtml.php includeɬܽ
	 * @param  mem_short	string		ȿά(ȿʬ * ˤ)
	 * @return TRUEλFALSE顼
	 * @desc   顼ˤ $this->m_err_code_array ˥顼ɤϿ롣
	 *         RegAppDnsListHtml.php include ɬ¹Ԥ뤳ȡ
	 */
	function create_dnsls_info($mem_short)
	{
		//--------------------------------------------------------------------
		// ڡ󥰾
		//--------------------------------------------------------------------
		$this->set_paging_data();							// GETѥ᡼Ͽ
		$this->set_sort_data();								// sort GETѥ᡼Ͽ
		$this->m_all_item = $this->get_dns_count($mem_short);	// 
		if ($this->m_all_item === FALSE)
		{
			return FALSE;
		}

		// Ⱦɲ
		$getarray["fn_sort"] = $this->m_sort_info;

		// ڡ󥰥桼ƥƥ饹(all item, item per page, cur page)
		$this->m_page_util = new RegAppPagingUtil(
									$this->m_all_item,
									(int)($this->m_item_num),
									(int)($this->m_cur_page));

		// ڡѤΣȣԣͣ
		$this->m_paging_link = $this->m_page_util->create_page_link(
												$this->m_pg_link_file,
												$getarray,
												$this->m_table_style);
		// ѤΣȣԣͣ
		$this->m_sort_link	 = $this->create_sort_link();

		//--------------------------------------------------------------------
		// DNS
		//--------------------------------------------------------------------
		$this->m_dns_list_tbl = $this->get_dns_list(
										$mem_short,
										$this->m_item_num,
										$this->m_page_util->m_start_item - 1);
		if ($this->m_dns_list_tbl == FALSE)
		{
			return FALSE;
		}

		return TRUE;
	}


	//-----------------------------------------------------------------------
	// public methods(HTML)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾print_title_table
	 *   IPɥ쥹ΤHTMLơ֥Υȥ(<tr></tr>)HTMLϤ
	 */
	function print_title_table()
	{
		$colnum	= count($this->m_disp_able);	// ܿ
		print ("<tr bgcolor=\"#C0CDFD\">\n");
		//----- ܥȥԽ -----//
		for ($n = 0; $n < $colnum; $n++)
		{
			print ("<td class=\"tdlisttitle\" width=\"" . $this->m_ls_colwidth[$n] ."%\">\n");
			if (in_array($this->m_disp_able[$n], $this->m_sort_able))
			{
				print ("<a href=\"" . $this->m_sort_link[$this->m_disp_able[$n]] . "\">");
			}
			print (htmlspecialchars($this->m_disp_item[$this->m_disp_able[$n]]));
			print ("</a>\n");
			print ("</td>\n");
		}
		print ("</tr>\n");
	}

	/**
	 * ؿ̾print_dnsls_table
	 *   DNSΤHTMLơ֥ι(<tr></tr>)HTMLϤ
	 */
	function print_dnsls_table()
	{
		// ǤƤɬ array ˤʤäƤϤ
		if ($this->m_dns_list_tbl == null || !is_array($this->m_dns_list_tbl))
		{
			return;
		}

		for ($n = 0; $n < count($this->m_dns_list_tbl); $n++)
		{
			print ("<tr>\n");
			print ("<td class=\"tdlistitem\">" .
				   htmlspecialchars($this->m_dns_list_tbl[$n]["member_short_name"]) .
				   "</td>\n");
			print ("<td class=\"tdlistitem\">\n" .
				   "<a href=\"" .
				   $this->create_info_link($this->m_dns_list_tbl[$n]["ip_network_number"]) .
				   "\">" .
				   htmlspecialchars($this->m_dns_list_tbl[$n]["ip_network_number"]) .
				   "</a>\n" .
				   "</td>\n");
			print ("<td class=\"tdlistitem\">" .
				   htmlspecialchars($this->m_dns_list_tbl[$n]["name_server"]) .
				   "</td>\n");
			print ("</tr>\n");
		}
	}

	//-----------------------------------------------------------------------
	// public methods(桼ƥƥ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_err_code_array
	 *   顼롣
	 * @return 顼(RegAppErrorMessage.php )
	 */
	function get_err_code_array()
	{
		return $this->m_err_code_array;
	}

	/**
	 * ؿ̾set_paging_data
	 *   ߥڡֹ(ɽ٤ڡֹ) m_cur_page Ͽ롣
	 *         ڡΥƥ m_item_num Ͽ롣
	 * @desc   GETϤ줿 "fn_cur_page" "fn_item_num" ͤϿ롣
	 *         GETƤʤ 1$cnf_dns_server_list 򤽤줾Ͽ
	 *         롣
	 */
	function set_paging_data()
	{
		if (isset($_GET["fn_cur_page"]))		// jump̿ᤢ
		{
			$this->m_cur_page = urldecode($_GET["fn_cur_page"]);
			// å(ͤǤʤ1ڡܤˤ)
			if (ereg("^[0-9]+$", $this->m_cur_page) == FALSE || $this->m_cur_page < 1)
				$this->m_cur_page = 1;
			else
				$this->m_cur_page = (int)$this->m_cur_page;
		}
		else									// ˥塼Υ
		{
			$this->m_cur_page = 1;
		}

		// ڡƥ
		global $cnf_dns_server_list;
		if (isset($_GET["fn_item_num"]))
		{
			$this->m_item_num = urldecode($_GET["fn_item_num"]);
			// å(ͤǤʤconfͤˤ)
			if (ereg("^[0-9]+$", $this->m_item_num) == FALSE || $this->m_item_num < 1)
				$this->m_item_num = $cnf_dns_server_list;
			else
				$this->m_item_num = (int)$this->m_item_num;
		}
		else
		{
			$this->m_item_num = $cnf_dns_server_list;
		}
	}

	/**
	 * ؿ̾set_sort_data
	 *   Ⱦ m_sort_info Ͽ롣
	 * @desc   GETϤ줿 "fn_sort"
	 *         GETƤʤ $this->m_sort_def . "_a" Ͽ롣
	 */
	function set_sort_data()
	{
		if (isset($_GET["fn_sort"]))
		{
			$sort_lf = trim($_GET["fn_sort"]);
			if (in_array(substr($sort_lf, 0, -2), $this->m_sort_able) == FALSE)
			{
				$sort_lf = $this->m_sort_def . "_a";	// Ĥʤdefault
			}
		}
		else
		{
			$sort_lf = $this->m_sort_def . "_a";		// Ĥʤdefault
		}
		$this->m_sort_info = $sort_lf;
	}

	//-----------------------------------------------------------------------
	// private methods(db select)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_dns_list
	 *   DNS
	 *         MDB_MEMINFO::member_number, MDB_MEMINFO::member_short_name,
	 *         MDB_DNS_NAME_SERVER::ip_network_number,MDB_DNS_NAME_SERVER::name_server
	 * @param  mem_short	string		ȿά(ȿʬ * ˤ)
	 * @param  limit		int									(i)
	 *										(default="")
	 * @param  offset		int				ϥǥå(0)		(i)
	 *										(default="")
	 * @return DNS_LIST_TBL[]	DNS¤Τ
	 *         FALSE			
	 * @desc   Ǥ DNS_LIST_TBL arrayȤʤ롣
	 *         顼ˤ $this->m_err_code_array ˥顼(ʣξ
	 *         礢)Ǽ롣0Ǥ⥨顼Ȥ
	 */
	function get_dns_list($mem_short, $limit="", $offset="")
	{
		$sqlstr  = "SELECT mem.member_number, mem.member_short_name, ns.ip_network_number, ns.name_server";
		$sqlstr .= " FROM mdb_meminfo mem, mdb_dnsinfo dns, mdb_dns_name_server ns";

		//----- ̳ô(ȿns) -----//
		if (strcmp($mem_short, "*") == 0)
		{
			$sqlstr .= " WHERE (mem.member_number = dns.member_number) AND mem.status IN('stop', 'normal', 'deleting') AND (dns.ip_network_number = ns.ip_network_number)";
		}
		//----- ȿ(ȿʲns) -----//
		else
		{
			$mem_short = GetApsString($mem_short);		// from common/db/common_function.php
			if (strcmp($mem_short, "null") == 0)
			{
				array_push($this->m_err_code_array, "D202");	// Ǥʤ顼
				return FALSE;
			}
			$sqlstr .= " WHERE (mem.member_short_name = " . $mem_short . ")";
			$sqlstr .= " AND mem.status IN('stop', 'normal', 'deleting')";
			$sqlstr .= " AND (mem.member_number = dns.member_number) AND (dns.ip_network_number = ns.ip_network_number)";
		}

		// ȶ
		$sqlstr .= $this->create_order_str();

		if ($limit != "" && $offset !== "")
		{
			if ($limit < 0 || $offset < 0)
			{
				array_push($this->m_err_code_array, "D202");		// Ǥʤ顼
				return FALSE;
			}
			$sqlstr .=  " LIMIT " . $limit . " OFFSET " . $offset;
		}

		$dns_ls_tbl = $this->reg_db->dbapi_query($sqlstr);
		if ($dns_ls_tbl === NULL)				// 0
		{
			array_push($this->m_err_code_array, "D205");		// 0泌顼
			return FALSE;
		}
		if ($dns_ls_tbl === FALSE)
		{
			array_push($this->m_err_code_array, "D202");		// Ǥʤ顼
			return FALSE;
		}

		return $dns_ls_tbl;
	}

	/**
	 * ؿ̾get_dns_count
	 *   Ƽ»ȿƤԤäDNSϿ
	 * @param  mem_short	string		ȿά(ȿʬ * ˤ)
	 * @return int			ͥåȥ
	 *         FALSE		ԡ0Ǥ⥨顼Ȥ
	 */
	function get_dns_count($mem_short)
	{
		$sqlstr  = "SELECT count(*) FROM mdb_meminfo mem, mdb_dnsinfo dns, mdb_dns_name_server ns";

		//----- ̳ô(ȿΥͥåȥ) -----//
		if (strcmp($mem_short, "*") == 0)
		{
			$sqlstr .= " WHERE (mem.member_number = dns.member_number) AND mem.status IN('stop', 'normal', 'deleting') AND (dns.ip_network_number = ns.ip_network_number)";
		}
		//----- ȿ(ȿʲΥͥåȥ) -----//
		else
		{
			$mem_short = GetApsString($mem_short);		// from common/db/common_function.php
			if (strcmp($mem_short, "null") == 0)
			{
				array_push($this->m_err_code_array, "D202");	// Ǥʤ顼
				return FALSE;
			}

			$sqlstr .= " WHERE (mem.member_short_name = " . $mem_short . ")";
			$sqlstr .= " AND mem.status IN('stop', 'normal', 'deleting')";
			$sqlstr .= " AND (mem.member_number = dns.member_number) AND (dns.ip_network_number = ns.ip_network_number)";
		}

		$count = $this->reg_db->dbapi_query_count($sqlstr);
		if ($count === FALSE)
		{
			array_push($this->m_err_code_array, "D202");		// Ǥʤ顼
			return FALSE;
		}
		else if ($count == 0)
		{
			array_push($this->m_err_code_array, "D205");		// 0泌顼
			return FALSE;
		}

		return $count;
	}

	/**
	 * ؿ̾create_order_str
	 *   Ⱦ(ORDER BY)
	 * @return string	ORDER BY(" ORDER BY"ޤ)
	 */
	function create_order_str()
	{
		$order_str = "";
		if ($this->m_sort_info !== "")
		{
			// ȡ/߽ڤʬ
			$sortif = array();
			if (ereg("^(fv_srt_[a-z]+)_([a|d])$", $this->m_sort_info, $sortif))
			{
				array_shift($sortif);	// ꥸʥƬǤ
			}
			else
			{	// 곰ϥǥե
				$sortif[0] = $this->m_sort_def;
				$sortif[1] = "a";
			}

			// 硦߽
			if ($sortif[1] == "d")
				$sortif[2] = " DESC";
			else
				$sortif[2] = "";

			// ȿάΤξ fv_srt_mem,fv_srt_ip,fv_srt_ns ν
			if (strcmp($sortif[0], "fv_srt_mem") == 0)
			{
				$order_str = $this->m_sort_col["fv_srt_mem"] . $sortif[2] . "," .
							 $this->m_sort_col["fv_srt_ip"] . $sortif[2] . "," .
							 $this->m_sort_col["fv_srt_ns"] . $sortif[2];
			}
			// ͥåȥɥ쥹ξ fv_srt_ip,fv_srt_ns ν
			else if (strcmp($sortif[0], "fv_srt_ip") == 0)
			{
				$order_str = $this->m_sort_col["fv_srt_ip"] . $sortif[2] . "," .
							 $this->m_sort_col["fv_srt_ns"] . $sortif[2];
			}
			// ͡ॵ̾ξ fv_srt_ns,fv_srt_ip ν
			else if (strcmp($sortif[0], "fv_srt_ns") == 0)
			{
				$order_str = $this->m_sort_col["fv_srt_ns"] . $sortif[2] . "," .
							 $this->m_sort_col["fv_srt_ip"] . $sortif[2];
			}

			if ($order_str !== "")
			{
				$order_str = (" ORDER BY " . $order_str);
			}
		}
		return $order_str;
	}

	//-----------------------------------------------------------------------
	// private methods(HTML)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾create_sort_link
	 *   ڡ󥰾Ȥ߹GET󥯤롣
	 * @return ʸ(Ⱦ)
	 */
	function create_sort_link()
	{
		$sortlink = array();
		$sort_str = "";
		for ($n = 0; $n < count($this->m_sort_able); $n++)
		{
			// ߤΥȴξ /߽ ž(fv_srt_XX_x _x ߾)
			if (strcmp(substr($this->m_sort_info, 0, -2), $this->m_sort_able[$n]) == 0)
			{
				$sort_str = $this->m_sort_able[$n];
				if (substr($this->m_sort_info, -1) == "a")
				{
					$sort_str .= "_d";
				}
				else
				{
					$sort_str .= "_a";
				}
			}
			else
			{
				$sort_str = $this->m_sort_able[$n] . "_a";
			}

			$sortlink[$this->m_sort_able[$n]]
							= $this->create_get_link(
											$this->m_pg_link_file,
											$this->m_page_util,
											$sort_str,
											GET_TYPE_SORT);
		}
		return $sortlink;
	}

	/**
	 * ؿ̾create_info_link
	 *   ڡ󥰾󡢥ȾȤ߹ܺٲ̤ؤGET󥯤롣
	 * @param  $info_str	string				ܺپоʸ					(i)
	 * @return		GETʸ
	 */
	function create_info_link($info_str)
	{
		$infolink = "";
		// ڡ,Ⱦ GETѥ᡼
		$infolink = $this->create_get_link(
								$this->m_if_link_file,
								$this->m_page_util,
								$this->m_sort_info,
								GET_TYPE_INFO);

		// ܺٲɽоݾGETѥ᡼ɲ
		if ($infolink == "")
		{
			$infolink = ($this->m_if_link_file . "?" . IF_LINK_GET_NAME . "=" . urlencode($info_str));
		}
		else
		{
			$infolink .= ("&amp;" . IF_LINK_GET_NAME . "=" . urlencode($info_str));
		}

		return $infolink;
	}

	/**
	 * ؿ̾create_get_link
	 *   ڡ󥰾󡢥ȾȤ߹GET󥯤롣
	 * @param  $link_file	string				ե̾				(i)
	 * @param  $page_util	RegAppPagingUtil	ڡ󥰥桼ƥƥ饹(i)
	 * @param  $sort_lf		string				Ⱦ(fn_sortб)	(i)
	 * @param  $type		int					ѥ᡼				(i)
	 *											GET_TYPE_SORT, GET_TYPE_INFO
	 * @return		GETʸ
	 * @desc		GET_TYPE_SORT ξϸߥڡ򣱤ˤ
	 *				GET_TYPE_INFO ξϸߥڡϿ
	 */
	function create_get_link($link_file, $page_util, $sort_lf, $type=GET_TYPE_SORT)
	{
		//  + ڡ󥰾
		$linkhead = $link_file;
		$linkstr = "";

		if ($page_util != null)		// Ƭ᤹
		{
			switch ($type)
			{
			case GET_TYPE_SORT:
				$linkstr .= "fn_item_num=" . $page_util->m_page_item . "&amp;fn_cur_page=1";
				break;
			case GET_TYPE_INFO:
				$linkstr .= $page_util->create_get_str();
				break;
			default:
				break;
			}
		}

		// Ⱦɲ
		if ($sort_lf !== "")
		{
			if ($linkstr == "")
				$linkstr .= ("fn_sort=" . urlencode(sort_lf));
			else
				$linkstr .= ("&amp;" . "fn_sort=" . urlencode($sort_lf));
		}

		if ($linkstr != "")
		{
			$linkhead = ($linkhead . "?" . $linkstr);
		}
		return $linkhead;
	}
}
?>
