<?php
/**
 * $Id: RegAppDpnListClass.php,v 1.10 2004/02/27 10:04:15 yoshi_s Exp $
 * ()١饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("DBAPI_APPLY.php");
require_once("RegAppInputCheck.php");
require_once("RegAppFormUtil.php");
require_once("RegAppApplyDBUtil.php");
?>
<?php
class RegAppDpnListClass
{
	var $reg_db;				// DBAPI_IMPLE
	var $reg_db_apply;			// DBAPI_APPLY
	var $apply_util;			// applyϢDB桼ƥƥ

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppDpnListClass
	 *   RegAppDpnListClass饹󥹥ȥ饯
	 */
	function RegAppDpnListClass($db)
	{
		$this->reg_db = $db;
		$this->reg_db_apply = new DBAPI_APPLY($this->reg_db);
		$this->apply_util	= new RegAppApplyDBUtil();
	}

	//-----------------------------------------------------------------------
	// public methods(db select)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_app_info
	 *   SDB_APPLY_INFO 鿽롣
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹	(i/o)
	 * @param  error_str	string[]			顼ɳǼ	(i/o)
	 * @param  mem_flg		boolean				mdb_meminfomember_short_name⸡TRUE
	 * @param  mem_number	integer				ȿֹ
	 *											ꥹȥפDPN_TYPE_MEMBERξ
	 *											ɬܡ
	 * @return boolean	TRUEFALSE
	 * @desc   ˤ conf_obj[]->m_disp_var ˳ǡ򥻥åȤ롣
	 *         顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         SDB_APPLY_INFO Ѥ conf_obj ˻ꤹ뤳ȡ
	 *         $conf_obj["fn_app_acceptid"]->m_disp_var 򥭡ˤƸԤ
	 */
	function get_app_info(&$conf_obj, &$error_str, $mem_flg, $mem_number="")
	{
		// Ƭ "fn_app_acceptid" ƳKEY
		$get_key = array_keys(array_slice($conf_obj, 1));
		$select_str = $this->apply_util->create_select_str($get_key, $this->apply_util->fn_app_col_tbl);

		$sqlstr  = "SELECT " . $select_str;
		if ($mem_flg)
		{
			// ȿάΤɽJOINDPN_TYPE_DISCUSS,DPN_TYPE_AUTO
			$sqlstr .= " FROM sdb_apply_info app LEFT JOIN mdb_meminfo mem ON app.member_number = mem.member_number";
		}
		else
		{
			$sqlstr .= " FROM sdb_apply_info app";
		}
		$sqlstr .= " WHERE " . $this->apply_util->fn_app_col_tbl["fn_app_acceptid"] . " = " .
				   $conf_obj["fn_app_acceptid"]->m_disp_var;

		if ($mem_number !== "")
		{
			// ʬФΤΤɽǽDPN_TYPE_MEMBER
			$sqlstr .= " AND app.member_number = " . $mem_number;
		}

		$apply_if_tbl = $this->reg_db->dbapi_query($sqlstr);
		if ($apply_if_tbl === FALSE || $apply_if_tbl === NULL)		// 顼or
		{
			array_push($error_str, "D300");		// Ǥʤ顼
			return FALSE;
		}

		// conf_obj[]->m_disp_var ˳ǡ򥻥åȤ
		for ($n = 0; $n < count($get_key); $n++)
		{
			// substr($this->apply_util->fn_app_col_tbl[$get_key[$n]], 4) >> ̾ΤtableάΤ򥫥å
			// ex) app.apply_kind_id >> apply_kind_id

			$db_col = ltrim(strrchr($this->apply_util->fn_app_col_tbl[$get_key[$n]], "."), ".");
			$db_data = $apply_if_tbl[0][$db_col];
			$conf_obj[$get_key[$n]]->set_disp_var($db_data);
		}

		return TRUE;
	}

	/**
	 * ؿ̾get_app_form_info
	 *   SDB_APPLY_INFO, SDB_FORM_XXXXXXXX 鿽롣
	 * @param  util_cls			string				ƿ桼ƥƥ饹̾(i)
	 *                                              require ѤǤ뤳
	 * @param  form_obj			RegAppFormXXXXXX	ƿ桼ƥƥ饹	(i/o)
	 *                                              ͳǼ
	 * @param  appif_obj		RegAppDispConf[]	Ϣ				(i/o)
	 *                                              "fn_app_acceptid" "fn_app_kindid" ѤǤ뤳
	 * @param  appfm_obj		RegAppDispConf[]	̾󥯥饹Ϣ			(i/o)
	 * @param  extra_if			RegAppExtraConf[]	­󥯥饹Ϣ		(i/o)
	 * @param  allow_stt		string[]			Ĥ뿽ơ(i)
	 * @param  allow_mem_stt	string[]			Ĥȿơ(i)
	 * @param  mem_num								ȿֹ						(i)
	 * @param  reg_db			DBAPI_IMPLE			DBͥȺѤΥ֥		(i)
	 * @param  lock_flg			boolean				åե饰(TRUEå)	(i)
	 * @return 1
	 *         ERR_APPOP_FATAL			fatal 顼
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_SEARCH			񤬸Ĥʤ
	 *         ERR_APPOP_STATUS			Ĥ륹ơˤʤäƤʤʿ
	 *         ERR_APPOP_MEM_STATUS		Ĥ륹ơˤʤäƤʤȿ
	 * @desc   ˤϿ­ appfm_objextra_if˥åȤ롣
	 *         Υ֥Ȥؿ뤿ᡢͽɬפϤʤ
	 *         ޤ$appif_obj["fn_app_last_date"]["fn_app_stt"] ˺ǽ
	 *         ơǼ롣
	 *         ȿֹ椬ꤵ줿硢sdb_apply_info:member_number򸡺
	 *         ղä롣
	 */
	function get_app_form_info($util_cls, &$form_obj, &$appif_obj, &$appfm_obj, &$extra_if,
							   $allow_stt, $allow_mem_stt, $mem_number, $reg_db, $lock_flg)
	{
		if (class_exists($util_cls) == FALSE)
		{
			return ERR_APPOP_FATAL;			// 饹¸ߥå
		}

		$get_app_form_method = "get_app_" . $appif_obj["fn_app_kindid"]->m_disp_var;
		switch ($appif_obj["fn_app_kindid"]->m_disp_var)
		{
		// Ƽ»ȿϿ
		case "opr0102":			// Ƽ»ȿϿ DBAPI_IMPLE ؿ¦Υѥ᡼ˤɬפ
			$form_obj = new $util_cls();
			if (method_exists($form_obj, $get_app_form_method) == FALSE)
			{
				return ERR_APPOP_FATAL;		// ؿ¸ߥå
			}
			$result = $form_obj->$get_app_form_method($reg_db,
													  $appif_obj, $appfm_obj, $extra_if,
													  $allow_stt, $mem_number,
													  $lock_flg);
			break;

		// ­󤢤
		case "ops0101":			// 꿶꿳
			$form_obj = new $util_cls($reg_db);
			if (method_exists($form_obj, $get_app_form_method) == FALSE)
			{
				return ERR_APPOP_FATAL;		// ؿ¸ߥå
			}
			$result = $form_obj->$get_app_form_method($appif_obj, $appfm_obj, $extra_if,
													  $allow_stt, $allow_mem_stt, $mem_number,
													  $lock_flg);
			break;

		// ưϿ
		case "ops0201":
		case "ops0202":
		case "ops0203":
		case "ops0204":
		case "ops0207":
		case "ops0208":
		case "ops0212":
			$form_obj = new $util_cls($reg_db);
			if (method_exists($form_obj, $get_app_form_method) == FALSE)
			{
				return ERR_APPOP_FATAL;		// ؿ¸ߥå
			}
			$result = $form_obj->$get_app_form_method($appif_obj, $appfm_obj, $allow_stt, $mem_number);
			break;

		// ưϳƿ
		case "ops0206":
			$form_obj = new $util_cls($reg_db, $appif_obj["fn_app_kindid"]->m_disp_var);
			if (method_exists($form_obj, $get_app_form_method) == FALSE)
			{
				return ERR_APPOP_FATAL;		// ؿ¸ߥå
			}
			$result = $form_obj->$get_app_form_method($appif_obj, $appfm_obj, $allow_stt, $mem_number);
			break;

		default:
			return ERR_APPOP_FATAL;
		}

		return $result;
	}

	/**
	 * ؿ̾get_app_extra_info
	 *   SDB_APPLY_INFO, SDB_FORM_EXTRA_INFO ­롣
	 * @param  util_cls		string				ƿ桼ƥƥ饹̾(i)
	 *                                          require ѤǤ뤳
	 * @param  form_obj		RegAppFormXXXXXX	ƿ桼ƥƥ饹	(i/o)
	 *                                          ͳǼ
	 * @param  appif_obj	RegAppDispConf[]	Ϣ				(i/o)
	 *                                          "fn_app_acceptid" "fn_app_kindid" ѤǤ뤳
	 * @param  extra_if		RegAppExtraConf[]	­󥯥饹Ϣ		(i/o)
	 * @param  mem_num							ȿֹ						(i)
	 * @param  reg_db		DBAPI_IMPLE			DBͥȺѤΥ֥		(i)
	 * @return 1
	 *         ERR_APPOP_FATAL			fatal 顼
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_SEARCH			񤬸Ĥʤ
	 *         ERR_APPOP_STATUS			Ĥ륹ơˤʤäƤʤ
	 * @desc   ˤ­ extra_if˥åȤ롣
	 *         Υ֥Ȥؿ뤿ᡢͽɬפϤʤ
	 *         ȿֹ椬ꤵ줿硢sdb_apply_info:member_number򸡺
	 *         ղä롣
	 */
	function get_app_extra_info($util_cls, &$form_obj, &$appif_obj, &$extra_if, $mem_number="", $reg_db="")
	{
		if (class_exists($util_cls) == FALSE)
		{
			return ERR_APPOP_FATAL;			// 饹¸ߥå
		}

		$get_app_extra_method = "get_extra_" . $appif_obj["fn_app_kindid"]->m_disp_var;
		switch ($appif_obj["fn_app_kindid"]->m_disp_var)
		{
		// Ƽ»ȿϿ
		case "opr0102":			// Ƽ»ȿϿ DBAPI_IMPLE ؿ¦Υѥ᡼ˤɬפ
			$form_obj = new $util_cls();
			if (method_exists($form_obj, $get_app_extra_method) == FALSE)
			{
				return ERR_APPOP_FATAL;		// ؿ¸ߥå
			}
			$result = $form_obj->$get_app_extra_method($reg_db, $appif_obj, $extra_if, $mem_number);
			break;

		// 꿶ꡢƿ
		case "ops0101":			// 꿶꿳
			$form_obj = new $util_cls($reg_db);
			if (method_exists($form_obj, $get_app_extra_method) == FALSE)
			{
				return ERR_APPOP_FATAL;		// ؿ¸ߥå
			}
			$result = $form_obj->$get_app_extra_method($appif_obj, $extra_if, $mem_number);
			break;

		default:
			return ERR_APPOP_FATAL;
		}

		return $result;
	}

	/**
	 * ؿ̾get_dpn_list
	 *   DPN_CONTENT 鿽ꥹȤ롣
	 * @param  appno		string			ֹ()				(i)
	 * @param  fn_array		string[]		оݤform name				(i)
	 * @param  error_str	string[]		顼ɳǼ				(i/o)
	 * @return DPN_LS_TBL,FALSE		ϳDPNꥹȡԻFALSE
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function get_dpn_list($appno, $fn_array, &$error_str)
	{
		$select_str = $this->apply_util->create_select_str($fn_array, $this->apply_util->m_dpn_col_tbl);

		$sqlstr  = "SELECT " . $select_str . " FROM dpn_content WHERE accept_id = " . $appno;
		$sqlstr .= " ORDER BY id";

		$dpn_ls_tbl = $this->reg_db->dbapi_query($sqlstr);
		if ($dpn_ls_tbl === FALSE || $dpn_ls_tbl === NULL)		// 顼or
		{
			array_push($error_str, "D300");		// Ǥʤ顼
			return FALSE;
		}

		return $dpn_ls_tbl;
	}

	/**
	 * ؿ̾get_dpn_info
	 *   DPN_CONTENT 鿽롣
	 * @param  appno		string				ֹ()	(i)
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹	(i/o)
	 * @param  error_str	string[]			顼ɳǼ	(i/o)
	 * @param  mem_number	integer				ȿֹ				(i)
	 *											ꥹȥפDPN_TYPE_MEMBERξ
	 *											ɬܡ
	 * @return boolean	TRUEFALSE
	 * @desc   ˤ conf_obj[]->m_disp_var ˳ǡ򥻥åȤ롣
	 *         顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         DPN_CONTENT Ѥ conf_obj ˻ꤹ뤳ȡ
	 *         $conf_obj["fn_dpn_id"]->m_disp_var 򥭡ˤƸԤ
	 */
	function get_dpn_info($appno, &$conf_obj, &$error_str, $mem_number="")
	{
		// Ƭ "fn_dpn_id" ƳKEY
		$get_key = array_keys(array_slice($conf_obj, 1));
		$select_str = $this->apply_util->create_select_str($get_key, $this->apply_util->m_dpn_col_tbl);

		$sqlstr = "SELECT " . $select_str . " FROM dpn_content WHERE id = " .
				  $conf_obj["fn_dpn_id"]->m_disp_var . " AND accept_id = ";

		if ($mem_number === "")
		{
			$sqlstr .= $appno;
		}
		else
		{
			// ʬФΤΤɽǽDPN_TYPE_MEMBER
			$sqlstr .= "(SELECT accept_id FROM sdb_apply_info app, mdb_meminfo mem" .
					   " WHERE app.member_number = mem.member_number AND app.accept_id = " .
					   $appno . " AND mem.member_number = " . $mem_number .
					   " AND mem.status = 'normal')";
		}

		$dpn_if_tbl = $this->reg_db->dbapi_query($sqlstr);
		if ($dpn_if_tbl === FALSE || $dpn_if_tbl === NULL)		// 顼or
		{
			array_push($error_str, "D303");		// Ǥʤ顼
			return FALSE;
		}

		// conf_obj[]->m_disp_var ˳ǡ򥻥åȤ
		for ($n = 0; $n < count($get_key); $n++)
		{
			$db_col = $this->apply_util->m_dpn_col_tbl[$get_key[$n]];
			$conf_obj[$get_key[$n]]->set_disp_var($dpn_if_tbl[0][$db_col]);
		}

		return TRUE;
	}

	/**
	 * ؿ̾get_mem_short
	 *   ȿֹ桢ơ˳ȿάΤ롣
	 * @param  mem_number		integer		ȿֹ			(i)
	 * @param  allow_mem_stt	string[]	ȿơ		(i)
	 * @param  mem_short		string		ȿά			(i/o)
	 * @return 1
	 *         ERR_APPOP_FATAL			fatal 顼
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_MEM_STATUS		Ĥ륹ơˤʤäƤʤȿ
	 *         ERR_APPOP_MEM_SEARCH		ȿĤʤ
	 */
	function get_mem_short($mem_number, $allow_mem_stt, &$mem_short)
	{
		if (!is_array($allow_mem_stt))
		{
			return ERR_APPOP_FATAL;
		}

		// ȿάΡơ
		$sqlstr	= "SELECT member_short_name, status FROM mdb_meminfo" .
				   " WHERE member_number = " . $mem_number;
		$result	= $this->reg_db->dbapi_query($sqlstr);
		if ($result === FALSE)
		{
			return ERR_APPOP_DB_ACCESS;		// DB顼
		}
		if ($result === NULL)
		{
			return ERR_APPOP_MEM_SEARCH;	// ȿĤʤ
		}

		// ȿơå
		if (in_array($result[0]["status"], $allow_mem_stt) == FALSE)
		{
			return ERR_APPOP_MEM_STATUS;
		}

		$mem_short = $result[0]["member_short_name"];
		return 1;
	}

	//-----------------------------------------------------------------------
	// public methods(form check)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_dpn_appno_syntax
	 *   оݤοֹ楷󥿥åԤ
	 *         rcv_flg = TRUE ((RCV-)[5-8])
	 *         rcv_flg = FALSE[1-8]
	 * @param  appno		string		ֹ(RCV-դ)				(i)
	 * @param  number		string		ֹ(RCV-̵)				(i/o)
	 * @param  error_str	string[]	顼ɳǼ				(i/o)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         appnoƬ"RCV-"ʤ 0(顼) ֤
	 *         åOKξ $app_number  "RCV-" ͤǼ
	 */
	function chk_dpn_appno_syntax($appno, &$app_number, &$error_str)
	{
		if ($appno == "")
		{
			array_push($error_str, "D300");						// ԥ顼
			return FALSE;
		}

		if (chk_apply_no($appno, $app_number, TRUE) !== REG_APP_INPUT_CHK_OK)
		{
			array_push($error_str, "D300");						// ԥ顼
			return FALSE;
		}

		return TRUE;
	}

	/**
	 * ؿ̾chk_dpnls_syntax
	 *   DPN CONTENTɽѤPOSTǡ󥿥åԤ
	 * @param  dpnls_conf	RegAppDispConf[]	DPNPOSTǡ			(i)
	 * @param  dpn_conf		RegAppDispConf[]	DPN CONTENTɽ̾	(i/o)
	 * @param  error_str	string[]			顼ɳǼ			(i/o)
	 * @return åOKTRUEåNGFALSE
	 * @desc   åOKˤ dpn_conf["fn_dpn_id"] DPN IDǼ
	 */
	function chk_dpnls_syntax($dpnls_conf, &$dpn_conf, &$error_str)
	{
		// ɬܥåʿֹ桢DPN ID
		if ($dpnls_conf["fn_app_acceptid"]->m_disp_var == "" || $dpnls_conf["fn_dpn_id"]->m_disp_var == "")
		{
			array_push($error_str, "D303");						// ԥ顼
			return FALSE;
		}

		$app_number = "";			// RCV- 꿽ֹ
		// ֹ楷󥿥å RCV- 꿽ֹ 
		if (chk_apply_no($dpnls_conf["fn_app_acceptid"]->m_disp_var, $app_number, FALSE) !== REG_APP_INPUT_CHK_OK)
		{
			array_push($error_str, "D303");						// ԥ顼
			return FALSE;
		}

		// DPN ID󥿥å
		// ͤǣʾʣͭꤨʤ
		if (ereg("^[0-9]+$", $dpnls_conf["fn_dpn_id"]->m_disp_var) == FALSE || $dpnls_conf["fn_dpn_id"]->m_disp_var < 1)
		{
			array_push($error_str, "D303");						// ԥ顼
			return FALSE;
		}

		// $dpn_conf,dpnls_conf ͤ򥻥åȤƽλ
		$dpn_conf["fn_dpn_id"]->set_disp_var((int)($dpnls_conf["fn_dpn_id"]->m_disp_var));

		return TRUE;
	}

	/**
	 * ؿ̾chk_appop_syntax
	 *   ƿѤPOSTǡ󥿥åԤ
	 * @param  appif_conf	RegAppDispConf[]	DPNPOSTǡ			(i)
	 * @param  chk_array	string[]			POSTǡå륭	(i)
	 * @param  kind_allow	string[]			ɽĤ뿽		(i)
	 * @param  error_str	string[]			顼ɳǼ			(i/o)
	 * @return åOKTRUEåNGFALSE
	 * @desc   "fn_app_acceptid", "fn_app_kindid", "fn_app_last_date", "fn_app_memnum"
	 *         Ͽͤåfn_app_memnum  opr0102 ʳξΤߡ
	 */
	function chk_appop_syntax(&$appif_conf, $chk_array, $kind_allow, &$error_str)
	{
		// ֹå
		if (in_array("fn_app_acceptid", $chk_array))
		{
			if ($appif_conf["fn_app_acceptid"]->m_disp_var == "")
			{
				array_push($error_str, "D300");						// ԥ顼
				return FALSE;
			}
			$app_number = "";			// RCV- 꿽ֹ
			// ֹ楷󥿥å RCV- 꿽ֹ 
			if (chk_apply_no($appif_conf["fn_app_acceptid"]->m_disp_var, $app_number, FALSE) !== REG_APP_INPUT_CHK_OK)
			{
				array_push($error_str, "D300");						// ԥ顼
				return FALSE;
			}
		}

		// ̥å
		if (in_array("fn_app_kindid", $chk_array))
		{
			if ($appif_conf["fn_app_kindid"]->m_disp_var == "" || !is_array($kind_allow))
			{
				array_push($error_str, "D300");						// ԥ顼
				return FALSE;
			}
			if (in_array($appif_conf["fn_app_kindid"]->m_disp_var, $kind_allow) == FALSE)
			{
				array_push($error_str, "D300");						// ԥ顼
				return FALSE;
			}
		}

		// ǽå
		if (in_array("fn_app_last_date", $chk_array))
		{
			if ($appif_conf["fn_app_last_date"]->m_disp_var == "")
			{
				array_push($error_str, "D300");						// ԥ顼
				return FALSE;
			}
			// ǽå
			if (chk_date_for_db($appif_conf["fn_app_last_date"]->m_disp_var) !== REG_APP_INPUT_CHK_OK)
			{
				array_push($error_str, "D300");						// ԥ顼
				return FALSE;
			}
		}

		// ȿֹåʳƼ»ȿϿʳϥåɬפ
		if (in_array("fn_app_memnum", $chk_array) && $appif_conf["fn_app_kindid"]->m_disp_var != "opr0102")
		{
			if ($appif_conf["fn_app_memnum"]->m_disp_var == "")
			{
				array_push($error_str, "D300");						// ԥ顼
				return FALSE;
			}
			// ȿֹå
			if (ereg("^[0-9]+$", $appif_conf["fn_app_memnum"]->m_disp_var) == FALSE)
			{
				array_push($error_str, "D300");						// ԥ顼
				return FALSE;
			}
		}

		return TRUE;
	}

	/**
	 * ؿ̾chk_app_form_in_data
	 *   եѹϲ̤POSTǡå̾˳Ǽ롣
	 * @param  util_cls		string				ƿ桼ƥƥ饹̾(i)
	 *                                          require ѤǤ뤳
	 * @param  form_obj		RegAppFormXXXXXX	ƿ桼ƥƥ饹	(i/o)
	 *                                          ͳǼ
	 * @param  appif_obj	RegAppDispConf[]	Ϣ				(i/o)
	 *                      "fn_app_acceptid" "fn_app_kindid" "fn_app_memnum"ѤǤ뤳
	 * @param  appfm_obj	RegAppDispConf[]	̾󥯥饹Ϣ			(i/o)
	 * @param  reg_db		DBAPI_IMPLE			DBͥȺѤΥ֥		(i)
	 * @return 1
	 *         ERR_APPOP_FATAL			fatal 顼
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_IN_SYNTAX		ϥǡ󥿥顼
	 *         ERR_APPOP_IN_SEMANTICS	ϥǡޥƥ顼
	 * @desc   ˤϿ appfm_obj ˥åȤ롣
	 *         ؿ뤿ᡢͽɬפϤʤ
	 */
	function chk_app_form_in_data($util_cls, &$form_obj, &$appif_obj, &$appfm_obj, &$error_str, $reg_db="")
	{
		if (class_exists($util_cls) == FALSE)
		{
			return ERR_APPOP_FATAL;			// 饹¸ߥå
		}

		switch ($appif_obj["fn_app_kindid"]->m_disp_var)
		{
		//----- Ƽ»ȿϿ -----//
		case "opr0102":
			$result = $this->chk_app_form_in_opr0102($util_cls, $form_obj,
													 $appif_obj, $appfm_obj,
													 $error_str,
													 $reg_db);
			break;
		//----- ¾ͭʤ -----//
		default:
			return ERR_APPOP_FATAL;
		}

		return $result;
	}

	/**
	 * ؿ̾chk_app_form_hidden_data
	 *   եѹϲ̤HIDDENǡå̾˳Ǽ롣
	 * @param  util_cls		string				ƿ桼ƥƥ饹̾(i)
	 *                                          require ѤǤ뤳
	 * @param  form_obj		RegAppFormXXXXXX	ƿ桼ƥƥ饹	(i/o)
	 *                                          ͳǼ
	 * @param  appif_obj	RegAppDispConf[]	Ϣ				(i/o)
	 *                      "fn_app_acceptid" "fn_app_kindid" "fn_app_memnum"ѤǤ뤳
	 * @param  appfm_obj	RegAppDispConf[]	̾󥯥饹Ϣ			(i/o)
	 * @param  reg_db		DBAPI_IMPLE			DBͥȺѤΥ֥		(i)
	 * @return 1
	 *         ERR_APPOP_FATAL			fatal 顼
	 *         ERR_APPOP_HIDDEN_SYNTAX	HIDDENǡ󥿥顼
	 * @desc   ˤϿ appfm_obj ˥åȤ롣
	 *         ؿ뤿ᡢͽɬפϤʤ
	 */
	function chk_app_form_hidden_data($util_cls, &$form_obj, &$appif_obj, &$appfm_obj, $reg_db="")
	{
		if (class_exists($util_cls) == FALSE)
		{
			return ERR_APPOP_FATAL;			// 饹¸ߥå
		}

		switch ($appif_obj["fn_app_kindid"]->m_disp_var)
		{
		//----- Ƽ»ȿϿ -----//
		case "opr0102":
			$result = $this->chk_app_form_hidden_opr0102($util_cls,
														 $form_obj,
														 $appfm_obj);
			break;

		//----- 꿶꿳Ŀ -----//
		case "ops0101":
			$result = $this->chk_app_form_hidden_ops0101($util_cls,
														 $form_obj,
														 $appfm_obj,
														 $reg_db);
			break;
		//----- ¾ͭʤ -----//
		default:
			return ERR_APPOP_FATAL;
		}

		return $result;
	}

	//-----------------------------------------------------------------------
	// public methods(html)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾conv_appls_for_html
	 *   RegAppDispConfΤ̤˴ؤHTML
	 *         ѹ롣
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹	(i/o)
	 * @desc   ["fn_item_num"]	ڡΥƥ	ʥڡѡ
	 *         ["fn_cur_page"]	ߥڡ			ʥڡѡ
	 *         ["fn_appno"]		ֹ				ʸѡ
	 *         ["fn_fy"]		FROMǯ				ʸѡ
	 *         ["fn_fm"]		FROM				ʸѡ
	 *         ["fn_fd"]		FROM				ʸѡ
	 *         ["fn_ty"]		TO  ǯ				ʸѡ
	 *         ["fn_tm"]		TO  				ʸѡ
	 *         ["fn_td"]		TO  				ʸѡ
	 *         ["fn_mem"]		ȿά				ʸѡ
	 *         ["fn_clerk"]		̳ô			ʸѡ
	 *         ["fn_type"]						ʸѡ
	 *         ["fn_stt"]		ơ			ʸѡ
	 *         ["fn_sort"]		Ⱦ			ʥѡ
	 * @desc   ̤θڡ󥰾󡢥Ⱦꤷ
	 *         RegAppDispConf[]ꤹ뤳
	 */
	function conv_appls_for_html(&$conf_obj)
	{
		$conf_obj["fn_item_num"]->conv_value_htmlstr();
		$conf_obj["fn_cur_page"]->conv_value_htmlstr();
		$conf_obj["fn_appno"]->conv_value_htmlstr();
		$conf_obj["fn_fy"]->conv_value_htmlstr();
		$conf_obj["fn_fm"]->conv_value_htmlstr();
		$conf_obj["fn_fd"]->conv_value_htmlstr();
		$conf_obj["fn_ty"]->conv_value_htmlstr();
		$conf_obj["fn_tm"]->conv_value_htmlstr();
		$conf_obj["fn_td"]->conv_value_htmlstr();
		$conf_obj["fn_mem"]->conv_value_htmlstr();
		$conf_obj["fn_clerk"]->conv_value_htmlstr();
		$conf_obj["fn_type"]->conv_value_htmlstr();
		$conf_obj["fn_stt"]->conv_value_htmlstr();
		$conf_obj["fn_sort"]->conv_value_htmlstr();
	}

	/**
	 * ؿ̾create_appls_hidden_tag
	 *   ̤θڡ󥰾󡢥ȾȤ߹HIDDEN롣
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹		(i)
	 * @param  pg_name		string				"fn_page_name"  value	(i)
	 * @return HIDDEN
	 * @desc   ̤θڡ󥰾󡢥Ⱦꤷ
	 *         RegAppDispConf[]ꤹ뤳
	 *         m_disp_var  htmlspecialchars¹Ԥޤ
	 */
	function create_appls_hidden_tag($conf_obj, $pg_name="")
	{
		$disp_key	 = array_keys($conf_obj);
		foreach ($conf_obj as $key => $value)
		{
			$conf_obj[$key]->conv_value_htmlstr();
		}
		return RegAppFormUtil::create_hidden_tag($conf_obj, $disp_key, $pg_name);
	}

	/**
	 * ؿ̾create_appls_get_link
	 *   ̤ѤGET LINK롣
	 *         ڡ󥰾󡢥ȾȤ߹GET LINK
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹		(i)
	 * @param  link_file	string				̥ץ̾	(i)
	 * @return GET LINK
	 * @desc   ̤θڡ󥰾󡢥Ⱦꤷ
	 *         RegAppDispConf[]ꤹ뤳
	 *         valueͤؤ urlencode ԤhtmlspecialcharsѤξꤹ뤳ȡ
	 */
	function create_appls_get_link($conf_obj, $link_file)
	{
		$disp_key	 = array_keys($conf_obj);
		return RegAppFormUtil::create_get_link($conf_obj, $disp_key, $link_file);
	}

	//-----------------------------------------------------------------------
	// private methods(form check)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_app_form_in_opr0102
	 *   եѹϲ̤POSTǡ(opr0102)å̾˳Ǽ롣
	 * @param  util_cls		string				ƿ桼ƥƥ饹̾(i)
	 *                                          require ѤǤ뤳
	 * @param  form_obj		RegAppFormXXXXXX	ƿ桼ƥƥ饹	(i/o)
	 *                                          ͳǼ
	 * @param  appif_obj	RegAppDispConf[]	Ϣ				(i/o)
	 *                      "fn_app_acceptid" "fn_app_kindid" "fn_app_memnum"ѤǤ뤳
	 * @param  appfm_obj	RegAppDispConf[]	̾󥯥饹Ϣ			(i/o)
	 * @param  reg_db		DBAPI_IMPLE			DBͥȺѤΥ֥		(i)
	 * @return 1
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_IN_SYNTAX		ϥǡ󥿥顼
	 *         ERR_APPOP_IN_SEMANTICS	ϥǡޥƥ顼
	 * @desc   ˤϿ appfm_obj ˥åȤ롣
	 *         ؿ뤿ᡢͽɬפϤʤ
	 */
	function chk_app_form_in_opr0102($util_cls, &$form_obj, &$appif_obj, &$appfm_obj, &$error_str, $reg_db)
	{
		//-------------------------------------------------------------------
		// ̾
		//-------------------------------------------------------------------
		$form_obj	= new $util_cls();		// 桼ƥƥ饹
		$parts_keys	= array(				// 륭
				"fn_mem_op_short",
				"fn_mem_op_orgjp", "fn_mem_op_orgen",
				"fn_mem_op_postal", "fn_mem_op_addjp", "fn_mem_op_adden",
				"fn_mem_op_tel", "fn_mem_op_fax", "fn_mem_op_mail",
				"fn_mem_in_person", "fn_mem_in_mail",
				"fn_mem_in_postal", "fn_mem_in_addjp", "fn_mem_in_adden",
				"fn_mem_in_tel", "fn_mem_in_fax", "fn_mem_in_notice",
				);
		$appfm_obj	= $form_obj->create_conf_obj($parts_keys);		// ̾ RegAppDispConf 
		RegAppFormUtil::set_post_vars($appfm_obj, $parts_keys);		// POSTǡå

		//-------------------------------------------------------------------
		// ϥǡ󥿥å
		//-------------------------------------------------------------------
		if ($form_obj->chk_mem_in_syntax($appfm_obj, $parts_keys, $error_str) == FALSE)
		{
			return ERR_APPOP_IN_SYNTAX;		// 󥿥å顼
		}

		//-------------------------------------------------------------------
		// ϥǡޥƥå(άΤʣƤʤ)
		//-------------------------------------------------------------------
		$result = $form_obj->chk_memshort_semantics($reg_db,
													$appfm_obj["fn_mem_op_short"],
													$error_str,
													TRUE,
													$appif_obj["fn_app_acceptid"]->m_disp_var);
		switch ($result)
		{
		case 1:									// åOK
			break;
		case ERR_APPOP_MEM_ACTIVES:				// άνʣ
			return ERR_APPOP_IN_SEMANTICS;
		case ERR_APPOP_DB_ACCESS:				// DB顼
		default:
			return ERR_APPOP_DB_ACCESS;
		
		}

		return 1;
	}

	/**
	 * ؿ̾chk_app_form_hidden_opr0102
	 *   եѹϲ̤POSTǡ(opr0102)å̾˳Ǽ롣
	 * @param  util_cls		string				ƿ桼ƥƥ饹̾(i)
	 *                                          require ѤǤ뤳
	 * @param  form_obj		RegAppFormXXXXXX	ƿ桼ƥƥ饹	(i/o)
	 *                                          ͳǼ
	 * @param  appfm_obj	RegAppDispConf[]	̾󥯥饹Ϣ			(i/o)
	 * @return 1
	 *         ERR_APPOP_HIDDEN_SYNTAX	HIDDENǡ󥿥顼
	 * @desc   ˤϿ appfm_obj ˥åȤ롣
	 *         ؿ뤿ᡢͽɬפϤʤ
	 */
	function chk_app_form_hidden_opr0102($util_cls, &$form_obj, &$appfm_obj)
	{
		//-------------------------------------------------------------------
		// ̾
		//-------------------------------------------------------------------
		$form_obj	= new $util_cls();		// 桼ƥƥ饹
		$parts_keys	= array(				// 륭
				"fn_mem_op_short",
				"fn_mem_op_orgjp", "fn_mem_op_orgen",
				"fn_mem_op_postal", "fn_mem_op_addjp", "fn_mem_op_adden",
				"fn_mem_op_tel", "fn_mem_op_fax", "fn_mem_op_mail",
				"fn_mem_in_person", "fn_mem_in_mail",
				"fn_mem_in_postal", "fn_mem_in_addjp", "fn_mem_in_adden",
				"fn_mem_in_tel", "fn_mem_in_fax", "fn_mem_in_notice",
				);
		$appfm_obj	= $form_obj->create_conf_obj($parts_keys);		// ̾ RegAppDispConf 
		RegAppFormUtil::set_post_vars($appfm_obj, $parts_keys);		// POSTǡå

		//-------------------------------------------------------------------
		// HIDDENǡ󥿥å
		//-------------------------------------------------------------------
		if ($form_obj->chk_mem_hidden_syntax($appfm_obj, $parts_keys) == FALSE)
		{
			return ERR_APPOP_HIDDEN_SYNTAX;		// 󥿥å顼
		}

		return 1;
	}

	/**
	 * ؿ̾chk_app_form_hidden_ops0101
	 *   եѹϲ̤POSTǡ(ops0101)å̾˳Ǽ롣
	 * @param  util_cls		string				ƿ桼ƥƥ饹̾(i)
	 *                                          require ѤǤ뤳
	 * @param  form_obj		RegAppFormXXXXXX	ƿ桼ƥƥ饹	(i/o)
	 *                                          ͳǼ
	 * @param  appfm_obj	RegAppDispConf[]	̾󥯥饹Ϣ			(i/o)
	 * @param  reg_db		DBAPI_IMPLE			DBͥȺѤΥ֥		(i)
	 * @return 1
	 *         ERR_APPOP_HIDDEN_SYNTAX	HIDDENǡ󥿥顼
	 * @desc   ˤϿ appfm_obj ˥åȤ롣
	 *         ؿ뤿ᡢͽɬפϤʤ
	 */
	function chk_app_form_hidden_ops0101($util_cls, &$form_obj, &$appfm_obj, $reg_db)
	{
		//-------------------------------------------------------------------
		// ̾
		//-------------------------------------------------------------------
		$form_obj	= new $util_cls($reg_db);		// 桼ƥƥ饹
		$parts_keys	= array(						// 륭
			"fn_mem_op_short",
			"fn_mem_op_orgjp", "fn_mem_op_orgen",
			"fn_mem_op_postal", "fn_mem_op_addjp", "fn_mem_op_adden",
			"fn_mem_op_tel", "fn_mem_op_fax", "fn_mem_op_mail",
			"fn_mem_in_person", "fn_mem_in_mail",
			"fn_mem_in_postal", "fn_mem_in_addjp", "fn_mem_in_adden",
			"fn_mem_in_tel", "fn_mem_in_fax", "fn_mem_in_notice",
		);
		$appfm_obj	= $form_obj->create_conf_obj($parts_keys);		// ̾ RegAppDispConf 
		array_shift($parts_keys);									// mem_op_short
		RegAppFormUtil::set_post_vars($appfm_obj, $parts_keys);		// POSTǡå

		//-------------------------------------------------------------------
		// HIDDENǡ󥿥å
		//-------------------------------------------------------------------
		if ($form_obj->chk_mem_hidden_syntax($appfm_obj, $parts_keys) == FALSE)
		{
			return ERR_APPOP_HIDDEN_SYNTAX;		// 󥿥å顼
		}

		return 1;
	}
}
?>
