<?php
/**
 * $Id: RegAppFormNetAllocAuto.php,v 1.20 2004/03/10 09:13:10 wtetsuya Exp $
 * IPɥ쥹(ops0206)Υ桼ƥƥ饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("DBAPI_OPS0206.php");			// SDB_FORM_OPS0206 DBAPI
require_once("DBAPI_DPN.php");				// DPN_CONTENT DBAPI
require_once("DBAPI_REPORT.php");			// RDB DBAPI
require_once("RegAppFormNet.php");			// ͥåȥϢ̾󥯥饹
require_once("RegAppFormOp.php");			// 桼ƥƥ饹
require("config/RegCnfCommon.php");			// ե
require_once("RegAppFormSendMail.php");
require_once("RegAppReportData.php");
?>
<?php
//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegAppFormNetAllocAuto extends RegAppFormNet
{
	/**
	 * DBAPI_IMPLE
	 */
	var $reg_db;

	/**
	 * applyϢDB桼ƥƥ
	 */
	var $apply_util;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppFormNetAllocAuto
	 *   RegAppFormNetAllocAuto饹󥹥ȥ饯
	 * @param  db			DBAPI_IMPLE
	 * @param  kind_id		
	 */
	function RegAppFormNetAllocAuto($db, $kind_id)
	{
		parent::RegAppFormNet($kind_id);
		$this->reg_db		= $db;
		$this->apply_util	= new RegAppApplyDBUtil();
	}

	/**
	 * ؿ̾get_label_info
	 *   եϲ̤ιܲʸ
	 * @param  for_html		boolean		TRUE:htmlspecialcharsѤΥǡ	(i)
	 * @return form name => ʸ Ϣ
	 */
	function get_label_info($for_html=TRUE)
	{
		$label_info = array(
			"fn_net_ip_address"	=>	"ƤԤIPͥåȥɥ쥹Ⱦѡ",
			"fn_net_name"		=>	"ͥåȥ̾Ⱦѱѿʸ",
			"fn_net_orgjp"		=>	"Ƥȿ̾",
			"fn_net_orgen"		=>	"Ƥȿ̾ʱѸɽȾѡ",
			"fn_net_mail"		=>	"ƤȿŻҥ᡼륢ɥ쥹Ⱦѡ",
			"fn_net_postal"		=>	"Ƥȿνϡ͹ֹ桧Ⱦѡ",
			"fn_net_addjp"		=>	"Ƥȿν",
			"fn_net_adden"		=>	"ƤȿνϡʱѸɽȾѡ",
			"fn_net_tec_handle"	=>	"ƤȿαǤ/ϢôԡNICϥɥ롧Ⱦѱѿʸ",
		);

		// htmlspecialchars
		if ($for_html)
			$label_info = RegAppFormUtil::conv_array_value_html($label_info);

		return $label_info;
	}

	//-----------------------------------------------------------------------
	// public methods(DB)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾send_app_net_alloc_auto
	 *   IPɥ쥹Ф
	 *         SDB_APPLY_INFO, SDB_FORM_OPS0206, DPN_CONTENT, MDB_IPNETINFO, MDB_IPNET_UPDATE_HISTORY
	 *         򹹿롣
	 * @param  mem_num							ȿֹ				(i)
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹Ϣ		(i)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return ϿRegAppCreateAppAcc
	 *         ERR_APPOP_FATAL				fattal顼
	 *         ERR_APPOP_DB_ACCESS			DB顼
	 *         ERR_APPOP_NET_UNDER_CIDR		꿶֥å۲ˤʤ
	 *         ERR_APPOP_NET_STATUS			NETWORKȽʣƤ
	 *         ERR_APPOP_NET_APP_STATUS		꿶꿳ĿȽʣƤ
	 *         ERR_APPOP_MEM_SEARCH			ȿĤʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function send_app_net_alloc_auto($mem_num, $conf_obj, &$error_str)
	{
		$reg_db_dpn		= new DBAPI_DPN($this->reg_db);			// DBAPI_DPN object
		$reg_db_net		= new DBAPI_IPNET($this->reg_db);		// DBAPI_IPNET object
		$reg_db_rpt 	= new DBAPI_REPORT($this->reg_db);		// DBAPI_REPORT object

		//-------------------------------------------------------------------
		// INFRA/USER ̤ξ
		//-------------------------------------------------------------------
		if (strcmp($this->m_kind_id, "ops0206") == 0)
		{
			$reg_db_form	= new DBAPI_OPS0206($this->reg_db);
			$form_func		= "create_apply_form_ops0206";
			// SDB_FORM_OPS0206 Ͽǡ
			$ops_form_tbl	= new SDB_FORM_OPS0206(
					"",
					array($conf_obj["fn_net_ip_address"]->m_disp_var),		// DB array ˤʤäƤ
					$conf_obj["fn_net_name"]->m_disp_var,
					$conf_obj["fn_net_orgjp"]->m_disp_var,
					$conf_obj["fn_net_orgen"]->m_disp_var,
					$conf_obj["fn_net_mail"]->m_disp_var,
					$conf_obj["fn_net_postal"]->m_disp_var,
					$conf_obj["fn_net_addjp"]->m_disp_var,
					$conf_obj["fn_net_adden"]->m_disp_var,
					$conf_obj["fn_net_tec_handle"]->m_disp_var
				);
		}
		else
		{
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_FATAL;
		}

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽǡ
		//-------------------------------------------------------------------
		// SDB_FORM_OPS0206Ͽ륭
		$conf_dpn_keys = array(
				"fn_net_ip_address",
				"fn_net_name",
				"fn_net_orgjp",
				"fn_net_orgen",
				"fn_net_mail",
				"fn_net_postal",
				"fn_net_addjp",
				"fn_net_adden",
				"fn_net_tec_handle",
		);

		// dpn_content ʸǡ(for create_dpn_data_accept_discuss)
		$content_conf_obj = new RegAppDispConfData($conf_dpn_keys, $conf_obj);

		//-------------------------------------------------------------------
		// ޥƥå
		//-------------------------------------------------------------------
		// ϡλֹ
		$add_info = RegIpv6AddressUtil::get_sequence_num(
											$conf_obj["fn_net_ip_address"]->m_disp_var);
		// å
		$add_info	= new RegNetAddressInfo($add_info[0], $add_info[1], "");

		// Ͽֺ
		$app_date = RegAppDateUtil::make_current_date_db();
		//-------------------------------------------------------------------
		// DBȥ󥶥󳫻ϡå
		//-------------------------------------------------------------------
		// ȥ󥶥󳫻
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// MEMBER åơå᡼륢ɥ쥹
		//-------------------------------------------------------------------
		$sql_str  = "SELECT applicant_mail_address FROM mdb_meminfo WHERE" .
					" member_number = " . $mem_num . " AND" .
					" status = 'normal'" . 
					" FOR UPDATE";
		$db_result = $this->reg_db->dbapi_query_lock($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			return ERR_APPOP_MEM_SEARCH;
		}
		// ᡼륢ɥ쥹Ͽ
		$mem_in_mail = $db_result[0]["applicant_mail_address"];

		//-------------------------------------------------------------------
		// IPɥ쥹 ޥƥåʳ꿶֥å
		//-------------------------------------------------------------------
		$chk_result	= parent::chk_net_ipaddress_semantics(
													$mem_num,
													$conf_obj["fn_net_ip_address"],
													$add_info,
													$error_str,
													TRUE);
		if ($chk_result !== 1)
		{
			$this->reg_db->REGDB_rollback();
			return $chk_result;
		}

		//-------------------------------------------------------------------
		// MDB_IPNETINFO Ͽǡ
		//-------------------------------------------------------------------
		// ɲѹ¤κ
		$mdb_net_tbl = new MDB_IPNETINFO(
				$conf_obj["fn_net_ip_address"]->m_disp_var,
				$conf_obj["fn_net_name"]->m_disp_var,
				$add_info->m_cidr_block,
				$conf_obj["fn_net_orgjp"]->m_disp_var,
				$conf_obj["fn_net_orgen"]->m_disp_var,
				$conf_obj["fn_net_postal"]->m_disp_var,
				$conf_obj["fn_net_addjp"]->m_disp_var,
				$conf_obj["fn_net_adden"]->m_disp_var,
				$conf_obj["fn_net_tec_handle"]->m_disp_var,
				$conf_obj["fn_net_mail"]->m_disp_var,
				$app_date,
				$app_date,
				""
		);

		//-------------------------------------------------------------------
		// SDB_APPLY_INFO, SDB_FORM_OPS0206 Ͽ
		//-------------------------------------------------------------------
		$sdb_appinfo_tbl = new SDB_APPLY_INFO(
							"", $app_date, "", "", $mem_num, "", "",
							$mem_in_mail, $app_date, "", "", $app_date);

		// DBAPI_OPS0206 object
		$apply_no = $reg_db_form->$form_func($sdb_appinfo_tbl, $ops_form_tbl);
		if ($apply_no === FALSE || $apply_no == 0)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽ
		//-------------------------------------------------------------------
		$dpn_content_tbl = $this->apply_util->create_dpn_data_accept_auto(
										$apply_no,
										"MEM",
										$mem_in_mail,
										$app_date,
										$this->m_kind_id,
										$content_conf_obj);
		$result = $reg_db_dpn->dpn_create_content($dpn_content_tbl);
		if ($result === FALSE || $result == 0)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// MDB_IPNETINFO/MDB_MEM_UPDATE_HISTORY 
		//-------------------------------------------------------------------
		$mdb_update_tbl = new MDB_UPDATE_INFO(
							$mem_in_mail,
							$app_date,
							sprintf("RCV-%08d", $apply_no),
							$this->m_kind_id);

		$result = $reg_db_net->create_ipnet_info(
									$mdb_net_tbl, $mdb_update_tbl);
		if ($result === FALSE || $result == 0)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// APNICѾϿ
		//-------------------------------------------------------------------
		include("config/RegCnfCommon.php");
		$report_info = new REPORT_INFO(
			"",                                                 // report_id
			$apply_no,                                          // accept_id
			$cnf_report_to,                                     // report_to    (config)
			"assigned",                                         // report_type
			$conf_obj["fn_net_ip_address"]->m_disp_var,         // inet6num
			$conf_obj["fn_net_name"]->m_disp_var,               // natname
			$cnf_report_country,                                // country      (config)
			$conf_obj["fn_net_orgen"]->m_disp_var,              // descr
			$conf_obj["fn_net_tec_handle"]->m_disp_var,         // admin_c
			$conf_obj["fn_net_tec_handle"]->m_disp_var,         // tech_c
			array(),                                            // rev_srv
			$cnf_report_status,                                 // status       (config)
			array(),                                            // remarks
			$conf_obj["fn_net_mail"]->m_disp_var,               // notify
			$cnf_report_mnt_by,                                 // mnt_by
			array(),                                            // mnt_lower
			array(),                                            // mnt_irt
			array($cnf_report_changed_email." ".date("Ymd")),   // changed      (config)
			$cnf_report_source,                                 // source       (config)
			"",                                                 // delete
			$cnf_report_password                                // password     (config)
		);
		$result = $reg_db_rpt->create_report_assigned($report_info);
		if($result === FALSE){
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		
		//-------------------------------------------------------------------
		// ᡼Ρʶ̳ôԸ
		//-------------------------------------------------------------------
		$mail_report_info = $reg_db_rpt->get_report($apply_no);
		if($mail_report_info === FALSE){
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		foreach($mail_report_info as $mail_report){
			// ̳Υɥ쥹(To) ˻$cnf_to_mailaddress
			// ѤƤ餽Ѥ configͤѹ
			include("config/RegCnfMail.php");
			$to_addr = array($cnf_to_mailaddress);
			// ᡼ǡ
			$reg_mail_data	= new RegAppFormMailData(
								$to_addr,										// to ɥ쥹
								"ops0206",										// ̻
								$this->apply_util->m_app_kind_tbl["ops0206"],	// ̾
								sprintf("RCV-%08d", $apply_no),					// ֹ
								$app_date);										// 
			// ǡ
			$rpt_obj = new RegAppReportData($mail_report);
			$report_body = $rpt_obj->create_body();
		
			// Υ᡼
			RegAppFormSendMail::send_form_report_mail($report_body, $reg_mail_data, FALSE);
		}

		//-------------------------------------------------------------------
		// ߥå
		//-------------------------------------------------------------------
		$this->reg_db->REGDB_commit();
		return (new RegAppCreateAppAcc($apply_no, $dpn_content_tbl->contents, $dpn_content_tbl->subject));
	}

	/**
	 * ؿ̾get_app_ops0206
	 *   IPɥ쥹(桼) 
	 * @param  appif_obj	RegAppDispConf[]	Ϣ				(i/o)
	 * @param  appfm_obj	RegAppDispConf[]	̾󥯥饹Ϣ			(i/o)
	 * @param  extra_if		RegAppExtraConf[]	­󥯥饹Ϣ		(i/o)
	 * @param  allow_stt	string[]			Ĥ륹ơ	(i)
	 * @param  mem_num							ȿֹ					(i)
	 * @return 1
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_SEARCH			񤬸Ĥʤ
	 *         ERR_APPOP_STATUS			Ĥ륹ơˤʤäƤʤ
	 * @desc   ˤϿ­ appfm_objextra_if˥åȤ롣
	 *         Υ֥Ȥؿ뤿ᡢͽɬפϤʤ
	 *         ޤ$appif_obj["fn_app_last_date"]˺ǽǼ롣
	 *         ȿֹ椬ꤵ줿硢sdb_apply_info:member_number򸡺
	 *         ղä롣
	 */
	function get_app_ops0206(&$appif_obj, &$appfm_obj, $allow_stt, $mem_num="")
	{
		return $this->get_app_opsform($appif_obj, $appfm_obj, $allow_stt, $mem_num);
	}

	/**
	 * ؿ̾get_app_opsform
	 *   IPɥ쥹(ops0206) 
	 * @param  appif_obj	RegAppDispConf[]	Ϣ				(i/o)
	 * @param  appfm_obj	RegAppDispConf[]	̾󥯥饹Ϣ			(i/o)
	 * @param  allow_stt	string[]			Ĥ륹ơ	(i)
	 * @param  mem_num							ȿֹ					(i)
	 * @return 1
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_SEARCH			񤬸Ĥʤ
	 *         ERR_APPOP_STATUS			Ĥ륹ơˤʤäƤʤ
	 * @desc   ˤϿ­ appfm_objextra_if˥åȤ롣
	 *         Υ֥Ȥؿ뤿ᡢͽɬפϤʤ
	 *         ޤ$appif_obj["fn_app_last_date"]˺ǽǼ롣
	 *         ȿֹ椬ꤵ줿硢sdb_apply_info:member_number򸡺
	 *         ղä롣
	 */
	function get_app_opsform(&$appif_obj, &$appfm_obj, $allow_stt, $mem_num="")
	{
		//-------------------------------------------------------------------
		// Ͽǡ
		//-------------------------------------------------------------------
		//----- SDB_FORM_OPS0206 ξ -----//
		// SELECTʳ
		$fn_opsform_array = array(
				"fn_net_name",
				"fn_net_orgjp",
				"fn_net_orgen",
				"fn_net_postal",
				"fn_net_addjp",
				"fn_net_adden",
		);

		$opsform_sql = $this->apply_util->create_apply_select_str(
													$appif_obj,
													$fn_opsform_array,
													$this->net_util->fn_col_tbl,
													$mem_num,
													TRUE);

		//----- SDB_FORM_IP_NETWORK_NUMBER ξ -----//
		$ipadd_sql	 = "SELECT ip_network_number FROM sdb_form_ip_network_number" .
					   " WHERE accept_id = " . $appif_obj["fn_app_acceptid"]->m_disp_var .
					   " ORDER BY order_no";

		//----- SDB_FORM_MAIL_ADDRESS ξ -----//
		$mail_sql	 = "SELECT mail_address FROM sdb_form_mail_address" .
					   " WHERE accept_id = " . $appif_obj["fn_app_acceptid"]->m_disp_var .
					   " ORDER BY order_no";

		//----- SDB_FORM_TECHNICAL_RESP ξ -----//
		$tecc_sql	 = "SELECT technical_responsibility FROM sdb_form_technical_resp" .
					   " WHERE accept_id = " . $appif_obj["fn_app_acceptid"]->m_disp_var .
					   " ORDER BY order_no";

		//-------------------------------------------------------------------
		// SDB_FORM_OPS0206 ξ
		//-------------------------------------------------------------------
		$opsform_result = $this->reg_db->dbapi_query($opsform_sql);
		if ($opsform_result === FALSE)			// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}
		if ($opsform_result === NULL)			// 
		{
			return ERR_APPOP_SEARCH;			// ¸ߤʤ error
		}

		//-------------------------------------------------------------------
		// SDB_FORM_IP_NETWORK_NUMBER ξ
		//-------------------------------------------------------------------
		$ipadd_result = $this->reg_db->dbapi_query($ipadd_sql);
		if ($ipadd_result === FALSE)				// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// SDB_FORM_MAIL_ADDRESS ξ
		//-------------------------------------------------------------------
		$mail_result = $this->reg_db->dbapi_query($mail_sql);
		if ($mail_result === FALSE)				// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// SDB_FORM_TECHNICAL_RESP ξ
		//-------------------------------------------------------------------
		$tecc_result = $this->reg_db->dbapi_query($tecc_sql);
		if ($tecc_result === FALSE)				// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}

		//--------------------------------------------------------------------
		// Ǽ
		//--------------------------------------------------------------------
		// ǽơݤå
		if (in_array($opsform_result[0]["status"], $allow_stt) == FALSE)
		{
			return ERR_APPOP_STATUS;
		}

		//----- ǼѲ̾Ϣκ -----//
		$conf_array	= array(
				"fn_mem_op_short",
				"fn_net_ip_address",
				"fn_net_name",
				"fn_net_orgjp",
				"fn_net_orgen",
				"fn_net_mail",
				"fn_net_postal",
				"fn_net_addjp",
				"fn_net_adden",
				"fn_net_tec_handle",
		);
		$appfm_obj = parent::create_conf_obj($conf_array);

		//----- SDB_FORM_OPS0206 Ǽ -----//
		foreach ($fn_opsform_array as $fn)
		{
			$appfm_obj[$fn]->set_disp_var($opsform_result[0][$this->net_util->fn_col_tbl[$fn]]);
		}
		$appfm_obj["fn_mem_op_short"]->set_disp_var($opsform_result[0]["member_short_name"]);
		$appif_obj["fn_app_last_date"]->set_disp_var($opsform_result[0]["final_reply"]);

		//----- SDB_FORM_IP_NETWORK_NUMBER Ǽ -----//
		if ($ipadd_result === NULL)
		{
			$appfm_obj["fn_net_ip_address"]->set_disp_var("");
		}
		else
		{
			$appfm_obj["fn_net_ip_address"]->m_disp_var = $ipadd_result[0]["ip_network_number"];
		}

		//----- SDB_FORM_MAIL_ADDRESS Ǽ -----//
		if ($mail_result === NULL)
		{
			$appfm_obj["fn_net_mail"]->set_disp_var("");
		}
		else
		{
			$appfm_obj["fn_net_mail"]->m_disp_var = array();
			foreach ($mail_result as $value)
			{
				if ($value["mail_address"] != "")
					array_push($appfm_obj["fn_net_mail"]->m_disp_var, $value["mail_address"]);
			}
		}

		//----- SDB_FORM_TECHNICAL_RESP Ǽ -----//
		if ($tecc_result === NULL)
		{
			$appfm_obj["fn_net_tec_handle"]->set_disp_var("");
		}
		else
		{
			$appfm_obj["fn_net_tec_handle"]->m_disp_var = array();
			foreach ($tecc_result as $value)
			{
				if ($value["technical_responsibility"] != "")
					array_push($appfm_obj["fn_net_tec_handle"]->m_disp_var, $value["technical_responsibility"]);
			}
		}

		return 1;
	}
}
?>
