<?php
/**
 * $Id: RegAppFormOps0204.php,v 1.2 2004/02/12 10:59:11 wtetsuya Exp $
 * հDNS(ops0204)Υ桼ƥƥ饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegAppFormDns.php");			// DNSϢ̾󥯥饹
require_once("DBAPI_OPS0204.php");			// SDB_FORM_OPS0204 DBAPI
require_once("DBAPI_DPN.php");				// DPN_CONTENT DBAPI
require_once("RegAppDateUtil.php");			// մϢ桼ƥƥ饹
?>
<?php
//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegAppFormOps0204 extends RegAppFormDns
{
	/**
	 * DBAPI_IMPLE
	 */
	var $reg_db;

	/**
	 * applyϢDB桼ƥƥ
	 */
	var $apply_util;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppFormOps0204
	 *   RegAppFormOps0204饹󥹥ȥ饯
	 * @param  $db		DBAPI_IMPLE
	 */
	function RegAppFormOps0204($db)
	{
		parent::RegAppFormDns();
		$this->reg_db		= $db;
		$this->apply_util	= new RegAppApplyDBUtil();
	}

	/**
	 * ؿ̾send_app_ops0204
	 *   հDNS Ф
	 *         SDB_APPLY_INFO,SDB_FORM_OPS0204,DPN_CONTENT,MDB_DNSINFO,MDB_DNS_UPDATE_HISTORY롣
	 * @param  mem_num							ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹Ϣ		(i)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return ϿRegAppCreateAppAcc
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_MEM_SEARCH		ȿĤʤ
	 *         ERR_APPOP_DNS_SEARCH		DNSĤʤ
	 *         ERR_APPOP_DNS_CHANGE		DNSƤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function send_app_ops0204($mem_num, &$conf_obj, &$error_str)
	{
		$reg_db_ops0204	= new DBAPI_OPS0204($this->reg_db);		// DBAPI_OPS0204 object
		$reg_db_dpn		= new DBAPI_DPN($this->reg_db);			// DBAPI_DPN object
		$reg_db_dns		= new DBAPI_DNS($this->reg_db);			// DBAPI_DNS object

		//-------------------------------------------------------------------
		// SDB_FORM_OPS0204 Ͽǡ
		//-------------------------------------------------------------------
		$ops_0204tbl = new SDB_FORM_OPS0204(
				"",
				$conf_obj["fn_dns_ip_address"]->m_disp_var,
				$conf_obj["fn_dns_ns"]->m_disp_var
		);

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽǡ
		//-------------------------------------------------------------------
		// SDB_FORM_OPS0204Ͽ륭
		$conf_dpn_keys = array(
			"fn_dns_ip_address",
			"fn_dns_ns",
		);

		// dpn_content ʸǡ(for create_dpn_data_accept_discuss)
		$content_conf_obj = new RegAppDispConfData($conf_dpn_keys, $conf_obj);

		// Ͽֺ
		$app_date = RegAppDateUtil::make_current_date_db();

		//-------------------------------------------------------------------
		// DBȥ󥶥󳫻ϡå
		//-------------------------------------------------------------------
		// ȥ󥶥󳫻
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//----- åơå᡼륢ɥ쥹 -----//
		$sql_str  = "SELECT applicant_mail_address FROM mdb_meminfo WHERE" .
					" member_number = " . $mem_num . " AND" .
					" status = 'normal'" . 
					" FOR UPDATE";
		$db_result = $this->reg_db->dbapi_query_lock($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			return ERR_APPOP_MEM_SEARCH;
		}
		// ᡼륢ɥ쥹Ͽ
		$mem_in_mail = $db_result[0]["applicant_mail_address"];

		//----- åå -----//
		$sql_str  = "SELECT last_update_date FROM mdb_dnsinfo WHERE" .
					" ip_network_number = " . GetApsString($conf_obj["fn_dns_ip_address"]->m_disp_var) .
					" FOR UPDATE";
		$db_result = $this->reg_db->dbapi_query_lock($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			array_push($error_str, "D100");					// βǽꥨ顼
			return ERR_APPOP_DNS_SEARCH;
		}

		if (strcmp($db_result[0]["last_update_date"], $conf_obj["fn_dns_last_date"]->m_disp_var) != 0)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D401");					// Ƥ륨顼
			return ERR_APPOP_DNS_CHANGE;
		}

		//-------------------------------------------------------------------
		// SDB_APPLY_INFO, SDB_FORM_OPS0204 Ͽ
		//-------------------------------------------------------------------
		// SDB_APPLY_INFO Ͽǡ
		$sdb_appinfo_tbl = new SDB_APPLY_INFO(
							"", $app_date, "", "", $mem_num, "", "",
							$mem_in_mail, $app_date, "", "", $app_date);

		$apply_no = $reg_db_ops0204->create_apply_form_ops0204(
												$sdb_appinfo_tbl,
												$ops_0204tbl);
		if ($apply_no === FALSE || $apply_no == 0)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽ
		//-------------------------------------------------------------------
		$dpn_content_tbl = $this->apply_util->create_dpn_data_accept_auto(
										$apply_no,
										"MEM",
										$mem_in_mail,
										$app_date,
										"ops0204",
										$content_conf_obj);
		$result = $reg_db_dpn->dpn_create_content($dpn_content_tbl);
		if ($result === FALSE || $result == 0)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// MDB_DNSINFO/MDB_DNS_UPDATE_HISTORY 
		//-------------------------------------------------------------------
		$mdb_update_tbl = new MDB_UPDATE_INFO(
							$mem_in_mail,
							$app_date,
							sprintf("RCV-%08d", $apply_no),
							"ops0204");

		$result = $reg_db_dns->delete_dns_info(
							$conf_obj["fn_dns_ip_address"]->m_disp_var, $mdb_update_tbl);
		if ($result === FALSE || $result == "0")
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// ߥå
		//-------------------------------------------------------------------
		$this->reg_db->REGDB_commit();
		return (new RegAppCreateAppAcc($apply_no, $dpn_content_tbl->contents, $dpn_content_tbl->subject));
	}

	/**
	 * ؿ̾get_app_ops0204
	 *   հDNS 
	 * @param  appif_obj	RegAppDispConf[]	Ϣ				(i/o)
	 * @param  appfm_obj	RegAppDispConf[]	̾󥯥饹Ϣ			(i/o)
	 * @param  allow_stt	string[]			Ĥ륹ơ	(i)
	 * @param  mem_num							ȿֹ						(i)
	 * @return 1
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_SEARCH			񤬸Ĥʤ
	 *         ERR_APPOP_STATUS			Ĥ륹ơˤʤäƤʤ
	 * @desc   ˤϿ­ appfm_objextra_if˥åȤ롣
	 *         Υ֥Ȥؿ뤿ᡢͽɬפϤʤ
	 *         ޤ$appif_obj["fn_app_last_date"]˺ǽǼ롣
	 *         ȿֹ椬ꤵ줿硢sdb_apply_info:member_number򸡺
	 *         ղä롣
	 */
	function get_app_ops0204(&$appif_obj, &$appfm_obj, $allow_stt, $mem_num="")
	{
		//-------------------------------------------------------------------
		// Ͽǡ
		//-------------------------------------------------------------------
		//----- SDB_FORM_OPS0204 ξ -----//
		// SELECTʳ
		$fn_ops0204_array = array(
				"fn_dns_ip_address",
		);

		$ops0204_sql = $this->apply_util->create_apply_select_str(
													$appif_obj,
													$fn_ops0204_array,
													$this->dns_util->fn_col_tbl,
													$mem_num,
													TRUE);

		//----- SDB_FORM_NAME_SERVER ξ -----//
		$ns_sql		 = "SELECT name_server FROM sdb_form_name_server" .
					   " WHERE accept_id = " . $appif_obj["fn_app_acceptid"]->m_disp_var .
					   " ORDER BY order_no";

		//-------------------------------------------------------------------
		// SDB_FORM_OPS0204 ξ
		//-------------------------------------------------------------------
		$ops0204_result = $this->reg_db->dbapi_query($ops0204_sql);
		if ($ops0204_result === FALSE)			// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}
		if ($ops0204_result === NULL)			// 
		{
			return ERR_APPOP_SEARCH;			// ¸ߤʤ error
		}

		//-------------------------------------------------------------------
		// SDB_FORM_NAME_SERVER ξ
		//-------------------------------------------------------------------
		$ns_result = $this->reg_db->dbapi_query($ns_sql);
		if ($ns_result === FALSE)				// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}

		//--------------------------------------------------------------------
		// Ǽ
		//--------------------------------------------------------------------
		// ǽơݤå
		if (in_array($ops0204_result[0]["status"], $allow_stt) == FALSE)
		{
			return ERR_APPOP_STATUS;
		}

		//----- ǼѲ̾Ϣκ -----//
		$conf_array	= array(
				"fn_mem_op_short",
				"fn_dns_ip_address",
				"fn_dns_ns",
		);
		$appfm_obj = parent::create_conf_obj($conf_array);

		//----- SDB_FORM_OPS0204 Ǽ -----//
		foreach ($fn_ops0204_array as $fn)
		{
			$appfm_obj[$fn]->set_disp_var($ops0204_result[0][$this->dns_util->fn_col_tbl[$fn]]);
		}
		$appfm_obj["fn_mem_op_short"]->set_disp_var($ops0204_result[0]["member_short_name"]);
		$appif_obj["fn_app_last_date"]->set_disp_var($ops0204_result[0]["final_reply"]);

		//----- SDB_FORM_NAME_SERVER Ǽ -----//
		if ($ns_result === NULL)
		{
			$appfm_obj["fn_dns_ns"]->set_disp_var("");
		}
		else
		{
			$appfm_obj["fn_dns_ns"]->m_disp_var = array();
			foreach ($ns_result as $value)
			{
				if ($value["name_server"] != "")
					array_push($appfm_obj["fn_dns_ns"]->m_disp_var, $value["name_server"]);
			}
		}

		return 1;
	}
	
	/**
	 * ؿsend_app_ops0204_for_tool
	 * հDNS(ġ뤫ƤФ)
	 * @param$dnsinfo[]DNS
	 * @param$mem_num󤹤ȿȿֹ
	 * @param$clerk_idġưôԤID
	 * @param$error_str[]顼ɳǼ
	 * @returnFALSEԡTRUE
	 * @descTRϸƤӽФǳϤƤ
	 */
	function send_app_ops0204_for_tool($dnsinfo, $mem_num, $clerk_id, &$error_str)
	{
		$reg_db_ops0204 = new DBAPI_OPS0204($this->reg_db);
		$reg_db_dpn = new DBAPI_DPN($this->reg_db);
		$reg_db_dns = new DBAPI_DNS($this->reg_db);
		
		$dnsinfo_new = array();
		foreach($dnsinfo as $val)
		{
			if(!in_array($val["ip_network_number"], array_keys($dnsinfo_new)))
			{
				$dnsinfo_new[$val["ip_network_number"]] = array();
				array_push($dnsinfo_new[$val["ip_network_number"]], $val["name_server"]);
			}
			else
			{
				array_push($dnsinfo_new[$val["ip_network_number"]], $val["name_server"]);
			}
		}
		
		foreach($dnsinfo_new as $key => $value)
		{
			$conf_obj = array("fn_dns_ip_address" => new RegAppDispConf("IPͥåȥɥ쥹"),
							  "fn_dns_ns" => new RegAppDispConf("͡ॵ"));
			
			$conf_obj["fn_dns_ip_address"]->m_disp_var = $key;
			$conf_obj["fn_dns_ns"]->m_disp_var = $value;
			
			// SDB_FORM_OPS0204Ͽǡ
			$ops_0204tbl = new SDB_FORM_OPS0204("", $conf_obj["fn_dns_ip_address"]->m_disp_var, $conf_obj["fn_dns_ns"]->m_disp_var);
			
			// DPN_CONTENTϿǡ
			$conf_dpn_keys = array("fn_dns_ip_address", "fn_dns_ns");
			
			// dpn_contentʸǡ
			$content_conf_obj = new RegAppDispConfData($conf_dpn_keys, $conf_obj);
			
			// Ͽֺ
			$app_date = RegAppDateUtil::make_current_date_db();
			
			// SDB_APPLY_INFOSDB_FORM_OPS0204Ͽ
			$sdb_appinfo_tbl = new SDB_APPLY_INFO("",				//No
												  $app_date,		//
												  "",				//clerk_id
												  "",				//apply_kind_id
												  $mem_num,			//ȿֹ
												  "",				//ơ
												  "",				//settlement_id
												  $clerk_id,		//send_person
												  $app_date,		//settlement_date
												  "",				//charge_flag
												  "",				//note
												  $app_date);		//final_reply
			$apply_no = $reg_db_ops0204->create_apply_form_ops0204($sdb_appinfo_tbl, $ops_0204tbl);
			if($apply_no === FALSE || $apply_no == 0)
			{
				array_push($error_str, "D302");
				return FALSE;
			}
			
			// DPN_CONTENTϿ
			$dpn_content_tbl = $this->apply_util->create_dpn_data_accept_auto($apply_no,
																			  "SYSTEM",
																			  $clerk_id,
																			  $app_date,
																			  "ops0204",
																			  $content_conf_obj);
			$result = $reg_db_dpn->dpn_create_content($dpn_content_tbl);
			if($result === FALSE || $result == 0)
			{
				array_push($error_str, "D302");
				return FALSE;
			}
			
			// MDB_DNSINFOMDB_DNS_UPDATE_HISTORY
			$mdb_update_tbl = new MDB_UPDATE_INFO($clerk_id,
												  $app_date,
												  sprintf("RCV-%08d", $apply_no), "ins0303");
			$result = $reg_db_dns->delete_dns_info($conf_obj["fn_dns_ip_address"]->m_disp_var, $mdb_update_tbl);
			if($result === FALSE || $result == "0")
			{
				array_push($error_str, "D302");
				return FALSE;
			}
		}
		return TRUE;
	}
}
?>
