<?php
/*
 * $Id: RegAppInputCheck.php,v 1.12 2004/03/03 10:30:58 wtetsuya Exp $
 * ե̤ϥå(ʸʸ)Ԥؿ
 */
?>
<?php
	//------------------------------------------------------------------------
	// defines
	//------------------------------------------------------------------------
	define("REG_APP_INPUT_ERR_STRLEN", -1);			// ʸ顼
	define("REG_APP_INPUT_ERR_PATTERN", 0);			// 顼
	define("REG_APP_INPUT_CHK_OK", 1);				// åOK

	define("AS_MIN_NUMBER", 1);				// ASֹǾ
	define("AS_MAX_NUMBER", 64511);			// ASֹ

	//------------------------------------------------------------------------
	// include,require
	//------------------------------------------------------------------------
	require_once("RegIpAddressUtil.php");	// IP AddressϢ桼ƥƥ饹
    require_once("RegIpv6AddressUtil.php");	// IPv6 AddressϢ桼ƥƥ饹

	//------------------------------------------------------------------------
	// public functions
	//------------------------------------------------------------------------
	/**
	 * ؿ̾chk_str_num
	 *   ʸ min-max δ֤ˤ뤫ɤå
	 * @param  value	string	ʸ			(i)
	 * @param  min		int		Ǿʸ		(i)
	 * @param  max		int		ʸ		(i)
	 * @return int -1顼(ϰϳ)1
	 * @desc   ޥХʸ⣱ʸȤƥå롣
	 */
	function chk_str_num($value, $min, $max)
	{
		$nLen = mb_strlen($value);
		if ($nLen < $min || $nLen > $max)
			return REG_APP_INPUT_ERR_STRLEN;			// ϰϳ
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_hankaku
	 *   ȾѤαѿڡ ()@,.#$!%^&=/\*+-'"_ۤȽǤ롣
	 * @param  value	string	ʸ			(i)
	 * @return int 0顼1
	 */
	function chk_hankaku($value)
	{
		if (ereg("^[[:alnum:][:space:]\(\)@,\.#$!%^&=/\\\*\+'\"_-]*$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_hankaku_length
	 *   ʸȡȾѤαѿڡ ()@,.#$!%^&=/\*+-'"_ۤȽǤ롣
	 * @param  value	string	ʸ			(i)
	 * @param  min		int		Ǿʸ		(i)
	 * @param  max		int		ʸ		(i)
	 * @return int -1ʸ顼0顼1
	 * @desc   ʸ1ХʸȤƥå롣
	 */
	function chk_hankaku_length($value, $min, $max)
	{
		if (chk_str_num($value, $min, $max) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}

		return chk_hankaku($value);		// å
	}

	/**
	 * ؿ̾chk_kana_length
	 *   ʸȡ̵ͭȽǤ롣ȾѥʤѥʤѴ
	 * @param  value	string	ʸ			(i/o)
	 * @param  min		int		Ǿʸ		(i)
	 * @param  max		int		ʸ		(i)
	 * @param  lf_flg	boolean	ԥå(TRUEå롢FALSEåʤ)	(i)
	 * @return int -1ʸ顼0顼1
	 * @desc   lf_flg TRUEξ硢Ԥ 0(顼) ֤
	 *         ʸåϡޥХȥåǹԤ
	 */
	function chk_kana_length(&$value, $min, $max, $lf_flg=FALSE)
	{
		$value = mb_convert_kana($value);		// Ⱦѥʢѥ
		$nLen = mb_strlen($value);				// ޥХʸ
		if ($nLen < $min || $nLen > $max)
			return REG_APP_INPUT_ERR_STRLEN;			// ϰϳ

		if ($lf_flg)
		{
			$data = explode("\n", $value);		// ԥå
			if (count($data) != 1)
			{
				return REG_APP_INPUT_ERR_PATTERN;		// 顼(Բ)
			}
		}
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_mem_short
	 *   ȿάΤȤȽǤ(Ƭʸʸ塢ѿ"-""_" 2-50ʸ)
	 * @param  value	string	ȿά		(i)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_mem_short($value)
	{
		if (chk_str_num($value, 2, 50) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}

		if (ereg("^[A-Za-z][[:alnum:]_-]{1,49}$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_mem_pass
	 *   ȿѥɤȤȽǤ
	 *        (Ƭѿʸ塢ȾѤαѿ ()@,.#$!%^&=/\*+-'"_)
	 * @param  value	string	ȿѥ		(i)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_mem_pass($value)
	{
		if (chk_str_num($value, 6, 32) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}

		if (ereg("^[A-Za-z0-9][[:alnum:]\(\)@,\.#$!%^&=/\\\*\+'\"_-]{5,31}$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_filename
	 *   åץɥե̾ȤȽǤ
	 *         (Ƭ"."ʳǱѿ"-""_"1-20ʸ)
	 * @param  value	string	ե̾		(i)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_filename($value)
	{
		if (chk_str_num($value, 1, 20) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}

		if (ereg("^[[:alnum:]_-][[:alnum:]\._-]*$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_nameserver
	 *   NameServerɥ쥹ȤȽǤ롣ʸ郎ʸʸѴ롣
	 *         (<֥ɥᥤ(ʣ)>.<ȥåץɥᥤ>)
	 *         (֥ɥᥤƬѿʸϱѿ-_1ʸʾ塢ȥåץɥᥤ󡧱ѿ1ʸʾ)
	 * @param  value	string	͡ॵ̾	(i/o)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_nameserver(&$value)
	{
		if (chk_str_num($value, 3, 256) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}

		// ѿ "." "_" "-" å
		if ((ereg("^[[:alnum:]\._-]*$", $value)) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}

		$value = strtolower($value);		// to lower

		$dom_value = explode(".", $value);		// ɥᥤڤФ
		$dom_count = count($dom_value);			// ɥᥤ
		// ȥåס֥ɥᥤ󤬺ɬ
		if ($dom_count < 2)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		// ֥ɥᥤå(Ƭѿʸ塢ѿ "_" "-"1ʸʾ)
		for ($i = 0; $i < ($dom_count - 1); $i++)
		{
			if ((ereg("^[a-z0-9]{1,}[a-z0-9_-]*$", $dom_value[$i])) == FALSE)
			{
				return REG_APP_INPUT_ERR_PATTERN;	// 顼
			}
		}
		// ȥåץɥᥤå(1ʸʾ)
		if(ereg("^[a-z]{1,}$", $dom_value[$dom_count-1]) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		return REG_APP_INPUT_CHK_OK;
	}

    /**
     * ؿ̾chk_ipaddress
     *   IPv6ɥ쥹ȤȽǤ
     *         (ϥɥ쥹ʬޥ)
     * @param   string  &$value     IPv6ͥåȥɥ쥹 (ex. 2001::1/64)
     * @return  integer ȽǷ    0顼1
     */
    function chk_ipaddress(&$value)
    {
        $res = RegIpv6AddressUtil::chk_ipblock($value) ? 1 : REG_APP_INPUT_ERR_PATTERN;
        if($res == 1){
            list($ip, $prefix) = explode("/", $value);
            $value = join("/", array(RegIpv6AddressUtil::compress_ipaddress($ip), $prefix));
        }
        return $res;
    }

	/**
	 * ؿ̾chk_ipaddress_v4
	 *   IPɥ쥹ȤȽǤ롣
	 *         ([0-255].[0-255].[0-255].[0-255]/[0-32]ޥ)
	 *         1ܰʳ0Ϻ롣
	 * @param  value	string	IPͥåȥɥ쥹	(i/o)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_ipaddress_v4(&$value)
	{
		// å([].[].[].[]/[])
		if (ereg("^([[:digit:]]{1,3})\.([[:digit:]]{1,3})\.([[:digit:]]{1,3})\.([[:digit:]]{1,3})/([[:digit:]]{1,2})$", $value, $newvalue) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}

		// 10ΰ̡100ΰ̤ΣϺ
		$address[0]	= (int)$newvalue[1];
		$address[1]	= (int)$newvalue[2];
		$address[2]	= (int)$newvalue[3];
		$address[3]	= (int)$newvalue[4];
		$prefix		= (int)$newvalue[5];
		$value		= $address[0] . "." . $address[1] . "." . $address[2] . "." . $address[3] . "/" . $prefix;

		// IPɥ쥹å([0-255].[0-255].[0-255].[0-255])
		for ($i = 0; $i < 4; $i++)
		{
			if(!((0 <= $address[$i]) && ($address[$i] < 256)))
			{
				return REG_APP_INPUT_ERR_PATTERN;	// 顼(0-255ˤʤ)
			}
		}
		// ޥĹå
		if(!((0 <= $prefix) && ($prefix <= 32)))
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼(0-32ˤʤ)
		}

		// å
		return RegIpAddressUtil::chk_ipaddress_mask($value);
	}

	/**
	 * ؿ̾chk_netname
	 *   ͥåȥ̾ȤȽǤ롣
	 *         (Ƭʸʸ͡1-12ʸ)
	 * @param  value	string	ͥåȥ̾		(i)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_netname($value)
	{
		if (chk_str_num($value, 1, 12) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}

		if (ereg("^[A-Z][A-Z0-9-]{0,11}$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_org_jp
	 *   ȿ̾ȤȽǤ롣ȾѥʤѥʤѴԥåʤ(1-256ʸ)
	 * @param  value	string	ȿ̾			(i/o)
	 * @return int -1ʸ顼1
	 */
	function chk_org_jp(&$value)
	{
		return chk_kana_length($value, 1, 256, TRUE);
	}

	/**
	 * ؿ̾chk_mailaddress
	 *   ᡼륢ɥ쥹ȤȽǤ롣
	 *         ([桼̾]@[ɥᥤ].[ɥᥤ]5-256ʸ)
	 * @param  value	string	᡼륢ɥ쥹		(i)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_mailaddress($value)
	{
		// ʸå
		if (chk_str_num($value, 5, 256) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}

		if (ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'.
				 '@'.
				 '[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.
				 '[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_postalcode
	 *   ͹ֹȤȽǤ롣
	 *         (Ƭʸʸ  -)
	 * @param  value	string	͹ֹ		(i)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_postalcode($value)
	{
		if (chk_str_num($value, 1, 10) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}
		if (ereg("^[A-Z0-9]-?([A-Z0-9]-?)*$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_address_jp
	 *   ȤȽǤ롣ȾѥʤѥʤѴԲġ(1-256ʸ)
	 * @param  value	string				(i/o)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_address_jp(&$value)
	{
		return chk_kana_length($value, 1, 256, TRUE);
	}

	/**
	 * ؿ̾chk_address_en
	 *   AddressȤȽǤ롣(Բġ1-256ʸ)
	 * @param  value	string	Address			(i/o)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_address_en(&$value)
	{
		// ԥå
		$data = explode("\n", $value);
		if (count($data) != 1)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼(Բ)
		}
		return chk_hankaku_length($value, 1, 256);
	}

	/**
	 * ؿ̾chk_handle
	 *   V6PCϥɥȤȽǤ롣ʸ郎бѾʸʸѴ
	 *         ([2ʸ][5-7][-V6PC])
	 * @param  value	string	V6PCϥɥ						(i/o)
	 * @param  v6flg	boolean	"-V6PC"դ?(TRUE:YESFALSE:NO)	(i)
	 * @return int 0顼1
	 * @desc   v6flg TRUEξ硢"-V6PC"ʤ 0(顼) ֤
	 */
	function chk_handle(&$value, $v6flg=FALSE)
	{
		if (preg_match("/^[A-Z]{2,4}[0-9]{1,3}\-AP$/", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_changereason
	 *   ѹͳȤȽǤ롣ȾѥʤѥʤѹOK(1-1000ʸ)
	 * @param  value	string	ѹͳ		(i/o)
	 * @return int -1ʸ顼1
	 */
	function chk_changereason(&$value)
	{
		return chk_kana_length($value, 1, 1000);
	}

	/**
	 * ؿ̾chk_deletereason
	 *   ֵͳȤȽǤ롣ȾѥʤѥʤѹOK(1-1000ʸ)
	 * @param  value	string	ѹͳ		(i/o)
	 * @return int -1ʸ顼1
	 */
	function chk_deletereason(&$value)
	{
		return chk_hankaku_length($value, 1, 1000);
	}

	/**
	 * ؿ̾chk_person_name
	 *   V6PCϥɥλ̾(롼̾)ޤô̾ȤȽǤ롣
	 *         Ⱦѥʤѥʤѹԥåʤ(1-50ʸ)
	 * @param  value	string	̾(롼̾)		(i/o)
	 * @return int -1ʸ顼1
	 */
	function chk_person_name(&$value)
	{
		return chk_kana_length($value, 1, 50, TRUE);
	}

	/**
	 * ؿ̾chk_person_lastfirst
	 *   V6PCϥɥLast,First(GroupName)ȤȽǤ롣
	 *         (Last,First[last],[first] Ƭޤ֥å˱ѻ1ʸʾ夢뤳)
	 *         (GroupName ѻ2ʸʾ夢뤳)
	 * @param  value	string	Last,First(GroupName)	(i)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_person_lastfirst($value)
	{
		if (chk_str_num($value, 3, 50) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}

		if (ereg("^[A-Za-z[:space:],\.\'-]+$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼(곰ʸ)
		}

		if (strpos($value, ",") === FALSE)		// GroupName
		{
			if (ereg("[A-Za-z][[:space:]\.\'-]*[A-Za-z]", $value) == FALSE)
			{
				return REG_APP_INPUT_ERR_PATTERN;	// 顼(GroupNameξϱѻ2ʸʾɬ)
			}
		}
		else									// Last,First
		{
			if (ereg("^([[:space:]\.\'-]*[A-Za-z][A-Za-z[:space:]\.\'-]*),([[:space:]\.\'-]*[A-Za-z][A-Za-z[:space:],\.\'-]*)$", $value) == FALSE)
			{
				return REG_APP_INPUT_ERR_PATTERN;	// 顼(Ƭ,֥åˤϱѻ1ʸʾɬ)
			}
		}

		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_division_jp
	 *   ̾ȤȽǤ롣Ⱦѥʤѥʤѹԥåʤ(1-256ʸ)
	 * @param  value	string	̾		(i/o)
	 * @return int -1ʸ顼1
	 */
	function chk_division_jp(&$value)
	{
		return chk_kana_length($value, 1, 256, TRUE);
	}

	/**
	 * ؿ̾chk_title_jp
	 *   ȤȽǤ롣Ⱦѥʤѥʤѹԥåʤ(1-256ʸ)
	 * @param  value	string			(i/o)
	 * @return int -1ʸ顼1
	 */
	function chk_title_jp(&$value)
	{
		return chk_kana_length($value, 1, 256, TRUE);
	}

	/**
	 * ؿ̾chk_telnumber
	 *   ֹȤȽǤ롣
	 *         (+[¤]-)?[¤]((ext.ޤϣ)[¤])?
	 *         (()ǰϤǤġڤ-Ѳġext.xϥڡ)
	 * @param  value	string	ֹ		(i)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_telnumber($value)
	{
		// ʸå
		if (chk_str_num($value, 4, 50) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}

		if (ereg("^(\+[0-9\(\)]+-)?(\(?[0-9]\)?(\-)?)+([[:space:]]*(ext\.|x)[[:space:]]*((\(?[0-9]\)?(\-)?)+)){0,1}$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}

		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_faxnumber
	 *   FAXֹȤȽǤ롣
	 *         (+[¤]-)?[¤]?  ()ǰϤǤġڤ-Ѳ)
	 * @param  value	string	FAXֹ		(i)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_faxnumber($value)
	{
		// ʸå
		if (chk_str_num($value, 4, 50) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}

		if (ereg("^(\+[0-9\(\)]+-)?(\(?[0-9]\)?(\-)?)+$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}

		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_clerk_id
	 *   ̳ôIDȤȽǤ(ѿ-_4-10ʸ)
	 * @param  value	string	̳ôID		(i)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_clerk_id($value)
	{
		if (chk_str_num($value, 4, 10) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}

		if (ereg("^[A-Za-z0-9_-]+$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_clerk_pass
	 *   ̳ôԥѥɤȤȽǤ(ѿ-_4-10ʸ)
	 * @param  value	string	̳ôԥѥ	(i)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_clerk_pass($value)
	{
		if (chk_str_num($value, 4, 10) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}

		if (ereg("^[A-Za-z0-9_-]+$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_clerk_name
	 *   ̳ôԥե͡ȤȽǤ(ѿ-_ ڡ4-20ʸ)
	 * @param  value	string	ե͡			(i)
	 * @return int -1ʸ顼0顼1
	 */
	function chk_clerk_name($value)
	{
		if (chk_str_num($value, 4, 20) == REG_APP_INPUT_ERR_STRLEN)
		{
			return REG_APP_INPUT_ERR_STRLEN;		// ʸ顼
		}

		if (ereg("^[[:space:]A-Za-z0-9_-]+$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_apply_no
	 *   ֹȤȽǤ롣
	 *         rcv_flg = TRUE ((RCV-)[5-8])
	 *         rcv_flg = FALSE[1-8]
	 * @param  value		string		ֹ(RCV- ̵ͭrcv_flg¸)	(i)
	 * @param  app_number	string		ֹ(RCV- ̵ͭrcv_flg¸)	(i/o)
	 * @param  rcv_flg		boolean		TRUE:RCV-ͭꡢFALSERCV-ʤ		(i)
	 * @return int 0顼1
	 * @desc   rcv_flgTRUEξ硢
	 *           Ƭ"RCV-"ʤ 0(顼) ֤
	 *           åOKξ $app_number  "RCV-" ͤǼ
	 *         rcv_flgFALSEξ硢
	 *           RCV- ʤǣͤݤå
	 *           åOKξ $app_number  "RCV-" ԲĤͤǼ
	 */
	function chk_apply_no($value, &$app_number, $rcv_flg=TRUE)
	{
		if ($rcv_flg)
		{
			if (ereg("^(RCV-)([0-9]{5,8})$", $value, $app_number) == FALSE)
			{
				$app_number = "";
				return REG_APP_INPUT_ERR_PATTERN;	// 顼
			}
			$app_number = (int)($app_number[2]);	// ͤΤߤǼ
		}
		else
		{
			if (ereg("^[0-9]{1,8}$", $value) == FALSE || ((int)$value < 1 || 99999999 < (int)$value))
			{
				$app_number = "";
				return REG_APP_INPUT_ERR_PATTERN;	// 顼
			}
			// RCV-XXXXXXXX Ǽ
			$app_number = sprintf("RCV-%08d", (int)$value);
		}
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_as_no
	 *   ASֹȤȽǤ롣
	 *         (1-5塢1ʾ64511ʲ)
	 * @param  value		string		ASֹ					(i/o)
	 * @return int 0顼1
	 */
	function chk_as_no(&$value)
	{
		if (ereg("^[0-9]{1,5}$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;	// 顼
		}
		if ((int)$value < AS_MIN_NUMBER || AS_MAX_NUMBER < (int)$value)
		{
			return REG_APP_INPUT_ERR_PATTERN;	// 顼
		}
		$value = (int)$value;
		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_yyyymmdd
	 *   ǯ(YYYY/MM/DD)ȤȽǤ롣
	 *         (YYYY/MM/DDաϣOK¸ߤʤϷ顼)
	 * @param  value	string	ǯ		(i)
	 * @return int 0顼1
	 */
	function chk_yyyymmdd($value)
	{
		if (ereg("^[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}

		$data = explode("/", $value);
		if (!checkdate($data[1], $data[2], $data[0]))
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼(¸ߤʤ)
		}
		if (1000 > ((int)$data[0]))
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}

		return REG_APP_INPUT_CHK_OK;
	}

	/**
	 * ؿ̾chk_date_for_db
	 *   DBեǡȤȽǤ롣
	 *         (YYYY-MM-DD hh:ii:ss timezone )
	 * @param  value	string	date data for db		(i)
	 * @return int 0顼1
	 */
	function chk_date_for_db($value)
	{
		if(ereg("^([0-9]{1,4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})(.*)$", $value) == FALSE)
		{
			return REG_APP_INPUT_ERR_PATTERN;		// 顼
		}
		return REG_APP_INPUT_CHK_OK;
	}
?>
