<?php
/**
 * $Id: RegAppWhois.php,v 1.5 2004/02/27 05:05:18 yoshi_s Exp $
 * Whois饹
 */
?>
<?php
// ex) whoisԤ֥Ȥ
// $whois =& new RegAppWhois("whois.apnic.net");
// $whois->set_name("2001::/32");
// $whois->execute();
// if($whois->is_error()){
//    exit("execute error:[".$this->get_return_code()."]");
// }
// // inet6num֥Ȥ
// $iobj =& $whois->get_object("inet6num");
// $inet6num = $iobj->get_item("inet6num");
// $netname = $iobj->get_item("netname");
// $descr = $iobj->get_item("descr");
// // person֥Ȥ
// $pobj =& $whois->get_object("person");
// $person = $pobj->get_item("person");
// $nic_hdl = $pobj->get_item("nic-hdl");
// 
require_once("RegAppWhoisObj.php");
//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegAppWhois{
    var $server;
    var $name;
    var $output;
    var $r_code;
    var $objects;
    var $object_idxes;
    var $current_object_idx;
    
    /**
     * ؿ̾RegAppWhois
     *   󥹥ȥ饯
     * @access  public
     * @param   string  [$server]   whois
     */
    function RegAppWhois($server=""){
        $this->server = $server;
        $this->name = "";
        $this->output = array();
        $this->r_code = "";
        $this->objects = array();
        $this->object_idxes = array();
        $this->current_object_idx = false;
    }
    
    //##################################################//
    //# public
    
    /**
     * ؿ̾set_server
     *   whoisФꤹ
     * @access  public
     * @param   string  $server whois
     */
    function set_server($server){
        $this->server = $server;
    }
    
    /**
     * ؿ̾set_name
     *   whoisԤ̾ޤIPɥ쥹ꤹ
     * @access  public
     * @param   string  $name   whoisʸ
     */
    function set_name($name){
        $this->name = $name;
    }
    
    /**
     * ؿ̾execute
     *   whois¹Ԥ
     * @access  public
     * @return  integer ݷ 0ԡ1
     */
    function execute(){
        $cmd = sprintf("whois -h %s %s",
            escapeshellarg($this->server),
            escapeshellarg($this->name)
        );
        exec($cmd, $this->output, $this->r_code);
        if($this->r_code){
            return 0;
        }
        foreach ($this->output as $line){
            $this->analyze_line($line);
        }
        return 1;
    }
    
    /**
     * ؿ̾analyze_line
     *   whoisϷ̤1ԤʬϤ
     * @access  public
     * @param   string  $line   whoisϷ1Ԥʸ
     */
    function analyze_line($line){
        $line = rtrim($line);
        $matches = array();
        if(preg_match("/^([^\s]+):\s+([^\s].*)$/", $line, $matches)){
            list($name, $value) = array_slice($matches, 1, 2);
            $obj =& $this->get_current_object();
            if($obj === false){
                $obj =& $this->create_object($name);
            }
            $obj->add_item($name, $value);
        }elseif($this->get_current_object() !== false){
            $this->free_current_object();
        }
    }
    
    /**
     * ؿ̾is_error
     *   whoisΥ顼Ƚꤹ
     * @access  publice
     * @return  integer 顼̡01顼
     */
    function is_error(){
        return $this->r_code ? 1 : 0;
    }
    
    /**
     * ؿ̾get_return_code
     *   whoisμ¹Է̡ʥ꥿󥳡ɡˤ
     * @access  publice
     * @return  integer ¹Է̡ʥ꥿󥳡ɡ
     */
    function get_return_code(){
        return $this->r_code;
    }
    
    /**
     * ؿ̾get_output
     *   whoisνϷ̤
     * @access  publice
     * @return  array   Ϸ̡ʣԣǡ
     */
    function get_output($type="array"){
        if(!strcmp($type, "string")){
            return join("\n", $this->output);
        }
        return $this->output;
    }
    
    /**
     * ؿ̾get_object
     *   whois֥Ȥ
     * @access  public
     * @param   string  $name   whois֥̾inet6num, person, ...
     * @param   integer [$num]  ֹ֥档Ʊ̾Υ֥Ȥʣ¸ߤ˻
     * @return  RegAppWhoisObj  whois֥
     * @desc    ʬϡ analyze_line() or execute() ˤλѤ
     * @desc    ե󥹤֤
     */
    function &get_object($name, $num=0){
        return $this->objects[$this->object_idxes[$name][$num]];
    }
    
    /**
     * ؿ̾get_object_all
     *   Ƥwhois֥Ȥ
     * @access  public
     * @param   string  $name   whois֥̾inet6num, person, ...
     * @param   integer [$num]  ֹ֥档֥Ȥʣ¸ߤ˻
     * @return  RegAppWhoisObj[]  whois֥
     * @desc    ʬϡ analyze_line() or execute() ˽λ˻Ѥ
     * @desc    ե󥹤֤
     */
    function &get_object_all(){
        return array_values($this->objects);
    }
    
    /**
     * ؿ̾count_object
     *   whois֥Ȥο
     * @access  public
     * @param   string  $name   whois֥̾inet6num, person, ...
     * @return  integer whois֥Ȥο
     * @desc    ʬϡ analyze_line() or execute() ˽λ˻Ѥ
     */
    function count_object($name){
        return count($this->object_idxes[$name]);
    }
    
    
    //##################################################//
    //# private
    
    /**
     * ؿ̾create_object
     *   whoisϷ̤1ԤʬϤ
     * @access  private
     * @return  RegAppWhoisObj  whois֥ȡinet6num, person, ...
     * @desc    ե󥹤֤
     */
    function &create_object($name){
        $class_name = "RegAppWhois".ucfirst($name)."Obj";
        if(!class_exists($class_name)){
            $class_name = "RegAppWhoisObj";
        }
        $obj =& new $class_name($name);
        array_push($this->objects, &$obj);
        $this->current_object_idx = count($this->objects) - 1;
        if(!array_key_exists($name, $this->object_idxes)){
            $this->object_idxes[$name] = array();
        }
        array_push($this->object_idxes[$name], $this->current_object_idx);
        return $obj;
    }
    
    /**
     * ؿ̾get_current_object
     *   ʬϤƤ륪֥Ȥ
     * @access  private
     * @return  RegAppWhoisObj  ʬwhois֥ȡinet6num, person, ...
     * @desc    ե󥹤֤
     */
    function &get_current_object(){
        if($this->current_object_idx === false){
            return false;
        }
        return $this->objects[$this->current_object_idx];
    }
    
    /**
     * ؿ̾free_current_object
     *   ʬϤƤ륪֥Ȥ
     * @access  private
     */
    function free_current_object(){
        $this->current_object_idx = false;
    }
}
?>
