<?php
/**
 * $Id: RegAppWhoisObj.php,v 1.2 2004/02/27 05:05:18 yoshi_s Exp $
 * Whois֥ȴ饹
 */
?>
<?php
//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegAppWhoisObj{
    var $name;
    var $item_info;
    
    /**
     * ؿ̾RegAppWhoisObj
     *   󥹥ȥ饯
     * @access  public
     * @param   string  $object_name    whois֥̾
     */
    function RegAppWhoisObj($object_name){
        $this->name = $object_name;
        $this->item_info = array();
    }
    
    /**
     * ؿ̾add_item
     *   whois֥Ȥιܤɲä
     * @access  public
     * @param   string  $name   whois֥Ȥι̾netname, descr, ...
     * @param   string  $value  whois֥Ȥι
     * @desc    Ʊ̾ʣɲòǽ
     */
    function add_item($name, $value){
        if(!array_key_exists($name, $this->item_info)){
            $this->item_info[$name] = array();
        }
        array_push($this->item_info[$name], $value);
    }
    
    /**
     * ؿ̾get_item
     *   whois֥Ȥιͤ
     * @access  public
     * @param   string  $name   whois֥Ȥι̾netname, descr, ...
     * @param   integer [$num]  ֹ档Ʊ̾ιܤʣ¸ߤ˻
     * @return  string  whois֥Ȥι
     */
    function get_item($name, $num=0){
        return $this->item_info[$name][$num];
    }
    
    /**
     * ؿ̾get_item_array
     *   whois֥ȤιͤǼ
     * @access  public
     * @param   string  $name   whois֥Ȥι̾netname, descr, ...
     * @return  array   whois֥Ȥι
     */
    function get_item_array($name){
        if(!array_key_exists($name, $this->item_info)){
            return array();
        }
        return $this->item_info[$name];
    }
    
    /**
     * ؿ̾count_item
     *   whois֥ȤΤܤͤο
     * @access  public
     * @param   string  $name   whois֥Ȥι̾inet6num, person, ...
     * @return  integer whois֥Ȥιͤο
     */
    function count_item($name){
        return count($this->get_item_array($name));
    }
}

//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
require_once("RegIpv6AddressUtil.php");
class RegAppWhoisInet6numObj extends RegAppWhoisObj{
    
    /**
     * ؿ̾is_equal
     *   IPɥ쥹֥åפ뤳Ȥǧ
     * @access  public
     * @return  integer     ǧ̡0ס1ס
     */
    function is_equal($ipblock){
        return (RegIpv6AddressUtil::chk_ipblock_overlap($this->get_item("inet6num"), $ipblock) == 1)
        ? 1 : 0;
    }
    
    /**
     * ؿ̾is_allocated
     *   꿶ꥢɥ쥹֥åǤ뤳Ȥǧ
     * @access  public
     * @return  integer     ǧ̡0̤꿶ꡢ1꿶Ѥߡ
     */
    function is_allocated(){
        return preg_match("/^ALLOCATED/", $this->get_item("status"));
    }
    
    /**
     * ؿ̾is_allocated_portable
     *   꿶ǽɥ쥹֥åǤ뤳Ȥǧ
     * @access  public
     * @return  integer     ǧ̡0̤꿶ꡢ1꿶Ѥߡ
     */
    function is_allocated_portable(){
        return preg_match("/^ALLOCATED\s+PORTABLE/", $this->get_item("status"));
    }
    
    /**
     * ؿ̾is_allocated_non_portable
     *   꿶Ѥߥɥ쥹֥åǤ뤳Ȥǧ
     * @access  public
     * @return  integer     ǧ̡0̤꿶ꡢ1꿶Ѥߡ
     */
    function is_allocated_non_portable(){
        return preg_match("/^ALLOCATED\s+NON\-PORTABLE/", $this->get_item("status"));
    }
    
    /**
     * ؿ̾is_assigned
     *   ƥɥ쥹֥åǤ뤳Ȥǧ
     * @access  public
     * @return  integer     ǧ̡0̤꿶ꡢ1꿶Ѥߡ
     */
    function is_assigned(){
        return preg_match("/^ASSIGNED/", $this->get_item("status"));
    }
    
    /**
     * ؿ̾is_assigned_portable
     *   Ʋǽɥ쥹֥åǤ뤳Ȥǧ
     * @access  public
     * @return  integer     ǧ̡0̤꿶ꡢ1꿶Ѥߡ
     */
    function is_assigned_portable(){
        return preg_match("/^ASSIGNED\s+PORTABLE/", $this->get_item("status"));
    }
    
    /**
     * ؿ̾is_assigned_non_portable
     *   ƺѤߥɥ쥹֥åǤ뤳Ȥǧ
     * @access  public
     * @return  integer     ǧ̡0̤꿶ꡢ1꿶Ѥߡ
     */
    function is_assigned_non_portable(){
        return preg_match("/^ASSIGNED\s+NON\-PORTABLE/", $this->get_item("status"));
    }
}
?>