<?php
/**
 * $Id: ins_memorg_class.php,v 1.3 2004/02/27 09:05:11 wtetsuya Exp $
 * mdb_meminfo ꥹ(ID&Password)Υ١饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("REGClass.php");				// DBѹ¤Υ饹
require_once("RegAppDateUtil.php");			// վ桼ƥƥ
require_once("DBAPIWrapper.php");			// DB API
require_once("DBAPI_MEMBER.php");			// DB API memberϢ饹
require_once("RegAppMemDBUtil.php");		// memberϢDB桼ƥƥ
?>

<?php
/**
 * ̾  ins_memorg_class
 *   
 */
class ins_memorg_class
{
	var $reg_db;				// DBAPI_IMPLE
	var $reg_db_mem;			// DBAPI_MEMBER
	var $mem_util;				// memberϢDB桼ƥƥ

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾ins_memorg_class
	 *   ins_memorg_class饹󥹥ȥ饯
	 * @param  $db		DBAPI_IMPLE
	 */
	function ins_memorg_class($db)
	{
		$this->reg_db		= $db;
		$this->reg_db_mem	= new DBAPI_MEMBER($this->reg_db);
		$this->mem_util		= new RegAppMemDBUtil();
	}

	//-----------------------------------------------------------------------
	// public methods(select)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_mem_status
	 *   ȿΥơnormal or stopݤȽꤹ
	 * @param  mem_short	string			ȿά				(i)
	 * @return int	10ȿ¸ߤʤ,status error-1DB³顼(¾ fatal error)
	 */
	function chk_mem_status($mem_short)
	{
		$count = $this->reg_db_mem->count_member_info(
								"member_short_name = '" .
								$mem_short .
								"' and (status = 'normal' or status = 'stop')");
		if ($count === FALSE)
		{
			return -1;
		}
		else if ($count == 0)
		{
			return 0;
		}
		return 1;
	}

	/**
	 * ؿ̾get_mem_info
	 *   ȿconf_obj  m_disp_var ˳Ǽ
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹	(i/o)
	 * @param  fn_array		string[]			̾	(i)
	 * @param  error_str	string[]			顼ɳǼ	(i/o)
	 * @return int	10ȿ¸ߤʤ,status error-1DB³顼(¾ fatal error)
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         ȿά(conf_obj["fn_mem_op_short"]->m_disp_var)б
	 *         롣fn_array ˤ conf_obj Υ̾ꤹ뤳ȡ
	 *
	 *         ex)CSI  organization  ơ
	 *         $conf_obj["fn_mem_op_short"]->m_disp_var = "CSI";
	 *         get_mem_info($conf_obj, array("fn_mem_op_orgen", "fn_mem_stt"), $err)
	 */
	function get_mem_info(&$conf_obj, $fn_array, &$error_str)
	{
		if (!is_array($fn_array))
		{
			array_push($error_str, "D207");		// Ǥʤ顼
			return -1;			// fatal error
		}

		// 륫̾ɲ
		$cols = array();
		for ($fn_cnt = 0; $fn_cnt < count($fn_array); $fn_cnt++)
		{
			array_push($cols, $this->mem_util->fn_col_tbl[$fn_array[$fn_cnt]]);
		}

		// ơåstop or normal
		$result = $this->chk_mem_status($conf_obj["fn_mem_op_short"]->m_disp_var);
		if ($result === -1)
		{
			array_push($error_str, "D207");		// Ǥʤ顼
			return $result;
		}
		else if ($result === 0)
		{
			array_push($error_str, "C020");		// ȿĤʤ顼
			return $result;
		}

		// DBȿʤϾΤߤʤΤǥåʤ
		$mem_tbl = $this->reg_db_mem->get_member_info(
								$conf_obj["fn_mem_op_short"]->m_disp_var,
								$cols);
		if ($mem_tbl === NULL)						// 0
		{
			array_push($error_str, "D207");		// Ǥʤ顼
			return 0;							// ¸ߤʤ error
		}
		if ($mem_tbl === FALSE)						// 
		{
			array_push($error_str, "D207");		// Ǥʤ顼
			return -1;							// fatal error
		}

		//   conf_obj ˳Ǽ
		for ($fn_cnt = 0; $fn_cnt < count($fn_array); $fn_cnt++)
		{
			$conf_obj[$fn_array[$fn_cnt]]->set_disp_var($mem_tbl[0]->{$this->mem_util->fn_col_tbl[$fn_array[$fn_cnt]]});
		}

		return 1;
	}

	//-----------------------------------------------------------------------
	// public methods(update)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chg_mem_org
	 *   Ƽ»ȿȿ̾,Organizationѹ
	 * @param  mem_short	string			ȿά					(i)
	 * @param  chg_orgjp	string			ѹȿ̾				(i)
	 * @param  chg_orgen	string			ѹOrganization		(i)
	 * @param  lastupdate	date data		ǧ̤ǳǽ(i)
	 * @param  clerk_id		string									(i)
	 * @param  error_str	string[]		顼ɳǼ		(i/o)
	 * @return boolean  TRUE:FALSE:
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         lastupdate  ľκǽ󤬰פʤϥ顼Ȥ롣
	 */
	function chg_mem_org($mem_short, $chg_orgjp, $chg_orgen, $lastupdate, $clerk_id, &$error_str)
	{
		if ($clerk_id === null || $mem_short === null || $chg_orgjp === null || $chg_orgen === null)
		{
			array_push($error_str, "C120");		// Ǥʤ顼
			return FALSE;
		}
		if ($clerk_id === "" || $mem_short === "" || $chg_orgjp === "" || $chg_orgen === "")
		{
			array_push($error_str, "C120");		// Ǥʤ顼
			return FALSE;
		}

		$last_date	= RegAppDateUtil::make_current_date_db();	// 
		//-------------------------------------------------------------------
		// DB
		//-------------------------------------------------------------------
		// ȥ󥶥󳫻
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "C114");		// Ǥʤ顼
			return FALSE;
		}

		//----- åơåȿֹ,ǽ -----//
		$sql_str  = "SELECT member_number, last_update_date FROM mdb_meminfo WHERE" .
					" member_short_name = " . GetApsString($mem_short) . " AND" .
					" status IN('stop', 'normal')" . 
					" FOR UPDATE";
		$db_result = $this->reg_db->dbapi_query_lock($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C120");					// ѹԥ顼
			return FALSE;
		}
		if ($db_result === NULL)							// 
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C111");					// normal,stopǤ٤
			return FALSE;
		}

		if (strcmp($lastupdate, $db_result[0]["last_update_date"]) !== 0)
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D401");					// Ƥ륨顼
			return FALSE;
		}

		$tmp_memnum	= $db_result[0]["member_number"];	// ȿֹǼ

		//----- ȿ̾,organizationѹ -----//
		$sql_str  = "UPDATE mdb_meminfo SET" .
					" organization_jp = " . GetApsString($chg_orgjp) . "," .
					" organization_en = " . GetApsString($chg_orgen) . "," .
					" last_update_date = " . GetApsString($last_date) .
					" WHERE member_number = " . $tmp_memnum;
		$db_result = $this->reg_db->dbapi_query_update($sql_str);
		if ($db_result === FALSE || $db_result == 0)
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C120");					// Ǥʤ顼
			return FALSE;
		}

		//----- ҥȥɲ -----//
		$sql_str = $this->mem_util->create_insert_str(
						array("member_number",
							  "organization_jp",
							  "organization_en",
							  "update_person",
							  "update_date",
							  "accept_id",
							  "operation_id"),
						array($tmp_memnum,
							  $chg_orgjp,
							  $chg_orgen,
							  $clerk_id,
							  $last_date,
							  "",
							  "ins0302"),
						array(FALSE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE));
		$sql_str = "INSERT INTO MDB_MEM_UPDATE_HISTORY" . $sql_str;
		$db_result = $this->reg_db->dbapi_query_insert($sql_str);
		if ($db_result === FALSE || $db_result == 0)
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C120");			// Ǥʤ顼
			return FALSE;
		}

		// ߥå
		$this->reg_db->REGDB_commit();
		return TRUE;
	}
}
?>
