<?php
/**
 * $Id: ops_0201_class.php,v 1.4 2004/02/27 07:38:27 wtetsuya Exp $
 * IPɥ쥹꿶֥åֵѿ(ops0201)ѤΥ桼ƥƥ饹
 */
?>
<?php
//---------------------------------------------------------------------------
// include,require
//---------------------------------------------------------------------------
require_once("RegAppFormUtil.php");

//---------------------------------------------------------------------------
// define
//---------------------------------------------------------------------------
define("DEL_CIDR_MAX", 10);			// ֵѥ֥å

/**
 * ̾  ops_0201_class
 *   IPɥ쥹꿶֥åֵѿ(ops0201)桼ƥƥ饹
 */
class ops_0201_class
{
	//-----------------------------------------------------------------------
	// public methods
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾set_review_data
	 *   ƳǧѤΥǡСȤԤ
	 *         POSTǡ˺ǽ򥻥åȤɽǡHTMLԤ
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹				(i/o)
	 * @param  cidr_ls_conf	RegAppDispConf[][]	ֵѥɥ쥹֥åꥹ		(i/o)
	 */
	function set_review_data(&$conf_obj, &$cidr_ls_conf)
	{
		$var_array = array();			// ǽꥹ
		foreach ($cidr_ls_conf as $key => $value)
		{
			$fn_key = strtr($value["fn_cidr_ip_address"]->m_disp_var, ".", "_");
			$conf_obj[$fn_key] =
						new RegAppDispConf("", 0, $value["fn_cidr_last_date"]->m_disp_var);

			// $cidr_ls_conf HTMLɽѤ˥򤹤
			$conv_key = array_keys($value);
			RegAppFormUtil::conv_dispvars_htmlstr($cidr_ls_conf[$key], $conv_key);
		}

		// conf_obj HTML
		$conv_key = array_keys($conf_obj);
		RegAppFormUtil::conv_dispvars_htmlstr($conf_obj, $conv_key);
	}

	/**
	 * ؿ̾set_post_last_date
	 *   POST줿ǽ
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹	(i/o)
	 * @return date_date	ǽϢʥIPɥ쥹͡ǽ
	 */
	function set_post_last_date($conf_obj)
	{
		if (!is_array($conf_obj["fn_cidr_ip_address"]->m_disp_var))
		{
			return "";
		}

		$last_list = "";
		foreach ($conf_obj["fn_cidr_ip_address"]->m_disp_var as $value)
		{
			$fn_key = strtr($value, ".", "_");
			if (!isset($_POST[$fn_key]))
				return "";
			$last_list[$value] = $_POST[$fn_key];
			if (chk_date_for_db($last_list[$value]) != REG_APP_INPUT_CHK_OK)
				return "";
		}
		return $last_list;
	}

	//-----------------------------------------------------------------------
	// public methods(󥿥å)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_cidr_select_num
	 *   POSTǡΥɥ쥹֥åϸĿå
	 * @param  conf_obj		RegAppDispConf		̾󥢥ɥ쥹֥å饹	(i)
	 * @param  error_str	string[]			顼ɳǼ			(i/o)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function chk_cidr_select_num($conf_obj, &$error_str)
	{
		if (!is_array($conf_obj->m_disp_var) || count($conf_obj->m_disp_var) <= DEL_CIDR_MAX)
			return TRUE;

		array_push($error_str, "D046");		// 10Ĥޤ
		return FALSE;
	}

	//-----------------------------------------------------------------------
	// public methods(HTML)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾print_cidrls_table
	 *   꿶ֵоݤȤʤ륢ɥ쥹֥åꥹȤɽ
	 * @param  ls_tbl		string[]	IPɥ쥹
	 *                      	      array("43.0.0.0/16", "43.1.0.0/16",...)
	 * @param  col_num		integer		
	 * @desc   <input type="checkbox" name="fn_cidr_ip_address[]" value="IPɥ쥹">IPɥ쥹
	 *         򣱤ĤΥꤷơ֥ɽ롣
	 */
	function print_cidrls_table($conf_obj, $ls_tbl, $col_num=3)
	{
		// ǤƤɬ array ˤʤäƤϤ
		if (!is_array($ls_tbl))
		{
			return;
		}

		include("RegAppTableStyle.php");

		$checked_num = 0;							// åָ߷
		if (!is_array($conf_obj->m_disp_var))
		{
			$check_max = 0;							// å
		}
		else
		{
			$check_max = count($conf_obj->m_disp_var);
			if ($check_max > DEL_CIDR_MAX)
			{
				$check_max = DEL_CIDR_MAX;					// ϣ
			}
		}

		if ($col_num < 1)
			$col_num = 3;		// ۾ʹݤ

		$item_num	= count($ls_tbl);				// 
		$line_num	= (int)($item_num / $col_num);	// ɽԿ򻻽
		$td_width	= (int)(100 / $col_num);		// 
		$line_n		= 0;							// ɽԥ

		print ("<table border=\"0\" class=\"" . $table_style . "\">\n");

		// ɽԤİʾ夢
		if ($line_num > 0)
		{
			// Ԥ
			for ($line_n = 0; $line_n < $line_num; $line_n++)
			{
				print ("<tr>\n");
				for ($col_n = 0; $col_n < $col_num; $col_n++)	// $col_num ʬɽ
				{
					$disp_cnt = (($line_n * $col_num) + $col_n);
					if (($checked_num < $check_max) && (in_array($ls_tbl[$disp_cnt], $conf_obj->m_disp_var)))
					{
						$checkedstr = " checked";
						$checked_num++;
					}
					else
					{
						$checkedstr = "";
					}

					$dips_var = htmlspecialchars($ls_tbl[$disp_cnt], ENT_QUOTES);
					print ("<td class=\"tdlistitem\" width=\"" . $td_width . "%\">\n");
					print ("&nbsp;&nbsp;<input type=\"checkbox\" name=\"fn_cidr_ip_address[]\" value=\"" . 
						   $dips_var . "\"" . $checkedstr . "><b>" . $dips_var . "</b>\n");
					print ("</td>\n");
				}
				print ("</tr>\n");
			}
		}

		// Ĥɽ(;꤬)
		if (($ls_tbl % $col_num) > 0)
		{
			print ("<tr>\n");
			// ǸΣԤ
			for ($col_n = 0; $col_n < $col_num; $col_n++)
			{
				$disp_cnt = ($line_n * $col_num) + $col_n;		// ɽƥΥǥå
				if ($disp_cnt < $item_num)						// ޤƥब¸ߤ
				{
					if (($checked_num < $check_max) && (in_array($ls_tbl[$disp_cnt], $conf_obj->m_disp_var)))
					{
						$checkedstr = " checked";
						$checked_num++;
					}
					else
					{
						$checkedstr = "";
					}

					$dips_var = htmlspecialchars($ls_tbl[$disp_cnt], ENT_QUOTES);
					print ("<td class=\"tdlistitem\" width=\"" . $td_width . "%\">\n");
					print ("&nbsp;&nbsp;<input type=\"checkbox\" name=\"fn_cidr_ip_address[]\" value=\"" . 
						   $dips_var . "\"" . $checkedstr . "><b>" . $dips_var . "</b>\n");
					print ("</td>\n");
				}
				else
				{
					// ƥϤʤΤǶ
					print ("<td class=\"tdlistitem\" width=\"" . $td_width . "%\">&nbsp;</td>\n");
				}
			}
			print ("</tr>\n");
		}

		print ("</table>\n");
	}
}
?>
