<?php
//$Id: DBAPIWrapper.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $

/* DBAPI̤ǻȤե뷲require */
require_once("common_function.php");
require_once("result.php");
require_once("DBAPI_BASE.php");
require_once("REGDBfunc.php");
require_once("RegV6pcLog.php");
require_once("REGClass.php");
require_once("APP_MDB_Select.php");
require_once("reg_lock.php");
require_once("reg_sql.php");
/* ޤ */

$reg_db_flag = true;  //regdb_execregdb_send_queryƤȤSQLSYSLOGϿ뤫Ƚ̤ե饰

class DBAPI_IMPL extends DBAPI_BASE
{
	/**
	* ؿDBAPI_IMPL
	* 󥹥ȥ饯
	* @param ʤ
	* @return ʤ
	*/
	function DBAPI_IMPL()
	{
		$par = get_parent_class($this);
		$this->$par();
	}
	
	//---------- DBϢ ----------
	/**
	* ؿREGDB_connect
	* DB³
	* @param DB³
	* @return DB³ϥɥ
	*/
	function REGDB_connect($dsn="")
	{
		if($this->profile_log)
		{
			$this->_pre_func("REGDB_connect");
        }
		$this->con = REGDB_connect($dsn);
        $this->dsn = $dsn;
        if($this->profile_log)
		{
			$this->_post_func("REGDB_connect");
        }
		return $this->con;
	}
	
	/**
	* ؿREGDB_close
	* DB³򥯥
	* @param ʤ
	* @return 
	*/
	function REGDB_close()
	{
		if($this->profile_log)
		{
			$this->_pre_func("REGDB_close");
        }
		$ret = REGDB_close($this->con);
        $this->con = null;
        if($this->profile_log)
		{
			$this->_post_func("REGDB_close");
        }
		return $ret;
	}
	
	/**
	* ؿREGDB_begin
	* ȥ󥶥󳫻
	* @param ȥ󥶥٥(ǥեȤϥ꡼ɥߥåƥå)
	* @return 
	*/
	function REGDB_begin($level=null)
	{
		if($this->profile_log)
		{
			$this->_pre_func("REGDB_begin");
        }
		$ret = $this->begin($level);
        if($this->profile_log)
		{
			$this->_post_func("REGDB_begin");
        }
		return $ret;
	}
	
	/**
	* ؿREGDB_rollback
	* ȥ󥶥Хå
	* @param ʤ
	* @return 
	*/
	function REGDB_rollback()
	{
		if($this->profile_log)
		{
			$this->_pre_func("REGDB_rollback");
        }
		$ret = $this->rollback();
        if($this->profile_log)
		{
			$this->_post_func("REGDB_rollback");
        }
		return $ret;
	}
	
	/**
	* ؿREGDB_commit
	* ȥ󥶥󥳥ߥå
	* @param ʤ
	* @return 
	*/
	function REGDB_commit()
	{
		if($this->profile_log)
		{
			$this->_pre_func("REGDB_commit");
        }
		$ret = $this->commit();
        if($this->profile_log)
		{
			$this->_post_func("REGDB_commit");
        }
		return $ret;
	}
	
	//---------- ٥API ----------
	/**
	* ؿdbapi_query
	* SQL¹Ԥ
	* @param SQLʸ
	* @return 
	*/
    function dbapi_query($sql)
	{
        if($this->profile_log)
        {
        	$this->_pre_func("DBAPI_Query");
        }
        $debugParam = array($sql);
        $this->_debug_log("DBAPI_Query", $debugParam);
        $this->result = DBAPI_Query($this->con, $sql);
        $ret = $this->_dbapi_return("DBAPI_Query", $debugParam);
        if($this->profile_log)
        {
        	$this->_post_func("DBAPI_Query");
        }
        return $ret;
    }
	
	/**
	* ؿdbapi_query_count
	* COUNTؿޤSQLʸ¹Ԥ
	* @param SQLʸ
	* @return ԡfalse
	*/
	function dbapi_query_count($sql)
	{
		if($this->profile_log)
        {
        	$this->_pre_func("DBAPI_Query_Count");
        }
        $debugParam = array($sql);
        $this->_debug_log("DBAPI_Query_Count", $debugParam);
        $this->result = DBAPI_Query_Count($this->con, $sql);
        $ret = $this->_dbapi_return("DBAPI_Query_Count", $debugParam);
        if($this->profile_log)
        {
        	$this->_post_func("DBAPI_Query_Count");
        }
        return $ret;
	}
	
	/**
	* ؿdbapi_query_update
	* UPDATEʸ¹Ԥ
	* @param SQLʸ
	* @return ԡfalse
	*/
	function dbapi_query_update($sql)
	{
		if($this->profile_log)
        {
        	$this->_pre_func("DBAPI_Query_Update");
        }
        $debugParam = array($sql);
        $this->_debug_log("DBAPI_Query_Update", $debugParam);
        $this->result = DBAPI_Query_Update($this->con, $sql);
        $ret = $this->_dbapi_return("DBAPI_Query_Update", $debugParam);
        if($this->profile_log)
        {
        	$this->_post_func("DBAPI_Query_Update");
        }
        return $ret;
	}
	
	/**
	* ؿdbapi_query_insert
	* INSERTʸ¹Ԥ
	* @param SQLʸ
	* @return ԡfalse
	*/
	function dbapi_query_insert($sql)
	{
		if($this->profile_log)
        {
        	$this->_pre_func("DBAPI_Query_Insert");
        }
        $debugParam = array($sql);
        $this->_debug_log("DBAPI_Query_Insert", $debugParam);
        $this->result = DBAPI_Query_Insert($this->con, $sql);
        $ret = $this->_dbapi_return("DBAPI_Query_Insert", $debugParam);
        if($this->profile_log)
        {
        	$this->_post_func("DBAPI_Query_Insert");
        }
        return $ret;
	}
	
	/**
	* ؿdbapi_query_delete
	* DELETEʸ¹Ԥ
	* @param SQLʸ
	* @return ԡfalse
	*/
	function dbapi_query_delete($sql)
	{
		if($this->profile_log)
        {
        	$this->_pre_func("DBAPI_Query_Delete");
        }
        $debugParam = array($sql);
        $this->_debug_log("DBAPI_Query_Delete", $debugParam);
        $this->result = DBAPI_Query_Delete($this->con, $sql);
        $ret = $this->_dbapi_return("DBAPI_Query_Delete", $debugParam);
        if($this->profile_log)
        {
        	$this->_post_func("DBAPI_Query_Delete");
        }
        return $ret;
	}
	
	/**
	* ؿdbapi_query_lock
	* SELECT FOR UPDATEʸLOCK TABLEʸȯԤ
	* @param SQLʸ
	* @param ߥå
	* @return falseDB꡼ԡåॢȥ顼null꡼̤
	*/
	function dbapi_query_lock($sql, $time=LOCK_TIME_LIMIT)
	{
		if($this->profile_log)
		{
			$this->_pre_func("DBAPI_Query_Lock");
		}
		$debugParam = array($sql, $time);
		$this->_debug_log("DBAPI_Query_Lock", $debugParam);
		$this->result = DBAPI_Query_Lock($this->con, $sql, $time);
		$ret = $this->_dbapi_return("DBAPI_Query_Lock", $debugParam);
		if($this->profile_log)
		{
			$this->_post_func("DBAPI_Query_Lock");
		}
		return $ret;
	}
}

?>
