<?php
//$Id: DBAPI_CLERK.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $
require_once("sdb_clerk_info.php");

class DBAPI_CLERK extends DBAPI_BASE
{
  /**
  * DBAPI_CLERK
  * @desc 󥹥ȥ饯
  * @param DBAPI_IMPL֥
  * @return ʤ
  */
  function DBAPI_CLERK($db="")
  {
    if($db == "")
    {
      $db = DBAPI::connect();
    }
    foreach(get_object_vars($db) as $key => $value)
    {
      $this->$key = $value;
    }
    return $this;
  }
  
  /**
  * get_clerk_passwd
  * @desc ̳ôԤΥѥɤ
  * @param ôID
  * @retrun ѥ
  */
  function get_clerk_passwd($clerk_id)
  {
    if($this->profile_log)
    {
      $this->_pre_func("GetClerkPasswd");
        }
    $debugParam = array($clerk_id);
        $this->_debug_log("GetClerkPasswd", $debugParam);
        $this->result = GetClerkPasswd($this->con, $clerk_id);
        $ret = $this->_dbapi_return("GetClerkPasswd", $debugParam);
        if($this->profile_log)
    {
      $this->_post_func("GetClerkPasswd");
        }
    return $ret;
  }
  
  /**
  * save_clerk_passwd
  * @desc ̳ôԤΥѥɤ¸
  * @param ôID
  * @param ѥ
  * @return true/false
  */
  function save_clerk_passwd($clerk_id, $passwd)
  {
    if($this->profile_log)
    {
      $this->_pre_func("SaveClerkPasswd");
        }
    $debugParam = array($clerk_id, $passwd);
        $this->_debug_log("SaveClerkPasswd", $debugParam);
        $this->result = SaveClerkPasswd($this->con, $clerk_id, $passwd);
        $ret = $this->_dbapi_return("SaveClerkPasswd", $debugParam);
        if($this->profile_log)
    {
      $this->_post_func("SaveClerkPasswd");
        }
    return $ret;
  }
  
  /**
  * get_clerk_info
  * @desc ôԾ
  * @param ôID
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return SDB_CLERK_INFO¤(array)
  */
  function get_clerk_info($clerk_id, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "clerk_id,full_name,auth_level";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetClerkInfo");
        }
    $debugParam = array($clerk_id);
        $this->_debug_log("GetClerkInfo", $debugParam);
        $this->result = GetClerkInfo($this->con, $clerk_id, $selcol, $ext);
        $ret = $this->_dbapi_return("GetClerkInfo", $debugParam);
        if($this->profile_log)
    {
      $this->_post_func("GetClerkInfo");
        }
    return $ret;
  }
  
  /**
  * search_clerk_info
  * @desc ôԾ򸡺
  * @param ôID
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return SDB_CLERK_INFO¤(array)
  */
  function search_clerk_info($condition, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "clerk_id,full_name,auth_level";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SearchClerkInfo");
        }
    $debugParam = array($condition);
        $this->_debug_log("SearchClerkInfo", $debugParam);
        $this->result = SearchClerkInfo($this->con, $condition, $selcol, $ext);
        $ret = $this->_dbapi_return("SearchClerkInfo", $debugParam);
        if($this->profile_log)
    {
      $this->_post_func("SearchClerkInfo");
        }
    return $ret;
  }
  
  /**
  * count_clerk_info
  * @desc ˥ޥåԿ
  * @param 
  * @return Կ
  */
  function count_clerk_info($condition="")
  {
    if($condition != "")
    {
      $condition = "where " . $condition;
    }
    if($this->profile_log)
    {
      $this->_pre_func("CountClerkInfo");
        }
    $debugParam = array($condition);
        $this->_debug_log("CountClerkInfo", $debugParam);
        $this->result = CountClerkInfo($this->con, $condition);
        $ret = $this->_dbapi_return("CountClerkInfo", $debugParam);
        if($this->profile_log)
    {
      $this->_post_func("CountClerkInfo");
        }
    return $ret;
  }
  
  /**
  * create_clerk_info
  * @desc ôԾ򿷵
  * @param SDB_CLERK_INFO¤
  * @param ѥ
  * @return true/false
  */
  function create_clerk_info($sdb_clerk_info, $password)
  {
    if($this->profile_log)
    {
      $this->_pre_func("CreateClerkInfo");
        }
    $debugParam = array($sdb_clerk_info);
        $this->_debug_log("CreateClerkInfo", $debugParam);
        $this->result = CreateClerkInfo($this->con, $sdb_clerk_info, $password);
        $ret = $this->_dbapi_return("CreateClerkInfo", $debugParam);
        if($this->profile_log)
    {
      $this->_post_func("CreateClerkInfo");
        }
    return $ret;
  }
  
  /**
  * save_clerk_info
  * @desc ôԾ򹹿
  * @param SDB_CLERK_INFO¤
  * @param ¸̾ȥǡ(array)
  * @return true/false
  */
  function save_clerk_info($sdb_clerk_info, $column_array="")
  {
    $selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "clerk_id,full_name,auth_level";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SaveClerkInfo");
        }
    $debugParam = array($sdb_clerk_info);
        $this->_debug_log("SaveClerkInfo", $debugParam);
        $this->result = SaveClerkInfo($this->con, $sdb_clerk_info, $selcol);
        $ret = $this->_dbapi_return("SaveClerkInfo", $debugParam);
        if($this->profile_log)
    {
      $this->_post_func("SaveClerkInfo");
        }
    return $ret;
  }
  
  /**
  * delete_clerk_info
  * @desc ôԾ
  * @param ôID
  * @return true/false
  */
  function delete_clerk_info($clerk_id)
  {
    if($this->profile_log)
    {
      $this->_pre_func("DeleteClerkInfo");
        }
    $debugParam = array($clerk_id);
        $this->_debug_log("DeleteClerkInfo", $debugParam);
        $this->result = DeleteClerkInfo($this->con, $clerk_id);
        $ret = $this->_dbapi_return("DeleteClerkInfo", $debugParam);
        if($this->profile_log)
    {
      $this->_post_func("DeleteClerkInfo");
        }
    return $ret;
  }
}

?>
