<?php
//$Id: DBAPI_OPR0102.php,v 1.5 2004/02/27 10:32:21 wtetsuya Exp $
require_once("sdb_apply_info.php");
require_once("sdb_form_common.php");
require_once("sequence_number.php");
require_once("sdb_form_opr0102.php");

class DBAPI_OPR0102 extends DBAPI_BASE
{
  /**
  * DBAPI_OPR0102
  * @desc 󥹥ȥ饯
  * @param DBAPI_IMPL֥
  * @return ʤ
  */
  function DBAPI_OPR0102($db="")
  {
    if($db == "")
    {
      $db = DBAPI::connect();
    }
    foreach(get_object_vars($db) as $key => $value)
    {
      $this->$key = $value;
    }
    return $this;
  }
  
  /**
  * get_apply_form_opr0102
  * @desc Ƽ»ȿϿ
  * @param No
  * @param ߤǡΥ̾(array)
  * @return SDB_FORM_OPR0102¤
  */
  function get_apply_form_opr0102($accept_id, $column_array="")
  {
    $selcol = "";
    $sub_selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "notice_address" || $value == "extra_info")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "accept_id,member_short_name,representative,applicant_mail_address,applicant_postal_code_number,applicant_address_jp,applicant_address_en,applicant_member_tel_number,applicant_member_fax_number,organization_jp,organization_en,mail_address,postal_code_number,address_jp,address_en,member_tel_number,member_fax_number";
      $sub_selcol = "notice_address,extra_info";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetApplyForm_OPR0102");
    }
    $debugParam = array($accept_id);
    $this->_debug_log("GetApplyForm_OPR0102", $debugParam);
    $this->result = GetApplyForm_OPR0102($this->con, $accept_id, $selcol, $sub_selcol);
    $ret = $this->_dbapi_return("GetApplyForm_OPR0102", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetApplyForm_OPR0102");
    }
    return $ret;
  }
  
  /**
  * create_apply_form_opr0102
  * @desc Ƽ»ȿϿ򿷵
  * @param SDB_APPLY_INFO¤
  * @param SDB_FORM_OPR0102¤
  * @param źեեǼǥ쥯ȥؤΥѥ
  * @return No
  */
  function create_apply_form_opr0102($apply_info, $opr0102, $path)
  {
    if(!is_array($opr0102->extra_info)){
      $opr0102->extra_info = array();
    }
    if(!is_array($opr0102->notice_address)){
      $opr0102->notice_address = array();
    }
    if($this->profile_log)
    {
      $this->_pre_func("CreateApplyForm_OPR0102");
    }
    $debugParam = array($apply_info, &$opr0102, $path);
    $this->_debug_log("CreateApplyForm_OPR0102", $debugParam);
    $this->result = CreateApplyForm_OPR0102($this->con, $apply_info, &$opr0102, $path);
    $ret = $this->_dbapi_return("CreateApplyForm_OPR0102", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CreateApplyForm_OPR0102");
    }
    return $ret;
  }
  
  /**
  * save_apply_form_opr0102
  * @desc Ƽ»ȿϿ򹹿
  * @param SDB_FORM_OPR0102¤
  * @param ¸̾ȥǡ(array)
  * @return ʤ
  */
  function save_apply_form_opr0102($opr0102, $column_array="")
  {
    if(!is_array($opr0102->extra_info)){
      $opr0102->extra_info = array();
    }
    if(!is_array($opr0102->notice_address)){
      $opr0102->notice_address = array();
    }
    $selcol = "";
    $sub_selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "notice_address" || $value == "extra_info")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "accept_id,member_short_name,representative,applicant_mail_address,applicant_postal_code_number,applicant_address_jp,applicant_address_en,applicant_member_tel_number,applicant_member_fax_number,organization_jp,organization_en,mail_address,postal_code_number,address_jp,address_en,member_tel_number,member_fax_number";
      $sub_selcol = "notice_address,extra_info";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SaveApplyForm_OPR0102");
    }
    $debugParam = array($opr0102);
    $this->_debug_log("SaveApplyForm_OPR0102", $debugParam);
    $this->result = SaveApplyForm_OPR0102($this->con, $opr0102, $selcol, $sub_selcol);
    $ret = $this->_dbapi_return("SaveApplyForm_OPR0102", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SaveApplyForm_OPR0102");
    }
    return $ret;
  }
}

?>
