<?php
//$Id: DBAPI_OPS0212.php,v 1.2 2004/02/12 10:59:11 wtetsuya Exp $
require_once("sdb_apply_info.php");
require_once("sdb_form_common.php");
require_once("sequence_number.php");
require_once("sdb_form_ops0212.php");
require_once("mdb_common.php");

class DBAPI_OPS0212 extends DBAPI_BASE
{
  /**
  * DBAPI_OPS0212
  * @desc 󥹥ȥ饯
  * @param DBAPI_IMPL֥
  * @return ʤ
  */
  function DBAPI_OPS0212($db="")
  {
    if($db == "")
    {
      $db = DBAPI::connect();
    }
    foreach(get_object_vars($db) as $key => $value)
    {
      $this->$key = $value;
    }
    return $this;
  }
  
  /**
  * get_apply_form_ops0212
  * @desc Ƽ»ȿѹ
  * @param No
  * @param ߤǡΥ̾(array)
  * @return SDB_FORM_OPS0212¤
  */
  function get_apply_form_ops0212($accept_id, $column_array="")
  {
    $selcol = "";
    $sub_selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "notice_address")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "accept_id,member_short_name,representative,applicant_mail_address,applicant_postal_code_number,applicant_address_jp,applicant_address_en,applicant_member_tel_number,applicant_member_fax_number,organization_jp,organization_en,mail_address,postal_code_number,address_jp,address_en,member_tel_number,member_fax_number";
      $sub_selcol = "notice_address";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetApplyForm_OPS0212");
    }
    $debugParam = array($accept_id);
    $this->_debug_log("GetApplyForm_OPS0212", $debugParam);
    $this->result = GetApplyForm_OPS0212($this->con, $accept_id, $selcol, $sub_selcol);
    $ret = $this->_dbapi_return("GetApplyForm_OPS0212", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetApplyForm_OPS0212");
    }
    return $ret;
  }
  
  /**
  * create_apply_form_ops0212
  * @desc Ƽ»ȿѹ򿷵
  * @param SDB_APPLY_INFO¤
  * @param SDB_FORM_OPS0212¤
  * @return No
  */
  function create_apply_form_ops0212($apply_info, $ops0212)
  {
    if(!is_array($ops0212->notice_address)){
      $ops0212->notice_address = array();
    }
    if($this->profile_log)
    {
      $this->_pre_func("CreateApplyForm_OPS0212");
    }
    $debugParam = array($apply_info, &$ops0212);
    $this->_debug_log("CreateApplyForm_OPS0212", $debugParam);
    $this->result = CreateApplyForm_OPS0212($this->con, $apply_info, &$ops0212);
    $ret = $this->_dbapi_return("CreateApplyForm_OPS0212", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CreateApplyForm_OPS0212");
    }
    return $ret;
  }
  
  /**
  * save_apply_form_ops0212
  * @desc Ƽ»ȿѹ򹹿
  * @param SDB_FORM_OPS0212¤
  * @param ¸̾ȥǡ(array)
  * @return ʤ
  */
  function save_apply_form_ops0212($ops0212, $column_array="")
  {
    if(!is_array($ops0212->notice_address)){
      $ops0212->notice_address = array();
    }
    $selcol = "";
    $sub_selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "notice_address")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "accept_id,member_short_name,representative,applicant_mail_address,applicant_postal_code_number,applicant_address_jp,applicant_address_en,applicant_member_tel_number,applicant_member_fax_number,organization_jp,organization_en,mail_address,postal_code_number,address_jp,address_en,member_tel_number,member_fax_number";
      $sub_selcol = "notice_address";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SaveApplyForm_OPS0212");
    }
    $debugParam = array($ops0212);
    $this->_debug_log("SaveApplyForm_OPS0212", $debugParam);
    $this->result = SaveApplyForm_OPS0212($this->con, $ops0212, $selcol, $sub_selcol);
    $ret = $this->_dbapi_return("SaveApplyForm_OPS0212", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SaveApplyForm_OPS0212");
    }
    return $ret;
  }
}

?>
