<?php
//$Id: REGDBfunc.php,v 1.2 2004/01/27 03:52:27 yoshi_s Exp $

require_once("RegV6pcLog.php");

/*
 * ؿ: REGDB_connect
 * : DBȤΥͥ³롣
 * @param  resource  $connectInfo  ͥ꥽
 * @param  resource  $connectInfo  ͥ꥽
 * @return resource  ݤ
*/
function REGDB_connect($connectInfo = ""){
  if ($connectInfo == ""){
    //Ķѿۥȡ桼DB̾
    $host = getenv("REGV6_DB_HOST");
    $user = getenv("REGV6_DB_USER");
    $name = getenv("REGV6_DB_NAME");
    if ($host) {
      $connectInfo .= " host=$host";
    }
    if ($user) {
      $connectInfo .= " user=$user";
    }
    if ($name) {
      $connectInfo .= " dbname=$name";
    }
  }
  //DB³
  $con = @pg_connect($connectInfo);
  if ($con == false){
    RegV6pcLog::err("DBAPI::can't connect:($connectInfo)");
    return null;
  }
  RegV6pcLog::debug("DBAPI::REG_connect($connectInfo)");
  //̤֤
  return $con;
}

/*
 * ؿ: REGDB_close
 * : DBȤΥͥǤ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  resource  $con  DBؤΥͥ꥽
 * @return resource  ݤ
*/
function REGDB_close($con){
  //³򥯥Ʒ̤֤
  RegV6pcLog::debug("REG_close()");
  return true ;
}

/*
 * ؿ: REGDB_begin
 * : Ϳ줿ȥ󥶥٥˽ȥ󥶥򳫻Ϥ롣
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $level  ȥ󥶥٥
 * @param  string  $level  ȥ󥶥٥
 * @return resource  ݤ
*/
function REGDB_begin($con, $level = null){
  //ؿregdb_execΥ:SQL(begin)¹ԤƷ̤
  $result = regdb_exec($con, "begin");
  if(!$result) return $result;
  //ȥ󥶥٥λ꤬ SQL ʸ롣
  if($level && in_array(strtoupper($level), array("READ COMMITTED","SERIALIZABLE")))
    //ؿregdb_execΥ:SQL¹ԤƷ̤
    $result = regdb_exec($con, "set transaction isolation level ".$level);
  //̤֤
  return $result;
}

/*
 * ؿ: REGDB_rollback
 * : ȥ󥶥Хå롣
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  resource  $con  DBؤΥͥ꥽
 * @return resource  ݤ
*/
function REGDB_rollback($con){
  //ؿregdb_exec(rollback)η̤򤽤Τޤ֤:SQL¹ԤƷ̤
  return regdb_exec($con, "rollback");
}

/*
 * ؿ: REGDB_commit
 * : ȥ󥶥򥳥ߥåȤ롣
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  resource  $con  DBؤΥͥ꥽
 * @return resource  ݤ
*/
function REGDB_commit($con){
  //ؿregdb_exec(commit)η̤򤽤Τޤ֤:SQL¹ԤƷ̤
  return regdb_exec($con, "commit");
}

?>
