<?php
//$Id: allocate.php,v 1.12 2004/02/27 10:32:21 wtetsuya Exp $

/**
* ؿMDBCIDRUpdate
* cidrγ꿶ȼDB򤪤ʤ(cidr_unallocate_blockcidr_blockȤΥҥȥ)
* @param$conDBͥ꥽
* @param$cidr꿶꾵ǧcidr
* @param$updateinfoMDB_UPDATE_INFO¤
* @param$member_number꿶Ƽ»ȿȿֹ
* @param$datecidr_blockinitial_registration_datelast_update_date˵롣꤬ʤäϤΥ⥸塼뤬ư
* @param$notecidr_blocknote˵
* @returnDB_RESULT_INFO¤
* @descȥ󥶥ϸƤӽФbeginƤȡ
*/
function MDBCIDRUpdate($con, $cidr, $updateinfo, $member_number, $date="", $note="")
{
  if($date == "")
  {
    $now = date("Y-m-d H:i:s T");  //ƥθ߻
  }
  else
  {
    $now = $date;  //ץλꤷ
  }
  
  //Ƽ»ȿϿ꿶κݤɲä̤
  $op_str_add = $updateinfo->operation_id . "_add";
  //Ƽ»ȿϿ꿶κݤκ̤
  $op_str_del = $updateinfo->operation_id . "_del";

  foreach($cidr as $val)
  {
    $range = RegIpv6AddressUtil::get_sequence_num($val);
    $sql_fmt = <<<_END_
SELECT COUNT(*) FROM cidr_allocated_block WHERE ip_network_number >>= cidr %s
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($val)
    );

    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
    if($check->is_error)
    {
      return $check;
    }
    $numrows = pg_numrows($result);
    $row = pg_fetch_array($result, 0, PGSQL_ASSOC);
    //̤1ԤǤͤ1ʳNG
    if($numrows != 1 || $row[count] != 1)
    {
      return new DB_RESULT_INFO(false, null, NO_COLUMN_SELECT);
    }
    $sql_fmt = <<<_END_
SELECT 
  ip_network_number,
  prefix_length,
  start_sequence_number,
  end_sequence_number,
  initial_registration_date,
  last_update_date,
  member_number,
  status,note 
FROM cidr_unallocate_block 
WHERE ip_network_number >>= cidr %s
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($val)
    );

    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
    if($check->is_error)
    {
      return $check;
    }
    $numrows = pg_numrows($result);
    if($numrows != 1)
    {
      return new DB_RESULT_INFO(false, null, NO_COLUMN_SELECT);
    }
    $row = pg_fetch_array($result, 0, PGSQL_ASSOC);
    //ǤȤ᤿쥳ɤDB
    $sql = "DELETE FROM cidr_unallocate_block WHERE ip_network_number = cidr ".GetApsString($row[ip_network_number]);
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorDeleteSome($con, $result, __FILE__, __LINE__);
    if($check->is_error)
    {
      return $check;
    }
    if($check->db_result_info != 1)
    {
      return new DB_RESULT_INFO(false, null, NO_RECORD_DELETE);
    }
    $sql_fmt = <<<_END_
INSERT INTO cidr_unallocate_block_history(
    ip_network_number, 
    prefix_length, 
    start_sequence_number, 
    end_sequence_number, 
    initial_registration_date, 
    last_update_date, 
    member_number, 
    status, 
    note, 
    update_person, 
    update_date, 
    accept_id, 
    operation_id
) VALUES (
    cidr %s, 
    %d, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($row[ip_network_number]), 
      $row[prefix_length], 
      GetApsString($row[start_sequence_number]), 
      GetApsString($row[end_sequence_number]),
      GetApsString($row[initial_registration_date]),
      GetApsString($row[last_update_date]), 
      GetApsString($row[member_number]), 
      GetApsString($row[status]), 
      GetApsString($row[note]), 
      GetApsString($updateinfo->update_person), 
      GetApsString($updateinfo->update_date), 
      GetApsString($updateinfo->accept_id), 
      GetApsString($op_str_del)
    );
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    if($check->is_error)
    {
      return $check;
    }
    if($check->db_result_info != 1)
    {
      return new DB_RESULT_INFO(false, null, NO_RECORD_INSERT);
    }
    //cidr_unallocate_blockκλ顢оݥ֥åϥ쥳ɤʬ䤹ΤäĴ٤
    $div_cidr = RegIpv6AddressUtil::reduce_ipblock($row[ip_network_number], $val);
    //ʬ䤹ɬפ硢ʬ䤷ĤΥ֥åunallocatedʥ֥åȤcidr_unallocate_block
    if(count($div_cidr) > 0)  //ʬ䤹ɬפ
    {
      foreach($div_cidr as $val_in)
      {
        $div_block_range = RegIpv6AddressUtil::get_sequence_num($val_in);  //ʬ䤷cidrΥȥֹ桢ɥֹȤ
        //ʬΥ쥳ɤcidr_unallocate_block
        $sql_fmt = <<<_END_
INSERT INTO cidr_unallocate_block (
    SELECT
        cidr %s, %d, %s, %s, %s, %s, %s, %s, %s
    WHERE 0 = ( 
        SELECT COUNT(*) FROM cidr_unallocate_block 
        WHERE ip_network_number >>= cidr %s 
              OR cidr %s >>= ip_network_number
    )
)
_END_;
        $sql = sprintf($sql_fmt,
          GetApsString($val_in),
          $div_block_range[2], 
          GetApsString($div_block_range[0]), 
          GetApsString($div_block_range[1]), 
          GetApsString($row[initial_registration_date]), 
          GetApsString($row[last_update_date]), 
          GetApsString($row[member_number]), 
          GetApsString($row[status]), 
          GetApsString($row[note]),
          GetApsString($val_in),
          GetApsString($val_in)
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
        if($check->is_error)
        {
          return $check;
        }
        if($check->db_result_info != 1)
        {
          return new DB_RESULT_INFO(false, null, NO_RECORD_INSERT);
        }
        //ҥȥʬ䤷cidrȤ򤫤
        $sql_fmt = <<<_END_
INSERT INTO cidr_unallocate_block_history (
    ip_network_number, 
    prefix_length, 
    start_sequence_number, 
    end_sequence_number, 
    initial_registration_date, 
    last_update_date, 
    member_number, 
    status, 
    note, 
    update_person, 
    update_date, 
    accept_id, 
    operation_id
) VALUES (
    cidr %s, 
    %d, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s, 
    %s
)
_END_;
        $sql = sprintf($sql_fmt,
          GetApsString($val_in), 
          $div_block_range[2], 
          GetApsString($div_block_range[0]), 
          GetApsString($div_block_range[1]), 
          GetApsString($row[initial_registration_date]), 
          GetApsString($row[last_update_date]), 
          GetApsString($row[member_number]), 
          GetApsString($row[status]), 
          GetApsString($row[note]), 
          GetApsString($updateinfo->update_person), 
          GetApsString($updateinfo->update_date), 
          GetApsString($updateinfo->accept_id), 
          GetApsString($op_str_add)
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
        if($check->is_error)
        {
          return $check;
        }
        if($check->db_result_info != 1)
	{
          return new DB_RESULT_INFO(false, null, NO_RECORD_INSERT);
        }
      }
    }
    //cidr_block˿쥳ɤɲä
        $sql_fmt = <<<_END_
INSERT INTO cidr_block (
    SELECT 
        cidr %s, %d, %s, %s, %s, %s, %d, %s
    WHERE 0 = ( 
        SELECT COUNT(*) FROM cidr_block 
        WHERE ip_network_number >>= cidr %s 
              OR cidr %s >>= ip_network_number
    )
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($val), 
      $range[2], 
      GetApsString($range[0]), 
      GetApsString($range[1]), 
      GetApsString($now), 
      GetApsString($now), 
      $member_number, 
      GetApsString($note) ,
      GetApsString($val), 
      GetApsString($val) 
    );
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    if($check->is_error)
    {
      return $check;
    }
    if($check->db_result_info != 1)
    {
      return new DB_RESULT_INFO(false, null, NO_RECORD_INSERT);
    }
    //ҥȥʬ䤷cidrȤ򤫤
    $sql_fmt = <<<_END_
INSERT INTO cidr_block_update_history (
    ip_network_number, 
    prefix_length, 
    start_sequence_number, 
    end_sequence_number, 
    initial_registration_date, 
    last_update_date, 
    member_number, 
    note, 
    update_person, 
    update_date, 
    accept_id, 
    operation_id
) VALUES (
    cidr %s,
    %d,
    %s,
    %s,
    %s,
    %s,
    %d,
    %s,
    %s,
    %s,
    %s,
    %s
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($val), 
      $range[2], 
      GetApsString($range[0]), 
      GetApsString($range[1]), 
      GetApsString($now), 
      GetApsString($now), 
      $member_number, 
      GetApsString($note), 
      GetApsString($updateinfo->update_person), 
      GetApsString($updateinfo->update_date), 
      GetApsString($updateinfo->accept_id), 
      GetApsString($updateinfo->operation_id)
    );
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    if($check->is_error)
    {
      return $check;
    }
    if($check->db_result_info != 1)
    {
      return new DB_RESULT_INFO(false, null, NO_RECORD_INSERT);
    }
  }
  return new DB_RESULT_INFO(false, null, true);  //ｪλ
}

/**
* ؿMDBCIDRDelete
* cidrֵѤȼDB򤪤ʤ(cidr_unallocate_blockcidr_blockȤΥҥȥ)
* @param$conDBͥ꥽
* @param$cidr_block꿶ֵѤcidr_block¤Τ
* @param$updateinfoMDB_UPDATE_INFO¤
* @returnDB_RESULT_INFO¤
* @descȥ󥶥ϸƤӽФbeginƤȡ
*/
function MDBCIDRDelete($con, $cidr_block, $updateinfo)
{
  $now = date("Y-m-d H:i:s T");
  if($updateinfo->update_date == "")
  {
    $updateinfo->update_date = $now;
  }
  //꿶ֵѤcidr_block¤ΤθĿʬ֤
  foreach($cidr_block as $val)
  {
    if($val->last_update_date == "")
    {
      $val->last_update_date = $now;
    }
    $range = RegIpv6AddressUtil::get_sequence_num($val->ip_network_number);
    //$valcidr_block¤
    //cidr_block
    $sql = "DELETE FROM cidr_block WHERE ip_network_number = ".GetApsString($val->ip_network_number)." AND member_number = ".$val->member_number;
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorDeleteSome($con, $result, __FILE__, __LINE__);
    if($check->is_error)  //DB顼ȯ
    {
      return $check;
    }
    if($check->db_result_info != 1)  //ǡκ˼
    {
      return new DB_RESULT_INFO(false, null, NO_RECORD_DELETE);
    }
    
    //ҥȥ˵
    $sql_fmt = <<<_END_
INSERT INTO cidr_block_update_history VALUES (
    cidr %s, %d, %s, %s, %s, %s, %d, %s, %s, %s, %s, %s
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($val->ip_network_number), 
      $val->prefix_length, 
      GetApsString($range[0]), 
      GetApsString($range[1]), 
      GetApsString($val->initial_registration_date), 
      GetApsString($val->last_update_date), 
      $val->member_number, 
      GetApsString($val->note), 
      GetApsString($updateinfo->update_person),
      GetApsString($updateinfo->update_date), 
      GetApsString($updateinfo->accept_id), 
      GetApsString($updateinfo->operation_id)
    );
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    if($check->is_error)  //DB顼ȯ
    {
      return $check;
    }
    if($check->db_result_info != 1)  //ǡɲä˼
    {
      return new DB_RESULT_INFO(false, null, NO_RECORD_INSERT);
    }
    
    //cidr_unallocate_block˾
    //statusɬreturnedˤʤ
    $sql_fmt = <<<_END_
INSERT INTO cidr_unallocate_block (
    SELECT 
        cidr %s, %d, %s, %s, %s, %s, %d, %s, %s
    WHERE 0 = (
        SELECT COUNT(*) FROM cidr_unallocate_block 
        WHERE ip_network_number >>= cidr %s 
              OR cidr %s >>= ip_network_number
    )
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($val->ip_network_number), 
      $val->prefix_length, 
      GetApsString($range[0]), 
      GetApsString($range[1]), 
      GetApsString($val->initial_registration_date), 
      GetApsString($val->last_update_date), 
      $val->member_number, 
      GetApsString('returned'), 
      GetApsString($val->note), 
      GetApsString($val->ip_network_number), 
      GetApsString($val->ip_network_number)
    );
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    if($check->is_error)  //DB顼ȯ
    {
      return $check;
    }
    if($check->db_result_info != 1)  //ǡɲä˼
    {
      return new DB_RESULT_INFO(false, null, NO_RECORD_INSERT);
    }
    
    //ҥȥ˵
    $sql_fmt = <<<_END_
INSERT INTO cidr_unallocate_block_history VALUES (
    cidr %s, %d, %s, %s, %s, %s, %d, %s, %s, %s, %s, %s, %s
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($val->ip_network_number), 
      $val->prefix_length, 
      GetApsString($range[0]), 
      GetApsString($range[1]), 
      GetApsString($val->initial_registration_date), 
      GetApsString($val->last_update_date), 
      $val->member_number, 
      GetApsString('returned'), 
      GetApsString($val->note), 
      GetApsString($updateinfo->update_person), 
      GetApsString($updateinfo->update_date), 
      GetApsString($updateinfo->accept_id), 
      GetApsString($updateinfo->operation_id)
    );

    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    if($check->is_error)  //DB顼ȯ
    {
      return $check;
    }
    if($check->db_result_info != 1)  //ǡɲä˼
    {
      return new DB_RESULT_INFO(false, null, NO_RECORD_INSERT);
    }
  }
  return new DB_RESULT_INFO(false, null, true);  //ｪλ
}

/**
* GetCIDRAllocatedBlock
* @desc  block_fromǻꤵ줿̥쥸ȥ꤫꿶줿CIDR
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $block_from  ̥쥸ȥ
* @param  string  $selcol  ߤǡΥ̾
* @param  string  ղþ(OFFSETLIMIT)
* @return  CIDR_ALLOCATED_BLOCK¤
*/
function GetCIDRAllocatedBlock($con, $block_from, $selcol, $ext){
  //SQLʸκɽCIDR_ALLOCATED_BLOCK
  if($block_from == "*"){
    $sql = "SELECT ".$selcol." FROM cidr_allocated_block ORDER BY start_sequence_number".$ext;
  }
  else{
    $sql = "SELECT ".$selcol." FROM cidr_allocated_block WHERE block_from = ".GetApsString($block_from)." ORDER BY start_sequence_number".$ext;
  }
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  //͸
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $cidr = array();
    for($i=0; $i<$numrows; $i++){
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      array_push($cidr, new CIDR_ALLOCATED_BLOCK($row));
    }
  }
  else{
    $cidr = null;
  }
  return new DB_RESULT_INFO(false, null, $cidr);  //
}

/**
* GetCIDRBlock
* @desc  member_short_nameǻꤵ줿ȿάΤ˳꿶äCIDR
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $member_short_name  ȿά
* @param  string  $selcol  ߤǡΥ̾
* @param  string  ղþ(OFFSETLIMIT)
* @return  CIDR_BLOCK¤
*/
function GetCIDRBlock($con, $member_short_name, $selcol, $ext){
  if($member_short_name == "*"){
    $sql = "SELECT ".$selcol." FROM cidr_block ORDER BY start_sequence_number".$ext;
  }
  else{
    //ȿά΢ȿֹ
    $result = GetMemberNumberByMemberShortName($con, $member_short_name);
    if($result->is_error)  return $result;
    $member_number = $result->db_result_info;
    if($member_number === null){
      return new DB_RESULT_INFO(false, null, null);
    }
    $sql = "SELECT ".$selcol." FROM cidr_block WHERE member_number = ".$member_number." ORDER BY start_sequence_number".$ext;
  }
  //SQLʸκɽCIDR_BLOCK
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  //͸
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $cidr = array();
    for($i=0; $i<$numrows; $i++){
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      if(substr_count($selcol, "member_number") >= 1){
        $row['member_short_name'] = $member_short_name;
      }
      unset($row['member_number']);
      array_push($cidr, new CIDR_BLOCK($row));
    }
  }
  else{
    $cidr = null;
  }
  return new DB_RESULT_INFO(false, null, $cidr);  //
}

/**
* GetCIDRUnAllocateBlock
* @desc  statusǻꤵ줿ơCIDR
* @param  resource  $con  DBؤΥͥ꥽
* @param  array  $status_array  ơ
* @param  string  $selcol  ߤǡΥ̾
* @param  string  ղþ(OFFSETLIMIT)
* @return  CIDR_UNALLOCATE_BLOCK¤
*/
function GetCIDRUnAllocateBlock($con, $status_array, $selcol, $ext){
  if($status_array == "*" && is_array($status_array) == false){
    $sql = "SELECT ".$selcol." FROM cidr_unallocate_block WHERE ORDER BY start_sequence_number".$ext;
  }
  else{
    foreach($status_array as $key => $value){
      $value = "'".$value."'";
      $status_array[$key] = $value;
    }
    $sql = "SELECT ".$selcol." FROM cidr_unallocate_block WHERE status IN (".implode(",", $status_array).") ORDER BY start_sequence_number".$ext;
  }
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  //͸
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $cidr = array();
    for($i=0; $i<$numrows; $i++){
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      if($row['member_number'] != ""){
        //ȿֹ梪ȿά
        $result2 = GetMemberShortNameByMemberNumber($con, $row['member_number']);
        if($result2->is_error)  return $result2;
        $row['member_short_name'] = $result2->db_result_info;
	if($row['member_short_name'] === null){
	  return new DB_RESULT_INFO(false, null, null);
	}
      }
      else{
        $row['member_short_name'] = "";
      }
      unset($row['member_number']);
      array_push($cidr, new CIDR_UNALLOCATE_BLOCK($row));
    }
  }
  else{
    $cidr = null;
  }
  return new DB_RESULT_INFO(false, null, $cidr);  //
}

/**
 * CreateCIDRAllocatedBlock
 * @desc ̥쥸ȥ꿶ƤCIDR֥å򿷵
 * @param DBؤΥͥ꥽
 * @param CIDR֥å
 * @param 꿶
 * @param ̥쥸ȥ̾
 * @param 
 * @param MDB_UPDATE_INFO¤
 * @return true/false
*/
function CreateCIDRAllocatedBlock($con, $ip_network_number, $allocated_date, $block_from, $note, $updateinfo)
{
  //ƥǹ
  $now = date("Y-m-d H:i:s T");
  if($updateinfo->update_date == "")  //꤬ʤиߤλ
  {
    $updateinfo->update_date = $now;
  }
  if($updateinfo->allocated_date == "")  //꤬ʤиߤλ
  {
    $updateinfo->allocated_date = $now;
  }

  //ؿGetSequenceNumberFromIPv4FormatΥ롧ȥ󥹡ɥ󥹤
  list($start_sequence_number, $end_sequence_number, $prefix_length) 
    = RegIpv6AddressUtil::get_sequence_num($ip_network_number);
  
  //SQLʸκɽCIDR_ALLOCATED_BLOCKؤ
  $sql_fmt = <<<_END_
INSERT INTO cidr_allocated_block (
  SELECT cidr %s, %s, %s, %s, %s, %s, %s, %s
  WHERE 0 = (
    SELECT COUNT(*) FROM cidr_allocated_block 
    WHERE ip_network_number >>= cidr %s 
          OR cidr %s >>= ip_network_number
  )
)
_END_;
  $sql = sprintf($sql_fmt, 
    GetApsString($ip_network_number),
    GetApsString($prefix_length),
    GetApsString($start_sequence_number),
    GetApsString($end_sequence_number),
    GetApsString($allocated_date),
    GetApsString($updateinfo->update_date),
    GetApsString($block_from),
    GetApsString($note),
    GetApsString($ip_network_number),
    GetApsString($ip_network_number)
  );
  
  //ؿregdb_execΥ롧SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
  //͸
  if($check->is_error)  return $check;
  if($check->db_result_info > 0){
    //κ
    $sql_fmt = <<<_END_
INSERT INTO cidr_allocated_block_history VALUES(
  cidr %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($ip_network_number),
      GetApsString($prefix_length),
      GetApsString($start_sequence_number),
      GetApsString($end_sequence_number),
      GetApsString($allocated_date),
      GetApsString($updateinfo->update_date),
      GetApsString($block_from),
      GetApsString($note),
      GetApsString($updateinfo->update_person),
      GetApsString($updateinfo->update_date),
      GetApsString($updateinfo->accept_id),
      GetApsString($updateinfo->operation_id)
    );
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    //͸
    if($check->is_error)  return $check;
    return new DB_RESULT_INFO(false, null, $check->db_result_info);  //
  }
  else{
    return new DB_RESULT_INFO(false, null, 0);
  }
}

/**
 * CreateCIDRBlock
 * @desc Ƽ»ȿ˳꿶äCIDR֥å򿷵
 * @param DBؤΥͥ꥽
 * @param CIDR֥å
 * @param 꿶򤷤
 * @param ȿά
 * @param 
 * @param MDB_UPDATE_INFO¤
 * @return true/false
*/
function CreateCIDRBlock($con, $ip_network_number, $allocate_date, $member_short_name, $note, $updateinfo)
{
  //ƥǹ
  $now = date("Y-m-d H:i:s T");
  if($updateinfo->update_date == "")  //꤬ʤиߤλ
  {
    $updateinfo->update_date = $now;
  }
  if($updateinfo->allocate_date == "")  //꤬ʤиߤλ
  {
    $updateinfo->allocate_date = $now;
  }
  //ȿά΢ȿֹ
  $result = GetMemberNumberByMemberShortName($con, $member_short_name);
  if($result->is_error)  return $result;
  $member_number = $result->db_result_info;
  if($member_number === null){
    return new DB_RESULT_INFO(false, null, 0);
  }
  //ؿGetSequenceNumberFromIPv4FormatΥ롧ȥ󥹡ɥ󥹤
  $block_range = RegIpv6AddressUtil::get_sequence_num($ip_network_number);
  //SQLʸκɽCIDR_BLOCKؤ
  $sql_fmt = <<<_END_
INSERT INTO cidr_block (
    SELECT 
        cidr %s, %d, %s, %s, %s, %s, %d, %s
    WHERE 0 = (
        SELECT COUNT(*) FROM cidr_block 
        WHERE ip_network_number >>= cidr %s 
              OR cidr %s >>= ip_network_number
    )
)
_END_;
  $sql = sprintf($sql_fmt,
    GetApsString($ip_network_number),
    $block_range[2],
    GetApsString($block_range[0]),
    GetApsString($block_range[1]),
    GetApsString($allocate_date),
    GetApsString($updateinfo->update_date),
    $member_number,
    GetApsString($note) 
  );

  //ؿregdb_execΥ롧SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
  //͸
  if($check->is_error)  return $check;
  if($check->db_result_info > 0){
    //κ
    $sql_fmt = <<<_END_
INSERT INTO cidr_block_update_history VALUES (
    cidr %s, %d, %s, %s, %s, %s, %d, %s, %s, %s, %s, %s
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($ip_network_number),
      $block_range[2],
      GetApsString($block_range[0]),
      GetApsString($block_range[1]),
      GetApsString($allocate_date),
      GetApsString($updateinfo->update_date),
      $member_number,
      GetApsString($note),
      GetApsString($updateinfo->update_person),
      GetApsString($updateinfo->update_date),
      GetApsString($updateinfo->accept_id),
      GetApsString($updateinfo->operation_id)
    );
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    //͸
    if($check->is_error)  return $check;
    return new DB_RESULT_INFO(false, null, $check->db_result_info);  //
  }
  else{
    return new DB_RESULT_INFO(false, null, 0);
  }
}

/**
 * CreateCIDRUnAllocateBlock
 * @desc Ƽ»ȿ˳꿶äCIDR֥å򿷵
 * @param DBؤΥͥ꥽
 * @param CIDR֥å
 * @param 꿶
 * @param ȿά(̤꿶ΰΤȤnull)
 * @param ơ(unallocatedreturned)
 * @param 
 * @param MDB_UPDATE_INFO¤
 * @return true/false
*/
function CreateCIDRUnAllocateBlock($con, $ip_network_number, $allocated_date, $member_short_name, $status, $note, $updateinfo)
{
  //ƥǹ
  $now = date("Y-m-d H:i:s T");
  if($updateinfo->update_date == "")
  {
    $updateinfo->update_date = $now;
  }
  if($updateinfo->allocated_date == "")  //꤬ʤиߤλ
  {
    $updateinfo->allocated_date = $now;
  }
  $member_number = null;  //member_numbernullξ⤢ꡢintegerʤΤ
  if($member_short_name != "")
  {
    //ȿά΢ȿֹ
    $result = GetMemberNumberByMemberShortName($con, $member_short_name);
    if($result->is_error)  return $result;
    $member_number = $result->db_result_info;
    if($member_number === null){
      return new DB_RESULT_INFO(false, null, 0);
    }
  }

  //ؿGetSequenceNumberFromIPv4FormatΥ롧ȥ󥹡ɥ󥹤
  list($start_sequence_number, $end_sequence_number, $prefix_length) 
    = RegIpv6AddressUtil::get_sequence_num($ip_network_number);
  
  //SQLʸκɽCIDR_UNALLOCATE_BLOCKؤ
  //̤꿶ΰοΤȤˤmember_numbernull
  $sql_fmt = <<<_END_
INSERT INTO cidr_unallocate_block (
  SELECT cidr %s, %s, %s, %s, %s, %s, %s, %s, %s
  WHERE 0 = (
    SELECT COUNT(*) FROM cidr_unallocate_block 
    WHERE ip_network_number >>= cidr %s
          OR cidr %s >>= ip_network_number
  )
)
_END_;
  $sql = sprintf($sql_fmt, 
    GetApsString($ip_network_number),
    GetApsString($prefix_length),
    GetApsString($start_sequence_number),
    GetApsString($end_sequence_number),
    GetApsString($allocated_date),
    GetApsString($updateinfo->update_date),
    GetApsString($member_number),
    GetApsString($status),
    GetApsString($note),
    GetApsString($ip_network_number),
    GetApsString($ip_network_number)
  );
  //ؿregdb_execΥ롧SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
  //͸
  if($check->is_error)  return $check;
  if($check->db_result_info > 0){
    //κ
    //̤꿶ΰοΤȤˤmember_numbernull
    $sql_fmt = <<<_END_
INSERT INTO cidr_unallocate_block_history VALUES (
    cidr %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s
)
_END_;
    $sql = sprintf($sql_fmt, 
      GetApsString($ip_network_number),
      GetApsString($prefix_length),
      GetApsString($start_sequence_number),
      GetApsString($end_sequecne_number),
      GetApsString($allocated_date),
      GetApsString($updateinfo->update_date),
      GetApsString($member_number),
      GetApsString($status),
      GetApsString($note),
      GetApsString($updateinfo->update_person),
      GetApsString($updateinfo->update_date),
      GetApsString($updateinfo->accept_id),
      GetApsString($updateinfo->operation_id)
    );
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    //͸
    if($check->is_error)  return $check;
    return new DB_RESULT_INFO(false, null, $check->db_result_info);  //
  }
  else{
    return new DB_RESULT_INFO(false, null, 0);
  }
}

/**
* SaveCIDRAllocatedBlock
* @desc  CIDR_ALLOCATED_BLOCKƤ򹹿
* @param  resource  $con  DBؤΥͥ꥽
* @param  CIDR_ALLOCATED_BLOCK
* @param  MDB_UPDATE_INFO
* @param  string  $selcol  ¸̾
* @return  true/false
*/
function SaveCIDRAllocatedBlock($con, $block, $updateinfo, $selcol){
  //ƥǹ
  $now = date("Y-m-d H:i:s T");
  if($block->last_update_date == ""){
    $block->last_update_date = $now;
  }
  if($updateinfo->update_date == ""){
    $updateinfo->update_date = $now;
  }
  //SQLκɽCIDR_ALLOCATED_BLOCKؤι
  $data = DBAPI_table_map_to_array_CIDR_ALLOCATED_BLOCK($block);
  foreach(explode(",", $selcol) as $value){
    $data_conv[$value] = $data[$value];
  }
  if(in_array("last_update_date", array_keys($data_conv)) == false){
    $data_conv[last_update_date] = array(type => "timestamp", value => $block->last_update_date);
  }
  $result = DBAPI_update_MDB($con, "cidr_allocated_block", "ip_network_number", "text", $block->ip_network_number, $data_conv, __FILE__, __LINE__);
  //͸
  if($result->is_error)  return $result;
  if($result->db_result_info > 0){
    //κ
    $sql_fmt = <<<_END_
INSERT INTO cidr_allocated_block_history VALUES (
    cidr %s, %d, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($data[ip_network_number][value]),
      $data[prefix_length][value],
      GetApsString($data[start_sequence_number][value]),
      GetApsString($data[end_sequence_number][value]),
      GetApsString($data[initial_registration_date][value]),
      GetApsString($data[last_update_date][value]),
      GetApsString($data[block_from][value]),
      GetApsString($data[note][value]),
      GetApsString($updateinfo->update_person),
      GetApsString($updateinfo->update_date),
      GetApsString($updateinfo->accept_id),
      GetApsString($updateinfo->operation_id)
    );
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    //͸
    if($check->is_error)  return $check;
    return new DB_RESULT_INFO(false, null, $check->db_result_info);
  }
  else{
    return new DB_RESULT_INFO(false, null, 0);
  }
}

/**
* SaveCIDRBlock
* @desc  CIDR_BLOCKƤ򹹿
* @param  resource  $con  DBؤΥͥ꥽
* @param  CIDR_BLOCK
* @param  MDB_UPDATE_INFO
* @param  string  $selcol  ¸̾
* @return  true/false
*/
function SaveCIDRBlock($con, $block, $updateinfo, $selcol){
  //ƥǹ
  $now = date("Y-m-d H:i:s T");
  if($block->last_update_date == ""){
    $block->last_update_date = $now;
  }
  if($updateinfo->update_date == ""){
    $updateinfo->update_date = $now;
  }
  //CIDR_BLOCKˤmember_numberɬ
  if($block->member_number === null){
    return new DB_RESULT_INFO(false, null, 0);
  }
  //SQLκɽCIDR_BLOCKؤι
  $data = DBAPI_table_map_to_array_CIDR_BLOCK($block);
  foreach(explode(",", $selcol) as $value){
    $data_conv[$value] = $data[$value];
  }
  if(in_array("last_update_date", array_keys($data_conv)) == false){
    $data_conv[last_update_date] = array(type => "timestamp", value => $block->last_update_date);
  }
  $result = DBAPI_update_MDB($con, "cidr_block", "ip_network_number", "text", $block->ip_network_number, $data_conv, __FILE__, __LINE__);
  //͸
  if($result->is_error)  return $result;
  if($result->db_result_info > 0){
    //κ
    $sql_fmt = <<<_END_
INSERT INTO cidr_block_update_history VALUES (
    cidr %s, %d, %s, %s, %s, %s, %d, %s, %s, %s, %s, %s
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($data[ip_network_number][value]),
      $data[prefix_length][value],
      GetApsString($data[start_sequence_number][value]),
      GetApsString($data[end_sequence_number][value]),
      GetApsString($data[initial_registration_date][value]),
      GetApsString($data[last_update_date][value]),
      $data[member_number][value],
      GetApsString($data[note][value]),
      GetApsString($updateinfo->update_person),
      GetApsString($updateinfo->update_date),
      GetApsString($updateinfo->accept_id),
      GetApsString($updateinfo->operation_id)
    );
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    //͸
    if($check->is_error)  return $check;
    return new DB_RESULT_INFO(false, null, $check->db_result_info);
  }
  else{
    return new DB_RESULT_INFO(false, null, 0);
  }
}

/**
* SaveCIDRUnAllocateBlock
* @desc  CIDR_UNALLOCATE_BLOCKƤ򹹿
* @param  resource  $con  DBؤΥͥ꥽
* @param  CIDR_UNALLOCATE_BLOCK
* @param  MDB_UPDATE_INFO
* @param  string  $selcol  ¸̾
* @return  true/false
*/
function SaveCIDRUnAllocateBlock($con, $block, $updateinfo, $selcol){
  //ƥǹ
  $now = date("Y-m-d H:i:s T");
  if($block->last_update_date == ""){
    $block->last_update_date = $now;
  }
  if($updateinfo->update_date == ""){
    $updateinfo->update_date = $now;
  }
  //CIDR_UNALLOCATE_BLOCKˤmember_numbernullΤȤ
  //statusunallocatedʤȤ
  if($block->member_number == ""){
    $block->member_number = "null";  //SQL顼ʤ褦
  }
  //SQLκɽCIDR_BLOCKؤι
  $data = DBAPI_table_map_to_array_CIDR_UNALLOCATE_BLOCK($block);
  foreach(explode(",", $selcol) as $value){
    $data_conv[$value] = $data[$value];
  }
  if(in_array("last_update_date", array_keys($data_conv)) == false){
    $data_conv[last_update_date] = array(type => "timestamp", value => $block->last_update_date);
  }
  $result = DBAPI_update_MDB($con, "cidr_unallocate_block", "ip_network_number", "text", $block->ip_network_number, $data_conv, __FILE__, __LINE__);
  //͸
  if($result->is_error)  return $result;
  if($result->db_result_info > 0){
    //κ
    $sql_fmt = <<<_END_
INSERT INTO cidr_unallocate_block_history VALUES (
    cidr %s, %d, %s, %s, %s, %s, %d, %s, %s, %s, %s, %s, %s
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($data[ip_network_number][value]),
      $data[prefix_length][value],
      GetApsString($data[start_sequence_number][value]),
      GetApsString($data[end_sequence_number][value]),
      GetApsString($data[initial_registration_date][value]),
      GetApsString($data[last_update_date][value]),
      $data[member_number][value],
      GetApsString($data[status][value]),
      GetApsString($data[note][value]),
      GetApsString($updateinfo->update_person),
      GetApsString($updateinfo->update_date),
      GetApsString($updateinfo->accept_id),
      GetApsString($updateinfo->operation_id)
    );
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    //͸
    if($check->is_error)  return $check;
    return new DB_RESULT_INFO(false, null, $check->db_result_info);
  }
  else{
    return new DB_RESULT_INFO(false, null, 0);
  }
}

/**
* SelectIncludedCIDRAllocatedBlock
* @desc  ϥɥ쥹˴ޤޤCIDR_ALLOCATED_BLOCKʣļǤ뤳Ȥ
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $ip_network_number  IPɥ쥹
* @param  string  $selcol  ߤǡΥ̾
* @param  string  $ext  ղþLIMITOFFSET
*/
function SelectIncludedCIDRAllocatedBlock($con, $ip_network_number, $selcol, $ext){
  $sql_fmt = <<<_END_
SELECT %s FROM cidr_allocated_block
WHERE ip_network_number <<= cidr %s
ORDER BY start_sequence_number%s
_END_;
  $sql = sprintf($sql_fmt,
    $selcol,
    GetApsString($ip_network_number),
    $ext
  );
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  //͸
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $cidr = array();
    for($i=0; $i<$numrows; $i++){
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      array_push($cidr, new CIDR_ALLOCATED_BLOCK($row));
    }
  }
  else{
    $cidr = null;
  }
  return new DB_RESULT_INFO(false, null, $cidr);  //
}

/**
* SelectIncludeCIDRAllocatedBlock
* @desc  ϥɥ쥹ޤCIDR_ALLOCATED_BLOCK1ĤǤʤ
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $ip_network_number  IPɥ쥹
* @param  string  $selcol  ߤǡΥ̾
* @param  string  $ext  ղþLIMITOFFSET
*/
function SelectIncludeCIDRAllocatedBlock($con, $ip_network_number, $selcol, $ext){
  $sql_fmt = <<<_END_
SELECT %s FROM cidr_allocated_block 
WHERE ip_network_number >>= cidr %s
ORDER BY start_sequence_number%s
_END_;
  $sql = sprintf($sql_fmt,
    $selcol,
    GetApsString($ip_network_number),
    $ext
  );
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  //͸
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $cidr = array();
    for($i=0; $i<$numrows; $i++){
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      array_push($cidr, new CIDR_ALLOCATED_BLOCK($row));
    }
  }
  else{
    $cidr = null;
  }
  return new DB_RESULT_INFO(false, null, $cidr);  //
}

/**
* SelectIncludedCIDRBlock
* @desc  ϥɥ쥹˴ޤޤCIDR_BLOCKʣļǤ뤳Ȥ
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $ip_network_number  IPɥ쥹
* @param  string  $selcol  ߤǡΥ̾
* @param  string  $ext  ղþLIMITOFFSET
*/
function SelectIncludedCIDRBlock($con, $ip_network_number, $selcol, $ext){
  $sql_fmt = <<<_END_
SELECT %s FROM cidr_block 
WHERE ip_network_number <<= cidr %s
ORDER BY start_sequence_number%s
_END_;
  $sql = sprintf($sql_fmt,
    $selcol,
    GetApsString($ip_network_number),
    $ext
  );
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  //͸
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $cidr = array();
    for($i=0; $i<$numrows; $i++){
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      array_push($cidr, new CIDR_BLOCK($row));
    }
  }
  else{
    $cidr = null;
  }
  return new DB_RESULT_INFO(false, null, $cidr);  //
}

/**
* SelectIncludeCIDRBlock
* @desc  ϥɥ쥹ޤCIDR_BLOCK1ĤǤʤ
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $ip_network_number  IPɥ쥹
* @param  string  $selcol  ߤǡΥ̾
* @param  string  $ext  ղþLIMITOFFSET
*/
function SelectIncludeCIDRBlock($con, $ip_network_number, $selcol, $ext){
  $sql_fmt = <<<_END_
SELECT %s FROM cidr_block 
WHERE ip_network_number >>= cidr %s
ORDER BY start_sequence_number%s
_END_;
  $sql = sprintf($sql_fmt,
    $selcol,
    GetApsString($ip_network_number),
    $ext
  );
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  //͸
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $cidr = array();
    for($i=0; $i<$numrows; $i++){
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      array_push($cidr, new CIDR_BLOCK($row));
    }
  }
  else{
    $cidr = null;
  }
  return new DB_RESULT_INFO(false, null, $cidr);  //
}

/**
* SelectIncludedCIDRUnAllocateBlock
* @desc  ϥɥ쥹˴ޤޤCIDR_UNALLOCATE_BLOCKʣļǤ뤳Ȥ
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $ip_network_number  IPɥ쥹
* @param  string  $selcol  ߤǡΥ̾
* @param  string  $ext  ղþLIMITOFFSET
*/
function SelectIncludedCIDRUnAllocateBlock($con, $ip_network_number, $selcol, $ext){
  $sql_fmt = <<<_END_
SELECT %s FROM cidr_unallocate_block 
WHERE ip_network_number <<= cidr %s
ORDER BY start_sequence_number%s
_END_;
  $sql = sprintf($sql_fmt,
    $selcol,
    GetApsString($ip_network_number),
    $ext
  );
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  //͸
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $cidr = array();
    for($i=0; $i<$numrows; $i++){
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      array_push($cidr, new CIDR_UNALLOCATE_BLOCK($row));
    }
  }
  else{
    $cidr = null;
  }
  return new DB_RESULT_INFO(false, null, $cidr);  //
}

/**
* SelectIncludeCIDRUnAllocateBlock
* @desc  ϥɥ쥹ޤCIDR_UNALLOCATE_BLOCK1ĤǤʤ
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $ip_network_number  IPɥ쥹
* @param  string  $selcol  ߤǡΥ̾
* @param  string  $ext  ղþLIMITOFFSET
*/
function SelectIncludeCIDRUnAllocateBlock($con, $ip_network_number, $selcol, $ext){
  $sql_fmt = <<<_END_
SELECT %s FROM cidr_unallocate_block 
WHERE ip_network_number >>= cidr %s
ORDER BY start_sequence_number%s
_END_;
  $sql = sprintf($sql_fmt,
    $selcol,
    GetApsString($ip_network_number),
    $ext
  );
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  //͸
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $cidr = array();
    for($i=0; $i<$numrows; $i++){
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      array_push($cidr, new CIDR_UNALLOCATE_BLOCK($row));
    }
  }
  else{
    $cidr = null;
  }
  return new DB_RESULT_INFO(false, null, $cidr);  //
}

/**
* DBAPI_table_map_to_array_CIDR_ALLOCATED_BLOCK
* @desc ֥CIDR_ALLOCATED_BLOCKCIDR_ALLOCATED_BLOCKơ֥бɽ֤
* @param CIDR_ALLOCATED_BLOCK
* @return array
*/
function DBAPI_table_map_to_array_CIDR_ALLOCATED_BLOCK($block){
  //ǡϿä鸽ߤλ򤤤
  $now = date("Y-m-d H:i:s T");
  if($block->initial_registration_date == ""){
    $block->initial_registration_date = $now;
  }
  //ȡɥ󥹤Ȥ
  $block_range = RegIpv6AddressUtil::get_sequence_num($block->ip_network_number);
  //array򤫤
  return array(
  ip_network_number => array(type => "cidr", value => $block->ip_network_number),
  prefix_length => array(type => "integer", value => $block->prefix_length),
  initial_registration_date => array(type => "timestamp", value => $block->initial_registration_date),
  last_update_date => array(type => "timestamp", value => $block->last_update_date),
  block_from => array(type => "text", value => $block->block_from),
  note => array(type => "text", value => $block->note),
  start_sequence_number => array(type => "text", value => $block_range[0]),
  end_sequence_number => array(type => "text", value => $block_range[1])
  );
}

/**
* DBAPI_table_map_to_array_CIDR_BLOCK
* @desc ֥CIDR_BLOCKCIDR_BLOCKơ֥бɽ򤫤
* @param CIDR_BLOCK
* @return array
*/
function DBAPI_table_map_to_array_CIDR_BLOCK($block){
  //ǡϿä鸽ߤλ򤤤
  $now = date("Y-m-d H:i:s T");
  if($block->initial_registration_date == ""){
    $block->initial_registration_date = $now;
  }
  //ȡɥ󥹤Ȥ
  $block_range = RegIpv6AddressUtil::get_sequence_num($block->ip_network_number);
  //array򤫤
  return array(
  ip_network_number => array(type => "cidr", value => $block->ip_network_number),
  prefix_length => array(type => "integer", value => $block->prefix_length),
  initial_registration_date => array(type => "timestamp", value => $block->initial_registration_date),
  last_update_date => array(type => "timestamp", value => $block->last_update_date),
  member_number => array(type => "integer", value => $block->member_number),
  note => array(type => "text", value => $block->note),
  start_sequence_number => array(type => "text", value => $block_range[0]),
  end_sequence_number => array(type => "text", value => $block_range[1])
  );
}

/**
* DBAPI_table_map_to_array_CIDR_UNALLOCATE_BLOCK
* @desc ֥CIDR_UNALLOCATE_BLOCKCIDR_UNALLOCATE_BLOCKбɽ򤫤
* @param CIDR_UNALLOCATE_BLOCK
* @return array
*/
function DBAPI_table_map_to_array_CIDR_UNALLOCATE_BLOCK($block){
  //ǡϿä鸽ߤλ򤤤
  $now = date("Y-m-d H:i:s T");
  if($block->initial_registration_date == ""){
    $block->initial_registration_date = $now;
  }
  //ȡɥ󥹤Ȥ
  $block_range = RegIpv6AddressUtil::get_sequence_num($block->ip_network_number);
  //array򤫤
  return array(
  ip_network_number => array(type => "cidr", value => $block->ip_network_number),
  prefix_length => array(type => "integer", value => $block->prefix_length),
  initial_registration_date => array(type => "timestamp", value => $block->initial_registration_date),
  last_update_date => array(type => "timestamp", value => $block->last_update_date),
  member_number => array(type => "integer", value => $block->member_number),
  status => array(type => "text", value => $block->status),
  note => array(type => "text", value => $block->note),
  start_sequence_number => array(type => "text", value => $block_range[0]),
  end_sequence_number => array(type => "text", value => $block_range[1])
  );
}

/**
* DeleteCIDRAllocatedBlock
* @desc ϤIPɥ쥹Υ쥳ɤCIDR_ALLOCATED_BLOCK
* @param $con DBͥ꥽
* @param $ip_network_number IPɥ쥹
* @param $updateinfo 
* @return Կԡfalse
*/
function DeleteCIDRAllocatedBlock($con, $ip_network_number, $updateinfo){
  //ƥǹ
  $now = date("Y-m-d H:i:s T");
  if($updateinfo->update_date == ""){
    $updateinfo->update_date = $now;
  }
  //history
  $sql = "SELECT ip_network_number,prefix_length,start_sequence_number,end_sequence_number,initial_registration_date,last_update_date,block_from,note FROM cidr_allocated_block WHERE ip_network_number = ".GetApsString($ip_network_number);
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $sql, __FILE__, __LINE__);
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows == 1){
    $row = pg_fetch_array($result,0,PGSQL_ASSOC);
    $sql_fmt = <<<_END_
INSERT INTO cidr_allocated_block_history VALUES (
    cidr %s, %d, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($row[ip_network_number]),
      $row[prefix_length],
      GetApsString($row[start_sequence_number]),
      GetApsString($row[end_sequence_number]),
      GetApsString($row[initial_registration_date]),
      GetApsString($row[last_update_date]),
      GetApsString($row[block_from]),
      GetApsString($row[note]),
      GetApsString($updateinfo->update_person),
      GetApsString($updateinfo->update_date),
      GetApsString($updateinfo->accept_id),
      GetApsString($updateinfo->operation_id)
    );
    //SQLμ¹
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    if($check->is_error)  return $check;
    if($check->db_result_info > 0){
      //delete
      $result = DBAPI_delete_MDB($con, "cidr_allocated_block", "ip_network_number", "text", $ip_network_number, __FILE__, __LINE__);
      if($result->is_error)  return $result;
      return new DB_RESULT_INFO(false, null, $result->db_result_info);
    }
  }
  return new DB_RESULT_INFO(false, null, 0);
}

/**
* DeleteCIDRBlock
* @desc ϤIPɥ쥹Υ쥳ɤCIDR_BLOCK
* @param $con DBͥ꥽
* @param $ip_network_number IPɥ쥹
* @param $updateinfo
* @return Կԡfalse
*/
function DeleteCIDRBlock($con, $ip_network_number, $updateinfo){
  //ƥǹ
  $now = date("Y-m-d H:i:s T");
  if($updateinfo->update_date == ""){
    $updateinfo->update_date = $now;
  }
  //history
  $sql = "SELECT ip_network_number,prefix_length,start_sequence_number,end_sequence_number,initial_registration_date,last_update_date,member_number,note FROM cidr_block WHERE ip_network_number = ".GetApsString($ip_network_number);
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $sql, __FILE__, __LINE__);
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows == 1){
    $row = pg_fetch_array($result,0,PGSQL_ASSOC);
    $sql_fmt = <<<_END_
INSERT INTO cidr_block_update_history VALUES (
    cidr %s, %d, %s, %s, %s, %s, %d, %s, %s, %s, %s, %s
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($row[ip_network_number]),
      $row[prefix_length],
      GetApsString($row[start_sequence_number]),
      GetApsString($row[end_sequence_number]),
      GetApsString($row[initial_registration_date]),
      GetApsString($updateinfo->update_date),
      $row[member_number],
      GetApsString($row[note]),
      GetApsString($updateinfo->update_person),
      GetApsString($updateinfo->update_date),
      GetApsString($updateinfo->accept_id),
      GetApsString($updateinfo->operation_id)
    );
    //SQLμ¹
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    if($check->is_error)  return $check;
    if($check->db_result_info > 0){
      //delete
      $result = DBAPI_delete_MDB($con, "cidr_block", "ip_network_number", "text", $ip_network_number, __FILE__, __LINE__);
      if($result->is_error)  return $result;
      return new DB_RESULT_INFO(false, null, $result->db_result_info);
    }
  }
  return new DB_RESULT_INFO(false, null, 0);
}

/**
* DeleteCIDRUnAllocateBlock
* @desc ϤIPɥ쥹Υ쥳ɤCIDR_UNALLOCATE_BLOCK
* @param $con DBͥ꥽
* @param $ip_network_number IPɥ쥹
* @param $updateinfo
* @return Կԡfalse
*/
function DeleteCIDRUnAllocateBlock($con, $ip_network_number, $updateinfo){
  //ƥǹ
  $now = date("Y-m-d H:i:s T");
  if($updateinfo->update_date == ""){
    $updateinfo->update_date = $now;
  }
  //history
  $sql = "SELECT ip_network_number,prefix_length,start_sequence_number,end_sequence_number,initial_registration_date,last_update_date,member_number,status,note FROM cidr_unallocate_block WHERE ip_network_number = ".GetApsString($ip_network_number);
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $sql, __FILE__, __LINE__);
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows == 1){
    $row = pg_fetch_array($result,0,PGSQL_ASSOC);
    if($row[member_number] == ""){
      $row[member_number] = "null";
    }
    $sql_fmt = <<<_END_
INSERT INTO cidr_unallocate_block_history VALUES (
    cidr %s, %d, %s, %s, %s, %s, %d, %s, %s, %s, %s, %s, %s
)
_END_;
    $sql = sprintf($sql_fmt,
      GetApsString($row[ip_network_number]),
      $row[prefix_length],
      GetApsString($row[start_sequence_number]),
      GetApsString($row[end_sequence_number]),
      GetApsString($row[initial_registration_date]),
      GetApsString($updateinfo->update_date),
      $row[member_number],
      GetApsString($row[status]),
      GetApsString($row[note]),
      GetApsString($updateinfo->update_person),
      GetApsString($updateinfo->update_date),
      GetApsString($updateinfo->accept_id),
      GetApsString($updateinfo->operation_id)
    );
    //SQLμ¹
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    if($check->is_error)  return $check;
    if($check->db_result_info > 0){
      //delete
      $result = DBAPI_delete_MDB($con, "cidr_unallocate_block", "ip_network_number", "text", $ip_network_number, __FILE__, __LINE__);
      if($result->is_error)  return $result;
      return new DB_RESULT_INFO(false, null, $result->db_result_info);
    }
  }
  return new DB_RESULT_INFO(false, null, 0);
}

/**
* SelectCIDRAllocatedBlockHistory
* @desc ϤIPɥ쥹ι
* @param $con DBͥ꥽
* @param $ip_network_number IPɥ쥹
* @param $selcol 륫̾
* @param $ext ղþ(LIMITOFFSETʤ)
* @return CIDR_ALLOCATED_BLOCK_HISTORY¤
*/
function SelectCIDRAllocatedBlockHistory($con, $ip_network_number, $selcol, $ext){
  $sql = "SELECT ".$selcol." FROM cidr_allocated_block_history WHERE ip_network_number = ".GetApsString($ip_network_number)." ORDER BY update_date".$ext;
  //SQLμ¹
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $resultArray = array();
    for($i=0; $i<$numrows; $i++){
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      array_push($resultArray, new CIDR_ALLOCATED_BLOCK_HISTORY($row));
    }
  }
  else{
    $resultArray = null;
  }
  return new DB_RESULT_INFO(false, null, $resultArray);
}

/**
* SelectCIDRBlockHistory
* @desc ϤIPɥ쥹ι
* @param $con DBͥ꥽
* @param $ip_network_number IPɥ쥹
* @param  $selcol 륫̾
* @param  $ext ղþ(LIMITOFFSETʤ)
* @return CIDR_BLOCK_UPDATE_HISTORY¤
*/
function SelectCIDRBlockHistory($con, $ip_network_number, $selcol, $ext){
  $sql = "SELECT ".$selcol." FROM cidr_block_update_history WHERE ip_network_number = ".GetApsString($ip_network_number)." ORDER BY update_date".$ext;
  //SQLμ¹
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $resultArray = array();
    for($i=0; $i<$numrows; $i++){
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      array_push($resultArray, new CIDR_BLOCK_UPDATE_HISTORY($row));
    }
  }
  else{
    $resultArray = null;
  }
  return new DB_RESULT_INFO(false, null, $resultArray);
}

/**
* SelectCIDRUnAllocateBlockHistory
* @desc ϤIPɥ쥹ι
* @param $con DBͥ꥽
* @param $ip_network_number IPɥ쥹
* @param $selcol 륫̾
* @param $ext ղþ(LIMITOFFSETʤ)
* @return CIDR_UNALLOCATE_BLOCK¤
*/
function SelectCIDRUnAllocateBlockHistory($con, $ip_network_number, $selcol, $ext){
  $sql = "SELECT ".$selcol." FROM cidr_unallocate_block_history WHERE ip_network_number = ".GetApsString($ip_network_number)." ORDER BY update_date".$ext;
  //SQLμ¹
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $resultArray = array();
    for($i=0; $i<$numrows; $i++){
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      array_push($resultArray, new CIDR_UNALLOCATE_BLOCK_HISTORY($row));
    }
  }
  else{
    $resultArray = null;
  }
  return new DB_RESULT_INFO(false, null, $resultArray);
}

/**
* SelectCIDRAllocatedBlockHistoryByUpdateDate
* @desc Ϥλδ֤ˤCIDR_ALLOCATED_BLOCKCIDR֥åꥹȤ򤫤
* @param $con DBͥ꥽
* @param $start 
* @param $end λ
* @return CIDR֥åꥹ
*/
function SelectCIDRAllocatedBlockHistoryByUpdateDate($con, $start, $end){
  return SelectUPDATE_INFO_HISTORYByUpdateDate($con,"cidr_allocated_block_history","ip_network_number",$start,$end);
}

/**
* SelectCIDRBlockHistoryByUpdateDate
* @desc Ϥλδ֤ˤCIDR_BLOCKCIDR֥åꥹȤ򤫤
* @param $con DBͥ꥽
* @param $start 
* @param $end λ
* @return CIDR֥åꥹ
*/
function SelectCIDRBlockHistoryByUpdateDate($con, $start, $end){
  return SelectUPDATE_INFO_HISTORYByUpdateDate($con,"cidr_block_update_history","ip_network_number",$start,$end);
}

/**
* SelectCIDRUnAllocateBlockHistoryByUpdateDate
* @desc Ϥλδ֤ˤCIDR_UNALLOCATE_BLOCKCIDR֥åꥹȤ򤫤
* @param $con DBͥ꥽
* @param $start 
* @param $end λ
* @return CIDR֥åꥹ
*/
function SelectCIDRUnAllocateBlockHistoryByUpdateDate($con, $start, $end){
  return SelectUPDATE_INFO_HISTORYByUpdateDate($con,"cidr_unallocate_block_history","ip_network_number",$start,$end);
}

/**
* GetCIDRBlockNoneDNS
* @desc ϤȿάΤDNSϿƤʤCIDR_BLOCK򤫤
* @param $con DBͥ꥽
* @param $member_short_name ȿά
* @param $selcol 륫̾
* @param $ext ղþ(LIMITOFFSETʤ)
* @return CIDR_BLOCK¤
*/
function GetCIDRBlockNoneDNS($con, $member_short_name, $selcol, $ext){
  //ȿά΢ȿֹ
  $result = GetMemberNumberByMemberShortName($con, $member_short_name);
  if($result->is_error)  return $result;
  $member_number = $result->db_result_info;
  if($member_number === null){
    return new DB_RESULT_INFO(false, null, null);
  }
  //SQLμ¹
  $sql = "SELECT ".$selcol." FROM cidr_block WHERE member_number = ".$member_number." AND ip_network_number NOT IN(SELECT ip_network_number FROM mdb_dnsinfo WHERE member_number = ".$member_number.")".$ext;
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $resultArray = array();
    for($i=0; $i<$numrows; $i++){
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      array_push($resultArray, new CIDR_BLOCK($row));
    }
  }
  else{
    $resultArray = null;
  }
  return new DB_RESULT_INFO(false, null, $resultArray);
}

/**
* GetSDBAllocatedBlock
* @desc CIDR֥åȤΤҤĤ
* @param $con DBͥ꥽
* @param $accept_id No
* @return array(CIDR֥åꥹ)
*/
function GetSDBAllocatedBlock($con, $accept_id){
  //RCVμNo
  $accept_num = GetAcceptIDNumberFromRCVFormat($accept_id);
  if($accept_num != ""){
    //ҤĤ
    $result = DBAPI_select_MDB_ARRAY($con, "sdb_allocated_block", "accept_id", "integer", $accept_num, "ip_network_number", __FILE__, __LINE__);
    //͸
    if($result->is_error)  return $result;
    if(is_array($result->db_result_info) == true && count($result->db_result_info) > 0){
      return $result;
    }
  }
  return new DB_RESULT_INFO(false, null, NO_COLUMN_SELECT);
}

/**
* CreateSDBAllocatedBlock
* @desc CIDR֥åȤΤҤĤ
* @param $con DBͥ꥽
* @param $accept_id No
* @param array(CIDR֥åꥹ)
* @return Կԡfalse
*/
function CreateSDBAllocatedBlock($con, $accept_id, $addr_list){
  //RCVμNo
  $accept_num = GetAcceptIDNumberFromRCVFormat($accept_id);
  if($accept_num != ""){
    if(is_array($addr_list) == true){
      //ҤĤ
      $result = DBAPI_insert_MDB_ARRAY($con, "sdb_allocated_block", "accept_id", "integer", $accept_num, "ip_network_number", "text", $addr_list, __FILE__, __LINE__);
      //͸
      if($result->is_error) return $result;
      return new DB_RESULT_INFO(false, null, true);
    }
  }
  return new DB_RESULT_INFO(false, null, NO_RECORD_INSERT);
}

?>
