<?php
//$Id: common_function.php,v 1.5 2004/02/27 10:32:21 wtetsuya Exp $

// 顼
define("NO_COLUMN_SELECT", -1);  //SELECTǤʤä
define("NO_RECORD_DELETE", -2);  //DELETE褦ȤDELETEǤʤä
define("NO_RECORD_INSERT", -3);  //INSERT褦ȤINSERTǤʤä
define("NO_RECORD_UPDATE", -4);  //UPDATE褦ȤUPDATEǤʤä
define("LOCK_TIME_OVER", -5);    //LOCK褦Ȥ»֥СLOCKǤʤä

//Reg_sqlॢȻ
define("LOCK_TIME_LIMIT", 10);    //ñ̡

/**
* ؿuserdef_cmp_cidr
* 桼ȴؿ(start_sequence_numberǥȤ)
* @param$a$cidrΰ
* @param$b$cidrΰ
* @returnο($a > $b)($a == $b)ο($a < $b)
*/
function userdef_cmp_cidr($a, $b)
{
  $a_range = RegIpv6AddressUtil::get_sequence_num($a);
  $b_range = RegIpv6AddressUtil::get_sequence_num($b);
  if($a_range[0] > $b_range[0])  return 1;
  if($a_range[0] == $b_range[0])  return 0;
  if($a_range[0] < $b_range[0])  return -1;
}

/**
* ؿIP_BLOCK_CIDR_gmp_cidr
* ȥֹ桢ɥֹ椫CIDRɽIPɥ쥹֥å׻
* @param$startȥֹ
* @param$endɥֹ
* @returnCIDRɽIPɥ쥹֥å
* @descCIDRʬΥåѤǤ
*/
function IP_BLOCK_CIDR_gmp_cidr($start, $end){
  if(strtolower(gettype($start)) != "string"){
    $start = (string)$start;  //$startʸѴgmp_initȤäȤʤ
  }
  if(strtolower(gettype($end)) != "string"){
    $end = (string)$end;  //$endʸѴgmp_initȤäȤʤ
  }
  $ip_block = array();
  $ip_seq = array();
  while (gmp_cmp($end, $start) >= 0){   // $end >= $start
    $c++;
    $len = gmp_add(gmp_sub($end, $start), 1); // $len = $end - $start + 1;
    $idx1 = gmp_scan1( $start, 0);
      
    if (gmp_cmp($start, 0) == 0) $idx1 = 33;
    $r1 = gmp_pow("2", $idx1);                // $r1 = 2 ^ $idx1
    if (gmp_cmp($len, $r1) >= 0){           // if ($len >= $r1)
      $next_start = gmp_add( $start, $r1);  // $next_start = $start + $r1;
        
      $block_start = $start;
      $block_end   = gmp_sub($next_start, 1);
      $block_length = prifixlength($block_start, $block_end);
      $cidr_block = gmpPrintCIDRBlockIPv4Format($block_start, $block_length);
      array_push($ip_block , $cidr_block);
      array_push($ip_seq, sprintf("%08s", gmp_strval($block_start,16)));
      $start = $next_start;
    }
      
    $len = gmp_add(gmp_sub($end, $start), 1); // $len = $end - $start + 1;
    $idx2 = gmp_scan0( $end, 0);
      
    if (gmp_cmp("32", $idx2) < 0) $idx2 = 33;
      
    $r2 = gmp_pow(2, $idx2);                  // $r2 = 2 ^ $idx2
    if (gmp_cmp($len, $r2) >= 0){             // if ($len >= $r2)
      $next_end = gmp_sub( $end, $r2); // $next_end = $end - $r2;
      $block_start = gmp_add(1,$next_end);
      $block_end   = $end;
      $block_length = prifixlength($block_start, $block_end);
      $cidr_block = gmpPrintCIDRBlockIPv4Format($block_start, $block_length);
      array_push($ip_block , $cidr_block);
      array_push($ip_seq, sprintf("%08s", gmp_strval($block_start,16)));
      $end = $next_end;
    }
  }
  array_multisort( $ip_seq, SORT_STRING, $ip_block);
  return $ip_block;
}

/**
* ؿgmpPrintCIDRBlockIPv4Format
* ȥֹ桢ץեåĹCIDRɽIPɥ쥹֥åȤ
* @param$sequence_numȥֹ
* @param$prefix_lengthץեåĹ
* @returnCIDRɽIPɥ쥹֥å
* @descδؿͤĤΤʤ$sequence_num$prefix_lengthȤ߹碌ǤΤߵǽ
* CIDRɽIPɥ쥹֥åʣˤʤIP_BLOCK_CIDR_gmp_cidrѤ뤳
*/
function gmpPrintCIDRBlockIPv4Format( $sequence_num, $prefix_length ){
  $mask = gmp_init(0xff);
  $byte4 = gmp_intval(gmp_and($sequence_num , $mask));
  $sequence_num = gmp_div_q($sequence_num, 256);
  $byte3 = gmp_intval(gmp_and($sequence_num , $mask));
  $sequence_num = gmp_div_q($sequence_num, 256);
  $byte2 = gmp_intval(gmp_and($sequence_num , $mask));
  $sequence_num = gmp_div_q($sequence_num, 256);
  $byte1 = gmp_intval(gmp_and($sequence_num , $mask));
  return $byte1.".".$byte2.".".$byte3.".".$byte4."/$prefix_length";
}

/**
* ؿprifixlength
* ȥֹ桢ɥֹ椫ץեåĹ׻
* @param$sȥֹ
* @param$eɥֹ
* @returnץեåĹ
* @descδؿͤĤΤʤ$s$eȤ߹碌ǤΤߵǽ
* ץեåĹʣˤʤIP_BLOCK_CIDR_gmp_cidrѤ뤳
*/
function prifixlength($s, $e){
  $len = gmp_add(gmp_sub($e ,$s), 1);
  $pre = gmp_sub(32, gmp_scan1($len, 0));
  return gmp_intval($pre);
}

/*
 * ؿ: GetSequenceNumberFromIPv4Format
 * : ɥåȷ 10 ɽ IP ɥ쥹Ϣ³ֹ֤
 * @param  string  $start_cidr  (Ϣ³ֹ)
 * @return integer  IPɥ쥹Ϣ³ֹɽ
*/
function GetSequenceNumberFromIPv4Format($start_cidr){
  if($start_cidr == null) return null;
  //ɥåȷɥ쥹,4Ĥο
  ereg("([0-9]{1,3})\.([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3})\/([0-9]{1,2})",
       $start_cidr,$regs);
  $byte_1st = $regs[1];$byte_2nd = $regs[2];$byte_3rd = $regs[3];
  $byte_4th = $regs[4];$prefix_length = $regs[5];
  //줿ͤĤοϢ³ֹѴơץեĹȤȤ֤
  $start_sequence_number =
    $byte_1st*pow(256,3)+$byte_2nd*pow(256,2)+$byte_3rd*256+$byte_4th;
  $end_sequence_number = $start_sequence_number
    + pow(2,32 - $prefix_length) - 1;
  return array($start_sequence_number,$end_sequence_number,$prefix_length);
}

/*
 * ؿ: GetAcceptIDNumberFromRCVFormat
 * : RCVοֹ椫Ф
 * @param  string  $acceptID  ֹ
 * @return integer  ֹοʬ
*/
function GetAcceptIDNumberFromRCVFormat($acceptID){
  //ֹ() RCV Ѵ֤
  if(ereg("RCV-0*([0-9]*)",$acceptID,$regs))
  {
    return $regs[1];
  }
  else
  {
    return "null";
  }
}

/*
 * ؿ: GetAcceptIDRCVFromNumber
 * : RCVοֹ
 * @param  string  $acceptID  ֹ
 * @return string  RCVοֹ
*/
function GetAcceptIDRCVFromNumber($acceptID){
  //ֹ(RCV )Ѵ֤  
  return(100000000 <= $acceptID) ? "RCV-".$acceptID :
    "RCV-".sprintf("%08d",$acceptID);
}

/*
 * ؿ: GetApsString
 * : ʸ˥󥰥륯ơɲä
 * @param  string  $str  ʸ
 * @return string  󥰥륯ơǰϤޤ줿ʸ
*/
function GetApsString($str){
  
  //⤷ʸǤ "null"֤
  if(($str == null) || ($str == ""))
    return "null";
  else
  //⤷ʸǤʤХ󥰥륯ơɲä֤    
    return "'".addSlashes($str)."'";
}

/*
 * ؿ: regdb_exec
 * : SQLSYSLOG˵Ͽơpg_exec¹Ԥ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $sql  SQL
 * @return resource  ̥꥽
*/
function regdb_exec($con, $sql){
  global $reg_db_flag;
  //SQL¹Ԥ
include("config/RegCnfDebug.php");
if ($cnf_sys_debug_flg)
{
//  print("\n" . $sql . "<br>\n");
}
  $result = pg_exec($con,$sql);
  //ե饰 $reg_db_flag TRUE ʤ SQL SYSLOG Ͽ
  if($reg_db_flag){
    if(!$result) $sql = $sql.":SQL Error";
    syslog(LOG_DEBUG,$sql);  
  }
  //SQLμ¹Է̤֤
  return $result;
}

/*
 * ؿ: regdb_send_query
 * : SQLSYSLOG˵Ͽơpg_send_query ¹Ԥ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $sql  SQL
 * @return boolean  ݤ
*/
function regdb_send_query($con, $sql){
  global $reg_db_flag;
  //SQLƱ¹Ԥ  
include("config/RegCnfDebug.php");
if ($cnf_sys_debug_flg)
{
//  print("\n" . $sql . "<br>\n");
}
  $result = pg_send_query($con, $sql);
  if($reg_db_flag){
    //ե饰 $reg_db_flag TRUE ʤ SQL SYSLOG Ͽ    
    if(!$result) $sql = $sql.":SQL Error";
    syslog(LOG_DEBUG,$sql);  
  }  
}


/*
 * ؿ: GetErrorCode
 * : PostgreSQL(Ver.7.2)Υ顼åꥨ顼ɤ֤
 * @param  string  $emesg  顼å
 * @return string  顼
*/
function GetErrorCode($emesg){
  //å󥨥顼åФ
  if(preg_match("/ExecAppend:\s+rejected\sdue\sto\sCHECK\sconstraint\s(\w*)/",$emesg,$match))
    return GetErrorCodeFrConst($match[1]);
  //PK󥨥顼Ф
  else if(preg_match("/ERROR:\s+Cannot\s+insert\s+a\s+duplicate\s+key\s+into\s+unique\s+index\s+(\w*)/",$emesg,$match))
    return GetErrorCodeFrConst($match[1]);
  //󥨥顼Ф
  else if(preg_match("/ERROR:\s+(\w*)\s+referential\s+integrity\s+violation/",$emesg,$match))
    return GetErrorCodeFrConst($match[1]);
  //嵭ʳΥåˤĤƤ"DB-900"򤫤 
  return "DB-900";
}


/*
 * ؿ: GetErrorCodeFrConst
 * : 쥸ȥDBꤷ̾ꥨ顼ɤ֤
 * @param  string  $const  ̾
 * @return string  DB˴Ϣ륨顼
*/
function GetErrorCodeFrConst($const){
	//쥸ȥDB̾ȥ顼ɤФϥå˺
	$c = array(
		//----- pkey -----//
		"mdb_meminfo_pkey"						=>	"DB-001",
		"cidr_block_pkey"						=>	"DB-002",
		"mdb_ipnetinfo_pkey"					=>	"DB-003",
		"mdb_dnsinfo_pkey"						=>	"DB-004",
		"cidr_allocated_block_pkey"				=>	"DB-005",
		"cidr_unallocate_block_pkey"			=>	"DB-006",
		"mdb_ipnet_technical_resp_pkey"			=>	"DB-007",
		"mdb_ipnet_mail_address_pkey"			=>	"DB-008",
		"mdb_mem_notice_address_pkey"			=>	"DB-009",
		"mdb_dns_name_server_pkey"				=>	"DB-010",
		"seq_number_management_pkey"			=>	"DB-011",
		"sdb_member_info_pkey"					=>	"DB-012",
		"sdb_ip_member_pkey"					=>	"DB-013",
		"sdb_ipv6_member_pkey"					=>	"DB-014",
		"sdb_apply_info_pkey"					=>	"DB-015",
		"sdb_form_opr0102_pkey"					=>	"DB-016",
		"sdb_form_ops0101_pkey"					=>	"DB-017",
		"sdb_form_ops0201_pkey"					=>	"DB-018",
		"sdb_form_ops0202_pkey"					=>	"DB-019",
		"sdb_form_ops0203_pkey"					=>	"DB-020",
		"sdb_form_ops0204_pkey"					=>	"DB-021",
		"sdb_form_ops0206_pkey"					=>	"DB-022",
		"sdb_form_ops0207_pkey"					=>	"DB-023",
		"sdb_form_ops0208_pkey"					=>	"DB-024",
		"sdb_form_ops0212_pkey"					=>	"DB-025",
		"sdb_clerk_info_pkey"					=>	"DB-026",
		"dpn_content_pkey"						=>	"DB-027",
		"sdb_form_technical_resp_pkey"			=>	"DB-028",
		"sdb_allocated_block_pkey"				=>	"DB-029",
		"sdb_form_ip_network_number_pkey"		=>	"DB-030",
		"sdb_form_mail_address_pkey"			=>	"DB-031",
		"sdb_form_name_server_pkey"				=>	"DB-032",
		"sdb_form_notice_address_pkey"			=>	"DB-033",
		"sdb_form_extra_info_pkey"				=>	"DB-034",
		"seq_rcv_pkey"							=>	"DB-035",
		"rdb_master_pkey"						=>	"DB-036",
		"rdb_ipnetinfo_pkey"					=>	"DB-037",

		//----- fkey -----//
		"cidr_block_fkey"						=>	"DB-101",
		"mdb_ipnetinfo_fkey"					=>	"DB-102",
		"mdb_dnsinfo_fkey"						=>	"DB-103",
		"cidr_unallocate_block_fkey"			=>	"DB-104",
		"mdb_ipnet_technical_resp_fkey"			=>	"DB-105",
		"mdb_ipnet_mail_address_fkey"			=>	"DB-106",
		"mdb_mem_notice_address_fkey"			=>	"DB-107",
		"mdb_dns_name_server_fkey"				=>	"DB-108",
		"sdb_member_info_fkey"					=>	"DB-109",
		"sdb_form_opr0102_fkey"					=>	"DB-110",
		"sdb_form_ops0101_fkey"					=>	"DB-111",
		"sdb_form_ops0201_fkey"					=>	"DB-112",
		"sdb_form_ops0202_fkey"					=>	"DB-113",
		"sdb_form_ops0203_fkey"					=>	"DB-114",
		"sdb_form_ops0204_fkey"					=>	"DB-115",
		"sdb_form_ops0206_fkey"					=>	"DB-116",
		"sdb_form_ops0207_fkey"					=>	"DB-117",
		"sdb_form_ops0208_fkey"					=>	"DB-118",
		"sdb_form_ops0212_fkey"					=>	"DB-119",
		"dpn_content_fkey"						=>	"DB-120",
		"sdb_form_technical_resp_fkey"			=>	"DB-121",
		"sdb_allocated_block_fkey"				=>	"DB-122",
		"sdb_form_ip_network_number_fkey"		=>	"DB-123",
		"sdb_form_mail_address_fkey"			=>	"DB-124",
		"sdb_form_name_server_fkey"				=>	"DB-125",
		"sdb_form_notice_address_fkey"			=>	"DB-126",
		"sdb_form_extra_info_fkey"				=>	"DB-127",
		"seq_rcv_fkey"							=>	"DB-128",
		"rdb_ipnetinfo_fkey"					=>	"DB-129",
		"rdb_admin_c_fkey"						=>	"DB-130",
		"rdb_tech_c_fkey"						=>	"DB-131",
		"rdb_rev_srv_fkey"						=>	"DB-132",
		"rdb_remarks_fkey"						=>	"DB-133",
		"rdb_notify_fkey"						=>	"DB-134",
		"rdb_mnt_by_fkey"						=>	"DB-135",
		"rdb_mnt_lower_fkey"					=>	"DB-136",
		"rdb_mnt_irt_fkey"						=>	"DB-137",

		//----- uniq -----//
		"mdb_meminfo_uniq"						=>	"DB-201",
		"cidr_block_uniq"						=>	"DB-202",
		"cidr_block_uniq2"						=>	"DB-203",
		"mdb_ipnetinfo_uniq"					=>	"DB-204",
		"mdb_ipnetinfo_uniq2"					=>	"DB-205",
		"mdb_dnsinfo_uniq"						=>	"DB-206",
		"mdb_dnsinfo_uniq2"						=>	"DB-207",
		"cidr_allocated_block_uniq"				=>	"DB-208",
		"cidr_allocated_block_uniq2"			=>	"DB-209",
		"cidr_unallocate_block_uniq"			=>	"DB-210",
		"cidr_unallocate_block_uniq2"			=>	"DB-211",
		"sdb_ip_member_uniq"					=>	"DB-212",
		"sdb_ip_member_uniq2"					=>	"DB-213",
		"sdb_ipv6_member_uniq"					=>	"DB-214",
		"sdb_ipv6_member_uniq2"					=>	"DB-215",
		"rdb_ipnetinfo_uniq"					=>	"DB-216",

		//----- check -----//
		"mdb_meminfo_check"						=>	"DB-301",
		"cidr_block_check"						=>	"DB-302",
		"mdb_ipnetinfo_check"					=>	"DB-303",
		"mdb_ipnetinfo_check2"					=>	"DB-304",
		"mdb_dnsinfo_check"						=>	"DB-305",
		"cidr_allocated_block_check"			=>	"DB-306",
		"cidr_allocated_block_history_check"	=>	"DB-307",
		"cidr_block_update_history_check"		=>	"DB-308",
		"cidr_unallocate_block_check"			=>	"DB-309",
		"cidr_unallocate_block_check2"			=>	"DB-310",
		"cidr_unallocate_block_history_check"	=>	"DB-311",
		"cidr_unallocate_block_history_check2"	=>	"DB-312",
		"mdb_ipnet_technical_resp_check"		=>	"DB-313",
		"mdb_ipnet_mail_address_check"			=>	"DB-314",
		"mdb_ipnet_update_history_check"		=>	"DB-315",
		"mdb_dns_update_history_check"			=>	"DB-316",
		"mdb_dns_name_server_check"				=>	"DB-317",
		"sdb_ip_member_check"					=>	"DB-318",
		"sdb_ipv6_member_check"					=>	"DB-319",
		"sdb_ipv6_member_check2"				=>	"DB-320",
		"sdb_apply_info_check"					=>	"DB-321",
		"sdb_apply_info_check2"					=>	"DB-322",
		"sdb_form_ops0202_check"				=>	"DB-323",
		"sdb_form_ops0203_check"				=>	"DB-324",
		"sdb_form_ops0204_check"				=>	"DB-325",
		"sdb_clerk_info_check"					=>	"DB-326",
		"sdb_allocated_block_check"				=>	"DB-327",
		"sdb_form_ip_network_number_check"		=>	"DB-328",
	);

  //쥸ȥDB̾ꥨ顼ɤФ
  $r = $c[$const];
  if($r == null) return "DB-900";
  //顼ɤ֤
  return $r;
}

?>
