<?php
//$Id: sdb_apply_info.php,v 1.3 2004/02/12 10:59:12 wtetsuya Exp $

/*
 * ؿ: GetApplyInfo
 * : No($apply_id)οǡ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $accept_id  ֹ
 * @param  string  $selcol  ¸̾
 * @param  string  $ext  ղþ(LIMITOFFSET)
 * @return SDB_APPLY_INFO  ǡ
*/
function GetApplyInfo($con, $accept_id, $selcol, $ext){
  if($accept_id == "*"){
    //SQLʸκ : ɽSDB_APPLY_INFO θ
    $sql = "SELECT accept_id,".$selcol." FROM sdb_apply_info ORDER BY accept_id".$ext;
  }
  else{
    //ؿGetAcceptIDNumberFromRCVFormatΥ:RCVοֹ椫Ф
    $accept_idnum = GetAcceptIDNumberFromRCVFormat($accept_id);
    //SQLʸκ : ɽSDB_APPLY_INFO θ
    $sql = "SELECT accept_id,".$selcol." FROM sdb_apply_info WHERE accept_id = ".$accept_idnum . $ext;
  }
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:Υ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  if ($check->is_error) {
    return $check;
  }
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $sdb_apply_info = array();
    for($i=0; $i<$numrows; $i++){
      //SQLμ¹Է̤ԥեåƷ̤
      $row = pg_fetch_array($result, $i,PGSQL_ASSOC);
      $row[accept_id] = GetAcceptIDRCVFromNumber($row[accept_id]);
      array_push($sdb_apply_info, new SDB_APPLY_INFO($row));
    }
  }
  else{
    $sdb_apply_info = null;
  }
  //̤֤
  return new DB_RESULT_INFO(false,null,$sdb_apply_info);
}

/*
 * ؿ: SearchApplyInfo
 * : ˥ޥå뿽ǡ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $condition  
 * @param  string  $selcol  ¸̾
 * @param  string  $ext  ղþ(LIMITOFFSET)
 * @return SDB_APPLY_INFO  ǡ
*/
function SearchApplyInfo($con, $condition, $selcol, $ext){
  if($condition == ""){
    //SQLʸκ : ɽSDB_APPLY_INFO θ
    $sql = "SELECT accept_id,".$selcol." FROM sdb_apply_info ORDER BY accept_id".$ext;
  }
  else{
    //SQLʸκ : ɽSDB_APPLY_INFO θ
    $sql = "SELECT accept_id,".$selcol." FROM sdb_apply_info WHERE ".$condition." ORDER BY accept_id".$ext;
  }
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:Υ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  if ($check->is_error) {
    return $check;
  }
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $sdb_apply_info = array();
    for($i=0; $i<$numrows; $i++){
      //SQLμ¹Է̤ԥեåƷ̤
      $row = pg_fetch_array($result, $i,PGSQL_ASSOC);
      $row[accept_id] = GetAcceptIDRCVFromNumber($row[accept_id]);
      array_push($sdb_apply_info, new SDB_APPLY_INFO($row));
    }
  }
  else{
    $sdb_apply_info = null;
  }
  //̤֤
  return new DB_RESULT_INFO(false,null,$sdb_apply_info);
}

/*
 * ؿ: CountApplyInfo
 * : ιԿ򥫥Ȥ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $condition  
 * @return integer  Կ 
*/
function CountApplyInfo($con, $condition)
{
  //SQLʸκɽSDB_APPLY_INFOθ
  $sql = "SELECT COUNT(*) FROM sdb_apply_info ".$condition;
  //ؿregdb_execΥ롧SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con,$result,__FILE__,__LINE__);
  if($check->is_error)  return $check;
  $row = pg_fetch_array($result,0,PGSQL_ASSOC);
  return new DB_RESULT_INFO(false, null, $row[count]);  //
}

/*
 * ؿ: CreateApplyInfo
 * : ǡ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  SDB_APPLY_INFO  $applyInfo  
 * @return boolean  ݤ
 * ͡Сmember_numberϥץ꤬ǥåȤ뤳
*/
function CreateApplyInfo($con, $applyInfo){
  //ؿSEQ_IncCountΥ
  $accept_id_result = SEQ_IncCount($con,"sdb_apply_info");
  //ؿͤĴ٤ƥ顼ǤХ顼֤
  if ($accept_id_result->is_error) return $result;  

  //SQLʸκ : ɽSDB_APPLY_INFOؤ
  //charge_flagˤϤĤ0
  $sql = "insert into SDB_APPLY_INFO values(".$accept_id_result->db_result_info.","
    .GetApsString($applyInfo->apply_date).","
    .GetApsString($applyInfo->clerk_id).","
    .GetApsString($applyInfo->apply_kind_id).","
    .GetApsString($applyInfo->member_number).","
    .GetApsString($applyInfo->status).","
    .GetApsString($applyInfo->settlement_id).","
    .GetApsString($applyInfo->send_person).","
    .GetApsString($applyInfo->settlement_date).",0,"
    .GetApsString($applyInfo->note).","
    .GetApsString($applyInfo->final_reply).")";

  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);  
  //ؿDoCheckDBErrorInsertOneorZeroΥ:꡼Υ顼åԤ
  $check = DoCheckDBErrorInsertOneorZero($con, $result,__FILE__,__LINE__);
  if ($check->is_error) return $check;
  //ؿGetAcceptIDRCVFromNumberΥ:RCVοֹ
  //̤֤
  return new DB_RESULT_INFO
    (false, null, GetAcceptIDRCVFromNumber($accept_id_result->db_result_info));
}

/*
 * ؿ: CreateApplyInfo_Contract
 * : ǡ(Ƽ»ȿϿVerȿֹNULL)
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  SDB_APPLY_INFO  $applyInfo  
 * @return boolean  ݤ
 * ͡Сmember_numberϳƤƤʤΤnullAPIåȤ
*/
function CreateApplyInfo_Contract($con, $applyInfo){
  //ؿSEQ_IncCountΥ
  $accept_id_result = SEQ_IncCount($con,"sdb_apply_info");
  //ؿͤĴ٤ƥ顼ǤХ顼֤
  if ($accept_id_result->is_error) return $result;  
  //SQLʸκ : ɽSDB_APPLY_INFOؤ
  //charge_flagˤϤĤ0
  $sql = "insert into SDB_APPLY_INFO values(".$accept_id_result->db_result_info.","
    .GetApsString($applyInfo->apply_date).","
    .GetApsString($applyInfo->clerk_id).","
    .GetApsString($applyInfo->apply_kind_id).",null,"
    .GetApsString($applyInfo->status).","
    .GetApsString($applyInfo->settlement_id).","
    .GetApsString($applyInfo->send_person).","
    .GetApsString($applyInfo->settlement_date).",0,"
    .GetApsString($applyInfo->note).","
    .GetApsString($applyInfo->final_reply).")";

  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);  
  //ؿDoCheckDBErrorInsertOneorZeroΥ:꡼Υ顼åԤ
  $check = DoCheckDBErrorInsertOneorZero($con, $result,__FILE__,__LINE__);
  if ($check->is_error) return $check;
  //ؿGetAcceptIDRCVFromNumberΥ:RCVοֹ
  //̤֤
  return new DB_RESULT_INFO
    (false, null, GetAcceptIDRCVFromNumber($accept_id_result->db_result_info));
}

/*
 * ؿ: SaveApplyInfo
 * : ǡ񤭤
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  SDB_APPLY_INFO  $applyInfo  
 * @param  string  ¸̾
 * @return boolean  ݤ
*/
function SaveApplyInfo($con, $applyInfo, $selcol){
  $dm = "";
  $str = "";
  foreach(explode(",",$selcol) as $key => $value){
	$str .= $dm.$value;
	$str .= " = ";
	$str .= GetApsString($applyInfo->$value);
	$dm = ",";
  }
  //print($applyInfo->accept_id."\n");
  //print(GetAcceptIDNumberFromRCVFormat($applyInfo->accept_id)."\n");
  //SQLʸκ : ɽSDB_APPLY_INFOι
  //charge_flagˤϤĤ0
  $sql = "update SDB_APPLY_INFO set ".$str." where accept_id = ".GetAcceptIDNumberFromRCVFormat($applyInfo->accept_id);
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorUpdateSomeΥ:꡼Υ顼åԤ
  $check = DoCheckDBErrorUpdateSome($con, $result,__FILE__,__LINE__);
  if ($check->is_error) return $check;
  //̤֤
  return new DB_RESULT_INFO(false, null, $check->db_result_info);
}

?>
