--
-- PostgreSQL database dump
--

SET SESSION AUTHORIZATION 'postgres';

--
-- TOC entry 3 (OID 2200)
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
GRANT ALL ON SCHEMA public TO PUBLIC;


SET SESSION AUTHORIZATION 'nobody';

SET search_path = public, pg_catalog;

--
-- TOC entry 4 (OID 350116)
-- Name: member_session; Type: TABLE; Schema: public; Owner: nobody
--

CREATE TABLE member_session (
    sid character varying(32) NOT NULL,
    member_short_name text,
    "password" text,
    action_id text,
    rawdata character varying(512),
    rdate timestamp with time zone DEFAULT now()
);


--
-- TOC entry 5 (OID 350122)
-- Name: member_session_pkey; Type: CONSTRAINT; Schema: public; Owner: nobody
--

ALTER TABLE ONLY member_session
    ADD CONSTRAINT member_session_pkey PRIMARY KEY (sid);


SET SESSION AUTHORIZATION 'postgres';

--
-- TOC entry 2 (OID 2200)
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: postgres
--

COMMENT ON SCHEMA public IS 'Standard public schema';


