<?php
/**
 * $Id: RegIPrevOutPut.php,v 1.1 2004/03/08 13:25:40 yoshi_s Exp $
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegIPrevMsg.php");			// DNSžå
require_once("RegIPrevConf.php");			// config饹
require_once("RegIPrevNSInfo.php");			// NS饹

//----------------------------------------------------------------------------
// define
//----------------------------------------------------------------------------
define("CONF_MASTER", 1);		// ץ饤ޥ
define("CONF_SLAVE", 2);		// 


//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegIPrevOutPut
{
	//----- å -----//
	/**
	 * åꥹ
	 */
	var $m_iprev_msg;

	/**
	 * åϿʸ
	 */
	var $m_log_msg;

	/**
	 * debugåϿʸ
	 */
	var $m_debug_msg;

	/**
	 * debug ե饰
	 */
	var $m_debug_flag;

	//----- ǡ -----//
	/**
	 * iniեǡ(RegIPrevConf֥)
	 */
	var $m_iprev_conf;

	/**
	 * revե˵Ҥ Serial
	 */
	var $m_rev_serial;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegIPrevOutPut
	 *   RegIPrevOutPut饹󥹥ȥ饯
	 * @param  $iprev_conf   RegIPrevConf֥   (i)
	 * @param  $iprev_msg    åꥹ           (i)
	 * @param  $debug_flag   ǥХåե饰(def=FALSE)  (i)
	 */
	function RegIPrevOutPut($iprev_conf, $iprev_msg, $debug_flag=FALSE)
	{
		$this->m_iprev_conf	= $iprev_conf;		// iniե
		$this->m_iprev_msg	= $iprev_msg;		// inc0103ѥåꥹ
		$this->m_log_msg	= "";				// å
		$this->m_debug_msg	= "";				// ǥХåå
		$this->m_debug_flag	= $debug_flag;		// ǥХåե饰

		$this->m_rev_serial	= time() + 1000000000;
	}

	//-----------------------------------------------------------------------
	// public methods(ե)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾output_conf_file
	 *   ץ饤ޥconfե롢ӡzoneե.revե
	 *         ΥإåԤ
	 * @param  $zone_list   zone				(i)
	 *                      array(
	 *                          [0] => zone
	 *                          [1] => zone
	 *                             .....
	 *                           );
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN03	zoneꥹȳ
	 *		         IPREV_GEN30	conf template file ʤ
	 *		         IPREV_GEN31	conf template copy 
	 *		         IPREV_GEN32	conf open 
	 *		         IPREV_GEN33	conf new dir 
	 *		         IPREV_GEN35	zone open 
	 *		         IPREV_GEN36	zone new dir 
	 *		         IPREV_GEN99	fatal error
	 * @desc   zoneեˤĤƤϡإåΤ߽񤭹ߤԤ
	 *         zone ʤϥƥץ졼Ȥ򤽤Τޤ޻Ѥ
	 */
	function output_conf_file($zone_list)
	{
		if (!is_array($zone_list) || count($zone_list) < 1)
			return IPREV_GEN03;

		//----- ץ饤ޥconf -----//
		$result = $this->output_conf_file_imple($zone_list, CONF_MASTER);
		switch ($result)
		{
		case IPREV_GEN00:		// 
			break;

		case IPREV_GEN30:		// conf template file ʤ
		case IPREV_GEN31:		// conf template copy 
		case IPREV_GEN32:		// conf open 
		case IPREV_GEN33:		// conf new dir 
		case IPREV_GEN35:		// zone open 
		case IPREV_GEN36:		// zone new dir 
			return $result;

		case IPREV_GEN99:		// fatal error
		default:
			$this->set_log_msg(IPREV_GEN99, "");
			return IPREV_GEN99;
		}

//		//----- conf -----//
//		$result = $this->output_conf_file_imple($zone_list, CONF_SLAVE);
//		switch ($result)
//		{
//		case IPREV_GEN00:		// 
//			break;
//
//		case IPREV_GEN30:		// conf template file ʤ
//		case IPREV_GEN31:		// conf template copy 
//		case IPREV_GEN32:		// conf open 
//		case IPREV_GEN33:		// conf new dir 
//		case IPREV_GEN35:		// zone open 
//		case IPREV_GEN36:		// zone new dir 
//			return $result;
//
//		case IPREV_GEN99:		// fatal error
//		default:
//			$this->m_log_msg .= $this->m_iprev_msg[IPREV_GEN99];
//			return IPREV_GEN99;
//		}

		return IPREV_GEN00;
	}

	/**
	 * ؿ̾output_conf_temp
	 *   ƥץ졼ȥեץ饤ޥconfեȤ
	 *         
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN30	conf template file ʤ
	 *		         IPREV_GEN31	conf template copy 
	 *		         IPREV_GEN33	conf new dir 
	 *		         IPREV_GEN99	fatal error
	 */
	function output_conf_temp()
	{
		$result = $this->output_conf_temp_imple(CONF_MASTER);
		switch ($result)
		{
		case IPREV_GEN00:		// 
			break;

		case IPREV_GEN30:		// conf template file ʤ
		case IPREV_GEN31:		// conf template copy 
		case IPREV_GEN33:		// conf new dir 
			return $result;

		case IPREV_GEN99:		// fatal error
		default:
			$this->set_log_msg(IPREV_GEN99, "");
			return IPREV_GEN99;
		}

//		$result = $this->output_conf_temp_imple(CONF_SLAVE);
//		switch ($result)
//		{
//		case IPREV_GEN00:		// 
//			break;
//
//		case IPREV_GEN30:		// conf template file ʤ
//		case IPREV_GEN31:		// conf template copy 
//		case IPREV_GEN33:		// conf new dir 
//			return $result;
//
//		case IPREV_GEN99:		// fatal error
//		default:
//			$this->set_log_msg(IPREV_GEN99, "");
//			return IPREV_GEN99;
//		}

		return IPREV_GEN00;
	}

	/**
	 * ؿ̾output_zone_file
	 *   zoneե.revեˤNS쥳ɾ񤭹
	 * @param  $ns_list		rev(RegIPrevNSInfo֥)			(i)
	 *						(array([0]=>RegIPrevNSInfo, [1]=>RegIPrevNSInfo, ...))
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN08	nsꥹȳ
	 *		         IPREV_GEN35	zone open 
	 *		         IPREV_GEN38	zone new dir ʤ
	 *		         IPREV_GEN39	zone file ʤ
	 *		         IPREV_GEN99	fatal error
	 */
	function output_zone_file($ns_list)
	{
		if (!is_array($ns_list) || count($ns_list) < 1)
			return IPREV_GEN08;

		$conf_data	= $this->m_iprev_conf->m_conf_data;
		if ($conf_data[NEWZONE] == "")
		{
			$this->set_log_msg(IPREV_GEN99, "");
			return IPREV_GEN99;				// ͭʤΤfatal error
		}

		//--------------------------------------------------------------------
		// ǥ쥯ȥꥪץå
		//--------------------------------------------------------------------
		$zdh = opendir($conf_data[NEWZONE]);
		if ($zdh == FALSE)
		{
			$this->set_log_msg(IPREV_GEN38, array($conf_data[NEWZONE]));
			return IPREV_GEN38;
		}
		closedir($zdh);

		//--------------------------------------------------------------------
		// NS쥳ɽ񤭹
		//--------------------------------------------------------------------
		$cur_zone	= "";				// 񤭹оݤzone̾
		$zone_file	= "";				// 񤭹оݤzoneեѥ
		$zfp		= FALSE;			// 񤭹оݤzoneեݥ
		$result		= IPREV_GEN00;		// 
		for ($n = 0; $n < count($ns_list); $n++)
		{
			//----- 񤭹оݤzoneľzone(եݥή) -----//
			if (strcmp($cur_zone, $ns_list[$n]->m_zone) != 0)
			{
				//--- Υեclose ---//
				if ($zfp != FALSE)
				{
					flock($zfp, LOCK_UN);			// unlock
					fclose($zfp);
				}
				//--- zoneեѹ ---//
				$cur_zone	= $ns_list[$n]->m_zone;
				$zone_file	= $conf_data[NEWZONE] . "/" . $cur_zone . ".rev";
				//--- ե¸ߥå ---//
				if (file_exists($zone_file) == FALSE)
				{
					$this->set_log_msg(IPREV_GEN39, array($zone_file));
					return IPREV_GEN39;
				}
				//--- ե륪ץ ---//
				$zfp = fopen($zone_file, "a");
				if ($zfp == FALSE)
				{
					$this->set_log_msg(IPREV_GEN35, array($zone_file));
					return IPREV_GEN35;
				}
				flock($zfp, LOCK_EX);
			}

			//----- NS쥳ɽ񤭹 -----//
			$result = $this->output_zone_file_imple($ns_list[$n], $zfp);
			switch ($result)
			{
			case IPREV_GEN00:		// 
				break;

			case IPREV_GEN99:		// fatal error
			default:
				$this->set_log_msg(IPREV_GEN99, "");
				$result = IPREV_GEN99;
				break;
			}

			if ($result != IPREV_GEN00)
				break;
		}

		//--------------------------------------------------------------------
		// 
		//--------------------------------------------------------------------
		if ($zfp != FALSE)
		{
			flock($zfp, LOCK_UN);
			fclose($zfp);
		}

		return $result;
	}


	//-----------------------------------------------------------------------
	// public methods(桼ƥƥ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾set_log_msg
	 *   åɲä
	 * @param $msg_id	åID
	 * @param $options	ץǡʸ
	 *					åθ [0][1]... ղä
	 */
	function set_log_msg($msg_id, $options="")
	{
		$this->m_log_msg .= $this->m_iprev_msg[$msg_id];
		if (is_array($options))
		{
			for ($n = 0; $n < count($options); $n++)
			{
				if ($options[$n] !== "")
				{
					if (substr($options[$n], -1) == "\n")
						$this->m_log_msg .= " [" . substr($options[$n], 0, -1) . "]";
					else
						$this->m_log_msg .= " [" . $options[$n] . "]";
				}
			}
		}
	}

	/**
	 * ؿ̾get_log_msg
	 *   å
	 * @return å
	 */
	function get_log_msg()
	{
		return $this->m_log_msg;
	}

	/**
	 * ؿ̾set_debug_msg
	 *   ǥХååɲäm_debug_flag == true Τߡ
	 * @param $msg_id	åID
	 * @param $options	ץǡʸ
	 *					åθ [0][1]... ղä
	 */
	function set_debug_msg($msg_id, $options)
	{
		if ($this->m_debug_flag)
		{
			$this->m_debug_msg .= $this->m_iprev_msg[$msg_id];
			if (is_array($options))
			{
				for ($n = 0; $n < count($options); $n++)
				{
					if ($options[$n] !== "")
					{
						if (substr($options[$n], -1) == "\n")
							$this->m_debug_msg .= " [" . substr($options[$n], 0, -1) . "]";
						else
							$this->m_debug_msg .= " [" . $options[$n] . "]";
					}
				}
			}
		}
	}

	/**
	 * ؿ̾get_debug_msg
	 *   ǥХååm_debug_flag == true Τߡ
	 * @return ǥХåʸ
	 */
	function get_debug_msg()
	{
		if ($this->m_debug_flag && $this->m_debug_msg != "")
		{
			$this->m_debug_msg =
						"\n\n-------------[output debug msg START]-------------\n" .
						$this->m_debug_msg .
						"\n\n-------------[output debug msg END]-------------\n";
		}
		else
		{
			return "";
		}
		return $this->m_debug_msg;
	}


	//-----------------------------------------------------------------------
	// private methods(ե)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾output_conf_temp_imple
	 *   ץ饤ޥ/˱templateեconfե
	 *         
	 * @param  $type        ץ饤ޥ or 		(i)
	 *                          CONF_MASTER
	 *                          CONF_SLAVE
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN30	conf template file ʤ
	 *		         IPREV_GEN31	conf template copy 
	 *		         IPREV_GEN33	conf new dir 
	 *		         IPREV_GEN99	fatal error
	 */
	function output_conf_temp_imple($type)
	{
		//--------------------------------------------------------------------
		// ץ饤ޥ, ͭ
		//--------------------------------------------------------------------
		$conf_data = $this->m_iprev_conf->m_conf_data;
		if ($conf_data[NEWCONF] == "")
		{
			return IPREV_GEN99;				// ͭʤΤfatal error
		}

		switch ($type)
		{
		case CONF_MASTER:
			$tmp_file	= $conf_data[MAS_TEMP];
			$cnf_file	= $conf_data[NEWCONF] . "/" . $conf_data[MAS_FILE];
			break;
		case CONF_SLAVE:
			$tmp_file	= $conf_data[SLA_TEMP];
			$cnf_file	= $conf_data[NEWCONF] . "/" . $conf_data[SLA_FILE];
			break;
		default:
			return IPREV_GEN99;
		}

		//--------------------------------------------------------------------
		// confǥ쥯ȥꥪץå
		//--------------------------------------------------------------------
		$cdh = opendir($conf_data[NEWCONF]);
		if ($cdh == FALSE)
		{
			if (mkdir($conf_data[NEWCONF], 0755) == FALSE)
			{
				$this->set_log_msg(IPREV_GEN33, array($conf_data[NEWCONF]));
				return IPREV_GEN33;
			}
		}
		else
		{
			closedir($cdh);
		}

		//--------------------------------------------------------------------
		// ƥץ졼ȥե򥳥ԡ
		//--------------------------------------------------------------------
		if (file_exists($tmp_file) == FALSE)
		{
			$this->set_log_msg(IPREV_GEN30, array($tmp_file));
			return IPREV_GEN30;
		}

		if (copy($tmp_file, $cnf_file) == FALSE)
		{
			$this->set_log_msg(IPREV_GEN31, array("temp:" . $tmp_file . ", conf:" . $cnf_file));
			return IPREV_GEN31;
		}

		return $result;
	}

	/**
	 * ؿ̾output_conf_file_imple
	 *   ץ饤ޥ/˱confեȡzoneե
	 *         .revեˤԤ
	 * @param  $zone_list   zone						(i)
	 *                      array(
	 *                          [0] => zone
	 *                          [1] => zone
	 *                             .....
	 *                           );
	 * @param  $type        ץ饤ޥ or 		(i)
	 *                          CONF_MASTER
	 *                          CONF_SLAVE
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN30	conf template file ʤ
	 *		         IPREV_GEN31	conf template copy 
	 *		         IPREV_GEN32	conf open 
	 *		         IPREV_GEN33	conf new dir 
	 *		         IPREV_GEN35	zone open 
	 *		         IPREV_GEN36	zone new dir 
	 *		         IPREV_GEN99	fatal error
	 * @desc   zoneեˤĤƤϡإåΤ߽񤭹ߤԤ
	 */
	function output_conf_file_imple($zone_list, $type)
	{
		//--------------------------------------------------------------------
		// ץ饤ޥ, ͭ
		//--------------------------------------------------------------------
		$conf_data = $this->m_iprev_conf->m_conf_data;
		if ($conf_data[NEWCONF] == "")
		{
			return IPREV_GEN99;				// ͭʤΤfatal error
		}

		switch ($type)
		{
		case CONF_MASTER:
			$tmp_file	= $conf_data[MAS_TEMP];
			$cnf_file	= $conf_data[NEWCONF] . "/" . $conf_data[MAS_FILE];
			$zone_dir	= $conf_data[MAS_ZONE];
			$type_str	= "type master;";
			$master_str	= "";
			break;
		case CONF_SLAVE:
			$tmp_file	= $conf_data[SLA_TEMP];
			$cnf_file	= $conf_data[NEWCONF] . "/" . $conf_data[SLA_FILE];
			$zone_dir	= $conf_data[SLA_ZONE];
			$type_str	= "type slave;";
			$master_str	= sprintf("\n\tmasters {\n\t\t%s;\n\t};",
								  $conf_data[SLA_MAS]);
			break;
		default:
			return IPREV_GEN99;
		}

		//--------------------------------------------------------------------
		// confǥ쥯ȥꥪץå
		//--------------------------------------------------------------------
		$cdh = opendir($conf_data[NEWCONF]);
		if ($cdh == FALSE)
		{
			if (mkdir($conf_data[NEWCONF], 0755) == FALSE)
			{
				$this->set_log_msg(IPREV_GEN33, array($conf_data[NEWCONF]));
				return IPREV_GEN33;
			}
//			$this->m_log_msg .= $this->m_iprev_msg[IPREV_GEN34] .
//								" [" . $conf_data[NEWCONF] . "]";
		}
		else
		{
			closedir($cdh);
		}

		//--------------------------------------------------------------------
		// zoneǥ쥯ȥꥪץå
		//--------------------------------------------------------------------
		if ($type == CONF_MASTER)
		{
			if ($conf_data[NEWZONE] == "")
				return IPREV_GEN99;				// ͭʤΤfatal error

			$zdh = opendir($conf_data[NEWZONE]);
			if ($zdh == FALSE)
			{
				if (mkdir($conf_data[NEWZONE], 0755) == FALSE)
				{
					$this->set_log_msg(IPREV_GEN36, array($conf_data[NEWZONE]));
					return IPREV_GEN36;
				}
//				$this->m_log_msg .= $this->m_iprev_msg[IPREV_GEN37] .
//									" [" . $conf_data[NEWZONE] . "]";
			}
			else
			{
				closedir($zdh);
			}
		}

		//--------------------------------------------------------------------
		// ƥץ졼ȥե򥳥ԡ
		//--------------------------------------------------------------------
		if (file_exists($tmp_file) == FALSE)
		{
			$this->set_log_msg(IPREV_GEN30, array($tmp_file));
			return IPREV_GEN30;
		}

		if (copy($tmp_file, $cnf_file) == FALSE)
		{
			$this->set_log_msg(IPREV_GEN31, array("temp:" . $tmp_file . ", conf:" . $cnf_file));
			return IPREV_GEN31;
		}

		//--------------------------------------------------------------------
		// confե˥ǡߡlockѡ
		//--------------------------------------------------------------------
		$cfp = fopen($cnf_file, "a");
		if ($cfp == FALSE)
		{
			$this->set_log_msg(IPREV_GEN32, array($cnf_file));
			return IPREV_GEN32;
		}

		$result = IPREV_GEN00;

		flock($cfp, LOCK_EX);					// lock
		$z_cnt = count($zone_list);				// zoneƽ񤭹
		for ($n = 0; $n < $z_cnt; $n++)
		{
			$put_str = sprintf("\nzone \"%s.IP6.ARPA\" {\n\t%s\n\tfile \"%s/%s.rev\";%s\n};\n",
							   $zone_list[$n],
							   $type_str,
							   $zone_dir,
							   $zone_list[$n],
							   $master_str);
			fputs($cfp, $put_str);

			//----- MASTERξ .rev ե -----//
			if ($type == CONF_MASTER)
			{
				$result = $this->output_zone_file_h($zone_list[$n]);
				switch ($result)
				{
				case IPREV_GEN00:			// 
				case IPREV_GEN35:			// zone open 
				case IPREV_GEN99:			// fatal error
					break;
				default:					// ʥ顼
					$result = IPREV_GEN99;
					break;
				}
				if ($result != IPREV_GEN00)
				{
					break;					// 顼ʤΤǺ
				}
			}
		}
		flock($cfp, LOCK_UN);					// unlock

		fclose($cfp);

		return $result;
	}

	/**
	 * ؿ̾output_zone_file_h
	 *   zone.revե˥եإå񤭹
	 * @param  $zone     zone1zoneʬ			(i)
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN35	zone open 
	 *		         IPREV_GEN99	fatal error
	 */
	function output_zone_file_h($zone)
	{
		//--------------------------------------------------------------------
		// ե
		//--------------------------------------------------------------------
		$conf_data	= $this->m_iprev_conf->m_conf_data;
		$auth_ns	= $this->m_iprev_conf->m_auth_ns;
		if ($conf_data[NEWZONE] == "")
		{
			return IPREV_GEN99;				// ͭʤΤfatal error
		}

		$write_path = $conf_data[NEWZONE] . "/" . $zone . ".rev";

		//--------------------------------------------------------------------
		// .rev ե륪ץ
		//--------------------------------------------------------------------
		$zfp = fopen($write_path, "w");
		if ($zfp == FALSE)
		{
			$this->set_log_msg(IPREV_GEN35, array($write_path));
			return IPREV_GEN35;
		}
		flock($zfp, LOCK_EX);					// lock

		//--------------------------------------------------------------------
		// .rev إå
		//--------------------------------------------------------------------
		$write_str  = "";
		//-----  -----//
		$write_str .= ";;\n";
		$write_str .= ";; Zone Information for " . $zone . ".ip6.arpa.\n";
		$write_str .= ";;\n";
		$write_str .= ";; \$Id\$\n";
		$write_str .= ";;\n";

		fputs($zfp, $write_str);
		$write_str  = "";

		//----- إå -----//
		$write_str .= $conf_data[ZONE_HEAD] . "\n";

		//----- SOA쥳 -----//
		$write_str .= "@\t\tIN\tSOA\t";
		$write_str .= $conf_data[SOA_ORIGIN] . ". ";
		$write_str .= $conf_data[SOA_MAIL] . ". (\n";
		$write_str .= "\t\t\t" . $this->m_rev_serial . "\t\t; Serial\n";
		$write_str .= "\t\t\t" . $conf_data[SOA_REFRESH] . "\t\t\t; Refresh\n";
		$write_str .= "\t\t\t" . $conf_data[SOA_RETRY] . "\t\t\t\t; Retry\n";
		$write_str .= "\t\t\t" . $conf_data[SOA_EXPIRE] . "\t\t\t; Expire\n";
		$write_str .= "\t\t\t" . $conf_data[SOA_TTL] . ")\t\t\t; Minimum\n";
		$write_str .= ";;\n";

		fputs($zfp, $write_str);
		$write_str  = "";

		//----- AUTH-NS -----//
		$auth_cnt = count($auth_ns);
		for ($n = 0; $n < $auth_cnt; $n++)
		{
			$write_str .= "\t\t\tIN\tNS\t" . $auth_ns[$n] . ".\n";
		}

		fputs($zfp, $write_str);
		$write_str  = "";

		//----- Network Information -----//
		$write_str .= ";;\n";
		$write_str .= ";;\tNetwork Information\n";
		$write_str .= ";;\n";

		fputs($zfp, $write_str);
		$write_str  = "";

		//--------------------------------------------------------------------
		// .rev ե륯
		//--------------------------------------------------------------------
		flock($zfp, LOCK_UN);					// unlock
		fclose($zfp);

		return IPREV_GEN00;
	}


	/**
	 * ؿ̾output_zone_file_imple
	 *   zoneե.revեˤNS쥳ɾ񤭹
	 * @param  $ns_info		nsRegIPrevNSInfo֥ȡ	(i)
	 * @param  $zfp			եݥ						(i)
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN99	fatal error
	 */
	function output_zone_file_imple($ns_info, $zfp)
	{
		if ($zfp == FALSE)
			return IPREV_GEN99;

		$put_str	= "";
		$z_cnt		= count($ns_info->m_block_list);
		for ($z_n = 0; $z_n < $z_cnt; $z_n++)
		{
			$ns_block	= $ns_info->m_block_list[$z_n];					// NS쥳ɤΥ֥å
//			// 񤭹߰Ĵ
//			if ($ns_block == "")
//				$h_str	= "";
//			else
//				$h_str	= sprintf("%". strlen($ns_block) . "s", "");

			$n_cnt		= count($ns_info->m_ns_list);					// nameserver
			for ($n_n = 0; $n_n < $n_cnt; $n_n++)
			{
				$put_str	.= sprintf("%s\t\t\tIN\tNS\t%s.\n", $ns_block, $ns_info->m_ns_list[$n_n]);
//				$ns_block	 = $h_str;
			}
		}

		fputs($zfp, $put_str);
		return IPREV_GEN00;
	}
}
?>
