<?php
//$Id: inc_0103.php,v 1.1 2004/03/08 13:25:40 yoshi_s Exp $
//DNSեžcron

require_once("RegCommonInfo.php");
require_once("DBAPIWrapper.php");			//MDBåѡ饹
require_once("RegAppCronLog.php");			//ϡ᡼
require_once("RegIPrev.php");				//

//----------------------------------------------------------------------------
// Хåեꥢ
//----------------------------------------------------------------------------
ob_end_clean();								// ϥХåեƤõ
ob_implicit_flush(true);					// ϥХåեưŪ˥եå
set_time_limit(60*60*24);					// ץȼ¹Ի֤Ϻ

//----------------------------------------------------------------------------
// ǥХå
//----------------------------------------------------------------------------
include("config/RegCnfDebug.php");
$inc0103_debug = $cnf_sys_debug_flg;

//----------------------------------------------------------------------------
// ϡ᡼åμ賫
//----------------------------------------------------------------------------
$cron_log = new RegAppCronLog("inc0103");
$cron_log->reg_cron_start("DNS file forward cron start.", __FILE__, __LINE__, 0);
$mail_msg_body = "";						//᡼body

//----------------------------------------------------------------------------
// Ķѿμ
//----------------------------------------------------------------------------
$env = array();
$env['MDB_HOST'] = getenv("REGV6_DB_HOST");
$env['MDB_USER'] = getenv("REGV6_DB_USER");
$env['MDB_NAME'] = getenv("REGV6_DB_NAME");
$env['NOW'] = date("Y-m-d H:i:s T");

//----------------------------------------------------------------------------
// DBͥ
//----------------------------------------------------------------------------
$mdb = DBAPI::connect("host={$env['MDB_HOST']} user={$env['MDB_USER']} dbname={$env['MDB_NAME']}");
if($mdb->con == null)
{
	$mail_msg_body .= "MDB can't connect(host={$env['MDB_HOST']} user={$env['MDB_USER']} dbname={$env['MDB_NAME']})";
	//顼λ᡼
	$cron_log->reg_cron_err_end($mail_msg_body, __FILE__, __LINE__, 0);
	exit;
}

//----------------------------------------------------------------------------
// name.conf, zone file 
//----------------------------------------------------------------------------
$err_flg = 0;										// 顼ե饰
$end_flg = 0;										// λե饰
$no_ns_flg = 0;										// nsʤե饰

//TR
$mdb->begin("SERIALIZABLE");

$iprev = new RegIPrev($mdb, $inc0103_debug);

//----------------------------------------------------------------------------
// config
//----------------------------------------------------------------------------
$result = $iprev->get_config_data();
switch ($result)
{
case IPREV_GEN00:				// 
// for degub >>>>>
	if ($inc0103_debug)
	{
		print_r("-------------[conf data]-------------\n");
		print_r("[conf all]\n");
		print_r($iprev->m_iprev_conf->m_conf_data);
		print_r("\n");
		print_r("[AUTH-NS]\n");
		print_r($iprev->m_iprev_conf->m_auth_ns);
		print_r("\n");
		print_r("[DNS_NOT_OUTPUT_ADDRESS]\n");
		print_r($iprev->m_iprev_conf->m_hide_list);
		print_r("\n");
		print_r("[SPECIAL_ADD_ZONE_FILE::add zone]\n");
		print_r($iprev->m_iprev_conf->m_add_zone_list);
		print_r("\n");
		print_r("[SPECIAL_ADD_ZONE_FILE::add ns]\n");
		print_r($iprev->m_iprev_conf->m_add_ns_list);
		print_r("\n");
		print_r("[message]\n");
		print_r($iprev->m_conf_msg);
		print_r("\n");
	}
// for degub <<<<<
	$mail_msg_body .= $iprev->m_conf_msg;
	break;

case IPREV_GEN50:				// config ե뤬¸ߤʤ
case IPREV_GEN51:				// DNS_NOT_OUTPUT_ADDRESS 㤤
case IPREV_GEN52:				// special add file 㤤
case IPREV_GEN53:				// special add file ʤ
case IPREV_GEN54:				// special add zoneipʤ
case IPREV_GEN55:				// special add zoneip㤤
case IPREV_GEN56:				// special add dnsipʤ
case IPREV_GEN57:				// special add dnsip㤤
case IPREV_GEN58:				// special add dnsipzoneipˤʤ
case IPREV_GEN59:				// special add nameserver㤤
case IPREV_GEN60:				// special add nameserverʤ
case IPREV_GEN61:				// special add dnsip overlap
case IPREV_GEN62:				// special add zoneip overlap
case IPREV_GEN66:				// AUTH-NS ͤꤵƤʤ
case IPREV_GEN67:				// AUTH-NS եޥåȥ顼
case IPREV_GEN99:				// fatal error
	$err_flg = 1;
	$mail_msg_body .= $iprev->m_conf_msg;
	break;

default:						// 
	$err_flg = 1;
	$mail_msg_body .= $iprev->get_iprev_msg($result);
	break;
}

//----------------------------------------------------------------------------
// ǥ쥯ȥ
//----------------------------------------------------------------------------
if ($err_flg == 0 && $end_flg == 0)
{
	$result = $iprev->init_new_dirctory();
	switch ($result)
	{
	case IPREV_GEN00:		// 
		$mail_msg_body .= $iprev->get_log_msg();
		break;

	case IPREV_GEN20:		// ǥ쥯ȥ
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_log_msg();
		break;

	default:
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_iprev_msg($result);
		break;
	}
}

//----------------------------------------------------------------------------
// zone list 
//----------------------------------------------------------------------------
if ($err_flg == 0)
{
	$result = $iprev->get_zone_list_db();
	switch ($result)
	{
	case IPREV_GEN00:			// 
// for degub >>>>>
		if ($inc0103_debug)
		{
			print_r("\n-------------[zone ip block list]-------------\n");
			print_r($iprev->m_zone_list_db);
			print_r("\n");
		}
// for degub <<<<<
		break;

	case IPREV_GEN03:			// zoneꥹȳ
		$end_flg = 1;
		$mail_msg_body .= $iprev->get_log_msg();
		break;

	case IPREV_GEN02:			// zoneꥹȳԡDB顼
	case IPREV_GEN10:			// conf,DB zoneʣ
	case IPREV_GEN99:			// fatal error
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_log_msg();
		break;

	default:					// 
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_iprev_msg($result);
		break;
	}
}

//----------------------------------------------------------------------------
// ns list 
//----------------------------------------------------------------------------
if ($err_flg == 0 && $end_flg == 0)
{
	$result = $iprev->get_ns_list_db();
	switch ($result)
	{
	case IPREV_GEN00:			// 
// for degub >>>>>
		if ($inc0103_debug)
		{
			print_r("\n-------------[ns ip block list]-------------\n");
			print_r($iprev->m_ns_list_db);
			print_r("\n");
		}
// for degub <<<<<
		break;

	case IPREV_GEN05:			// nsꥹȳ
		$no_ns_flg = 1;
		$mail_msg_body .= $iprev->get_log_msg();
		break;

	case IPREV_GEN04:			// nsꥹȳ
	case IPREV_GEN99:			// fatal error
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_log_msg();
		break;

	default:					// 
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_iprev_msg($result);
		break;
	}
}

//----------------------------------------------------------------------------
// zone list file 
//----------------------------------------------------------------------------
if ($err_flg == 0 && $end_flg == 0)
{
	$result = $iprev->get_zone_list_file();
	switch ($result)
	{
	case IPREV_GEN00:			// 
// for degub >>>>>
		if ($inc0103_debug)
		{
			print_r("\n-------------[zone file list]-------------\n");
			print_r($iprev->m_zone_list_file);
			print_r("\n");
		}
// for degub <<<<<
		break;

	case IPREV_GEN99:			// fatal error
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_log_msg();
		break;

	default:					// 
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_iprev_msg($result);
		break;
	}
}

//----------------------------------------------------------------------------
// ns list file from DB
//----------------------------------------------------------------------------
if ($err_flg == 0 && $end_flg == 0 && $no_ns_flg == 0)
{
	$result = $iprev->get_ns_list_file_db();
	switch ($result)
	{
	case IPREV_GEN00:			// 
		break;

	case IPREV_GEN06:			// nameserverꥹȳԡDB顼
	case IPREV_GEN07:			// nameserverꥹȳ
	case IPREV_GEN08:			// nsꥹȳ
	case IPREV_GEN09:			// оzoneʤ
	case IPREV_GEN99:			// fatal error
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_log_msg();
		break;

	default:
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_iprev_msg($result);
		break;
	}
}

//----------------------------------------------------------------------------
// ns list file from config
//----------------------------------------------------------------------------
if ($err_flg == 0 && $end_flg == 0)
{
	$result = $iprev->get_ns_list_file_conf();
	switch ($result)
	{
	case IPREV_GEN00:			// 
// for degub >>>>>
		if ($inc0103_debug)
		{
			print_r("\n-------------[ns file list]-------------\n");
			print_r($iprev->m_ns_list_file);
			print_r("\n");
		}
// for degub <<<<<
		break;

	case IPREV_GEN07:
// for degub >>>>>
		if ($inc0103_debug)
		{
			if ($no_ns_flg == 0)
			{
				print_r("\n-------------[ns file list]-------------\n");
				print_r($iprev->m_ns_list_file);
				print_r("\n");
			}
			else
			{
				print_r("\n-------------[ns file list equal zero]-------------\n");
				print_r("\n");
			}
		}
// for degub <<<<<
		break;

	case IPREV_GEN09:			// оzoneʤ
	case IPREV_GEN99:			// fatal error
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_log_msg();
		break;

	default:
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_iprev_msg($result);
		break;
	}
}

//----------------------------------------------------------------------------
// ե
//----------------------------------------------------------------------------
if ($err_flg == 0)
{
	$result = $iprev->output_dns_file($end_flg);
	switch ($result)
	{
	case IPREV_GEN00:		// 
		$mail_msg_body .= $iprev->m_out_msg;
		break;

	case IPREV_GEN03:		// zoneꥹȳ
	case IPREV_GEN08:		// nsꥹȳ
		$mail_msg_body .= $iprev->m_out_msg;
		break;

	case IPREV_GEN30:		// conf template file ʤ
	case IPREV_GEN31:		// conf template copy 
	case IPREV_GEN32:		// conf open 
	case IPREV_GEN33:		// conf new dir 
	case IPREV_GEN35:		// zone open 
	case IPREV_GEN36:		// zone new dir 
	case IPREV_GEN38:		// zone new dir ʤ
	case IPREV_GEN39:		// zone file ʤ
	case IPREV_GEN99:		// fatal error
		$err_flg = 1;
		$mail_msg_body .= $iprev->m_out_msg;
		break;

	default:
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_iprev_msg($result);
		break;
	}
}

//----------------------------------------------------------------------------
// ե빹
//----------------------------------------------------------------------------
if ($err_flg == 0)
{
	$result = $iprev->update_dns_file();
	switch ($result)
	{
	case IPREV_GEN00:		// 
		$mail_msg_body .= $iprev->m_update_msg;
		break;

	case IPREV_GEN73:		// CUR[ZONE|CONF]
	case IPREV_GEN74:		// DEL[ZONE|CONF]
	case IPREV_GEN75:		// CUR[ZONE|CONF]delete
	case IPREV_GEN77:		// NEW[ZONE|CONF]copy
	case IPREV_GEN79:		// diff command 
	case IPREV_GEN82:		// NEW[ZONE|CONF] all copy
	case IPREV_GEN99:		// fatal error
		$err_flg = 1;
		$mail_msg_body .= $iprev->m_update_msg;
		break;

	default:
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_iprev_msg($result);
		break;
	}
}

//----------------------------------------------------------------------------
// եž
//----------------------------------------------------------------------------
if ($err_flg == 0)
{
	$result = $iprev->reload_rev_named();
	switch ($result)
	{
	case IPREV_GEN00:		// 
		$mail_msg_body .= $iprev->m_reload_msg;
		break;

	case IPREV_GEN40:		// rsync (db to dns)
	case IPREV_GEN41:		// rsync (dns to dns zone)
	case IPREV_GEN42:		// rsync (dns to dns conf)
	case IPREV_GEN43:		// named reload 
	case IPREV_GEN99:		// fatal error
		$err_flg = 1;
		$mail_msg_body .= $iprev->m_reload_msg;
		break;

	default:
		$err_flg = 1;
		$mail_msg_body .= $iprev->get_iprev_msg($result);
		break;
	}
}

//----------------------------------------------------------------------------
// λ
//----------------------------------------------------------------------------
if(!$err_flg)
{
	$mdb->commit();
	$mail_msg_body .= $iprev->get_iprev_msg(IPREV_GEN00);	// ǽϿ
	//ｪλ᡼
	$cron_log->reg_cron_normal_end($mail_msg_body, __FILE__, __LINE__, 0);
	return;			//ƤӽФ $? ˤ 0 
}
else
{
	$mdb->rollback();
	//顼λ᡼
	$cron_log->reg_cron_err_end($mail_msg_body, __FILE__, __LINE__, 0);
	exit;			//ƤӽФ $? ˤ 1 
}
?>
