<?php
/**
 * $Id: RegBench.php,v 1.5 2004/02/27 06:26:54 yoshi_s Exp $
 */
require_once("RegV6pcLog.php");

/********************************************************************
 * GLOBALѿ
 ********************************************************************/

$_reg_bench_time_item = array(
    "sec"  => (integer)0,
    "fsec" => (float)0,
    "full" => ""
);
$_reg_bench_time = array(
    "start" => $_reg_bench_time_item,
    "end"   => $_reg_bench_time_item,
    "diff"  => $_reg_bench_time_item
);

/********************************************************************
 * ؿ
 ********************************************************************/

/**
 * ؿ̾reg_bench_start
 *   ٥ޡ򳫻Ϥ
 */
function reg_bench_start(){
    global $_reg_bench_time;
    list($fsec, $sec) = explode(" ", microtime());
    $sec = (integer)$sec;
    $fsec = (float)$fsec;
    list($f1, $f2) = explode(".", $fsec);
    $_reg_bench_time["start"]["sec"]  = $sec;
    $_reg_bench_time["start"]["fsec"] = $fsec;
    $_reg_bench_time["start"]["full"] = join(".", array($sec, $f2));
}

/**
 * ؿ̾reg_bench_end
 *   ٥ޡλ
 */
function reg_bench_end(){
    global $_reg_bench_time;
    list($fsec, $sec) = explode(" ", microtime());
    $sec = (integer)$sec;
    $fsec = (float)$fsec;
    list($f1, $f2) = explode(".", $fsec);
    $_reg_bench_time["end"]["sec"]  = $sec;
    $_reg_bench_time["end"]["fsec"] = $fsec;
    $_reg_bench_time["end"]["full"] = join(".", array($sec, $f2));
    $tmp_fsec = $_reg_bench_time["end"]["fsec"] - $_reg_bench_time["start"]["fsec"];
    $tmp_sec = $_reg_bench_time["end"]["sec"] - $_reg_bench_time["start"]["sec"];
    if($tmp_fsec < 0){
        $tmp_sec--;
        $tmp_fsec = (float)1 + $tmp_fsec;
    }
    list($tf1, $tf2) = explode(".", $tmp_fsec);
    $diff_full = join(".", array($tmp_sec, $tf2));
    $diff_sec = $tmp_sec;
    $diff_fsec = $tmp_fsec;
    $_reg_bench_time["diff"]["sec"]  = $diff_sec;
    $_reg_bench_time["diff"]["fsec"] = $diff_fsec;
    $_reg_bench_time["diff"]["full"] = $diff_full;
}

/**
 * ؿ̾reg_bench_log
 *   ٥ޡ̤syslog˽Ϥ
 */
function reg_bench_log(){
    global $_reg_bench_time;
    global $_SERVER;
    $script_name = basename($_SERVER["SCRIPT_NAME"]);
    $remote_addr = $_SERVER["REMOTE_ADDR"];
    $start_message = sprintf("[bench] start=%s script=%s remote=%s",
        $_reg_bench_time["start"]["full"],
        $script_name,
        $remote_addr
    );
    $end_message = sprintf("[bench] end=%s script=%s remote=%s",
        $_reg_bench_time["end"]["full"],
        $script_name,
        $remote_addr
    );
    $diff_message = sprintf("[bench] diff=%s script=%s remote=%s",
        $_reg_bench_time["diff"]["full"],
        $script_name,
        $remote_addr
    );
    RegV6pcLog::debug("[bench] [S]-----------------------------------");
    RegV6pcLog::debug($start_message);
    RegV6pcLog::debug($end_message);
    RegV6pcLog::debug($diff_message);
    RegV6pcLog::debug("[bench] [E]-----------------------------------");
}

/**
 * ؿ̾reg_bench_end_log
 *   ٥ޡλ̤syslog˽Ϥ
 */
function reg_bench_end_log(){
    reg_bench_end();
    reg_bench_log();
}

/********************************************************************
 * ¹
 ********************************************************************/
 
reg_bench_start();
register_shutdown_function("reg_bench_end_log");

?>