<?php
//
//  $Id: RegAppCronLog.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $
//
?>
<?php

//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegV6pcLog.php");				// ϥ饹
require_once("RegAppSendMail.php");			// ᡼饹
require_once("RegAppMailTemplate.php");		// ᡼ƥץ졼ȥ饹

/**
 * ̾  RegAppCronLog
 *   cronѥϥ饹Ϥ cronư齪λޤǤβư᡼Τ롣
 *   ɬ newƻѤ뤳ȡ
 */
class RegAppCronLog
{
	//-----------------------------------------------------------------------
	// fields
	//-----------------------------------------------------------------------
	var $m_out_message;				// λΥ᡼å
	var $m_func_id;					// cronǽID
	var $m_v6pclog_obj;				// ϥ饹

	//-----------------------------------------------------------------------
	// public methods
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppCronLog
	 *   RegAppCronLog饹󥹥ȥ饯
	 *         ᡼åRegAppCronLog롣
	 * @param func_id			string	ǽID		(i)
	 * @desc   ܥ饹λѤϡɬ new ǺƹԤ
	 */
	function RegAppCronLog($func_id)
	{
		$this->m_out_message = "";					// ᡼å
		$this->m_v6pclog_obj = new RegV6pcLog();	// LOG_USERѤ
		$this->m_func_id	 = $func_id;			// ǽID
	}

	/**
	 * ؿ̾reg_cron_start
	 *   cronưΥ(NOTICE)
	 *         ᡼åκμ򳫻Ϥ롣
	 * @param message			string	ʸ				(i)
	 * @param filename			string	븵ե̾		(i)
	 * @param line				string	븵ֹ			(i)
	 * @param out				int		ɸϥץ  Ϥʤ0 Ϥ롧1(default=0)	(i)
	 */
	function reg_cron_start($message, $filename, $line, $out=0)
	{
		$this->m_out_message = "";									// åѿ
		$log_message = $this->m_func_id . "::[reg_cron_start]::" . $message;		// å
		// 
		$this->m_v6pclog_obj->notice($log_message, $filename, $line);
		$this->m_out_message = $log_message . "\n";					// å

		if($out)
		{
			echo $log_message . "\n";		// ɸ
		}
	}

	/**
	 * ؿ̾reg_cron_normal_end
	 *   cronｪλΥ(NOTICE)ư齪λޤǤΥå᡼
	 *         ᡼ϡץ˽
	 * @param message			string	ʸ				(i)
	 * @param filename			string	븵ե̾		(i)
	 * @param line				string	븵ֹ			(i)
	 * @param out				int		ɸϥץ  Ϥʤ0 Ϥ롧1(default=0)	(i)
	 */
	function reg_cron_normal_end($message, $filename, $line, $out=0)
	{
		$log_message = $this->m_func_id . "::[reg_cron_normal_end]::" . $message;	// å
		// 
		$this->m_v6pclog_obj->notice($log_message, $filename, $line);
		$this->m_out_message .= $log_message . "\n";					// å

		if($out)
		{
			echo $log_message . "\n";		// ɸ
		}
		// cron̥᡼
		$result = $this->cron_mail("Success", TRUE);
	}

	/**
	 * ؿ̾reg_cron_err_end
	 *   cron顼λΥ(ERR)ư齪λޤǤΥå᡼
	 * @param message			string	ʸ				(i)
	 * @param filename			string	븵ե̾		(i)
	 * @param line				string	븵ֹ			(i)
	 * @param out				int		ɸϥץ  Ϥʤ0 Ϥ롧1(default=0)	(i)
	 */
	function reg_cron_err_end($message, $filename, $line, $out=0)
	{
		$log_message = $this->m_func_id . "::[reg_cron_err_end]::" . $message;		// å
		// 
		$this->m_v6pclog_obj->err($log_message, $filename, $line);
		$this->m_out_message .= $log_message . "\n";					// å

		if($out)
		{
			echo $log_message . "\n";		// ɸ
		}
		$result = $this->cron_mail("Fail", FALSE);
	}

	/**
	 * ؿ̾reg_cron_err_dbapi
	 *   cronDBAPI顼ȯΥϤ(ERR)
	 * @param message			string	ʸ				(i)
	 * @param filename			string	븵ե̾		(i)
	 * @param line				string	븵ֹ			(i)
	 * @param out				int		ɸϥץ  Ϥʤ0 Ϥ롧1(default=0)	(i)
	 */
	function reg_cron_err_dbapi($message, $filename, $line, $out=0)
	{
		$log_message = $this->m_func_id . "::[reg_cron_err_dbapi]::" . $message;		// å
		// 
		$this->m_v6pclog_obj->err($log_message, $filename, $line);
		$this->m_out_message .= $log_message . "\n";					// å

		if($out)
		{
			echo $log_message . "\n";		// ɸ
		}
	}

	/**
	 * ؿ̾reg_cron_err_app
	 *   cronǽϥ顼ȯΥϤ(ERR)
	 * @param message			string	ʸ				(i)
	 * @param filename			string	븵ե̾		(i)
	 * @param line				string	븵ֹ			(i)
	 * @param out				int		ɸϥץ  Ϥʤ0 Ϥ롧1(default=0)	(i)
	 */
	function reg_cron_err_app($message, $filename, $line, $out=0)
	{
		$log_message = $this->m_func_id . "::[reg_cron_err_app]::" . $message;		// å
		// 
		$this->m_v6pclog_obj->err($log_message, $filename, $line);
		$this->m_out_message .= $log_message . "\n";					// å

		if($out)
		{
			echo $log_message . "\n";		// ɸ
		}
	}

	/**
	 * ؿ̾reg_proc_info
	 *   cronηвᳵץϤ(INFO)
	 * @param message			string	ʸ				(i)
	 * @param filename			string	븵ե̾		(i)
	 * @param line				string	븵ֹ			(i)
	 * @param out				int		ɸϥץ  Ϥʤ0 Ϥ롧1(default=0)	(i)
	 */
	function reg_proc_info($message, $filename, $line, $out=0)
	{
		$log_message = $this->m_func_id . "::[reg_cron_proc_info]::" . $message;		// å
		// 
		$this->m_v6pclog_obj->info($log_message, $filename, $line);
		$this->m_out_message .= $log_message . "\n";					// å
		if($out)
		{
			echo $log_message . "\n";		// ɸ
		}
	}

	/**
	 * ؿ̾reg_proc_debug
	 *   cronηвܺ٥Ϥ(DEBUG)
	 *         ǥХå⡼ɻΤ߼¹Ԥ롣
	 * @param message			string	ʸ				(i)
	 * @param filename			string	븵ե̾		(i)
	 * @param line				string	븵ֹ			(i)
	 * @param out				int		ɸϥץ  Ϥʤ0 Ϥ롧1(default=0)	(i)
	 */
	function reg_proc_debug($message, $filename, $line, $out=0)
	{
		// ǥХå⡼ɻΤ߼¹Ԥ롣
		include("config/RegCnfDebug.php");
		if ($cnf_sys_debug_flg)
		{
			$log_message = $this->m_func_id . "::[reg_cron_proc_debug]::" . $message;	// å
			// 
			$this->m_v6pclog_obj->debug($log_message, $filename, $line);
			$this->m_out_message .= $log_message . "\n";					// å
			if($out)
			{
				echo $log_message . "\n";		// ɸ
			}
		}
	}

	//-----------------------------------------------------------------------
	// private methods
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾cron_mail
	 *   cronν(ư齪λޤ)᡼
	 *         ϻѤå(m_out_message)᡼Ρ
	 *         ｪλˤץå롣
	 * @param  result			string	CronResult MSG					(i)
	 * @param  send_chk_flg		boolean	ݥåե饰			(i)
	 *                                  TRUEå롢FALSEåʤ
	 * @return boolean	TRUEFALSE
	 * @desc   v6pcǤϡcronｪλ $send_chk_flg TRUE(default)
	 *         ˤƸƤӽФ
	 */
	function cron_mail($result, $send_chk_flg=TRUE)
	{
		include("config/RegCnfMail.php");			// ᡼ե

		// ᡼ץǧ
		if ($send_chk_flg)
		{
			// ǽID̤ѿ̾ "cnf_mail_send_ǽID"
			$mail_flg = "cnf_mail_send_" . $this->m_func_id;
			if ($$mail_flg !== 1)
			{
				return;		// ｪλʤΤǥ᡼ʤ
			}
		}

		//----- ᡼ -----//
		// ƥץ졼Ⱦ󥯥饹
		$mail_temp_obj = new RegAppMailTemplate("cron_result");
		// ƥץ졼ȤθͭǡϿ
		$mail_temp_obj->m_cron_result_key["__%Date%__"]
								= $mail_temp_obj->m_template_common_key["__%Date%__"];
		$mail_temp_obj->m_cron_result_key["__%ToAddr%__"]
								= $cnf_cron_result_mailaddress;
		$mail_temp_obj->m_cron_result_key["__%FunctionID%__"]	= $this->m_func_id;
		$mail_temp_obj->m_cron_result_key["__%CronResult%__"]	= $result;
		$mail_temp_obj->m_cron_result_key["__%CronInfo%__"]		= $this->m_out_message;

		//----- ᡼ -----//
		$send_mail_obj = new RegAppSendMail();		// ᡼饹
		if ($send_mail_obj->make_template_mail($mail_temp_obj) !== 1)
		{
			// ᡼
			$g_v6pc_debug_item = __FILE__. "(" .__LINE__ . ")" . " : call make_template_mail error!!";
			include("RegPrintDebugMsg.php");
			return FALSE;
		}
		return $send_mail_obj->send_template_mail();		// 
	}
}
?>
