<?php
/**
 * $Id: RegAppFormCidr.php,v 1.6 2004/02/27 10:04:15 yoshi_s Exp $
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegAppFormUtil.php");			// ե桼ƥƥ饹
require_once("RegAppDateUtil.php");			// մϢ桼ƥƥ饹
require_once("DBAPIWrapper.php");			// DB API IMPLE
require_once("REGClass.php");				// DBѹ¤Υ饹
require_once("DBAPI_CIDR.php");				// DB API CIDRϢ饹
require_once("RegAppApplyDBUtil.php");		// ϢDB桼ƥƥ饹
require_once("RegAppCidrDBUtil.php");		// CIDRϢDB桼ƥƥ
//require_once("RegIpAddressUtil.php");		// IP AddressϢ桼ƥƥ饹
require_once("RegIpv6AddressUtil.php");		// IP AddressϢ桼ƥƥ饹

//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegAppFormCidr
{
	/**
	 * IPɥ쥹֥å饹Υǥե
	 * array(form name => RegAppInputCheck)
	 */
	var $m_conf_default;

	/**
	 * IPɥ쥹֥åϢDB桼ƥƥ
	 */
	var $cidr_util;

	/**
	 * 󥿥åؿ饹
	 * array(form name => RegAppChkSyntax)
	 */
	var $m_chk_funcs;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppFormCidr
	 *   RegAppFormCidr饹󥹥ȥ饯
	 * @param  
	 */
	function RegAppFormCidr()
	{
		//-------------------------------------------------------------------
		// IPNETϢDB桼ƥƥ
		//-------------------------------------------------------------------
		$this->cidr_util	= new RegAppCidrDBUtil();

		//-------------------------------------------------------------------
		// ̾饹
		//-------------------------------------------------------------------
		$this->m_conf_default = array(
			"fn_mem_op_short"		=>	new RegAppDispConf("ȿά", 50),
			"fn_cidr_ip_address"	=>	new RegAppDispConf("IPͥåȥɥ쥹", 43),
			"fn_cidr_init_date"		=>	new RegAppDispConf("Ͽ"),
			"fn_cidr_last_date"		=>	new RegAppDispConf("ǽ"),
		);

		//-------------------------------------------------------------------
		// 󥿥åؿ饹
		//-------------------------------------------------------------------
		$this->m_chk_funcs = array(
			"fn_mem_op_short"		=>	new RegAppChkSyntax("chk_mem_short", null, "D001", "D007", "D008", 1, 1, FALSE),
			"fn_cidr_ip_address"	=>	new RegAppChkSyntax("chk_ipaddress", null, "D047", "D013", "D013", 1, 10, TRUE, "D410"),
			"fn_cidr_init_date"		=>	new RegAppChkSyntax("chk_date_for_db", null, "", "", "", 1, 1, FALSE),
			"fn_cidr_last_date"		=>	new RegAppChkSyntax("chk_date_for_db", null, "", "", "", 1, 1, FALSE, "D401"),
		);
	}

	/**
	 * ؿ̾create_conf_obj
	 *   IPɥ쥹֥åѤRegAppDispConf[] 
	 * @param  create_fn_keys	string[]		key		(i)
	 * @return  RegAppDispConf[]
	 */
	function create_conf_obj($create_fn_keys)
	{
		$ret_conf = array();
		foreach ($this->m_conf_default as $key => $value)
		{
			if (in_array($key, $create_fn_keys))
			{
				$ret_conf[$key] = $value;
			}
		}
		return $ret_conf;
	}

	//-----------------------------------------------------------------------
	// public methods(󥿥å)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_cidr_in_syntax
	 *   POSTǡIPɥ쥹֥å(form input)Υ󥿥åԤ
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹				(i/o)
	 * @param  chk_fn_keys	string[]			󥿥åԤkey		(i)
	 * @param  error_str	string[]			顼ɳǼ			(i/o)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         顼ܤ conf_obj  m_error_flg ΩƤ
	 */
	function chk_cidr_in_syntax(&$conf_obj, $chk_fn_keys, &$error_str)
	{
		$chk_result = TRUE;

		// syntax checkؿƤӽФ
		foreach ($conf_obj as $key => $value)
		{
			if (in_array($key, $chk_fn_keys))
			{
				// input checkƤӽФ
				if (RegAppFormUtil::call_chk_function($conf_obj[$key], $this->m_chk_funcs[$key], $error_str) == FALSE)
				{
					$chk_result = FALSE;
				}
			}
		}

		return $chk_result;
	}

	/**
	 * ؿ̾chk_cidr_hidden_syntax
	 *   POSTǡIPɥ쥹֥å(hidden)Υ󥿥åԤ
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹				(i/o)
	 * @param  chk_fn_keys	string[]			󥿥åԤkey		(i)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   棱ĤǤ⥨顼ˤʤäϸ³Υ󥿥åϹԤʤ
	 */
	function chk_cidr_hidden_syntax(&$conf_obj, $chk_fn_keys)
	{
		// syntax checkؿƤӽФ
		foreach ($conf_obj as $key => $value)
		{
			if (in_array($key, $chk_fn_keys))
			{
				// hidden checkƤӽФ
				if (RegAppFormUtil::call_chk_function($conf_obj[$key], $this->m_chk_funcs[$key], ($err=array()), TRUE) == FALSE)
				{
					return FALSE;
				}
			}
		}

		return TRUE;
	}
}
?>
