<?php
/**
 * $Id: RegAppFormDns.php,v 1.7 2004/03/08 01:29:25 wtetsuya Exp $
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegAppFormUtil.php");			// ե桼ƥƥ饹
require_once("RegAppDateUtil.php");			// մϢ桼ƥƥ饹
require_once("DBAPIWrapper.php");			// DB API IMPLE
require_once("REGClass.php");				// DBѹ¤Υ饹
require_once("DBAPI_DNS.php");				// DB API dnsϢ饹
require_once("RegAppApplyDBUtil.php");		// ϢDB桼ƥƥ饹
require_once("RegAppDnsDBUtil.php");		// DNSϢDB桼ƥƥ

//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegAppFormDns
{
	/**
	 * հDNS饹Υǥե
	 * array(form name => RegAppInputCheck)
	 */
	var $m_conf_default;

	/**
	 * DNSϢDB桼ƥƥ
	 */
	var $dns_util;

	/**
	 * 󥿥åؿ饹
	 * array(form name => RegAppChkSyntax)
	 */
	var $m_chk_funcs;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppFormDns
	 *   RegAppFormDns饹󥹥ȥ饯
	 * @param  
	 */
	function RegAppFormDns()
	{
		//-------------------------------------------------------------------
		// ̾饹
		//-------------------------------------------------------------------
		$this->m_conf_default = array(
			"fn_mem_op_short"	=>	new RegAppDispConf("ȿά", 50),
			"fn_dns_ip_address"	=>	new RegAppDispConf("IPͥåȥɥ쥹", 43),
			"fn_dns_ns"			=>	new RegAppDispConf("͡ॵ̾", 256),
			"fn_dns_init_date"	=>	new RegAppDispConf("Ͽ"),
			"fn_dns_last_date"	=>	new RegAppDispConf("ǽ"),
		);

		//-------------------------------------------------------------------
		// 󥿥åؿ饹
		//-------------------------------------------------------------------
		$this->m_chk_funcs = array(
			"fn_mem_op_short"	=>	new RegAppChkSyntax("chk_mem_short", null, "D001", "D007", "D008", 1, 1, FALSE),

			"fn_dns_ip_address"	=>	new RegAppChkSyntax("chk_ipaddress", null, "D001", "D013", "D013", 1, 1, FALSE),
			"fn_dns_ns"			=>	new RegAppChkSyntax("chk_nameserver", null, "D001", "D036", "D037", 1, 10, TRUE, "D026"),

			"fn_dns_init_date"	=>	new RegAppChkSyntax("chk_date_for_db", null, "", "", "", 1, 1, FALSE),
			"fn_dns_last_date"	=>	new RegAppChkSyntax("chk_date_for_db", null, "", "", "", 1, 1, FALSE, "D401"),
		);

		//-------------------------------------------------------------------
		// DNSϢDB桼ƥƥ
		//-------------------------------------------------------------------
		$this->dns_util	= new RegAppDnsDBUtil();
	}

	/**
	 * ؿ̾create_conf_obj
	 *   հDNSѤRegAppDispConf[] 
	 * @param  create_fn_keys	string[]		key		(i)
	 * @return  RegAppDispConf[]
	 */
	function create_conf_obj($create_fn_keys)
	{
		$ret_conf = array();
		foreach ($this->m_conf_default as $key => $value)
		{
			if (in_array($key, $create_fn_keys))
			{
				$ret_conf[$key] = $value;
			}
		}
		return $ret_conf;
	}

	/**
	 * ؿ̾get_label_info
	 *   եϲ̤ιܲʸ
	 * @param  for_html		boolean		TRUE:htmlspecialcharsѤΥǡ	(i)
	 * @return form name => ʸ Ϣ
	 */
	function get_label_info($for_html=TRUE)
	{
		$label_info = array(
			"fn_dns_ns"	=>	"IPɥ쥹֥åꤹ͡ॵ̾Ⱦѡ",
		);

		// htmlspecialchars
		if ($for_html)
			$label_info = RegAppFormUtil::conv_array_value_html($label_info);

		return $label_info;
	}

	/**
	 * ؿ̾get_form_example
	 *   եϲ̤ι
	 * @param  for_html		boolean		TRUE:htmlspecialcharsѤΥǡ
	 * @return form name => ʸ Ϣ
	 */
	function get_form_example($for_html=TRUE)
	{
		require("config/RegCnfFormInfo.php");		// եե
		$var_example = array(
			"fn_dns_ns"	=>	$cnf_form_example["name_server"],
		);

		// htmlspecialchars
		if ($for_html)
			$var_example = RegAppFormUtil::conv_array_value_html($var_example);

		return $var_example;
	}

	//-----------------------------------------------------------------------
	// public methods(DB)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_dns_list
	 *   DNSꥹȤ
	 * @param  mem_num					ȿֹ				(i)
	 * @param  error_str	string[]	顼ɳǼ	(i/o)
	 * @return int	IPɥ쥹array("43.0.0.0/16", "43.1.0.0/16", "43.2.0.0/16"...)
	 *              ERR_APPOP_DB_ACCESS		DB顼
	 *              ERR_APPOP_DNS_SEARCH	DNSĤʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function get_dns_list($mem_num, &$error_str)
	{
		$sql_str = "SELECT ip_network_number FROM mdb_dnsinfo" .
				   " WHERE member_number = " . $mem_num . " ORDER BY start_sequence_number";
		$db_result = $this->reg_db->dbapi_query($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			array_push($error_str, "D202");		// DNSǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			array_push($error_str, "D205");		// ͡ॵФʤ顼
			return ERR_APPOP_DNS_SEARCH;		// ¸ߤʤ error
		}

		$ret_list = array();
		for ($n = 0; $n < count($db_result); $n++)
		{
			$ret_list[$n] = $db_result[$n]["ip_network_number"];
		}

		return $ret_list;
	}

	/**
	 * ؿ̾get_dns_info
	 *   DNSconf_obj  m_disp_var ˳Ǽ
	 * @param  mem_num							ȿֹ				(i)
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹	(i/o)
	 * @param  error_str	string[]			顼ɳǼ	(i/o)
	 * @return int	1
	 *              ERR_APPOP_DB_ACCESS		DB顼
	 *              ERR_APPOP_DNS_SEARCH	DNSĤʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         IPɥ쥹(conf_obj["fn_dns_ip_address"]->m_disp_var)б
	 *         롣
	 */
	function get_dns_info($mem_num, &$conf_obj, &$error_str)
	{
		$fn_array	= array_keys($conf_obj);				// conf_objΥ
		// ϥɥоݤ鳰
		$fn_array = $this->create_get_dns_fnkeys($fn_array);

		// 륫̾ɲ
		$cols = array();
		for ($fn_cnt = 0; $fn_cnt < count($fn_array); $fn_cnt++)
		{
			array_push($cols, $this->dns_util->fn_col_tbl[$fn_array[$fn_cnt]]);
		}

		// DBDNSʤϾΤߤʤΤǥåʤ
		$reg_db_dns	= new DBAPI_DNS($this->reg_db);
		$dns_tbl	= $reg_db_dns->get_dns_info_ip_and_mem_num(
									$conf_obj["fn_dns_ip_address"]->m_disp_var,
									$mem_num,
									$cols);
		if ($dns_tbl === NULL)					// 0
		{
			array_push($error_str, "D202");		// Ǥʤ顼
			array_push($error_str, "D100");		// Ƥ륨顼
			return ERR_APPOP_DNS_SEARCH;		// ¸ߤʤ error
		}
		if ($dns_tbl === FALSE)					// 
		{
			array_push($error_str, "D202");		// Ǥʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//   conf_obj ˳Ǽ
		for ($fn_cnt = 0; $fn_cnt < count($fn_array); $fn_cnt++)
		{
			$conf_obj[$fn_array[$fn_cnt]]->set_disp_var($dns_tbl[0]->{$this->dns_util->fn_col_tbl[$fn_array[$fn_cnt]]});
		}

		return 1;
	}

	//-----------------------------------------------------------------------
	// public methods(DPN_CONTENT)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾create_get_dns_fnkeys
	 *   RegAppDispConf[] Υ󤫤 GET_DNSINFO ɬפΤʤͤ򥫥åȤ
	 * @param  fn_keys		string[]		RegAppDispConfΥ		(i)
	 * @return string		fn_keys  "fn_mem_op_short" "fn_dns_ip_address" 
	 */
	function create_get_dns_fnkeys($fn_array)
	{
		// ip_addressϳɬפʤ
		$fn_array	= array_filter($fn_array, "delete_not_get_dns_callback");
		$tmp_cnt	= 0;
		$ret_array	= array();
		foreach ($fn_array as $value)
		{
			if ($value != "")
			{
				$ret_array[$tmp_cnt] = $value;
				$tmp_cnt++;
			}
		}
		return $ret_array;
	}

	//-----------------------------------------------------------------------
	// public methods(󥿥å)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_dns_in_syntax
	 *   POSTǡDNS(form input)Υ󥿥åԤ
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹				(i/o)
	 * @param  chk_fn_keys	string[]			󥿥åԤkey		(i)
	 * @param  error_str	string[]			顼ɳǼ			(i/o)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         顼ܤ conf_obj  m_error_flg ΩƤ
	 */
	function chk_dns_in_syntax(&$conf_obj, $chk_fn_keys, &$error_str)
	{
		$chk_result = TRUE;

		// syntax checkؿƤӽФ
		foreach ($conf_obj as $key => $value)
		{
			if (in_array($key, $chk_fn_keys))
			{
				// input checkƤӽФ
				if (RegAppFormUtil::call_chk_function($conf_obj[$key], $this->m_chk_funcs[$key], $error_str) == FALSE)
				{
					$chk_result = FALSE;
				}
			}
		}

		return $chk_result;
	}

	/**
	 * ؿ̾chk_dns_hidden_syntax
	 *   POSTǡDNS(hidden)Υ󥿥åԤ
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹				(i/o)
	 * @param  chk_fn_keys	string[]			󥿥åԤkey		(i)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   棱ĤǤ⥨顼ˤʤäϸ³Υ󥿥åϹԤʤ
	 */
	function chk_dns_hidden_syntax(&$conf_obj, $chk_fn_keys)
	{
		// syntax checkؿƤӽФ
		foreach ($conf_obj as $key => $value)
		{
			if (in_array($key, $chk_fn_keys))
			{
				// hidden checkƤӽФ
				if (RegAppFormUtil::call_chk_function($conf_obj[$key], $this->m_chk_funcs[$key], ($err=array()), TRUE) == FALSE)
				{
					return FALSE;
				}
			}
		}

		return TRUE;
	}

	//-----------------------------------------------------------------------
	// public methods(HTML)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾print_cidrls_table
	 *   հDNS/ѹ/оݤȤʤIPɥ쥹֥åꥹȤɽ
	 * @param  ls_tbl		string[]	IPɥ쥹
	 *                      	      array("43.0.0.0/16", "43.1.0.0/16",...)
	 * @param  col_num		integer		
	 * @desc   <input type="radio" name="fn_dns_ip_address" value="IPɥ쥹">IPɥ쥹
	 *         򣱤ĤΥꤷơ֥ɽ롣
	 */
	function print_cidrls_table($ls_tbl, $col_num=3)
	{
		// ǤƤɬ array ˤʤäƤϤ
		if (!is_array($ls_tbl))
		{
			return;
		}

		include("RegAppTableStyle.php");

		if ($col_num < 1)
			$col_num = 3;		// ۾ʹݤ

		$item_num	= count($ls_tbl);				// 
		$line_num	= (int)($item_num / $col_num);	// ɽԿ򻻽
		$td_width	= (int)(100 / $col_num);		// 
		$line_n		= 0;							// ɽԥ
		$checkedstr = " checked";

		print ("<table border=\"0\" class=\"" . $table_style . "\">\n");

		// ɽԤİʾ夢
		if ($line_num > 0)
		{
			// Ԥ
			for ($line_n = 0; $line_n < $line_num; $line_n++)
			{
				print ("<tr>\n");
				for ($col_n = 0; $col_n < $col_num; $col_n++)	// $col_num ʬɽ
				{
					$dips_var = htmlspecialchars($ls_tbl[($line_n * $col_num) + $col_n], ENT_QUOTES);
					print ("<td class=\"tdlistitem\" width=\"" . $td_width . "%\">\n");
					print ("&nbsp;&nbsp;<input type=\"radio\" name=\"fn_dns_ip_address\" value=\"" . 
						   $dips_var . "\"" . $checkedstr . "><b>" . $dips_var . "</b>\n");
					print ("</td>\n");
					$checkedstr = "";
				}
				print ("</tr>\n");
			}
		}

		// Ĥɽ(;꤬)
		if (($ls_tbl % $col_num) > 0)
		{
			print ("<tr>\n");
			// ǸΣԤ
			for ($col_n = 0; $col_n < $col_num; $col_n++)
			{
				$disp_cnt = ($line_n * $col_num) + $col_n;		// ɽƥΥǥå
				if ($disp_cnt < $item_num)						// ޤƥब¸ߤ
				{
					$dips_var = htmlspecialchars($ls_tbl[$disp_cnt], ENT_QUOTES);
					print ("<td class=\"tdlistitem\" width=\"" . $td_width . "%\">\n");
					print ("&nbsp;&nbsp;<input type=\"radio\" name=\"fn_dns_ip_address\" value=\"" . 
						   $dips_var . "\"" . $checkedstr . "><b>" . $dips_var . "</b>\n");
					print ("</td>\n");
					$checkedstr = "";
				}
				else
				{
					// ƥϤʤΤǶ
					print ("<td class=\"tdlistitem\" width=\"" . $td_width . "%\">&nbsp;</td>\n");
				}
			}
			print ("</tr>\n");
		}

		print ("</table>\n");
	}
}

/**
 * ؿ̾delete_not_get_dns_callback
 *   RegAppDispConf[] Υ GET_DNSINFO ɬפΤʤͤ򥫥åȤ
 * @param  value				(i)
 * @return TRUE"fn_mem_op_short" "fn_dns_ip_address" ʳFALSE"fn_mem_op_short" "fn_dns_ip_address"
 */
function delete_not_get_dns_callback($value)
{
	switch ($value)
	{
	case "fn_mem_op_short":
	case "fn_dns_ip_address":
		return FALSE;
	default:
		break;
	}
	return TRUE;
}
?>
