<?php
/**
 * $Id: RegAppFormMember.php,v 1.6 2004/03/02 07:05:34 wtetsuya Exp $
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegAppFormUtil.php");			// ե桼ƥƥ饹
require_once("RegAppDateUtil.php");			// մϢ桼ƥƥ饹
require_once("RegAppApplyDBUtil.php");		// ϢDB桼ƥƥ饹
require_once("RegAppMemDBUtil.php");		// memberϢDB桼ƥƥ
require_once("DBAPIWrapper.php");			// DB API IMPLE
require_once("REGClass.php");				// DBѹ¤Υ饹

//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegAppFormMember
{
	/**
	 * ȿ̾饹Υǥե
	 * array(form name => RegAppInputCheck)
	 */
	var $m_conf_default;

	/**
	 * memberϢDB桼ƥƥ
	 */
	var $mem_util;

	/**
	 * 󥿥åؿ饹
	 * array(form name => RegAppChkSyntax)
	 */
	var $m_chk_funcs;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppFormMember
	 *   RegAppFormMember饹󥹥ȥ饯
	 * @param  
	 */
	function RegAppFormMember()
	{
		//-------------------------------------------------------------------
		// MEMBERϢDB桼ƥƥ
		//-------------------------------------------------------------------
		$this->mem_util		= new RegAppMemDBUtil();

		//-------------------------------------------------------------------
		// ̾饹
		//-------------------------------------------------------------------
		$this->m_conf_default = array(
			"fn_mem_op_short"	=>	new RegAppDispConf("ȿά", 50),
			"fn_mem_op_orgjp"	=>	new RegAppDispConf("ȿ̾", 256),
			"fn_mem_op_orgen"	=>	new RegAppDispConf("Organization", 256),
			"fn_mem_op_postal"	=>	new RegAppDispConf("͹ֹ", 10),
			"fn_mem_op_addjp"	=>	new RegAppDispConf("", 256),
			"fn_mem_op_adden"	=>	new RegAppDispConf("Address", 256),
			"fn_mem_op_tel"		=>	new RegAppDispConf("ֹ", 50),
			"fn_mem_op_fax"		=>	new RegAppDispConf("FAXֹ", 50),
			"fn_mem_op_mail"	=>	new RegAppDispConf("Żҥ᡼", 256),

			"fn_mem_in_person"	=>	new RegAppDispConf("ô̾", 50),
			"fn_mem_in_mail"	=>	new RegAppDispConf("Żҥ᡼", 256),
			"fn_mem_in_postal"	=>	new RegAppDispConf("͹ֹ", 10),
			"fn_mem_in_addjp"	=>	new RegAppDispConf("", 256),
			"fn_mem_in_adden"	=>	new RegAppDispConf("Address", 256),
			"fn_mem_in_tel"		=>	new RegAppDispConf("ֹ", 50),
			"fn_mem_in_fax"		=>	new RegAppDispConf("FAXֹ", 50),
			"fn_mem_in_notice"	=>	new RegAppDispConf("Υɥ쥹", 256),		// array

			"fn_mem_num"		=>	new RegAppDispConf("ȿֹ"),

			"fn_mem_last_date"	=>	new RegAppDispConf("ǽ"),
			"fn_mem_stt"		=>	new RegAppDispConf("ơ")
		);

		//-------------------------------------------------------------------
		// 󥿥åؿ饹
		//-------------------------------------------------------------------
		$this->m_chk_funcs = array(
			"fn_mem_op_short"	=>	new RegAppChkSyntax("chk_mem_short", null, "D001", "D007", "D008", 1, 1, FALSE),
			"fn_mem_op_orgjp"	=>	new RegAppChkSyntax("chk_org_jp", null, "D001", "D009", "D010", 1, 1, FALSE),
			"fn_mem_op_orgen"	=>	new RegAppChkSyntax("chk_hankaku_length", array(1,256), "D001", "D009", "D011", 1, 1, FALSE),
			"fn_mem_op_postal"	=>	new RegAppChkSyntax("chk_postalcode", null, "D001", "D017", "D050", 1, 1, FALSE),
			"fn_mem_op_addjp"	=>	new RegAppChkSyntax("chk_address_jp", null, "D001", "D009", "D019", 1, 1, FALSE),
			"fn_mem_op_adden"	=>	new RegAppChkSyntax("chk_address_en", null, "D001", "D009", "D051", 1, 1, FALSE),
			"fn_mem_op_tel"		=>	new RegAppChkSyntax("chk_telnumber", null, "D001", "D020", "D021", 1, 1, FALSE),
			"fn_mem_op_fax"		=>	new RegAppChkSyntax("chk_faxnumber", null, "D001", "D020", "D021", 0, 1, FALSE),
			"fn_mem_op_mail"	=>	new RegAppChkSyntax("chk_mailaddress", null, "D001", "D022", "D049", 1, 1, FALSE),

			"fn_mem_in_person"	=>	new RegAppChkSyntax("chk_person_name", null, "D001", "D023", "D010", 1, 1, FALSE),
			"fn_mem_in_mail"	=>	new RegAppChkSyntax("chk_mailaddress", null, "D001", "D022", "D049", 1, 1, FALSE),
			"fn_mem_in_postal"	=>	new RegAppChkSyntax("chk_postalcode", null, "D001", "D017", "D050", 1, 1, FALSE),
			"fn_mem_in_addjp"	=>	new RegAppChkSyntax("chk_address_jp", null, "D001", "D009", "D019", 1, 1, FALSE),
			"fn_mem_in_adden"	=>	new RegAppChkSyntax("chk_address_en", null, "D001", "D009", "D051", 1, 1, FALSE),
			"fn_mem_in_tel"		=>	new RegAppChkSyntax("chk_telnumber", null, "D001", "D020", "D021", 1, 1, FALSE),
			"fn_mem_in_fax"		=>	new RegAppChkSyntax("chk_faxnumber", null, "D001", "D020", "D021", 0, 1, FALSE),
			"fn_mem_in_notice"	=>	new RegAppChkSyntax("chk_mailaddress", null, "D001", "D022", "D049", 1, 5, TRUE, "D026"),

			"fn_mem_extra_if"	=>	new RegAppChkSyntax("chk_filename", null, "", "D028", "D029", 0, 3, TRUE, array("D030", "D031", "D055")),
			"fn_cidr_extra_if"	=>	new RegAppChkSyntax("chk_filename", null, "", "D028", "D029", 0, 3, TRUE, array("D030", "D031", "D055")),

			"fn_mem_num"		=>	new RegAppChkSyntax("", null, "D001", "", "D010", 1, 1, FALSE),
			"fn_mem_last_date"	=>	new RegAppChkSyntax("chk_date_for_db", null, "", "", "", 1, 1, FALSE, "D401"),
		);
	}

	/**
	 * ؿ̾create_conf_obj
	 *   ȿѤRegAppDispConf[] 
	 * @param  create_fn_keys	string[]		key		(i)
	 * @return  RegAppDispConf[]
	 */
	function create_conf_obj($create_fn_keys)
	{
		$ret_conf = array();
		foreach ($this->m_conf_default as $key => $value)
		{
			if (in_array($key, $create_fn_keys))
			{
				$ret_conf[$key] = $value;
			}
		}
		return $ret_conf;
	}

	/**
	 * ؿ̾get_form_example
	 *   եϲ̤ι
	 * @param  for_html		boolean		TRUE:htmlspecialcharsѤΥǡ
	 * @return form name => ʸ Ϣ
	 */
	function get_form_example($for_html=TRUE)
	{
		require("config/RegCnfFormInfo.php");		// եե
		$var_example = array(
			"fn_mem_op_short"	=>	$cnf_form_example["member_short_name"],
			"fn_mem_op_orgjp"	=>	$cnf_form_example["organization_jp"],
			"fn_mem_op_orgen"	=>	$cnf_form_example["organization_en"],
			"fn_mem_op_postal"	=>	$cnf_form_example["postal_code_number"],
			"fn_mem_op_addjp"	=>	$cnf_form_example["address_jp"],
			"fn_mem_op_adden"	=>	$cnf_form_example["address_en"],
			"fn_mem_op_tel"		=>	$cnf_form_example["tel_number"],
			"fn_mem_op_fax"		=>	$cnf_form_example["fax_number"],
			"fn_mem_op_mail"	=>	$cnf_form_example["mail_address"],

			"fn_mem_in_person"	=>	$cnf_form_example["person_name"],
			"fn_mem_in_mail"	=>	$cnf_form_example["mail_address"],
			"fn_mem_in_postal"	=>	$cnf_form_example["postal_code_number"],
			"fn_mem_in_addjp"	=>	$cnf_form_example["address_jp"],
			"fn_mem_in_adden"	=>	$cnf_form_example["address_en"],
			"fn_mem_in_tel"		=>	$cnf_form_example["tel_number"],
			"fn_mem_in_fax"		=>	$cnf_form_example["fax_number"],
			"fn_mem_in_notice"	=>	$cnf_form_example["mail_address"],

			"fn_mem_num"		=>	""
		);

		// htmlspecialchars
		if ($for_html)
			$var_example = RegAppFormUtil::conv_array_value_html($var_example);

		return $var_example;
	}

	//-----------------------------------------------------------------------
	// public methods(󥿥å)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_mem_in_syntax
	 *   POSTǡȿ(form input)Υ󥿥åԤ
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹				(i/o)
	 * @param  chk_fn_keys	string[]			󥿥åԤkey		(i)
	 * @param  error_str	string[]			顼ɳǼ			(i/o)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         顼ܤ conf_obj  m_error_flg ΩƤ
	 */
	function chk_mem_in_syntax(&$conf_obj, $chk_fn_keys, &$error_str)
	{
		$chk_result = TRUE;

		// syntax checkؿƤӽФ
		foreach ($conf_obj as $key => $value)
		{
			if (in_array($key, $chk_fn_keys))
			{
				// input checkƤӽФ
				if (RegAppFormUtil::call_chk_function($conf_obj[$key], $this->m_chk_funcs[$key], $error_str) == FALSE)
				{
					$chk_result = FALSE;
				}
			}
		}

		// member_number 㳰
		if (in_array("fn_mem_num", $chk_fn_keys) &&
				ereg("^[0-9]+$", $conf_obj["fn_mem_num"]->m_disp_var) == FALSE)
		{
			RegAppFormUtil::set_err_data($conf_obj["fn_mem_num"],
										 $error_str,
										 $this->m_chk_funcs["fn_mem_num"]->m_err_pattern);
			$chk_result = FALSE;
		}
		return $chk_result;
	}

	/**
	 * ؿ̾chk_mem_hidden_syntax
	 *   POSTǡȿ(hidden)Υ󥿥åԤ
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹				(i/o)
	 * @param  chk_fn_keys	string[]			󥿥åԤkey		(i)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   棱ĤǤ⥨顼ˤʤäϸ³Υ󥿥åϹԤʤ
	 */
	function chk_mem_hidden_syntax(&$conf_obj, $chk_fn_keys)
	{
		// syntax checkؿƤӽФ
		foreach ($conf_obj as $key => $value)
		{
			if (in_array($key, $chk_fn_keys))
			{
				// hidden checkƤӽФ
				if (RegAppFormUtil::call_chk_function($conf_obj[$key], $this->m_chk_funcs[$key], ($err=array()), TRUE) == FALSE)
				{
					return FALSE;
				}
			}
		}

		// member_number 㳰
		if (in_array("fn_mem_num", $chk_fn_keys) &&
			ereg("^[0-9]+$", $conf_obj["fn_mem_num"]->m_disp_var) == FALSE)
		{
			return FALSE;					// ȿֹ
		}
		return TRUE;
	}

	/**
	 * ؿ̾chk_extra_syntax
	 *   POSTǡ­Υ󥿥å(ե̾ե륵å)Ԥ
	 * @param  extra_if		RegAppExtraConf[]	źեե󥯥饹		(i/o)
	 * @param  error_str	string[]			顼ɳǼ			(i/o)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         顼ܤ extra_if  m_error_flg ΩƤ
	 */
	function chk_extra_syntax(&$extra_if, &$error_str)
	{
		$chk_result = TRUE;

		// syntax checkؿƤӽФ
		foreach ($extra_if as $key => $value)
		{
			// extra checkƤӽФ(顼˥٥̾)
			if (RegAppFormUtil::chk_extra_syntax($extra_if[$key], $this->m_chk_funcs[$key], $error_str, FALSE) == FALSE)
			{
				$chk_result = FALSE;
			}
		}

		return $chk_result;
	}

	//-----------------------------------------------------------------------
	// public methods(DPN_CONTENT)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_conf_content_delimiter
	 *   DPN_CONTENT contents Ͽݤζڤʸ
	 * @param  apply_kind_id	string	
	 * @return m_conf_default Υ̾ȶڤʸϢ
	 */
	function get_conf_content_delimiter($apply_kind_id)
	{
		switch($apply_kind_id)
		{
		case "ops0101":
			$conf_deli	= array(
							"fn_alloc_cidr"		=>	"----- 꿶֥å -----",
							"fn_mem_op_short"	=>	"-------- Ѿ --------",
							"fn_mem_in_person"	=>	"-------- Ծ --------",);
			break;
		case "ops0212":
			$conf_deli	= array(
							"fn_mem_op_short"	=>	"-------- Ѿ --------",
							"fn_mem_in_person"	=>	"-------- Ծ --------",);
			break;
		case "opr0102":
			$conf_deli	= array(
							"fn_alloc_cidr"		=>	"----- 꿶֥å -----",
							"fn_mem_op_short"	=>	"-------- Ѿ --------",
							"fn_mem_in_person"	=>	"-------- Ծ --------",);
			break;
		default:
			$conf_deli = "";
			break;
		}

		return $conf_deli;
	}

	/**
	 * ؿ̾get_extra_content_delimiter
	 *   DPN_CONTENT contents Ͽݤζڤʸ
	 * @param  apply_kind_id	string	
	 * @return extra_if ̾ȶڤʸϢ
	 */
	function get_extra_content_delimiter($apply_kind_id)
	{
		switch($apply_kind_id)
		{
		case "ops0101":
			$extra_deli	= array(
						"fn_cidr_extra_if"	=>	"----- 꿶꿳 -----",);
			break;
		case "opr0102":
			$extra_deli	= array(
						"fn_mem_extra_if"	=>	"----- 꿶꿳 -----",);
			break;
		default:
			$extra_deli = "";
			break;
		}
		return $extra_deli;
	}

	/**
	 * ؿ̾create_get_mem_fnkeys
	 *   RegAppDispConf[] Υ󤫤 GET_MEMINFO ɬפΤʤͤ򥫥åȤ
	 * @param  fn_keys		string[]		RegAppDispConfΥ		(i)
	 * @return string		fn_keys  "fn_mem_op_short" 
	 */
	function create_get_mem_fnkeys($fn_array)
	{
		// ȿάΤϳɬפʤ
		$fn_array	= array_filter($fn_array, "delete_not_get_mem_callback");
		$tmp_cnt	= 0;
		$ret_array	= array();
		foreach ($fn_array as $value)
		{
			if ($value != "")
			{
				$ret_array[$tmp_cnt] = $value;
				$tmp_cnt++;
			}
		}
		return $ret_array;
	}
}

/**
 * ؿ̾delete_not_get_mem_callback
 *   RegAppDispConf[] Υ GET_MEMINFO ɬפΤʤͤ򥫥åȤ
 * @param  value				(i)
 * @return TRUE"fn_mem_op_short"ʳFALSE"fn_mem_op_short"
 */
function delete_not_get_mem_callback($value)
{
	switch ($value)
	{
	case "fn_mem_op_short":
		return FALSE;
	default:
		break;
	}
	return TRUE;
}
?>
