<?php
/**
 * $Id: RegAppFormOps0202.php,v 1.3 2004/02/12 12:40:07 wtetsuya Exp $
 * հDNS꿽(ops0202)Υ桼ƥƥ饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegAppFormDns.php");			// DNSϢ̾󥯥饹
require_once("DBAPI_OPS0202.php");			// SDB_FORM_OPS0202 DBAPI
require_once("DBAPI_DPN.php");				// DPN_CONTENT DBAPI
?>
<?php
//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegAppFormOps0202 extends RegAppFormDns
{
	/**
	 * DBAPI_IMPLE
	 */
	var $reg_db;

	/**
	 * applyϢDB桼ƥƥ
	 */
	var $apply_util;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppFormOps0202
	 *   RegAppFormOps0202饹󥹥ȥ饯
	 * @param  $db		DBAPI_IMPLE
	 */
	function RegAppFormOps0202($db)
	{
		parent::RegAppFormDns();
		$this->reg_db		= $db;
		$this->apply_util	= new RegAppApplyDBUtil();
	}

	//-----------------------------------------------------------------------
	// public methods(DB)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_cidr_no_dns_list
	 *   ͡ॵФϿƤʤCIDR_BLOCKꥹȤ
	 * @param  mem_num					ȿֹ				(i)
	 * @param  error_str	string[]	顼ɳǼ	(i/o)
	 * @return int	IPɥ쥹array("43.0.0.0/16", "43.1.0.0/16", "43.2.0.0/16"...)
	 *              ERR_APPOP_DB_ACCESS		DB顼
	 *              ERR_APPOP_CIDR_SEARCH	륢ɥ쥹֥å¸ߤʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function get_cidr_no_dns_list($mem_num, &$error_str)
	{
		$sql_str = "SELECT ip_network_number FROM cidr_block" .
				   " WHERE member_number = " . $mem_num .
				   " AND ip_network_number NOT IN" .
				   "(SELECT ip_network_number FROM mdb_dnsinfo WHERE member_number = " . $mem_num . ")" .
				   " ORDER BY start_sequence_number";
		$db_result = $this->reg_db->dbapi_query($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			array_push($error_str, "D200");		// ɥ쥹֥åǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			array_push($error_str, "D405");		// Ͽĥ֥åʤ顼
			return ERR_APPOP_CIDR_SEARCH;		// ¸ߤʤ error
		}

		$ret_list = array();
		for ($n = 0; $n < count($db_result); $n++)
		{
			$ret_list[$n] = $db_result[$n]["ip_network_number"];
		}

		return $ret_list;
	}

	/**
	 * ؿ̾chk_cidr_no_dns
	 *   ͡ॵФϿƤʤCIDR_BLOCKݤȽꤹ
	 * @param  mem_num					ȿֹ									(i)
	 * @param  ip_address	string		åIPɥ쥹(xxx.xxx.xxx.xxx/xx)	(i)
	 * @return 1͡ॵФϿƤʤCIDR_BLOCK
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_CIDR_SEARCH	CIDR¸ߤʤ
	 */
	function chk_cidr_no_dns($mem_num, $ip_address)
	{
		$sql_str  = "SELECT COUNT(*) FROM cidr_block WHERE" .
					" member_number = " . $mem_num .
					" AND ip_network_number = " . GetApsString($ip_address) . 
					" AND ip_network_number NOT IN(SELECT ip_network_number FROM mdb_dnsinfo WHERE member_number = " .
					$mem_num . ")";
		$db_result = $this->reg_db->dbapi_query_count($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result != 1)								// 1Ǥʤ
		{
			return ERR_APPOP_CIDR_SEARCH;
		}

		return 1;
	}

	/**
	 * ؿ̾send_app_ops0202
	 *   հDNS꿽 Ф
	 *         SDB_APPLY_INFO,SDB_FORM_OPS0202,DPN_CONTENT,MDB_DNSINFO,MDB_DNS_UPDATE_HISTORY롣
	 * @param  mem_num							ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹Ϣ		(i)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return ϿRegAppCreateAppAcc
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_MEM_SEARCH		ȿĤʤ
	 *         ERR_APPOP_CIDR_SEARCH	륢ɥ쥹֥å¸ߤʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function send_app_ops0202($mem_num, &$conf_obj, &$error_str)
	{
		$reg_db_ops0202	= new DBAPI_OPS0202($this->reg_db);		// DBAPI_OPS0202 object
		$reg_db_dpn		= new DBAPI_DPN($this->reg_db);			// DBAPI_DPN object
		$reg_db_dns		= new DBAPI_DNS($this->reg_db);			// DBAPI_DNS object

		//-------------------------------------------------------------------
		// SDB_FORM_OPS0202 Ͽǡ
		//-------------------------------------------------------------------
		$ops_0202tbl = new SDB_FORM_OPS0202(
				"",
				$conf_obj["fn_dns_ip_address"]->m_disp_var,
				$conf_obj["fn_dns_ns"]->m_disp_var
		);

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽǡ
		//-------------------------------------------------------------------
		// SDB_FORM_OPS0202Ͽ륭
		$conf_dpn_keys = array(
			"fn_dns_ip_address",
			"fn_dns_ns",
		);
		// dpn_content ʸǡ(for create_dpn_data_accept_discuss)
		$content_conf_obj = new RegAppDispConfData($conf_dpn_keys, $conf_obj);

		// Ͽֺ
		$app_date = RegAppDateUtil::make_current_date_db();

		//-------------------------------------------------------------------
		// MDB_DNSINFO Ͽǡ
		//-------------------------------------------------------------------
		// ѹ¤κ
		$mdb_dns_tbl = new MDB_DNSINFO(
				$conf_obj["fn_dns_ip_address"]->m_disp_var,
				$mem_num,
				$conf_obj["fn_dns_ns"]->m_disp_var,
				$app_date,
				$app_date,
				""
			);

		//-------------------------------------------------------------------
		// DBȥ󥶥󳫻ϡå
		//-------------------------------------------------------------------
		// ȥ󥶥󳫻
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//----- åơå᡼륢ɥ쥹 -----//
		$sql_str  = "SELECT applicant_mail_address FROM mdb_meminfo WHERE" .
					" member_number = " . $mem_num . " AND" .
					" status = 'normal'" . 
					" FOR UPDATE";
		$db_result = $this->reg_db->dbapi_query_lock($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			return ERR_APPOP_MEM_SEARCH;
		}
		// ᡼륢ɥ쥹Ͽ
		$mem_in_mail = $db_result[0]["applicant_mail_address"];

		//-------------------------------------------------------------------
		// Ͽ֥åȽ
		//-------------------------------------------------------------------
		$chk_result = $this->chk_cidr_no_dns($mem_num, $conf_obj["fn_dns_ip_address"]->m_disp_var);
		switch ($chk_result)
		{
		case ERR_APPOP_DB_ACCESS:					// DB顼
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			return $chk_result;
		case ERR_APPOP_CIDR_SEARCH:
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D407");					// ֵorꤵƤ륨顼
			return $chk_result;
		case 1:
		default:
			break;
		}

		//-------------------------------------------------------------------
		// SDB_APPLY_INFO, SDB_FORM_OPS0202 Ͽ
		//-------------------------------------------------------------------
		// SDB_APPLY_INFO Ͽǡ
		$sdb_appinfo_tbl = new SDB_APPLY_INFO(
							"", $app_date, "", "", $mem_num, "", "",
							$mem_in_mail, $app_date, "", "", $app_date);

		$apply_no = $reg_db_ops0202->create_apply_form_ops0202(
												$sdb_appinfo_tbl,
												$ops_0202tbl);
		if ($apply_no === FALSE || $apply_no == 0)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽ
		//-------------------------------------------------------------------
		$dpn_content_tbl = $this->apply_util->create_dpn_data_accept_auto(
										$apply_no,
										"MEM",
										$mem_in_mail,
										$app_date,
										"ops0202",
										$content_conf_obj);
		$result = $reg_db_dpn->dpn_create_content($dpn_content_tbl);
		if ($result === FALSE || $result == 0)
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// MDB_DNSINFO/MDB_DNS_UPDATE_HISTORY 
		//-------------------------------------------------------------------
		$mdb_update_tbl = new MDB_UPDATE_INFO(
							$mem_in_mail,
							$app_date,
							sprintf("RCV-%08d", $apply_no),
							"ops0202");

		$result = $reg_db_dns->create_dns_info(
											$mdb_dns_tbl, $mdb_update_tbl);
		if ($result === FALSE || $result == "0")
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// ߥå
		//-------------------------------------------------------------------
		$this->reg_db->REGDB_commit();
		return (new RegAppCreateAppAcc($apply_no, $dpn_content_tbl->contents, $dpn_content_tbl->subject));
	}

	/**
	 * ؿ̾get_app_ops0202
	 *   հDNS꿽 
	 * @param  appif_obj	RegAppDispConf[]	Ϣ				(i/o)
	 * @param  appfm_obj	RegAppDispConf[]	̾󥯥饹Ϣ			(i/o)
	 * @param  allow_stt	string[]			Ĥ륹ơ	(i)
	 * @param  mem_num							ȿֹ						(i)
	 * @return 1
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_SEARCH			񤬸Ĥʤ
	 *         ERR_APPOP_STATUS			Ĥ륹ơˤʤäƤʤ
	 * @desc   ˤϿ­ appfm_objextra_if˥åȤ롣
	 *         Υ֥Ȥؿ뤿ᡢͽɬפϤʤ
	 *         ޤ$appif_obj["fn_app_last_date"]˺ǽǼ롣
	 *         ȿֹ椬ꤵ줿硢sdb_apply_info:member_number򸡺
	 *         ղä롣
	 */
	function get_app_ops0202(&$appif_obj, &$appfm_obj, $allow_stt, $mem_num="")
	{
		//-------------------------------------------------------------------
		// Ͽǡ
		//-------------------------------------------------------------------
		//----- SDB_FORM_OPS0202 ξ -----//
		// SELECTʳ
		$fn_ops0202_array = array(
				"fn_dns_ip_address",
		);

		$ops0202_sql = $this->apply_util->create_apply_select_str(
													$appif_obj,
													$fn_ops0202_array,
													$this->dns_util->fn_col_tbl,
													$mem_num,
													TRUE);

		//----- SDB_FORM_NAME_SERVER ξ -----//
		$ns_sql		 = "SELECT name_server FROM sdb_form_name_server" .
					   " WHERE accept_id = " . $appif_obj["fn_app_acceptid"]->m_disp_var .
					   " ORDER BY order_no";

		//-------------------------------------------------------------------
		// SDB_FORM_OPS0202 ξ
		//-------------------------------------------------------------------
		$ops0202_result = $this->reg_db->dbapi_query($ops0202_sql);
		if ($ops0202_result === FALSE)			// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}
		if ($ops0202_result === NULL)			// 
		{
			return ERR_APPOP_SEARCH;			// ¸ߤʤ error
		}

		//-------------------------------------------------------------------
		// SDB_FORM_NAME_SERVER ξ
		//-------------------------------------------------------------------
		$ns_result = $this->reg_db->dbapi_query($ns_sql);
		if ($ns_result === FALSE)				// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}

		//--------------------------------------------------------------------
		// Ǽ
		//--------------------------------------------------------------------
		// ǽơݤå
		if (in_array($ops0202_result[0]["status"], $allow_stt) == FALSE)
		{
			return ERR_APPOP_STATUS;
		}

		//----- ǼѲ̾Ϣκ -----//
		$conf_array	= array(
				"fn_mem_op_short",
				"fn_dns_ip_address",
				"fn_dns_ns",
		);
		$appfm_obj = parent::create_conf_obj($conf_array);

		//----- SDB_FORM_OPS0202 Ǽ -----//
		foreach ($fn_ops0202_array as $fn)
		{
			$appfm_obj[$fn]->set_disp_var($ops0202_result[0][$this->dns_util->fn_col_tbl[$fn]]);
		}
		$appfm_obj["fn_mem_op_short"]->set_disp_var($ops0202_result[0]["member_short_name"]);
		$appif_obj["fn_app_last_date"]->set_disp_var($ops0202_result[0]["final_reply"]);

		//----- SDB_FORM_NAME_SERVER Ǽ -----//
		if ($ns_result === NULL)
		{
			$appfm_obj["fn_dns_ns"]->set_disp_var("");
		}
		else
		{
			$appfm_obj["fn_dns_ns"]->m_disp_var = array();
			foreach ($ns_result as $value)
			{
				if ($value["name_server"] != "")
					array_push($appfm_obj["fn_dns_ns"]->m_disp_var, $value["name_server"]);
			}
		}

		return 1;
	}
}
?>
