<?php
/**
 * $Id: RegAppReportData.php,v 1.4 2004/02/21 09:50:05 yoshi_s Exp $
 * APNICѥ᡼եޥåȺ饹
 */
?>
<?php
//
// ex) APNICѥ᡼եޥåȤϤ
// $obj = new RegAppReportData($report_info);
// print $obj->create_body();
//
// ex) ǤդιܤꤷΥ᡼եޥåȤϤ
// $obj = new RegAppReportData();
// $obj->add_item("inet6num:", "4::/64");
// $obj->add_item("netname:",  "V6PC-NET");
// $obj->add_item("admin-c:",  array("taro@v6nic.net", "jiro@v6nic.net"));
// print $obj->output();
//

//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegAppReportData{

	var $item_info;
	var $item_idx;
	var $report_info;
	var $notice_message;

	/**
	 * ؿ̾RegAppReportData
	 *   󥹥ȥ饯
	 * @param  REPORT_INFO	$report_info	ѥǡ¤
	 */
	function RegAppReportData($report_info=""){
		$this->report_info = $report_info;
		$this->item_info = array();
		$this->notice_message = array(
			"mnt-by"	=> "### APNIC maintainer objectƤ ###",
			"password"	=> "### APNIC maintainer objectϿʿʸѥɤƤ ###",
			"changed"	=> "### ѹƤ ###"
		);
	}
	
	/**
	 * ؿ̾create_body
	 *   APNICѥեޥåȤ
	 * @return	APNICBodyǡʸ
	 */
	function create_body(){
		$this->init_item();
		$this->add_item(new RegAppReportItem("inet6num",  $this->report_info->inet6num,  1));
		$this->add_item(new RegAppReportItem("netname",   $this->report_info->netname,   1));
		$this->add_item(new RegAppReportItem("descr",     $this->report_info->descr,     1));
		$this->add_item(new RegAppReportItem("country",   $this->report_info->country,   1));
		$this->add_item(new RegAppReportItem("admin-c",   $this->report_info->admin_c,   1));
		$this->add_item(new RegAppReportItem("tech-c",    $this->report_info->tech_c,    1));
		$this->add_item(new RegAppReportItem("rev-srv",   $this->report_info->rev_srv,   0));
		$this->add_item(new RegAppReportItem("status",    $this->report_info->status,    1));
		$this->add_item(new RegAppReportItem("remarks",   $this->report_info->remarks,   0));
		$this->add_item(new RegAppReportItem("notify",    $this->report_info->notify,    0));
		$this->add_item(new RegAppReportItem("mnt-by",    $this->report_info->mnt_by,    1, $this->notice_message["mnt-by"]));
		$this->add_item(new RegAppReportItem("mnt-lower", $this->report_info->mnt_lower, 0));
		$this->add_item(new RegAppReportItem("mnt-irt",   $this->report_info->mnt_irt,   0));
		$this->add_item(new RegAppReportItem("changed",   $this->report_info->changed,   1, $this->notice_message["changed"]));
		$this->add_item(new RegAppReportItem("source",    $this->report_info->source,    1));
		$this->add_item(new RegAppReportItem("delete",    $this->report_info->delete,    0));
		
		// passwordmnt-byϢư
		$mnt_by = $this->get_item("mnt-by");
		// passwordܤ
		if($mnt_by->is_notice()){
			$this->add_item(new RegAppReportItem("password", "",                            1, $this->notice_message["password"]));
		// passwordܤ˹ͤ
		}elseif(strcmp($this->report_info->password, "")){
			$this->add_item(new RegAppReportItem("password", $this->report_info->password,  1));
		// passwordܹԤ
		}else{
			$this->add_item(new RegAppReportItem("password", "",                            0));
		}
		
		return $this->output();
	}
	
	/**
	 * ؿ̾init_item
	 *   APNICѹܾ
	 */
	function init_item(){
		$this->item_info = array();
	}
	
	/**
	 * ؿ̾add_item
	 *   APNICѹܤɲä
	 * @param  RegAppReportItem		$item	ѹܥ֥
	 */
	function add_item($item){
		array_push($this->item_info, $item);
		$this->item_idx[$item->name] = count($this->item_info) - 1;
	}
	
	/**
	 * ؿ̾get_item
	 *   APNICѹܤ
	 * @param  RegAppReportItem		$name	ѹ̾
	 */
	function get_item($name){
		return $this->item_info[$this->item_idx[$name]];
	}
	
	/**
	 * ؿ̾get_notice_items
	 *   ΤԤܤ
	 * @return	RegAppReportItem[]	ιܥꥹ
	 */
	function get_notice_items(){
		$notice_info = array();
		foreach($this->item_info as $item){
			if($item->is_notice()){
				array_push($notice_info, $item);
			}
		}
		return $notice_info;
	}
	
	/**
	 * ؿ̾output
	 *   APNICѥǡʸ֤
	 * @return string	APNICBodyǡʸ
	 */
	function output(){
		$output_info = array();
		foreach ($this->item_info as $item){
			if($item->is_exists()){
				array_push($output_info, $item->output());
			}
		}
		return join("\n", $output_info);
	}
}


/**
 * APNICѹܥ饹
 */

//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegAppReportItem{
	var $name;
	var $value;
	var $mandatory;
	var $notice_message;
	var $notice;
	
	/**
	 * ؿ̾RegAppReportItem
	 *   󥹥ȥ饯
	 * @param  string			$name			̾
	 * @param  (string|array)	$value			
	 * @param  integer			$mondatory		ɬܥե饰0ɬܤǤʤ1ɬܡ
	 * @param  string			$notice_message	Υå
	 *											ɬܤĹͤ¸ߤʤˡͤ
	 */
	function RegAppReportItem($name, $value, $mandatory=0, $notice_message=""){
		$this->name = $name;
		$this->value = is_array($value) ? $value : array($value);
		$this->mandatory = $mandatory;
		$this->notice_message = $notice_message;
		$this->notice = 0;
		$this->value_info = array();
		$this->parse();
	}
	
	/**
	 * ؿ̾add_value_info
	 *   ;ͤɲä
	 * @param  string		$value_string	
	 * @return integer		ɲ÷̡0̤ɲá1ɲá
	 * @desc   ͤʸ""ξɲäʤ
	 */
	function add_value_info($value_string){
		$inp = 0;
		if(strcmp($value_string, "")){
			$value_array = preg_split("/\r?\n/", $value_string);
			foreach ($value_array as $v){
				if(strcmp($v, "")){
					array_push($this->value_info, $v);
					$inp = 1;
				}
			}
		}
		return $inp;
	}
	
	/**
	 * ؿ̾parse
	 *   ͤѡ
	 */
	function parse(){
		foreach($this->value as $value_string){
			$this->add_value_info($value_string);
		}
		if($this->mandatory && !count($this->value_info)){
			if(strcmp($this->notice_message, "")){
				array_push($this->value_info, $this->notice_message);
				$this->notice = 1;
			}else{
				array_push($this->value_info, "");
			}
		}
	}
	
	/**
	 * ؿ̾is_notice
	 *   ΤԤܤǤ뤳Ȥǧ
	 * @return integer	ǧ̡0ΤԤʤ1ΤԤ
	 * @desc   ɬ parse() θѤ
	 */
	function is_notice(){
		return $this->notice;
	}
	
	/**
	 * ؿ̾is_exists
	 *   ͤ¸ߤ뤳Ȥǧ
	 * @return integer	ǧ̡0¸ߤʤ1¸ߤ
	 * @desc   ɬ parse() θѤ
	 */
	function is_exists(){
		return count($this->value_info) ? 1 : 0;
	}
	
	/**
	 * ؿ̾output
	 *   ʸʹ̾͡ˤ֤
	 * @return string	ʸ
	 * @desc
	 */
	function output(){
		$output_info = array();
		foreach($this->value_info as $value){
			array_push($output_info, sprintf("%-14s%-s", $this->name.":", $value));
		}
		return join("\n", $output_info);
	}
}
?>
