<?php
/**
 * $Id: ops_0602_class.php,v 1.8 2004/03/08 01:29:25 wtetsuya Exp $
 * IPɥ쥹(ops_0602)ѤΥ桼ƥƥ饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("REGClass.php");				// DBѹ¤Υ饹
require_once("DBAPIWrapper.php");			// DB API IMPLE
require_once("DBAPI_IP_MEMBER.php");		// DB API IP LIMIT饹
require_once("RegAppDispConf.php");			// ե󥯥饹
require_once("RegAppFormUtil.php");			// ե桼ƥƥ饹
require_once("RegAppInputCheck.php");		// եϥå饹
require_once("RegIpAddressUtil.php");		// IP AddressϢ桼ƥƥ饹
require_once("RegIpv6AddressUtil.php");		// IP AddressϢ桼ƥƥ饹
require_once("RegV6pcLog.php");				// ϥ饹
//----------------------------------------------------------------------------
// define
//----------------------------------------------------------------------------
define("ERR_LIMIT_DB_ACCESS", -1);			// DB顼
define("ERR_LIMIT_MEM_SEARCH", -2);			// ȿĤʤ

//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
/**
 * ̾  ops_0602_class
 *   IPɥ쥹(ops_0602)ѥ桼ƥƥ饹
 *   POST줿ǡѤ롣POSTǡ˸ƤӽФ
 */
class ops_0602_class
{
	/**
	 * DBAPI_IMPLE
	 */
	var $reg_db;

	/**
	 * 󥿥åؿ饹
	 * array(form name => RegAppChkSyntax)
	 */
	var $m_chk_funcs;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾ops_0602_class
	 *   ops_0602_class󥹥ȥ饯
	 * @param  $db		DBAPI_IMPLE
	 */
	function ops_0602_class($db)
	{
		$this->reg_db = $db;

		// 󥿥åؿ饹
		$this->m_chk_funcs = array(
			"fn_mem_ipv4_limit"	=>	new RegAppChkSyntax("chk_ipaddress_v4", null, "", "D054", "D054", 0, 5, TRUE, "D040"),
			"fn_mem_ipv6_limit"	=>	new RegAppChkSyntax("chk_ipaddress", null, "", "D013", "D013", 0, 5, TRUE, "D040"),
		);
	}

	/**
	 * ؿ̾get_label_info
	 *   եϲ̤ιܲʸ
	 * @param  for_html		boolean		TRUE:htmlspecialcharsѤΥǡ	(i)
	 * @return form name => ʸ Ϣ
	 */
	function get_label_info($for_html=TRUE)
	{
		$label_info = array(
			"fn_mem_ipv4_limit"	=>	"ĤIPv4ͥåȥɥ쥹Ⱦѡ",
			"fn_mem_ipv6_limit"	=>	"ĤIPv6ͥåȥɥ쥹Ⱦѡ",
		);

		// htmlspecialchars
		if ($for_html)
			$label_info = RegAppFormUtil::conv_array_value_html($label_info);

		return $label_info;
	}

	/**
	 * ؿ̾get_form_example
	 *   եϲ̤ι
	 * @param  for_html		boolean		TRUE:htmlspecialcharsѤΥǡ
	 * @return form name => ʸ Ϣ
	 */
	function get_form_example($for_html=TRUE)
	{
		require("config/RegCnfFormInfo.php");		// եե
		$var_example = array(
			"fn_mem_ipv4_limit" => $cnf_form_example["ip_network_number_v4"],
			"fn_mem_ipv6_limit" => $cnf_form_example["ip_network_number"],
		);

		// htmlspecialchars
		if ($for_html)
			$var_example = RegAppFormUtil::conv_array_value_html($var_example);

		return $var_example;
	}

	//-----------------------------------------------------------------------
	// public methods(󥿥å)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_form_in_syntax
	 *   POSTǡΥ󥿥åԤ
	 *         IPͥåȥɥ쥹ʸå
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹	(i/o)
	 * @param  error_str	string[]			顼ɳǼ	(i/o)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         եǡ RegAppDispConf ꤹ뤳ȡ
	 */
	function chk_form_in_syntax(&$conf_obj, &$error_str)
	{
		////// IPv4 //////
		// input checkƤӽФ
		if (RegAppFormUtil::call_chk_function($conf_obj["fn_mem_ipv4_limit"],
											  $this->m_chk_funcs["fn_mem_ipv4_limit"],
											  $error_str) == FALSE)
		{
			return FALSE;
		}

		//----- ʣϤƤϽʣåԤ -----//
		if (count($conf_obj["fn_mem_ipv4_limit"]->m_disp_var) >= 2)
		{
			if (RegIpAddressUtil::chk_ip_array_overlap($conf_obj["fn_mem_ipv4_limit"]->m_disp_var))
			{
				// ʣƤ뤿ᡢ顼
				RegAppFormUtil::set_err_data($conf_obj["fn_mem_ipv4_limit"],
											 $error_str,
											 $this->m_chk_funcs["fn_mem_ipv4_limit"]->m_err_ex);
				return FALSE;
			}
		}
		
		////// IPv6 //////
		// input checkƤӽФ
		if (RegAppFormUtil::call_chk_function($conf_obj["fn_mem_ipv6_limit"],
											  $this->m_chk_funcs["fn_mem_ipv6_limit"],
											  $error_str) == FALSE)
		{
			return FALSE;
		}

		//----- ʣϤƤϽʣåԤ -----//
		if (count($conf_obj["fn_mem_ipv6_limit"]->m_disp_var) >= 2)
		{
			if (RegIpv6AddressUtil::chk_ipblock_array_overlap($conf_obj["fn_mem_ipv6_limit"]->m_disp_var))
			{
				// ʣƤ뤿ᡢ顼
				RegAppFormUtil::set_err_data($conf_obj["fn_mem_ipv6_limit"],
											 $error_str,
											 $this->m_chk_funcs["fn_mem_ipv6_limit"]->m_err_ex);
				return FALSE;
			}
		}

		return TRUE;
	}

	/**
	 * ؿ̾chk_form_hidden_syntax
	 *   POSTǡȿ(hidden)Υ󥿥åԤ
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹				(i/o)
	 * @param  chk_fn_keys	string[]			󥿥åԤkey		(i)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   棱ĤǤ⥨顼ˤʤäϸ³Υ󥿥åϹԤʤ
	 */
	function chk_form_hidden_syntax(&$conf_obj)
	{
		////// IPv4 //////
		// input checkƤӽФ
		if (RegAppFormUtil::call_chk_function($conf_obj["fn_mem_ipv4_limit"],
											  $this->m_chk_funcs["fn_mem_ipv4_limit"],
											  ($err=array()),
											  TRUE) == FALSE)
		{
			return FALSE;
		}

		//----- ʣϤƤϽʣåԤ -----//
		if (count($conf_obj["fn_mem_ipv4_limit"]->m_disp_var) >= 2)
		{
			if (RegIpAddressUtil::chk_ip_array_overlap($conf_obj["fn_mem_ipv4_limit"]->m_disp_var))
			{
				// ʣƤ뤿ᡢ顼
				RegAppFormUtil::set_err_data($conf_obj["fn_mem_ipv4_limit"],
											 $error_str,
											 $this->m_chk_funcs["fn_mem_ipv4_limit"]->m_err_ex);
				return FALSE;
			}
		}
		////// IPv6 //////
		// input checkƤӽФ
		if (RegAppFormUtil::call_chk_function($conf_obj["fn_mem_ipv6_limit"],
											  $this->m_chk_funcs["fn_mem_ipv6_limit"],
											  ($err=array()),
											  TRUE) == FALSE)
		{
			return FALSE;
		}

		//----- ʣϤƤϽʣåԤ -----//
		if (count($conf_obj["fn_mem_ipv4_limit"]->m_disp_var) >= 2)
		{
			if (RegIpv6AddressUtil::chk_ipblock_array_overlap($conf_obj["fn_mem_ipv6_limit"]->m_disp_var))
			{
				// ʣƤ뤿ᡢ顼
				RegAppFormUtil::set_err_data($conf_obj["fn_mem_ipv6_limit"],
											 $error_str,
											 $this->m_chk_funcs["fn_mem_ipv6_limit"]->m_err_ex);
				return FALSE;
			}
		}

		return TRUE;
	}

	//-----------------------------------------------------------------------
	// public methods(DB)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_ip_limit_info
	 *   IPɥ쥹¤conf_obj->m_disp_var
	 *         ˳Ǽ롣
	 * @param  mem_num							ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf		ե󥯥饹			(i/o)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return boolean	TRUEԡFALSE
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         ξ conf_obj->m_disp_var ˥åȤ
	 */
	function get_ip_limit_info($mem_num, &$conf_obj, &$error_str)
	{
		if(!$this->get_ipv4_limit_info($mem_num, $conf_obj, $error_str)){
			return FALSE;
		}
		if(!$this->get_ipv6_limit_info($mem_num, $conf_obj, $error_str)){
			return FALSE;
		}
		return TRUE;
	}

	/**
	 * ؿ̾get_ipv4_limit_info
	 *   IPv4ɥ쥹¤conf_obj->m_disp_var
	 *         ˳Ǽ롣
	 * @param  mem_num							ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf		ե󥯥饹			(i/o)
	 *                      ["fn_mem_ip_limit"]
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return boolean	TRUEԡFALSE
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         ξ conf_obj->m_disp_var ˥åȤ
	 */
	function get_ipv4_limit_info($mem_num, &$conf_obj, &$error_str)
	{
		$sql_str	= "SELECT ip_network_number FROM sdb_ip_member" .
					  " WHERE member_number = " . $mem_num;
		$db_result	= $this->reg_db->dbapi_query($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			array_push($error_str, "D210");					// ԥ顼
			return FALSE;
		}
		if ($db_result === NULL)							// 
		{
			$conf_obj["fn_mem_ipv4_limit"]->set_disp_var("");
			return TRUE;
		}

		$limit_ls = array();
		foreach ($db_result as $value)
		{
			if ($value["ip_network_number"] != "")
				array_push($limit_ls, $value["ip_network_number"]);
		}
		if (count($limit_ls) < 1)
		{
			$conf_obj["fn_mem_ipv4_limit"]->set_disp_var("");
			return TRUE;
		}

		$conf_obj["fn_mem_ipv4_limit"]->set_disp_var($limit_ls);
		return TRUE;
	}

	/**
	 * ؿ̾get_ipv6_limit_info
	 *   IPɥ쥹¤conf_obj->m_disp_var
	 *         ˳Ǽ롣
	 * @param  mem_num							ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf		ե󥯥饹			(i/o)
	 *                      ["fn_mem_ip_limit"]
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return boolean	TRUEԡFALSE
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         ξ conf_obj->m_disp_var ˥åȤ
	 */
	function get_ipv6_limit_info($mem_num, &$conf_obj, &$error_str)
	{
		$sql_str	= "SELECT ip_network_number FROM sdb_ipv6_member" .
					  " WHERE member_number = " . $mem_num;
		$db_result	= $this->reg_db->dbapi_query($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			array_push($error_str, "D210");					// ԥ顼
			return FALSE;
		}
		if ($db_result === NULL)							// 
		{
			$conf_obj["fn_mem_ipv6_limit"]->set_disp_var("");
			return TRUE;
		}

		$limit_ls = array();
		foreach ($db_result as $value)
		{
			if ($value["ip_network_number"] != "")
				array_push($limit_ls, $value["ip_network_number"]);
		}
		if (count($limit_ls) < 1)
		{
			$conf_obj["fn_mem_ipv6_limit"]->set_disp_var("");
			return TRUE;
		}

		$conf_obj["fn_mem_ipv6_limit"]->set_disp_var($limit_ls);
		return TRUE;
	}

	/**
	 * ؿ̾save_ip_limit
	 *   IPɥ쥹¤Ͽ򹹿롣
	 *         ͤʤƥꥢ롣
	 * @param  mem_num							ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf		ե󥯥饹			(i/o)
	 *                      ["fn_mem_ip_limit"]
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return TRUE
	 *         ԡERR_LIMIT_DB_ACCESS		DB顼
	 *               ERR_LIMIT_MEM_SEARCH		normalMEMBERʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function save_ip_limit($mem_num, &$conf_obj, &$error_str)
	{
		$lock_sql	= "SELECT member_number FROM mdb_meminfo" .
					  " WHERE member_number = " . $mem_num .
					  " AND status = 'normal' FOR UPDATE";
		//-------------------------------------------------------------------
		// DBȥ󥶥󳫻ϡå
		//-------------------------------------------------------------------
		// ȥ󥶥󳫻
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "D000");					// 顼ȯޤ
			return ERR_LIMIT_DB_ACCESS;
		}

		$db_result = $this->reg_db->dbapi_query_lock($lock_sql);
		if ($db_result === FALSE)							// 顼
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D000");					// 顼ȯޤ
			return ERR_LIMIT_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D000");					// 顼ȯޤ
			return ERR_LIMIT_MEM_SEARCH;
		}
		
		// IPv4
		$res = $this->save_ipv4_limit($mem_num, $conf_obj, $error_str);
		if($res !== TRUE){
				$this->reg_db->REGDB_rollback();
				return $res;
		}
		
		// IPv6
		$res = $this->save_ipv6_limit($mem_num, $conf_obj, $error_str);
		if($res !== TRUE){
				$this->reg_db->REGDB_rollback();
				return $res;
		}

		$this->reg_db->REGDB_commit();
		return TRUE;
	}

	/**
	 * ؿ̾save_ipv4_limit
	 *   IPv4ɥ쥹¤Ͽ򹹿롣
	 *         ͤʤƥꥢ롣
	 * @param  mem_num							ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf		ե󥯥饹			(i/o)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return TRUE
	 *         ԡERR_LIMIT_DB_ACCESS		DB顼
	 *               ERR_LIMIT_MEM_SEARCH		normalMEMBERʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function save_ipv4_limit($mem_num, &$conf_obj, &$error_str)
	{
		$reg_db_limit = new DBAPI_IP_MEMBER($this->reg_db);

		$del_sql	= "DELETE FROM sdb_ip_member WHERE member_number = " . $mem_num;
		$type_del	 = TRUE;			// ե饰
		$ip_limit_ls = array();			// ɲѤIPɥ쥹ꥹ
		if (is_array($conf_obj["fn_mem_ipv4_limit"]->m_disp_var) 
		&& count($conf_obj["fn_mem_ipv4_limit"]->m_disp_var) > 0)
		{
			$type_del = FALSE;
			foreach ($conf_obj["fn_mem_ipv4_limit"]->m_disp_var as $ip_limit)
			{
				if ($ip_limit != "")
					array_push($ip_limit_ls, $ip_limit);
			}
			if (count($ip_limit_ls) < 1)
			{
				$type_del = TRUE;
			}
		}
		
		// 
		if ($type_del)
		{
			$db_result	= $this->reg_db->dbapi_query_delete($del_sql);
			if ($db_result === FALSE)						// 顼
			{
				array_push($error_str, "D000");				// 顼ȯޤ
				return ERR_LIMIT_DB_ACCESS;
			}
		}
		// ɲù
		else
		{
			$db_result	= $reg_db_limit->app_create_ipv4_member_info($mem_num, $ip_limit_ls);
			if ($db_result === FALSE)						// 顼 or 0
			{
				array_push($error_str, "D000");				// 顼ȯޤ
				return ERR_LIMIT_DB_ACCESS;
			}
			if ($db_result != count($ip_limit_ls))
			{
				array_push($error_str, "D000");				// 顼ȯޤ
				return ERR_LIMIT_DB_ACCESS;
			}
		}
		
		return TRUE;
	}

	/**
	 * ؿ̾save_ipv6_limit
	 *   IPv6ɥ쥹¤Ͽ򹹿롣
	 *         ͤʤƥꥢ롣
	 * @param  mem_num							ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf		ե󥯥饹			(i/o)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return TRUE
	 *         ԡERR_LIMIT_DB_ACCESS		DB顼
	 *               ERR_LIMIT_MEM_SEARCH		normalMEMBERʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function save_ipv6_limit($mem_num, &$conf_obj, &$error_str)
	{
		$reg_db_limit = new DBAPI_IP_MEMBER($this->reg_db);

		$del_sql	= "DELETE FROM sdb_ipv6_member WHERE member_number = " . $mem_num;
		$type_del	 = TRUE;			// ե饰
		$ip_limit_ls = array();			// ɲѤIPɥ쥹ꥹ
		if (is_array($conf_obj["fn_mem_ipv6_limit"]->m_disp_var) && count($conf_obj["fn_mem_ipv6_limit"]->m_disp_var) > 0)
		{
			$type_del = FALSE;
			foreach ($conf_obj["fn_mem_ipv6_limit"]->m_disp_var as $ip_limit)
			{
				if ($ip_limit != "")
					array_push($ip_limit_ls, $ip_limit);
			}
			if (count($ip_limit_ls) < 1)
			{
				$type_del = TRUE;
			}
		}
		
		// 
		if ($type_del)
		{
			$db_result	= $this->reg_db->dbapi_query_delete($del_sql);
			if ($db_result === FALSE)						// 顼
			{
				array_push($error_str, "D000");				// 顼ȯޤ
				return ERR_LIMIT_DB_ACCESS;
			}
		}
		// ɲù
		else
		{
			$db_result	= $reg_db_limit->app_create_ip_member_info($mem_num, $ip_limit_ls);
			if ($db_result === FALSE)						// 顼 or 0
			{
				array_push($error_str, "D000");				// 顼ȯޤ
				return ERR_LIMIT_DB_ACCESS;
			}
			if ($db_result != count($ip_limit_ls))
			{
				array_push($error_str, "D000");				// 顼ȯޤ
				return ERR_LIMIT_DB_ACCESS;
			}
		}
		
		return TRUE;
	}

	//-----------------------------------------------------------------------
	// public methods()
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾write_saveps_log
	 *   ƤϤ
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹				(i/o)
	 */
	function write_ip_limit_log($conf_obj)
	{
		// ȿά
		$mem_short = $conf_obj["fn_mem_op_short"]->m_disp_var;

		// Ͽɥ쥹ʥ޶ڤ
		$ip_list = array();
		// IPv4
		if (is_array($conf_obj["fn_mem_ipv4_limit"]->m_disp_var) 
		&& count($conf_obj["fn_mem_ipv4_limit"]->m_disp_var) > 0){
			foreach ($conf_obj["fn_mem_ipv4_limit"]->m_disp_var as $value){
				if ($value != ""){
					array_push($ip_list, $value);
				}
			}
		}
		// IPv6
		if (is_array($conf_obj["fn_mem_ipv6_limit"]->m_disp_var) 
		&& count($conf_obj["fn_mem_ipv6_limit"]->m_disp_var) > 0){
			foreach ($conf_obj["fn_mem_ipv6_limit"]->m_disp_var as $value){
				if ($value != ""){
					array_push($ip_list, $value);
				}
			}
		}
		$ip_add = (count($ip_list) > 0) ? join(",", $ip_list) : "all delete";

		RegV6pcLog::info("[ops0602]::[update member ip filter]::[client " .
						 getenv("REMOTE_ADDR") . "] user " . $mem_short .
						 ": ipaddress filter " . $ip_add);
	}
}
?>
