<?php
//$Id: DBAPI_DPN.php,v 1.2 2004/02/27 10:32:21 wtetsuya Exp $
require_once("mdb_common.php");
require_once("sequence_number.php");
require_once("discussion.php");


class DBAPI_DPN extends DBAPI_BASE
{
  /**
  * DBAPI_DPN
  * @desc 󥹥ȥ饯
  * @param DBAPI_IMPL֥
  * @return ʤ
  */
  function DBAPI_DPN($db="")
  {
    if($db == "")
    {
      $db = DBAPI::connect();
    }
    foreach(get_object_vars($db) as $key => $value)
    {
      $this->$key = $value;
    }
    return $this;
  }
  
  /**
  * dpn_get_content
  * @desc 
  * @param No
  * @param ȯID
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * param OFFSET(0)
  * @return DPN_CONTENT¤(array)
  */
  function dpn_get_content($accept_id, $id, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "id,accept_id,parent_id,subject,contents,sender_id,name,date";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("DPN_GetContent");
    }
    $debugParam = array($id, $accept_id);
    $this->_debug_log("DPN_GetContent", $debugParam);
    $this->result = DPN_GetContent($this->con, $id, $accept_id, $selcol, $ext);
    $ret = $this->_dbapi_return("DPN_GetContent", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("DPN_GetContent");
    }
    return $ret;
  }
  
  /**
  * dpn_search_content
  * @desc No鿽
  * @param No
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return DPN_CONTENT¤(array)
  */
  function dpn_search_content($accept_id, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "id,accept_id,parent_id,subject,contents,sender_id,name,date";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("DPN_SearchContent");
    }
    $debugParam = array($accept_id);
    $this->_debug_log("DPN_SearchContent", $debugParam);
    $this->result = DPN_SearchContent($this->con, $accept_id, $selcol, $ext);
    $ret = $this->_dbapi_return("DPN_SearchContent", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("DPN_SearchContent");
    }
    return $ret;
  }
  
  /**
  * dpn_count_content
  * @desc ˥ޥå뿽ιԿ
  * @param  No
  * @param  
  * @return  Կ(integer)
  */
  function dpn_count_content($condition="")
  {
    if($condition != "")
    {
      $condition = "where " . $condition;
    }
    if($this->profile_log)
    {
      $this->_pre_func("DPN_CountContent");
    }
    $debugParam = array($condition);
    $this->_debug_log("DPN_CountContent", $debugParam);
    $this->result = DPN_CountContent($this->con, $condition);
    $ret = $this->_dbapi_return("DPN_CountContent", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("DPN_CountContent");
    }
    return $ret;
  }
  
  /**
  * dpn_create_content
  * @desc 򿷵
  * @param DPN_CONTENT¤
  * @return true/false
  */
  function dpn_create_content($dpn_content)
  {
    if($this->profile_log)
    {
      $this->_pre_func("DPN_CreateContent");
    }
    $debugParam = array($dpn_content);
    $this->_debug_log("DPN_CreateContent", $debugParam);
    $this->result = DPN_CreateContent($this->con, &$dpn_content);
    $ret = $this->_dbapi_return("DPN_CreateContent", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("DPN_CreateContent");
    }
    return $ret;
  }
  
  /**
  * dpn_get_last_content_id
  * @desc No˴ϢĤƤǿȯID
  * @param No
  * @return ȯID
  * @descδؿSELECT FOR UPDATEƤǤ롣ΥåॢȤ򵯤Ȥϡ
  * LOCK_TIME_OVER(-5)äƤΤǡɬפ˱Ƥcatch뤳
  */
  function dpn_get_last_content_id($accept_id)
  {
    if($this->profile_log)
    {
      $this->_pre_func("DPN_GetLastContentID");
    }
    $debugParam = array($accept_id);
    $this->_debug_log("DPN_GetLastContentID", $debugParam);
    $this->result = DPN_GetLastContentID($this->con, $accept_id);
    $ret = $this->_dbapi_return("DPN_GetLastContentID", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("DPN_GetLastContentID");
    }
    return $ret;
  }
  
}

?>
