<?php
//$Id: DBAPI_REPORT.php,v 1.4 2004/02/12 08:48:45 yoshi_s Exp $
require_once("mdb_common.php");
require_once("report.php");

class DBAPI_REPORT extends DBAPI_BASE{
  /**
  * DBAPI_REPORT
  * @desc 󥹥ȥ饯
  * @param DBAPI_IMPL֥
  * @return ʤ
  */
  function DBAPI_REPORT($db=""){
    if($db == ""){
      $db = DBAPI::connect();
    }
    foreach(get_object_vars($db) as $key => $value){
      $this->$key = $value;
    }
    return $this;
  }
  
 /**
  * ؿcreate_report_assigned
  * IPɥ쥹Ͽģ¡ʣңģ¡ˤϿ
  * @param  REPORT_INFO $report_info    ¤
  * @return 
  *             TRUE
  *             ԡFALSE
  */
  function create_report_assigned($report_info){
    return $this->_report_base_method("CreateReport_Assigned", $report_info);
  }
  
 /**
  * ؿcreate_report_modified
  * ͥåȥ󵭺ܻѹģ¡ʣңģ¡ˤϿ
  * @param  REPORT_INFO $report_info    ¤
  * @return 
  *             TRUE
  *             ԡFALSE
  */
  function create_report_modified($report_info){
    return $this->_report_base_method("CreateReport_Modified", $report_info);
  }
  
 /**
  * ؿcreate_report_returned
  * ƺѤIPɥ쥹ֵѾģ¡ʣңģ¡ˤϿ
  * @param  REPORT_INFO $report_info    ¤
  * @return 
  *             TRUE
  *             ԡFALSE
  */
  function create_report_returned($report_info){
    return $this->_report_base_method("CreateReport_Returned", $report_info);
  }
  
 /**
  * ؿget_report
  * ģ¡ʣңģ¡ˤ
  * @param  integer     $accept_id      ֹ
  * @return 
  *             REPORT_INFO[]
  *             ԡFALSE
  */
  function get_report($accept_id){
    return $this->_report_base_method("GetReport", $accept_id);
  }
  
 /**
  * ؿ_report_base_method
  * Ѵܥ᥽å
  *       ѥ᥽åɤϤ٤ܥ᥽åɤ𤷼¹Ԥ
  * @param  Ǥ
  * @return 
  */
  function _report_base_method(){
    $params = func_get_args();
    $func_name = array_shift($params);
    $debug_params = $params;
    $func_params = $params;
    array_unshift($func_params, $this->con);
    if($this->profile_log) $this->_pre_func($func_name);
    $this->_debug_log($func_name, $debug_params);
    $this->result = call_user_func_array($func_name, $func_params);
    $ret = $this->_dbapi_return($func_name, $debug_params);
    if($this->profile_log) $this->_post_func($func_name);
    return $ret;
  }
}
?>