<?php
/**
 * $Id: report.php,v 1.7 2004/02/23 01:36:37 yoshi_s Exp $
 * ̥쥸ȥؤΥ桼ƥƥ饹
 */
?>
<?php
/**
 * ؿCreateReport_Assigned
 * IPɥ쥹Ͽģ¡ʣңģ¡ˤϿ
 * @param   DBAPI_IMPL  $con            DBͥ꥽
 * @param   REPORT_INFO $report_info    ¤
 * @return  DB_RESULT_INFO  
 *                          
 *                              ->is_error = false
 *                              ->db_error_info = null
 *                              ->db_result_info = 1
 *                          ԡ
 *                              ->is_error = true
 *                              ->db_error_info = 顼å
 *                              ->db_result_info = null
 */
function CreateReport_Assigned($con, $report_info){
    return CreateReport_Base($con, $report_info);
}

/**
 * ؿCreateReport_Modified
 * ͥåȥ󵭺ܻѹģ¡ʣңģ¡ˤϿ
 * @param   DBAPI_IMPL  $con            DBͥ꥽
 * @param   REPORT_INFO $report_info    ¤
 * @return  DB_RESULT_INFO  
 *                          
 *                              ->is_error = false
 *                              ->db_error_info = null
 *                              ->db_result_info = 1
 *                          ԡ
 *                              ->is_error = true
 *                              ->db_error_info = 顼å
 *                              ->db_result_info = null
 */
function CreateReport_Modified($con, $report_info){
    return CreateReport_Base($con, $report_info);
}

/**
 * ؿCreateReport_Returned
 * ƺѤIPɥ쥹ֵѾģ¡ʣңģ¡ˤϿ
 * @param   DBAPI_IMPL  $con            DBͥ꥽
 * @param   REPORT_INFO $report_info    ¤
 * @return  DB_RESULT_INFO  
 *                          
 *                              ->is_error = false
 *                              ->db_error_info = null
 *                              ->db_result_info = 1
 *                          ԡ
 *                              ->is_error = true
 *                              ->db_error_info = 顼å
 *                              ->db_result_info = null
 */
function CreateReport_Returned($con, $report_info){
    return CreateReport_Base($con, $report_info);
}

/**
 * ins0701 IPɥ쥹Ͽ
 */
/**
 * ؿGetReport
 * ģ¡ʣңģ¡ˤ
 * @param   DBAPI_IMPL  $con            DBͥ꥽
 * @param   integer     $accept_id      ֹ
 * @return  DB_RESULT_INFO  
 *                          
 *                              ->is_error = false
 *                              ->db_error_info = null
 *                              ->db_result_info = REPORT_INFO[]
 *                          ԡ
 *                              ->is_error = true
 *                              ->db_error_info = 顼å
 *                              ->db_result_info = null
 */
function GetReport($con, $accept_id){

    $sql_fmt = <<<_END_
    SELECT 
        report_id,
        report_to,
        report_type,
        inet6num,
        netname,
        descr,
        country,
        status,
        source,
        delete,
        password
    FROM rdb_ipnetinfo WHERE accept_id = %s 
    ORDER BY report_id
_END_;
    $sql = sprintf($sql_fmt,
        $accept_id
    );
    $m_result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorSelect($con, $m_result,__FILE__,__LINE__);
    if ($check->is_error) {
        return $check;
    }
    
    $m_rows = pg_num_rows($m_result);
    $result_info = array();
    for($m_idx=0; $m_idx<$m_rows; $m_idx++){
    
        // report_id, report_to, report_type, inet6num, netname, descr
        // country, status, source, delete, password
        list($report_id, $report_to, $report_type, $inet6num, $netname, 
        $descr, $country, $status, $source, $delete, $password)
        = pg_fetch_row($m_result, $m_idx);
        
        // changed
        $changed = array();
        $sql_fmt = <<<_END_
        SELECT changed FROM rdb_changed WHERE report_id = %s ORDER BY order_no
_END_;
        $sql = sprintf($sql_fmt,
            $report_id
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
        if ($check->is_error) {
            return $check;
        }
        $rows = pg_num_rows($result);
        for($idx=0; $idx < $rows; $idx++){
            array_push($changed, pg_fetch_result($result, $idx, 0));
        }
        pg_free_result($result);
    
        // admin_c
        $admin_c = array();
        $sql_fmt = <<<_END_
        SELECT admin_c FROM rdb_admin_c WHERE report_id = %s ORDER BY order_no
_END_;
        $sql = sprintf($sql_fmt,
            $report_id
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
        if ($check->is_error) {
            return $check;
        }
        $rows = pg_num_rows($result);
        for($idx=0; $idx < $rows; $idx++){
            array_push($admin_c, pg_fetch_result($result, $idx, 0));
        }
        pg_free_result($result);
    
        // tech_c
        $tech_c = array();
        $sql_fmt = <<<_END_
        SELECT tech_c FROM rdb_tech_c WHERE report_id = %s ORDER BY order_no
_END_;
        $sql = sprintf($sql_fmt,
            $report_id
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
        if ($check->is_error) {
            return $check;
        }
        $rows = pg_num_rows($result);
        for($idx=0; $idx < $rows; $idx++){
            array_push($tech_c, pg_fetch_result($result, $idx, 0));
        }
        pg_free_result($result);
    
        // rev_srv
        $rev_srv = array();
        $sql_fmt = <<<_END_
        SELECT rev_srv FROM rdb_rev_srv WHERE report_id = %s ORDER BY order_no
_END_;
        $sql = sprintf($sql_fmt,
            $report_id
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
        if ($check->is_error) {
            return $check;
        }
        $rows = pg_num_rows($result);
        for($idx=0; $idx < $rows; $idx++){
            array_push($rev_srv, pg_fetch_result($result, $idx, 0));
        }
        pg_free_result($result);

        // mnt_irt
        $mnt_irt = array();
        $sql_fmt = <<<_END_
        SELECT mnt_irt FROM rdb_mnt_irt WHERE report_id = %s ORDER BY order_no
_END_;
        $sql = sprintf($sql_fmt,
            $report_id
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
        if ($check->is_error) {
            return $check;
        }
        $rows = pg_num_rows($result);
        for($idx=0; $idx < $rows; $idx++){
            array_push($mnt_irt, pg_fetch_result($result, $idx, 0));
        }
        pg_free_result($result);

        // mnt_lower
        $mnt_lower = array();
        $sql_fmt = <<<_END_
        SELECT mnt_lower FROM rdb_mnt_lower WHERE report_id = %s ORDER BY order_no
_END_;
        $sql = sprintf($sql_fmt,
            $report_id
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
        if ($check->is_error) {
            return $check;
        }
        $rows = pg_num_rows($result);
        for($idx=0; $idx < $rows; $idx++){
            array_push($mnt_lower, pg_fetch_result($result, $idx, 0));
        }
        pg_free_result($result);

        // mnt_by
        $mnt_by = array();
        $sql_fmt = <<<_END_
        SELECT mnt_by FROM rdb_mnt_by WHERE report_id = %s ORDER BY order_no
_END_;
        $sql = sprintf($sql_fmt,
            $report_id
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
        if ($check->is_error) {
            return $check;
        }
        $rows = pg_num_rows($result);
        for($idx=0; $idx < $rows; $idx++){
            array_push($mnt_by, pg_fetch_result($result, $idx, 0));
        }
        pg_free_result($result);

        // notify
        $notify = array();
        $sql_fmt = <<<_END_
        SELECT notify FROM rdb_notify WHERE report_id = %s ORDER BY order_no
_END_;
        $sql = sprintf($sql_fmt,
            $report_id
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
        if ($check->is_error) {
            return $check;
        }
        $rows = pg_num_rows($result);
        for($idx=0; $idx < $rows; $idx++){
            array_push($notify, pg_fetch_result($result, $idx, 0));
        }
        pg_free_result($result);

        // remarks
        $remarks = array();
        $sql_fmt = <<<_END_
        SELECT remarks FROM rdb_remarks WHERE report_id = %s ORDER BY order_no
_END_;
        $sql = sprintf($sql_fmt,
            $report_id
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
        if ($check->is_error) {
            return $check;
        }
        $rows = pg_num_rows($result);
        for($idx=0; $idx < $rows; $idx++){
            array_push($remarks, pg_fetch_result($result, $idx, 0));
        }
        pg_free_result($result);

        array_push($result_info,  
            new REPORT_INFO(
                $report_id,
                $accept_id,
                $report_to,
                $report_type,
                $inet6num,
                $netname,
                $country,
                $descr,
                $admin_c,
                $tech_c,
                $rev_srv,
                $status,
                $remarks,
                $notify,
                $mnt_by,
                $mnt_lower,
                $mnt_irt,
                $changed,
                $source,
                $delete,
                $password
            )
        );
    }
    pg_free_result($m_result);
    return new DB_RESULT_INFO(false, null, $result_info);
}

/**
 * ؿCreateReport_Base
 * ģ¡ʣңģ¡ˤϿ
 * @param   DBAPI_IMPL  $con            DBͥ꥽
 * @param   REPORT_INFO $report_info    ¤
 * @return  DB_RESULT_INFO  
 *                          
 *                              ->is_error = false
 *                              ->db_error_info = null
 *                              ->db_result_info = 1
 *                          ԡ
 *                              ->is_error = true
 *                              ->db_error_info = 顼å
 *                              ->db_result_info = null
 */
function CreateReport_Base($con, &$report_info){

    // get report_id
    $result = SEQ_IncCount($con, "REPORT.NO");
    if($result->is_error){
        return $result;
    }
    $report_info->report_id = $result->db_result_info;
    
    // rdb_ipnetinfo
    $sql_fmt = <<<_END_
    INSERT INTO rdb_ipnetinfo (
        report_id,
        accept_id,
        inet6num,
        report_to,
        report_type,
        netname,
        descr,
        country,
        status,
        source,
        delete,
        password
    ) VALUES (
        %s,
        %s,
        %s,
        %s,
        %s,
        %s,
        %s,
        %s,
        %s,
        %s,
        %s,
        %s
    )
_END_;
    $sql = sprintf($sql_fmt,
        $report_info->report_id,
        $report_info->accept_id,
        GetApsString($report_info->inet6num),
        GetApsString($report_info->report_to),
        GetApsString($report_info->report_type),
        GetApsString($report_info->netname),
        GetApsString($report_info->descr),
        GetApsString($report_info->country),
        GetApsString($report_info->status),
        GetApsString($report_info->source),
        GetApsString($report_info->delete),
        GetApsString($report_info->password)
    );
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
    if($check->is_error){
        return $check;
    }

    // rdb_admin_c
    $order_no = 0;
    foreach ($report_info->admin_c as $val){
        $sql_fmt = <<<_END_
        INSERT INTO rdb_admin_c (
            report_id,
            order_no,
            admin_c
        ) VALUES (
            %s,
            %s,
            %s
        )
_END_;
        $sql = sprintf($sql_fmt,
            $report_info->report_id,
            ++$order_no,
            GetApsString($val)
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
        if($check->is_error){
            return $check;
        }
    }
    
    // rdb_tech_c
    $order_no = 0;
    foreach ($report_info->tech_c as $val){
        $sql_fmt = <<<_END_
        INSERT INTO rdb_tech_c (
            report_id,
            order_no,
            tech_c
        ) VALUES (
            %s,
            %s,
            %s
        )
_END_;
        $sql = sprintf($sql_fmt,
            $report_info->report_id,
            ++$order_no,
            GetApsString($val)
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
        if($check->is_error){
            return $check;
        }
    }
    
    // rdb_rev_srv
    $order_no = 0;
    foreach ($report_info->rev_srv as $val){
        $sql_fmt = <<<_END_
        INSERT INTO rdb_rev_srv (
            report_id,
            order_no,
            rev_srv
        ) VALUES (
            %s,
            %s,
            %s
        )
_END_;
        $sql = sprintf($sql_fmt,
            $report_info->report_id,
            ++$order_no,
            GetApsString($val)
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
        if($check->is_error){
            return $check;
        }
    }
    
    // rdb_mnt_irt
    $order_no = 0;
    foreach ($report_info->mnt_irt as $val){
        $sql_fmt = <<<_END_
        INSERT INTO rdb_mnt_irt(
            report_id,
            order_no,
            mnt_irt
        ) VALUES (
            %s,
            %s,
            %s
        )
_END_;
        $sql = sprintf($sql_fmt,
            $report_info->report_id,
            ++$order_no,
            GetApsString($val)
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
        if($check->is_error){
            return $check;
        }
    }
    
    // rdb_mnt_lower
    $order_no = 0;
    foreach ($report_info->mnt_lower as $val){
        $sql_fmt = <<<_END_
        INSERT INTO rdb_mnt_lower (
            report_id,
            order_no,
            mnt_lower
        ) VALUES (
            %s,
            %s,
            %s
        )
_END_;
        $sql = sprintf($sql_fmt,
            $report_info->report_id,
            ++$order_no,
            GetApsString($val)
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
        if($check->is_error){
            return $check;
        }
    }
    
    // rdb_mnt_by
    $order_no = 0;
    foreach ($report_info->mnt_by as $val){
        $sql_fmt = <<<_END_
        INSERT INTO rdb_mnt_by (
            report_id,
            order_no,
            mnt_by
        ) VALUES (
            %s,
            %s,
            %s
        )
_END_;
        $sql = sprintf($sql_fmt,
            $report_info->report_id,
            ++$order_no,
            GetApsString($val)
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
        if($check->is_error){
            return $check;
        }
    }
    
    // rdb_notify
    $order_no = 0;
    foreach ($report_info->notify as $val){
        $sql_fmt = <<<_END_
        INSERT INTO rdb_notify (
            report_id,
            order_no,
            notify
        ) VALUES (
            %s,
            %s,
            %s
        )
_END_;
        $sql = sprintf($sql_fmt,
            $report_info->report_id,
            ++$order_no,
            GetApsString($val)
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
        if($check->is_error){
            return $check;
        }
    }
    
    // rdb_remarks
    $order_no = 0;
    foreach ($report_info->remarks as $val){
        $sql_fmt = <<<_END_
        INSERT INTO rdb_remarks (
            report_id,
            order_no,
            remarks
        ) VALUES (
            %s,
            %s,
            %s
        )
_END_;
        $sql = sprintf($sql_fmt,
            $report_info->report_id,
            ++$order_no,
            GetApsString($val)
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
        if($check->is_error){
            return $check;
        }
    }
    
    // rdb_changed
    $order_no = 0;
    foreach ($report_info->changed as $val){
        $sql_fmt = <<<_END_
        INSERT INTO rdb_changed (
            report_id,
            order_no,
            changed
        ) VALUES (
            %s,
            %s,
            %s
        )
_END_;
        $sql = sprintf($sql_fmt,
            $report_info->report_id,
            ++$order_no,
            GetApsString($val)
        );
        $result = regdb_exec($con, $sql);
        $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
        if($check->is_error){
            return $check;
        }
    }
    
    return new DB_RESULT_INFO(false, null, 1);
}

?>