<?php
//$Id: sdb_form_ops0206.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $

/**
* GetApplyForm_OPS0206
* @desc (桼)μ
* @param DB³ϥɥ
* @param No
* @param ߤǡΥ̾
* @param ߤǡΥ̾(֥ơ֥)
* @return DB_RESULT_INFO¤
*/
function GetApplyForm_OPS0206($con, $accept_id, $selcol, $sub_selcol){
  //ؿGetAcceptIDNumberFromRCVFormatΥ:RCVοֹ椫Ф
  $accept_num = GetAcceptIDNumberFromRCVFormat($accept_id);

  if($sub_selcol != "")
  {
    //ؿDBAPI_subtable_map_form_to_array_OPS0206Υ:ɽSDB_FORM_OPS0206Υ֥ơ֥°бɽ
    $tablemap = DBAPI_subtable_map_form_to_array_OPS0206($sub_selcol);
    //ؿDBAPI_pg_select_sdb_subtablesΥ:ƥ֥ơ֥򸡺Ʒ̤
    if(count($tablemap) >= 1)
    {
      $result = DBAPI_pg_select_sdb_subtables($con, $accept_num, $tablemap,__FILE__,__LINE__);
      //ؿͤĴ٤ƥ顼ǤХ顼֤
      if ($result->is_error) return $result;
      $subtable = $result->db_result_info;
    }
  }

  if(is_array($subtable) == false)
  {
    $subtable = array();
  }

  if($selcol != "")
  {
    //ؿDBAPI_pg_get_SDB_FORMΥ:ɽSDB_FORM_OPS0206긡ԤեɤͤϢ
    $result = DBAPI_pg_get_SDB_FORM($con, "sdb_form_ops0206", $accept_num, $selcol, __FILE__, __LINE__);
    //ؿͤĴ٤ƥ顼ǤХ顼֤
    if ($result->is_error) return $result;
    $form = $result->db_result_info;
  }
  else
  {
    $form = array();
  }

  //ؿGetAcceptIDRCVFromNumberΥ:RCVοֹ
  $form['accept_id'] = GetAcceptIDRCVFromNumber($accept_num);
  $form = array_merge($form, $subtable);
  //̤֤
  return new DB_RESULT_INFO(false, null, new SDB_FORM_OPS0206($form));
}

/**
* DBAPI_table_map_form_to_array_OPS0206
* @desc SDB_FORM_OPS0206Υ饹ȥơ֥бɽ
* @param (桼)
* @param Noʬ
* @return SDB_FORM_OPS0206Υ饹ȥơ֥бɽ
*/
function DBAPI_table_map_form_to_array_OPS0206(&$form, $accept_num){
  return array(
  "accept_id" => $accept_num,
  "network_name" => $form->network_name,
  "organization_jp" => $form->organization_jp,
  "organization_en" => $form->organization_en,
  "postal_code_number" => $form->postal_code_number,
  "address_jp" => $form->address_jp,
  "address_en" => $form->address_en
    );
}
/**
* DBAPI_subtable_map_form_to_array_OPS0206
* @desc ɽSDB_FORM_OPS0206Υ֥ơ֥°бɽ
* @param ߤǡΥ̾(֥ơ֥)
* @return ơ֥̾°Ф
*/
function DBAPI_subtable_map_form_to_array_OPS0206($sub_selcol=""){
  $ret_array = array();
  if($sub_selcol == "")
  {
  	$sub_selcol = "ip_network_number, technical_responsibility, mail_address";
  }
  if(substr_count($sub_selcol, "ip_network_number") >= 1)
  {
    $ret_array["ip_network_number"] = array("sdb_form_ip_network_number", "ip_network_number");
  }
  if(substr_count($sub_selcol, "technical_responsibility") >= 1)
  {
    $ret_array["technical_responsibility"] = array("sdb_form_technical_resp", "technical_responsibility");
  }
  if(substr_count($sub_selcol, "mail_address") >= 1)
  {
    $ret_array["mail_address"] = array("sdb_form_mail_address", "mail_address");
  }
  return $ret_array;
}
/**
* CreateApplyForm_OPS0206
* @desc (桼)򿷵
* @param DB³ϥɥ
* @param SDB_APPLY_INFO¤
* @param SDB_FORM_OPS0206¤
* @return No
*/
function CreateApplyForm_OPS0206($con, &$apply_info, &$form){
  $now = date("Y-m-d H:i:s T");
  //(븵Ǻǡɬʬ)
  //apply_dateåȤƤʤȤΤAPIȤ
  if($apply_info->apply_date == ""){
    $apply_info->apply_date = $now;
  }
  $apply_info->clerk_id = "SYSTEM";  //SYSTEM
  $apply_info->apply_kind_id = "ops0206";
  $apply_info->status = "fixed";
  $apply_info->settlement_id = "SYSTEM";  //SYSTEM
  if($apply_info->settlement_date == ""){
    $apply_info->settlement_date = $now;
  }
  if($apply_info->final_reply == ""){
    $apply_info->final_reply = $now;
  }

  //ؿCreateApplyInfoΥ:ܾ
  $result = CreateApplyInfo($con, $apply_info);
  //ؿͤĴ٤ƥ顼ǤХ顼֤
  if ($result->is_error) return $result;

  $form->accept_id = $result->db_result_info;
  //ؿGetAcceptIDNumberFromRCVFormatΥ:RCVοֹ椫Ф
  $accept_num = GetAcceptIDNumberFromRCVFormat($result->db_result_info);

  //ؿDBAPI_table_map_form_to_array_OPS0206Υ:SDB_FORM_OPS0206Υ饹ȥơ֥бɽ
  $data = DBAPI_table_map_form_to_array_OPS0206($form, $accept_num);

  //ؿDBAPI_pg_insert_SDB_FORMΥ:ɽSDB_FORM_OPS0206곺Ԥ
  $result = DBAPI_pg_insert_SDB_FORM($con, "sdb_form_ops0206", $data,__FILE__,__LINE__);
  //ؿͤĴ٤ƥ顼ǤХ顼֤
  if ($result->is_error) return $result;

  //ؿDBAPI_subtable_insert_OPS0206Υ:ɽSDB_FORM_OPS0206Υ֥ơ֥˳Ԥ
  $result = DBAPI_subtable_insert_OPS0206($con, $accept_num, $form,__FILE__,__LINE__);
  //ؿͤĴ٤ƥ顼ǤХ顼֤
  if ($result->is_error) return $result;

  //̤֤֤ΤϼNoοʬΤ
  return new DB_RESULT_INFO(false, null, $accept_num);
}

/**
* SaveApplyForm_OPS0206
* @desc (桼)ι
* @param DB³ϥɥ
* @param (桼)
* @param ¸̾
* @param ¸̾(֥ơ֥)
* @return true/false
*/
function SaveApplyForm_OPS0206($con, $form, $selcol, $sub_selcol){
  $accept_id = $form->accept_id;
  //ؿGetAcceptIDNumberFromRCVFormatΥ:RCVοֹ椫Ф
  $accept_num = GetAcceptIDNumberFromRCVFormat($accept_id);

  //ؿDBAPI_table_map_form_to_array_OPS0206Υ:SDB_FORM_OPS0206Υ饹ȥơ֥бɽ
  $data = DBAPI_table_map_form_to_array_OPS0206($form, $accept_num);

  if($selcol != "")
  {
    foreach(explode(",", $selcol) as $key => $value)
    {
      $data_conv[$value] = $data[$value];
    }

    //ؿDBAPI_pg_update_SDB_FORMΥ:ɽSDB_FORM_OPS0206곺Ԥ򹹿
    $result = DBAPI_pg_update_SDB_FORM($con, "sdb_form_ops0206", $accept_num, $data_conv,__FILE__,__LINE__);
    //ؿͤĴ٤ƥ顼ǤХ顼֤
    if ($result->is_error) return $result;
  }

  if($sub_selcol != "")
  {
    //ؿDBAPI_subtable_map_form_to_array_OPS0206Υ:ɽSDB_FORM_OPS0206Υ֥ơ֥°бɽ
    $tablemap = DBAPI_subtable_map_form_to_array_OPS0206($sub_selcol);
    $result = DBAPI_pg_delete_sdb_subtables($con, $accept_num, $tablemap,__FILE__,__LINE__);
    //ؿͤĴ٤ƥ顼ǤХ顼֤
    if ($result->is_error) return $result;

    //ؿDBAPI_subtable_insert_OPS0206Υ:ɽSDB_FORM_OPS0206Υ֥ơ֥˳Ԥ
    DBAPI_subtable_insert_OPS0206($con, $accept_num, $form, __FILE__, __LINE__, $sub_selcol);
    //ؿͤĴ٤ƥ顼ǤХ顼֤
    if ($result->is_error) return $result;
  }

  //̤֤
  return new DB_RESULT_INFO(false, null, true);
}

/**
* DBAPI_subtable_insert_OPS0206
* @desc (桼)륵֥ơ֥ιԤ
* @param DB³ϥɥ
* @param Noʬ
* @param (桼)
* @param ե̾
* @param ץ೺ֹ
* @param ¸̾(֥ơ֥)
* @return true/false
*/
function DBAPI_subtable_insert_OPS0206($con, $accept_num, &$form, $file, $line, $sub_selcol=""){
  $result = true;
  //ؿDBAPI_subtable_map_form_to_array_OPS0206Υ:ɽSDB_FORM_OPS0206Υ֥ơ֥°бɽ
  $tablemap = DBAPI_subtable_map_form_to_array_OPS0206($sub_selcol);
  foreach ($tablemap as $attrname => $tblname){
    $result = DBAPI_pg_insert_SDB_ARRAY($con, $tblname[0], $accept_num, $tblname[1], $form->$attrname,$file,$line);
    //ؿͤĴ٤ƥ顼ǤХ顼֤
    if ($result->is_error) return $result;
  }

  //̤֤
  return $result;
}

?>
