<?php
/**
 * $Id: RegIPrevConf.php,v 1.1 2004/03/08 13:25:40 yoshi_s Exp $
 */
?>
<?php
//----------------------------------------------------------------------------
// require
//----------------------------------------------------------------------------
require_once("RegAppInputCheck.php");			// ϥå
require_once("RegIpv6AddressUtil.php");			// IPv6ɥ쥹桼ƥƥ

//----------------------------------------------------------------------------
// define
//----------------------------------------------------------------------------
//----- config file name -----//
define("DNS_CONF_FILE", "dns_iprev_gen.ini");

//----- DNS_CONF_FILE(dns file create setting) -----//
// zoneեѥǥ쥯ȥ
define("CURZONE", "DIR_CURRENT_ZONE");
define("NEWZONE", "DIR_NEW_ZONE");
// confեѥǥ쥯ȥ
define("CURCONF", "DIR_CURRENT_NAMED_CONF");
define("NEWCONF", "DIR_NEW_NAMED_CONF");
// zone
define("DELZONE", "DIR_DELETE_ZONE");
define("DELCONF", "DIR_DELETE_CONF");
// ץ饤ޥDNSо
define("MAS_FILE", "MASTER_CONF_FILENAME");
define("MAS_TEMP", "MASTER_CONF_TEMPLATE");
define("MAS_ZONE", "MASTER_CONF_ZONE_DIR");
// DNSо
define("SLA_FILE", "SLAVE_CONF_FILENAME");
define("SLA_TEMP", "SLAVE_CONF_TEMPLATE");
define("SLA_ZONE", "SLAVE_CONF_ZONE_DIR");
define("SLA_MAS", "SLAVE_CONF_MASTERS");
// zoneեإå
define("ZONE_HEAD", "ZONE-HEAD");
// SOA쥳ɾ
define("SOA_ORIGIN", "SOA-ORIGIN");
define("SOA_MAIL", "SOA-MAIL-ADDR");
define("SOA_REFRESH", "SOA-REFRESH");
define("SOA_RETRY", "SOA-RETRY");
define("SOA_EXPIRE", "SOA-EXPIRE");
define("SOA_TTL", "SOA-TTL");
// AUTH NS
define("AUTH_NS", "AUTH-NS");
// special info
define("HIDE_LS", "DNS_NOT_OUTPUT_ADDRESS");
define("ADD_LS", "SPECIAL_ADD_ZONE_FILE");
// update command
define("CMD_RMALL", "CMD_RM_ALL");
define("CMD_CPALL", "CMD_COPY_ALL");
define("CMD_DF", "CMD_DIFF");
define("CMD_DFOPT", "CMD_DIFF_OPT");

//----- DNS_CONF_FILE(dns upload(cron server to rev dns server)) -----//
// upload command
define("CMD_SSH", "CMD_SSH");
define("CMD_SUDO", "CMD_SUDO");
define("CMD_RSYNC", "CMD_RSYNC");
// dest host
define("DEST_HOST", "DEST_HOST");
define("DEST_ZONE", "DEST_ZONE_DIR");
define("DEST_CONF", "DEST_CONF_DIR");

//----- DNS_CONF_FILE(dns upload(rev dns server setting)) -----//
define("CMD_RELOAD", "CMD_NAMED_RELOAD");

//----- special add file -----//
// zone
define("SEC_ZONE", "zone");
define("ZONE_IP", "ip_address");
// rev
define("SEC_REV", "rev_dns");
define("REV_IP", "ip_address");
define("REV_NS", "name_server");

// 꿶֥åФNameserver
define("CONF_SERVER_MAX", 10);
?>
<?php
//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegIPrevConf
{
	//-----------------------------------------------------------------------
	// ѿ
	//-----------------------------------------------------------------------
	/**
	 * config եϥå奭ꥹ
	 */
	var $m_conf_key;

	/**
	 * config եǥե
	 */
	var $m_def_conf;

	/**
	 * config 
	 */
	var $m_conf_data;

	//----- AUTH NS -----//
	/**
	 * AUTH-NS iniեΥ޶ڤǡǤ˳Ǽ
	 * array([0]=>authns, [1]=>authns, ...)
	 */
	var $m_auth_ns;

	//----- special info -----//
	/**
	 * DBϿƤƤ zone, ns쥳 ˽Ϥʤɥ쥹֥å
	 *   array(
	 *     [0] => array([0] => start_seq(str), [1] => end_seq(str), [2] => prefix_length),
	 *     [1] => array([0] => start_seq(str), [1] => end_seq(str), [2] => prefix_length),
	 *     [2] => array([0] => start_seq(str), [1] => end_seq(str), [2] => prefix_length),
	 *             ...
	 *   );
	 */
	var $m_hide_list;

	/**
	 * DBϿʤƤ Ϥ zone 
	 */
	var $m_add_zone_list;

	/**
	 * DBϿʤƤ Ϥ NS쥳 
	 */
	var $m_add_ns_list;

	//----- message -----//
	/**
	 * åꥹ
	 */
	var $m_iprev_msg;

	/**
	 * åϿʸ
	 */
	var $m_log_msg;

	/**
	 * debugåϿʸ
	 */
	var $m_debug_msg;

	/**
	 * debug ե饰
	 */
	var $m_debug_flag;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegIPrevConf
	 *   RegIPrevConf饹󥹥ȥ饯
	 * @param  $iprev_msg    åꥹ				(i)
	 * @param  $debug_flag   ǥХåե饰(def=FALSE)	 	(i)
	 */
	function RegIPrevConf($iprev_msg, $debug_flag=FALSE)
	{
		// եǡΥ
		$this->m_conf_key = array(
			// dns file create setting
			CURZONE,
			NEWZONE,
			CURCONF,
			NEWCONF,
			DELZONE,
			DELCONF,
			MAS_FILE,
			MAS_TEMP,
			MAS_ZONE,
			SLA_FILE,
			SLA_TEMP,
			SLA_ZONE,
			SLA_MAS,
			ZONE_HEAD,
			SOA_ORIGIN,
			SOA_MAIL,
			SOA_REFRESH,
			SOA_RETRY,
			SOA_EXPIRE,
			SOA_TTL,
			AUTH_NS,
			HIDE_LS,
			ADD_LS,
			CMD_RMALL,
			CMD_CPALL,
			CMD_DF,
			CMD_DFOPT,
			// dns upload(cron server to rev dns server)
			CMD_SSH,
			CMD_SUDO,
			CMD_RSYNC,
			DEST_HOST,
			DEST_ZONE,
			DEST_CONF,
			// dns upload(rev dns server setting)
			CMD_RELOAD,
		);

		// եǥե
		$this->m_def_conf = array(
			// dns file create setting
			CURZONE		=>	"zone",
			NEWZONE		=>	"new-zone",
			CURCONF		=>	"named-conf",
			NEWCONF		=>	"new-named-conf",
			DELZONE		=>	"del-zone",
			DELCONF		=>	"del-named-conf",
			MAS_FILE	=>	"MASTER-INADDR-JP.conf",
			MAS_TEMP	=>	"MASTER-TEMP.txt",
			MAS_ZONE	=>	"DB",
			SLA_FILE	=>	"SLAVE-INADDR-JP.conf",
			SLA_TEMP	=>	"SLAVE-TEMP.txt",
			SLA_ZONE	=>	"bak",
			SLA_MAS		=>	"202.12.30.131",
			ZONE_HEAD	=>	"\$TTL    3600",
			SOA_ORIGIN	=>	"ns0.nic.ad.jp",
			SOA_MAIL	=>	"webmaster.fbweb.v6nic.jp",
			SOA_REFRESH	=>	"3600",
			SOA_RETRY	=>	"900",
			SOA_EXPIRE	=>	"604800",
			SOA_TTL		=>	"86400",
			AUTH_NS		=>	"ns0.nic.ad.jp,ns.wide.ad.jp,ns0.iij.ad.jp,dns0.spin.ad.jp,ns-jp.sinet.ad.jp,ns-jp.nic.ad.jp",
			HIDE_LS		=>	"",
			ADD_LS		=>	"",
			CMD_RMALL	=>	"/bin/rm -R",
			CMD_CPALL	=>	"/bin/cp -R",
			CMD_DF		=>	"/usr/bin/diff",
			CMD_DFOPT	=>	"-I '; Serial' -I ';; \$Id' -I '// \$Id'",
			// dns upload(cron server to rev dns server)
			CMD_SSH		=>	"/usr/bin/ssh",
			CMD_SUDO	=>	"/usr/local/bin/sudo",
			CMD_RSYNC	=>	"/usr/local/bin/rsync",
			DEST_HOST	=>	"localhost",
			DEST_ZONE	=>	"/usr/tmp/v6pc-tool/dnscron/DB",
			DEST_CONF	=>	"/usr/tmp/v6pc-tool/dnscron/conf",
			// dns upload(rev dns server setting)
			CMD_RELOAD	=>	"/usr/tmp/v6pc-tool/dnscron/gen_reload.sh",
		);

		// inc0103ѥåꥹ
		$this->m_iprev_msg	= $iprev_msg;
		// å
		$this->m_log_msg	= "";
		// ǥХåå
		$this->m_debug_msg	= "";
		// ǥХåե饰
		$this->m_debug_flag	= $debug_flag;
	}

	//-----------------------------------------------------------------------
	// public methods
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_config_data
	 *   ini ե뤫ɤ߽Фѿ˥åȤ
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN50	config ե뤬¸ߤʤ
	 *		         IPREV_GEN51	DNS_NOT_OUTPUT_ADDRESS 㤤
	 *               IPREV_GEN52	special add file 㤤
	 *               IPREV_GEN53	special add file ʤ
	 *               IPREV_GEN54	special add zoneipʤ
	 *               IPREV_GEN55	special add zoneip㤤
	 *               IPREV_GEN56	special add dnsipʤ
	 *               IPREV_GEN57	special add dnsip㤤
	 *               IPREV_GEN58	special add dnsipzoneipˤʤ
	 *               IPREV_GEN59	special add nameserver㤤
	 *               IPREV_GEN60	special add nameserverʤ
	 *               IPREV_GEN61	special add dnsip overlap
	 *               IPREV_GEN62	special add zoneip overlap
	 *               IPREV_GEN66	AUTH-NS ͤꤵƤʤ
	 *               IPREV_GEN67	AUTH-NS եޥåȥ顼
	 *               IPREV_GEN99	fatal error
	 */
	function get_config_data()
	{
		//--------------------------------------------------------------------
		// iniեɤ߹
		//--------------------------------------------------------------------
		if (!file_exists(DNS_CONF_FILE))
		{
			$this->clear_config_data();
			$this->set_log_msg(IPREV_GEN50, "");
			return IPREV_GEN50;
		}
		$tmp_conf = parse_ini_file(DNS_CONF_FILE, FALSE);

		//--------------------------------------------------------------------
		// configǡå
		//--------------------------------------------------------------------
		// ե򥻥åȡϿʤξϥǥեͤ򥻥åȤ
		for ($n = 0; $n < count($this->m_conf_key); $n++)
		{
			if (isset($tmp_conf[$this->m_conf_key[$n]]) && trim($tmp_conf[$this->m_conf_key[$n]]) != "")
			{
				$this->m_conf_data[$this->m_conf_key[$n]] = trim($tmp_conf[$this->m_conf_key[$n]]);
			}
			else
			{
				$this->m_conf_data[$this->m_conf_key[$n]] = $this->m_def_conf[$this->m_conf_key[$n]];
				$this->set_debug_msg(IPREV_GEN63, array($this->m_conf_key[$n]));
			}
		}

		//--------------------------------------------------------------------
		// üǡѿ˳Ǽ
		//--------------------------------------------------------------------
		$result = IPREV_GEN00;

		//----- AUTH_NS -----//
		$result = $this->set_auth_ns($this->m_conf_data[AUTH_NS], $this->m_auth_ns);
		switch ($result)
		{
		case IPREV_GEN00:
			$this->set_debug_msg(IPREV_GEN68, array(count($this->m_auth_ns)));
			break;
		case IPREV_GEN66:		// AUTH-NSʤ
		case IPREV_GEN67:		// AUTH-NSեޥåȥ顼
			$this->clear_config_data();
			return $result;
		default:
			$this->clear_config_data();
			$this->set_log_msg(IPREV_GEN99, "");
			return IPREV_GEN99;
		}

		//----- DNS_NOT_OUTPUT_ADDRESS -----//
		$result = $this->set_hide_list($this->m_conf_data[HIDE_LS], $this->m_hide_list);
		switch ($result)
		{
		case IPREV_GEN00:
			$this->set_log_msg(IPREV_GEN64, array(count($this->m_hide_list)));
			break;
		case IPREV_GEN51:		// եޥåȥ顼
			$this->clear_config_data();
			return $result;
		default:
			$this->clear_config_data();
			$this->set_log_msg(IPREV_GEN99, "");
			return IPREV_GEN99;
		}

		//----- SPECIAL_ADD_ZONE_FILE -----//
		$result = $this->set_add_list($this->m_conf_data[ADD_LS],
									  $this->m_add_zone_list,
									  $this->m_add_ns_list);
		switch ($result)
		{
		case IPREV_GEN00:
			$this->set_log_msg(IPREV_GEN65,
							   array(("zone:" . count($this->m_add_zone_list)),
							   		 ("ns:" . count($this->m_add_ns_list)),)
							   );
			break;

		case IPREV_GEN52:		// special add file 㤤
		case IPREV_GEN53:		// special add file ʤ
		case IPREV_GEN54:		// special add zoneipʤ
		case IPREV_GEN55:		// special add zoneip㤤
		case IPREV_GEN56:		// special add dnsipʤ
		case IPREV_GEN57:		// special add dnsip㤤
		case IPREV_GEN58:		// special add dnsipzoneipˤʤ
		case IPREV_GEN59:		// special add nameserver㤤
		case IPREV_GEN60:		// special add nameserverʤ
		case IPREV_GEN61:		// special add dnsip overlap
		case IPREV_GEN62:		// special add zoneip overlap
			$this->clear_config_data();
			return $result;

		case IPREV_GEN99:
		default:
			$this->clear_config_data();
			$this->set_log_msg(IPREV_GEN99, "");
			return IPREV_GEN99;
		}

		return IPREV_GEN00;
	}

	/**
	 * ؿ̾clear_config_data
	 *   
	 */
	function clear_config_data()
	{
		$this->m_conf_data		= array();
		$this->m_auth_ns		= array();
		$this->m_hide_list		= array();
		$this->m_add_zone_list	= array();
		$this->m_add_ns_list	= array();
	}

	//-----------------------------------------------------------------------
	// public methodsʥ桼ƥƥ
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾set_log_msg
	 *   åɲä
	 * @param $msg_id	åID
	 * @param $options	ץǡʸ
	 *					åθ [0][1]... ղä
	 */
	function set_log_msg($msg_id, $options="")
	{
		$this->m_log_msg .= $this->m_iprev_msg[$msg_id];
		if (is_array($options))
		{
			for ($n = 0; $n < count($options); $n++)
			{
				if ($options[$n] !== "")
				{
					if (substr($options[$n], -1) == "\n")
						$this->m_log_msg .= " [" . substr($options[$n], 0, -1) . "]";
					else
						$this->m_log_msg .= " [" . $options[$n] . "]";
				}
			}
		}
	}

	/**
	 * ؿ̾get_log_msg
	 *   å
	 * @return å
	 */
	function get_log_msg()
	{
		return $this->m_log_msg;
	}

	/**
	 * ؿ̾set_debug_msg
	 *   ǥХååɲäm_debug_flag == true Τߡ
	 * @param $msg_id	åID
	 * @param $options	ץǡʸ
	 *					åθ [0][1]... ղä
	 */
	function set_debug_msg($msg_id, $options)
	{
		if ($this->m_debug_flag)
		{
			$this->m_debug_msg .= $this->m_iprev_msg[$msg_id];
			if (is_array($options))
			{
				for ($n = 0; $n < count($options); $n++)
				{
					if ($options[$n] !== "")
					{
						if (substr($options[$n], -1) == "\n")
							$this->m_debug_msg .= " [" . substr($options[$n], 0, -1) . "]";
						else
							$this->m_debug_msg .= " [" . $options[$n] . "]";
					}
				}
			}
		}
	}

	/**
	 * ؿ̾get_debug_msg
	 *   ǥХååm_debug_flag == true Τߡ
	 * @return ǥХåʸ
	 */
	function get_debug_msg()
	{
		if ($this->m_debug_flag && $this->m_debug_msg != "")
		{
			$this->m_debug_msg =
						"\n\n-------------[config debug msg START]-------------\n" .
						$this->m_debug_msg .
						"\n\n-------------[config debug msg END]-------------\n";
		}
		else
		{
			return "";
		}
		return $this->m_debug_msg;
	}

	//-----------------------------------------------------------------------
	// private methods
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾set_auth_ns
	 *   configեꤵ줿 AUTH-NS 򥫥ޤʬ䤷˳Ǽ
	 * @param  $conf_data   configե    (i)
	 * @param  $res_data    ʬ̤        (i/o)
	 * @return IPREV_GEN00
	 *         ԡIPREV_GEN66	AUTH-NS ͤꤵƤʤ
	 *               IPREV_GEN67	AUTH-NS եޥåȥ顼
	 * @desc   ʸ󤬶ξ array() Ͽ
	 */
	 
	function set_auth_ns($conf_data, &$res_data)
	{
		$res_data	= array();
		$tmp_data	= array();
		if ($conf_data == "")
		{
			$this->set_log_msg(IPREV_GEN66, "");
			return IPREV_GEN66;
		}

		$tmp_data = explode(",", $conf_data);
		for ($n = 0; $n < count($tmp_data); $n++)
		{
			$tmp_auth = trim($tmp_data[$n]);
			if ($tmp_auth != "")
			{
				if (chk_nameserver($tmp_auth) != REG_APP_INPUT_CHK_OK)
				{
					$this->set_log_msg(IPREV_GEN67, array($tmp_auth));
					return IPREV_GEN67;
				}
				array_push($res_data, $tmp_auth);
			}
		}
		if (count($res_data) == 0)
		{
			$this->set_log_msg(IPREV_GEN66, "");
			return IPREV_GEN66;
		}

		return IPREV_GEN00;
	}

	/**
	 * ؿ̾set_hide_list
	 *   configեꤵ줿 DNS_NOT_OUTPUT_ADDRESS Ϥƥɥ쥹ǡϿ
	 * @param  $conf_data   configե    (i)
	 * @param  $res_data    ɥ쥹ǡ          (i/o)
	 *         array(
	 *            [0] => array([0] => start_seq(str), [1] => end_seq(str), [2] => prefix_length),
	 *            [1] => array([0] => start_seq(str), [1] => end_seq(str), [2] => prefix_length),
	 *            [2] => array([0] => start_seq(str), [1] => end_seq(str), [2] => prefix_length),
	 *                     ...
	 *         );
	 * @return IPREV_GEN00
	 *         ԡIPREV_GEN51	DNS_NOT_OUTPUT_ADDRESS 㤤
	 */
	function set_hide_list($conf_data, &$res_data)
	{
		$res_data	= array();
		if ($conf_data == "")
			return IPREV_GEN00;

		$conf_ls = explode(",", $conf_data);	// ޤʬ䤹

		$cnt = count($conf_ls);
		for ($n = 0; $n < $cnt; $n++)
		{
			$tmp_addr = trim($conf_ls[$n]);
			// å
			if ($tmp_addr == "")
				continue;
			if (chk_ipaddress($tmp_addr) != REG_APP_INPUT_CHK_OK)
			{
				$this->set_log_msg(IPREV_GEN51, array(("ip:" . $tmp_addr)));
				return IPREV_GEN51;
			}
			// ϡλֹ
			$tmp_info = RegIpv6AddressUtil::get_sequence_num($tmp_addr, "str");
			if ($tmp_info == FALSE)
			{
				$this->set_log_msg(IPREV_GEN51, array(("ip:" . $tmp_addr)));
				return IPREV_GEN51;
			}

			// ɲäʤꥹȤ˥ɥ쥹push
			array_push($res_data, $tmp_info);
		}

		return IPREV_GEN00;
	}

	/**
	 * ؿ̾set_add_list
	 *   configեꤵ줿 SPECIAL_ADD_ZONE_FILE Ϥ ZONE,NS Ͽ
	 * @param  $conf_data		configե(ɲΥե̾ꥹ)	(i)
	 * @param  $res_zone_list	ɲzoneǼ								(i/o)
	 *         array(
	 *              [0] => array([DB_ZONE_IP]     => IPv6 address,
	 *                           [DB_ZONE_PREFIX] => Prefix length,
	 *                           [DB_ZONE_START]  => start sequence number,
	 *                           [DB_ZONE_END]    => end sequence number,),
	 *                 ...
	 *         )
	 * @param  $res_ns_list		ɲnsǼ								(i/o)
	 *         array(
	 *              [0] => array([DB_ZONE_IP]     => zone IPv6 address,
	 *                           [DB_ZONE_PREFIX] => zone Prefix length,
	 *                           [DB_ZONE_START]  => zone start sequence number,
	 *                           [DB_ZONE_END]    => zone end sequence number,
	 *                           [DB_DNS_IP]      => ns IPv6 address,
	 *                           [DB_DNS_PREFIX]  => ns Prefix length,
	 *                           [DB_DNS_START]   => ns start sequence number,
	 *                           [DB_DNS_END]     => ns end sequence number,
	 *                           [DB_NS_LIST]     => ns name server list (array(nameserver, nameserver, ...))),
	 *                 ...
	 *         )
	 * @return IPREV_GEN00
	 *         ԡIPREV_GEN52	special add file 㤤
	 *               IPREV_GEN53	special add file ʤ
	 *               IPREV_GEN54	special add zoneipʤ
	 *               IPREV_GEN55	special add zoneip㤤
	 *               IPREV_GEN56	special add dnsipʤ
	 *               IPREV_GEN57	special add dnsip㤤
	 *               IPREV_GEN58	special add dnsipzoneipˤʤ
	 *               IPREV_GEN59	special add nameserver㤤
	 *               IPREV_GEN60	special add nameserverʤ
	 *               IPREV_GEN61	special add dnsip overlap
	 *               IPREV_GEN62	special add zoneip overlap
	 *               IPREV_GEN99	fatal error
	 */
	function set_add_list($conf_data, &$res_zone_list, &$res_ns_list)
	{
		$res_zone_list	= array();		// zone
		$res_ns_list	= array();		// ns

		$tmp_conf			= "";
		$tmp_info			= array();	// work special add ini file info
		$tmp_zone			= array();	// work zone ip address info
		$tmp_zone_ip_list	= array();	// work zone ip address list

		if ($conf_data == "")
			return IPREV_GEN00;

		//--------------------------------------------------------------------
		// ե̾ڤФ
		//--------------------------------------------------------------------
		$conf_ls = explode(",", $conf_data);	// ޤʬ䤹

		//--------------------------------------------------------------------
		// եñ̤Ǿɹ
		//--------------------------------------------------------------------
		$cnt = count($conf_ls);
		for ($n = 0; $n < $cnt; $n++)
		{
			$tmp_conf = trim($conf_ls[$n]);
			if (trim($tmp_conf) == "")
				continue;		// ե̾ʤ

			// ե̾å
			if (chk_filename(basename($tmp_conf)) != REG_APP_INPUT_CHK_OK)
			{
				$this->set_log_msg(IPREV_GEN52, array(basename($tmp_conf)));
				return IPREV_GEN52;
			}
			if (!file_exists($tmp_conf))
			{
				$this->set_log_msg(IPREV_GEN53, array(basename($tmp_conf)));
				return IPREV_GEN53;
			}

			// iniեɤ߹
			$tmp_info = parse_ini_file($tmp_conf, TRUE);

			//----------------------------------------------------------------
			// zone, ns եʬϿƥꥹȤɲ
			//----------------------------------------------------------------
			$result = $this->get_add_ns_info($tmp_info, $tmp_zone, $tmp_ns_list, $tmp_conf);
			switch ($result)
			{
			case IPREV_GEN00:
				for ($res_cnt = 0; $res_cnt < count($tmp_ns_list); $res_cnt++)
				{
					array_push($res_ns_list, $tmp_ns_list[$res_cnt]);
				}

				array_push($res_zone_list, $tmp_zone);
				array_push($tmp_zone_ip_list, $tmp_zone[DB_ZONE_IP]);
				break;

			case IPREV_GEN54:		// special add zoneipʤ
			case IPREV_GEN55:		// special add zoneip㤤
			case IPREV_GEN56:		// special add dnsipʤ
			case IPREV_GEN57:		// special add dnsip㤤
			case IPREV_GEN58:		// special add dnsipzoneipˤʤ
			case IPREV_GEN59:		// special add nameserver㤤
			case IPREV_GEN60:		// special add nameserverʤ
			case IPREV_GEN61:		// special add dnsip overlap
				return $result;

			case IPREV_GEN99:		// fatal error
			default:
				return IPREV_GEN99;
			}
		}

		//--------------------------------------------------------------------
		// zone ip address ʣå
		//--------------------------------------------------------------------
		if (count($tmp_zone_ip_list) > 0 && RegIpv6AddressUtil::chk_ipblock_array_overlap($tmp_zone_ip_list))
		{
			// ʣΤϿʤ
			$this->set_log_msg(IPREV_GEN62, "");
			return IPREV_GEN62;
		}

		return IPREV_GEN00;
	}

	/**
	 * ؿ̾get_add_ns_info
	 *   
	 * @param  $ini_info    special add iniե(1եʬ)        (i)
	 * @param  $res_zone    ɲzoneǼ                            (i/o)
	 *              array([DB_ZONE_IP]     => IPv6 address,
	 *                    [DB_ZONE_PREFIX] => Prefix length,
	 *                    [DB_ZONE_START]  => start sequence number,
	 *                    [DB_ZONE_END]    => end sequence number
	 *              )
	 * @param  $res_ns_list ɲnsǼ                              (i/o)
	 *          array(
	 *              [0]=>array([DB_ZONE_IP]     => zone IPv6 address,
	 *                         [DB_ZONE_PREFIX] => zone Prefix length,
	 *                         [DB_ZONE_START]  => zone start sequence number,
	 *                         [DB_ZONE_END]    => zone end sequence number,
	 *                         [DB_DNS_IP]      => ns IPv6 address,
	 *                         [DB_DNS_PREFIX]  => ns Prefix length,
	 *                         [DB_DNS_START]   => ns start sequence number,
	 *                         [DB_DNS_END]     => ns end sequence number,
	 *                         [DB_NS_LIST]     => ns name server list (array(nameserver, nameserver, ...))),
	 *              [1]=>.....,
	 *              ...,
	 *          )
	 * @param  $file_name   special add iniե̾(1եʬ)            (i)
	 * @return IPREV_GEN00
	 *         ԡIPREV_GEN54	special add zoneipʤ
	 *               IPREV_GEN55	special add zoneip㤤
	 *               IPREV_GEN56	special add dnsipʤ
	 *               IPREV_GEN57	special add dnsip㤤
	 *               IPREV_GEN58	special add dnsipzoneipˤʤ
	 *               IPREV_GEN59	special add nameserver㤤
	 *               IPREV_GEN60	special add nameserverʤ
	 *               IPREV_GEN61	special add dnsip overlap
	 *               IPREV_GEN99	fatal error
	 */
	function get_add_ns_info($ini_info, &$res_zone, &$res_ns_list, $file_name="")
	{
		$tmp_zone		= array();		// work zone ip address info
		$tmp_ns			= array();		// work ns ip address info(1Ĥns)
		$tmp_ns_ip_list	= array();		// work ns ip address list(ns)

		$res_zone		= array();
		$res_ns_list	= array();

		$result = IPREV_GEN00;
		//--------------------------------------------------------------------
		// zone 
		//--------------------------------------------------------------------
		if (isset($ini_info[SEC_ZONE]) && is_array($ini_info[SEC_ZONE]))
		{
			$result = $this->get_add_ns_info_zone($ini_info[SEC_ZONE], $tmp_zone, $file_name);
			switch ($result)
			{
			case IPREV_GEN00:
				$res_zone = $tmp_zone;
				break;
			case IPREV_GEN55:		// special add zoneip㤤
				return $result;
			default:
				return IPREV_GEN99;
			}
		}
		else
		{
			$this->set_log_msg(IPREV_GEN54, array($file_name));
			return IPREV_GEN54;		// special add zoneipʤ
		}

		//--------------------------------------------------------------------
		// rev 
		//--------------------------------------------------------------------
		for ($rev_cnt = 1; ; $rev_cnt++)
		{
			$tmp_ns		= array();
			if (isset($ini_info[SEC_REV . $rev_cnt]) && is_array($ini_info[SEC_REV . $rev_cnt]))
			{
				$result = $this->get_add_ns_info_ns(
										$ini_info[SEC_REV . $rev_cnt],
										$res_zone,
										$tmp_ns,
										$file_name,
										$rev_cnt);
				switch ($result)
				{
				case IPREV_GEN00:
					break;
				case IPREV_GEN56:		// special add dnsipʤ
				case IPREV_GEN57:		// special add dnsip㤤
				case IPREV_GEN58:		// special add dnsipzoneipˤʤ
				case IPREV_GEN59:		// special add nameserver㤤
				case IPREV_GEN60:		// special add nameserverʤ
					return $result;
				default:
					return IPREV_GEN99;
				}

				if (is_array($tmp_ns) && count($tmp_ns) > 0)
				{
					// ns 򥻥å
					array_push($res_ns_list, $tmp_ns);
					// ns  ip address list ˥å
					array_push($tmp_ns_ip_list, $tmp_ns[DB_DNS_IP]);
				}
			}
			else
			{
				break;
			}
		}

		//--------------------------------------------------------------------
		// rev ip address ʣå
		//--------------------------------------------------------------------
		if (count($tmp_ns_ip_list) > 0 && RegIpv6AddressUtil::chk_ipblock_array_overlap($tmp_ns_ip_list))
		{
			// ʣΤϿʤ
			$this->set_log_msg(IPREV_GEN61, array($file_name));
			return IPREV_GEN61;			// special add dnsip overlap
		}

		return IPREV_GEN00;
	}

	/**
	 * ؿ̾get_add_ns_info_zone
	 *   
	 * @param  $ini_info    special add iniե [SEC_ZONE]ǡ(i)
	 * @param  $res_zone    ɲzoneǼ                            (i/o)
	 *              array([DB_ZONE_IP]     => IPv6 address,
	 *                    [DB_ZONE_PREFIX] => Prefix length,
	 *                    [DB_ZONE_START]  => start sequence number,
	 *                    [DB_ZONE_END]    => end sequence number
	 *              )
	 * @param  $file_name   special add iniե̾                         (i)
	 * @return IPREV_GEN00
	 *         ԡIPREV_GEN55	special add zoneip㤤
	 */
	function get_add_ns_info_zone($ini_info, &$res_zone, $file_name="")
	{
		$res_zone		= array();

		$tmp_zone_ip	= trim($ini_info[ZONE_IP]);
		$tmp_zone		= array();
		if (isset($tmp_zone_ip) != "" && chk_ipaddress($tmp_zone_ip) == REG_APP_INPUT_CHK_OK)
		{
			// ϡλֹ
			$tmp_zone = RegIpv6AddressUtil::get_sequence_num($tmp_zone_ip, "str");
			if ($tmp_zone == FALSE)
			{
				$this->set_log_msg(IPREV_GEN55, array(($file_name . " : " . $tmp_zone_ip)));
				return IPREV_GEN55;
			}
		}
		else
		{
			$this->set_log_msg(IPREV_GEN55, array(($file_name . " : " . $tmp_zone_ip)));
			return IPREV_GEN55;
		}

		//----- zone 򥻥å -----//
		$res_zone = $this->set_zone_for_db_format($tmp_zone_ip, $tmp_zone);

		return IPREV_GEN00;
	}


	/**
	 * ؿ̾get_add_ns_info_ns
	 *   
	 * @param  $ini_info    special add iniե [rev_dnsX]ǡ(i)
	 *                      [SEC_REV . n] ʬϤ
	 * @param  $res_zone    ɲzone                                      (i)
	 *              array([DB_ZONE_IP]     => IPv6 address,
	 *                    [DB_ZONE_PREFIX] => Prefix length,
	 *                    [DB_ZONE_START]  => start sequence number,
	 *                    [DB_ZONE_END]    => end sequence number
	 *              )
	 * @param  $res_ns      ɲnsǼ                              (i/o)
	 *              array([DB_ZONE_IP]     => zone IPv6 address,
	 *                    [DB_ZONE_PREFIX] => zone Prefix length,
	 *                    [DB_ZONE_START]  => zone start sequence number,
	 *                    [DB_ZONE_END]    => zone end sequence number,
	 *                    [DB_DNS_IP]      => ns IPv6 address,
	 *                    [DB_DNS_PREFIX]  => ns Prefix length,
	 *                    [DB_DNS_START]   => ns start sequence number,
	 *                    [DB_DNS_END]     => ns end sequence number,
	 *                    [DB_NS_LIST]     => ns name server list (array(nameserver, nameserver, ...))
	 *              )
	 * @param  $file_name   special add iniե̾                         (i)
	 * @param  $rev_cnt     rev_dns ֹ                            (i)
	 * @return IPREV_GEN00
	 *         ԡIPREV_GEN56	special add dnsipʤ
	 *               IPREV_GEN57	special add dnsip㤤
	 *               IPREV_GEN58	special add dnsipzoneipˤʤ
	 *               IPREV_GEN59	special add nameserver㤤
	 *               IPREV_GEN60	special add nameserverʤ
	 */
	function get_add_ns_info_ns($ini_info, $res_zone, &$res_ns, $file_name="", $rev_cnt=0)
	{
		$res_ns		= array();
		$tmp_ns_ip	= trim($ini_info[REV_IP]);	// name server ip address Ǽ

		//----- ip address ʤ -----//
		if ($tmp_ns_ip == "")
		{
			// name_server ꤵƤ뤫å
			for ($ns_cnt = 1; $ns_cnt < CONF_SERVER_MAX; $ns_cnt++)
			{
				$tmp_ns_str = trim($ini_info[REV_NS . $ns_cnt]);
				if ($tmp_ns_str == "")
					continue;
				// ip ꤻ ns ꤷƤΤǰ۾ｪλ
				$this->set_log_msg(IPREV_GEN56, array(($file_name . " : " . SEC_REV . $rev_cnt)));
				return IPREV_GEN56;				// special add dnsipʤ
			}
			// ip & ns ꤷƤʤｪλ
			return IPREV_GEN00;
		}
		//-----  ip address ꤢ -----//
		else if (chk_ipaddress($tmp_ns_ip) == REG_APP_INPUT_CHK_OK)
		{
			// ns쥳ɤΥɥ쥹 zone ϰϤ˴ޤޤ뤫ݤå
			switch (RegIpv6AddressUtil::chk_ipblock_overlap($tmp_ns_ip, $res_zone[DB_ZONE_IP]))
			{
			case 1:				// 
			case 3:				// zone ϰ
				break;
			default:			// ¾
				$this->set_log_msg(IPREV_GEN58, array(($file_name . " : " . SEC_REV . $rev_cnt)));
				return IPREV_GEN58;			// special add dnsipzoneipˤʤ
			}

			// ϡλֹ
			$tmp_ns = RegIpv6AddressUtil::get_sequence_num($tmp_ns_ip, "str");
			if ($tmp_ns == FALSE)
			{
				$this->set_log_msg(IPREV_GEN57, array(($file_name . " : " . SEC_REV . $rev_cnt)));
				return IPREV_GEN57;			// special add dnsip㤤
			}

			// name server̾ ɤ߹
			$tmp_ns_str_list = array();
			for ($ns_cnt = 1; $ns_cnt < CONF_SERVER_MAX; $ns_cnt++)
			{
				$tmp_ns_str = trim($ini_info[REV_NS . $ns_cnt]);
				if ($tmp_ns_str == "")
					continue;
				if (chk_nameserver($tmp_ns_str) != REG_APP_INPUT_CHK_OK)
				{
					$this->set_log_msg(
							IPREV_GEN59,
							array(($file_name . " : " . SEC_REV . $rev_cnt . " : " . REV_NS . $ns_cnt)));
					return IPREV_GEN59;		// special add nameserver㤤
				}
				array_push($tmp_ns_str_list, $tmp_ns_str);
			}
			//  name server ʤ
			if (count($tmp_ns_str_list) < 1)
			{
				$this->set_log_msg(IPREV_GEN60, array(($file_name . " : " . $rev_cnt)));
				return IPREV_GEN60;			// special add nameserverʤ
			}

			// ̳Ǽip & nsinfo
			$res_ns		= $this->set_ns_for_db_format($res_zone, $tmp_ns_ip, $tmp_ns, $tmp_ns_str_list);
		}
		//----- ۾ ip address ꤢ -----//
		else
		{
			$this->set_log_msg(IPREV_GEN57, array(($file_name . " : " . SEC_REV . $rev_cnt)));
			return IPREV_GEN57;				// special add dnsip㤤
		}

		return IPREV_GEN00;
	}


	/**
	 * ؿ̾set_zone_for_db_format
	 *   configե뤫ɤ߹ zone DB˹碌ƥåȤ
	 * @param  $zone_ip		zone  IPɥ쥹prefixɽ				(i)
	 * @param  $zone_info	zone 
	 *                      array([0] => start_seq(str), [1] => end_seq(str), [2] => prefix_length)
	 * @return DB
	 *         array([DB_ZONE_IP]     => IPv6 address,
	 *               [DB_ZONE_PREFIX] => Prefix length,
	 *               [DB_ZONE_START]  => start sequence number,
	 *               [DB_ZONE_END]    => end sequence number,
	 *         );
	 */
	function set_zone_for_db_format($zone_ip, $zone_info)
	{
		$db_form = array();
		$db_form[DB_ZONE_IP]		= $zone_ip;
		$db_form[DB_ZONE_PREFIX]	= $zone_info[2];
		$db_form[DB_ZONE_START]		= $zone_info[0];
		$db_form[DB_ZONE_END]		= $zone_info[1];
		return $db_form;
	}

	/**
	 * ؿ̾set_ns_for_db_format
	 *   configե뤫ɤ߹ ns DB˹碌ƥåȤ
	 * @param  $zone_info	zone 											(i)
	 *                      array([DB_ZONE_IP]     => IPv6 address,
	 *                            [DB_ZONE_PREFIX] => Prefix length,
	 *                            [DB_ZONE_START]  => start sequence number,
	 *                            [DB_ZONE_END]    => end sequence number,
	 *                      );
	 * @param  $ns_ip		ns  IPɥ쥹prefixɽ						(i)
	 * @param  $ns_ip_info	ns ip											(i)
	 *                      array([0] => start_seq(str), [1] => end_seq(str), [2] => prefix_length)
	 * @param  $ns_info		ns 
	 *                      name server ̾
	 * @return DB
	 *         array([DB_ZONE_IP]     => zone IPv6 address,
	 *               [DB_ZONE_PREFIX] => zone Prefix length,
	 *               [DB_ZONE_START]  => zone start sequence number,
	 *               [DB_ZONE_END]    => zone end sequence number,
	 *               [DB_DNS_IP]      => ns IPv6 address,
	 *               [DB_DNS_PREFIX]  => ns Prefix length,
	 *               [DB_DNS_START]   => ns start sequence number,
	 *               [DB_DNS_END]     => ns end sequence number,
	 *               [DB_NS_LIST]     => ns name server list (array(nameserver, nameserver, ...)),
	 *         );
	 */
	function set_ns_for_db_format($zone_info, $ns_ip, $ns_ip_info, $ns_info)
	{
		$db_form = array();

		$db_form[DB_ZONE_IP]		= $zone_info[DB_ZONE_IP];
		$db_form[DB_ZONE_PREFIX]	= $zone_info[DB_ZONE_PREFIX];
		$db_form[DB_ZONE_START]		= $zone_info[DB_ZONE_START];
		$db_form[DB_ZONE_END]		= $zone_info[DB_ZONE_END];

		$db_form[DB_DNS_IP]			= $ns_ip;
		$db_form[DB_DNS_PREFIX]		= $ns_ip_info[2];
		$db_form[DB_DNS_START]		= $ns_ip_info[0];
		$db_form[DB_DNS_END]		= $ns_ip_info[1];

		$db_form[DB_NS_LIST]		= $ns_info;

		return $db_form;
	}

}
?>
