<?php
/**
 * $Id: RegIPrevUpload.php,v 1.1 2004/03/08 13:25:40 yoshi_s Exp $
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegIPrevMsg.php");			// DNSžå
require_once("RegIPrevConf.php");			// config饹

//----------------------------------------------------------------------------
// define
//----------------------------------------------------------------------------
// žоݥ
define("UPLOAD_CONF_FILE", 0);					// conf(.conf)
define("UPLOAD_ZONE_FILE", 1);					// zone(.rev)
// named reload 
define("RELOAD_SUCCESS", 0);					// 
define("RELOAD_ERR_ZONE", 1);					// zone rsync 
define("RELOAD_ERR_CONF", 2);					// conf rsync 
define("RELOAD_ERR_RNDC", 3);					// named reload 

//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegIPrevUpload
{
	//----- å -----//
	/**
	 * åꥹ
	 */
	var $m_iprev_msg;

	/**
	 * åϿʸ
	 */
	var $m_log_msg;

	/**
	 * debugåϿʸ
	 */
	var $m_debug_msg;

	/**
	 * debug ե饰
	 */
	var $m_debug_flag;

	//----- ǡ -----//
	/**
	 * iniեǡ(RegIPrevConf֥)
	 */
	var $m_iprev_conf;

	//----- ޥʸ -----//
	/**
	 * zone rsyncޥ
	 */
	var $m_cmd_zone_rsync;

	/**
	 * conf rsyncޥ
	 */
	var $m_cmd_conf_rsync;

	/**
	 * reloadޥ
	 */
	var $m_cmd_reload;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegIPrevUpload
	 *   RegIPrevUpload饹󥹥ȥ饯
	 * @param  $iprev_conf   RegIPrevConf֥   (i)
	 * @param  $iprev_msg    åꥹ           (i)
	 * @param  $debug_flag   ǥХåե饰(def=FALSE)  (i)
	 */
	function RegIPrevUpload($iprev_conf, $iprev_msg, $debug_flag=FALSE)
	{
		$this->m_iprev_conf	= $iprev_conf;		// iniե
		$this->m_iprev_msg	= $iprev_msg;		// inc0103ѥåꥹ
		$this->m_log_msg	= "";				// å
		$this->m_debug_msg	= "";				// ǥХåå
		$this->m_debug_flag	= $debug_flag;		// ǥХåե饰

		$this->init_cmd_str();					// ޥʸ
	}

	//-----------------------------------------------------------------------
	// public methods
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾upload_dns_file
	 *   rsync ޥɤȯԤ dns Ф zone,confե
	 *         ž
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN40	rsync (db to dns)
	 *               IPREV_GEN99	fatal error
	 */
	function upload_dns_file()
	{
		$result = $this->upload_dns_file_imple(UPLOAD_ZONE_FILE);
		switch ($result)
		{
		case IPREV_GEN00:		// 
			break;

		case IPREV_GEN40:		// rsync (db to dns)
			return $result;
		case IPREV_GEN99:		// fatal error
		default:
			$this->set_log_msg(IPREV_GEN99, "");
			return IPREV_GEN99;
		}

		$result = $this->upload_dns_file_imple(UPLOAD_CONF_FILE);
		switch ($result)
		{
		case IPREV_GEN00:		// 
		case IPREV_GEN40:		// rsync (db to dns)
			break;
		case IPREV_GEN99:		// fatal error
		default:
			$this->set_log_msg(IPREV_GEN99, "");
			$result = IPREV_GEN99;
		}

		return $result;
	}

	/**
	 * ؿ̾reload_rev_named
	 *   DNSФΥư named reload Ԥ
	 *         ž
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN41	rsync (dns to dns zone)
	 *               IPREV_GEN42	rsync (dns to dns conf)
	 *               IPREV_GEN43	named reload 
	 *               IPREV_GEN99	fatal error
	 */
	function reload_rev_named()
	{
		//-------------------------------------------------------------------
		// rsync ¹
		//-------------------------------------------------------------------
		$cmd_ret = 1;
		system($this->m_cmd_reload, $cmd_ret);
		switch ($cmd_ret)
		{
		case RELOAD_SUCCESS:				// 
			return IPREV_GEN00;
		case RELOAD_ERR_ZONE:				// rsync (dns to dns zone)
			$result = IPREV_GEN41;
			break;
		case RELOAD_ERR_CONF:				// rsync (dns to dns conf)
			$result = IPREV_GEN42;
			break;
		case RELOAD_ERR_RNDC:				// named reload 
			$result = IPREV_GEN43;
			break;
		default:
			return IPREV_GEN99;
		}

		$this->set_log_msg($result, ("ret:" . $cmd_ret));
		return $result;
	}


	//-----------------------------------------------------------------------
	// private methodsʥեž
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾upload_dns_file_imple
	 *   rsync ޥɤȯԤ dns Ф zone/confե
	 *         ž
	 * @param  $type    žоݥ
	 *                  UPLOAD_CONF_FILE or UPLOAD_ZONE_FILE
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN40	rsync (db to dns)
	 *               IPREV_GEN99	fatal error
	 */
	function upload_dns_file_imple($type)
	{
		//-------------------------------------------------------------------
		// Ƚ
		//-------------------------------------------------------------------
		$type_str	= "";
		switch ($type)
		{
		case UPLOAD_CONF_FILE:
			$cmd_str	= $this->m_cmd_conf_rsync;
			$type_str	= "conf";
			break;

		case UPLOAD_ZONE_FILE:
			$cmd_str	= $this->m_cmd_zone_rsync;
			$type_str	= "zone";
			break;

		default:
			return IPREV_GEN99;				// ͭʤΤfatal error
		}

		//-------------------------------------------------------------------
		// rsync ¹
		//-------------------------------------------------------------------
		$cmd_ret = 1;
		system($cmd_str, $cmd_ret);
		if ($cmd_ret != 0)
		{
			$this->set_log_msg(IPREV_GEN40, array($type_str, ("ret:" . $cmd_ret)));
			return IPREV_GEN40;
		}

		return IPREV_GEN00;
	}

	//-----------------------------------------------------------------------
	// private methods(桼ƥƥ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾init_cmd_str
	 *   ޥʸƥѿϿ
	 */
	function init_cmd_str()
	{
		$rsync_opt = sprintf(
				"-rlptDzv -e %s --delete --exclude '*~'",
				$this->m_iprev_conf->m_conf_data[CMD_SSH]);

		$this->m_cmd_zone_rsync	= sprintf(
				"%s %s %s/ %s:%s",
				$this->m_iprev_conf->m_conf_data[CMD_RSYNC],
				$rsync_opt,
				$this->m_iprev_conf->m_conf_data[CURZONE],
				$this->m_iprev_conf->m_conf_data[DEST_HOST],
				$this->m_iprev_conf->m_conf_data[DEST_ZONE]);

		$this->m_cmd_conf_rsync	= sprintf(
				"%s %s %s/ %s:%s",
				$this->m_iprev_conf->m_conf_data[CMD_RSYNC],
				$rsync_opt,
				$this->m_iprev_conf->m_conf_data[CURCONF],
				$this->m_iprev_conf->m_conf_data[DEST_HOST],
				$this->m_iprev_conf->m_conf_data[DEST_CONF]);

		$this->m_cmd_reload	= sprintf(
				"%s %s '%s %s'",
				$this->m_iprev_conf->m_conf_data[CMD_SSH],
				$this->m_iprev_conf->m_conf_data[DEST_HOST],
				$this->m_iprev_conf->m_conf_data[CMD_SUDO],
				$this->m_iprev_conf->m_conf_data[CMD_RELOAD]);
	}

	/**
	 * ؿ̾set_log_msg
	 *   åɲä
	 * @param $msg_id	åID
	 * @param $options	ץǡʸ
	 *					åθ [0][1]... ղä
	 */
	function set_log_msg($msg_id, $options="")
	{
		$this->m_log_msg .= $this->m_iprev_msg[$msg_id];
		if (is_array($options))
		{
			for ($n = 0; $n < count($options); $n++)
			{
				if ($options[$n] !== "")
				{
					if (substr($options[$n], -1) == "\n")
						$this->m_log_msg .= " [" . substr($options[$n], 0, -1) . "]";
					else
						$this->m_log_msg .= " [" . $options[$n] . "]";
				}
			}
		}
	}

	/**
	 * ؿ̾get_log_msg
	 *   å
	 * @return å
	 */
	function get_log_msg()
	{
		return $this->m_log_msg;
	}

	/**
	 * ؿ̾set_debug_msg
	 *   ǥХååɲäm_debug_flag == true Τߡ
	 * @param $msg_id	åID
	 * @param $options	ץǡʸ
	 *					åθ [0][1]... ղä
	 */
	function set_debug_msg($msg_id, $options)
	{
		if ($this->m_debug_flag)
		{
			$this->m_debug_msg .= $this->m_iprev_msg[$msg_id];
			if (is_array($options))
			{
				for ($n = 0; $n < count($options); $n++)
				{
					if ($options[$n] !== "")
					{
						if (substr($options[$n], -1) == "\n")
							$this->m_debug_msg .= " [" . substr($options[$n], 0, -1) . "]";
						else
							$this->m_debug_msg .= " [" . $options[$n] . "]";
					}
				}
			}
		}
	}

	/**
	 * ؿ̾get_debug_msg
	 *   ǥХååm_debug_flag == true Τߡ
	 * @return ǥХåʸ
	 */
	function get_debug_msg()
	{
		if ($this->m_debug_flag && $this->m_debug_msg != "")
		{
			$this->m_debug_msg =
						"\n\n-------------[upload debug msg START]-------------\n" .
						$this->m_debug_msg .
						"\n\n-------------[upload debug msg END]-------------\n";
		}
		else
		{
			return "";
		}
		return $this->m_debug_msg;
	}
}
?>
